/* ArchiveManager.c generated by valac 0.56.14, the Vala compiler
 * generated from ArchiveManager.vala, do not modify */

/* ArchiveManager.vala
 *
 * Copyright (C) 2009-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include "font-manager.h"

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_FILE_ROLLER_DBUS_SERVICE (file_roller_dbus_service_get_type ())
#define FILE_ROLLER_DBUS_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_ROLLER_DBUS_SERVICE, FileRollerDBusService))
#define IS_FILE_ROLLER_DBUS_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_ROLLER_DBUS_SERVICE))
#define FILE_ROLLER_DBUS_SERVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FILE_ROLLER_DBUS_SERVICE, FileRollerDBusServiceIface))

typedef struct _FileRollerDBusService FileRollerDBusService;
typedef struct _FileRollerDBusServiceIface FileRollerDBusServiceIface;

#define TYPE_FILE_ROLLER_DBUS_SERVICE_PROXY (file_roller_dbus_service_proxy_get_type ())
enum  {
	FILE_ROLLER_DBUS_SERVICE_PROGRESS_SIGNAL,
	FILE_ROLLER_DBUS_SERVICE_NUM_SIGNALS
};
static guint file_roller_dbus_service_signals[FILE_ROLLER_DBUS_SERVICE_NUM_SIGNALS] = {0};
typedef GDBusProxy FileRollerDBusServiceProxy;
typedef GDBusProxyClass FileRollerDBusServiceProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define FONT_MANAGER_TYPE_ARCHIVE_MANAGER (font_manager_archive_manager_get_type ())
#define FONT_MANAGER_ARCHIVE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_ARCHIVE_MANAGER, FontManagerArchiveManager))
#define FONT_MANAGER_ARCHIVE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_ARCHIVE_MANAGER, FontManagerArchiveManagerClass))
#define FONT_MANAGER_IS_ARCHIVE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_ARCHIVE_MANAGER))
#define FONT_MANAGER_IS_ARCHIVE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_ARCHIVE_MANAGER))
#define FONT_MANAGER_ARCHIVE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_ARCHIVE_MANAGER, FontManagerArchiveManagerClass))

typedef struct _FontManagerArchiveManager FontManagerArchiveManager;
typedef struct _FontManagerArchiveManagerClass FontManagerArchiveManagerClass;
typedef struct _FontManagerArchiveManagerPrivate FontManagerArchiveManagerPrivate;
enum  {
	FONT_MANAGER_ARCHIVE_MANAGER_0_PROPERTY,
	FONT_MANAGER_ARCHIVE_MANAGER_AVAILABLE_PROPERTY,
	FONT_MANAGER_ARCHIVE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* font_manager_archive_manager_properties[FONT_MANAGER_ARCHIVE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	FONT_MANAGER_ARCHIVE_MANAGER_PROGRESS_SIGNAL,
	FONT_MANAGER_ARCHIVE_MANAGER_NUM_SIGNALS
};
static guint font_manager_archive_manager_signals[FONT_MANAGER_ARCHIVE_MANAGER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FileRollerDBusServiceIface {
	GTypeInterface parent_iface;
	void (*add_to_archive) (FileRollerDBusService* self, const gchar* archive, gchar** uris, gint uris_length1, gboolean use_progress_dialog, GError** error);
	void (*compress) (FileRollerDBusService* self, gchar** uris, gint uris_length1, const gchar* destination, gboolean use_progress_dialog, GError** error);
	void (*extract) (FileRollerDBusService* self, const gchar* archive, const gchar* destination, gboolean use_progress_dialog, GError** error);
	void (*extract_here) (FileRollerDBusService* self, const gchar* archive, gboolean use_progress_dialog, GError** error);
	GHashTable** (*get_supported_types) (FileRollerDBusService* self, const gchar* action, gint* result_length1, GError** error);
};

struct _FontManagerArchiveManager {
	GObject parent_instance;
	FontManagerArchiveManagerPrivate * priv;
};

struct _FontManagerArchiveManagerClass {
	GObjectClass parent_class;
};

struct _FontManagerArchiveManagerPrivate {
	gint SERVICE_UNKNOWN_ERROR;
	gint SERVICE_TIMED_OUT;
	FileRollerDBusService* service;
};

static gint FontManagerArchiveManager_private_offset;
static gpointer font_manager_archive_manager_parent_class = NULL;
static gboolean font_manager_archive_manager_SERVICE_UNKNOWN;
static gboolean font_manager_archive_manager_SERVICE_UNKNOWN = FALSE;

VALA_EXTERN GType file_roller_dbus_service_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint file_roller_dbus_service_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
VALA_EXTERN GType file_roller_dbus_service_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileRollerDBusService, g_object_unref)
VALA_EXTERN void file_roller_dbus_service_add_to_archive (FileRollerDBusService* self,
                                              const gchar* archive,
                                              gchar** uris,
                                              gint uris_length1,
                                              gboolean use_progress_dialog,
                                              GError** error);
VALA_EXTERN void file_roller_dbus_service_compress (FileRollerDBusService* self,
                                        gchar** uris,
                                        gint uris_length1,
                                        const gchar* destination,
                                        gboolean use_progress_dialog,
                                        GError** error);
VALA_EXTERN void file_roller_dbus_service_extract (FileRollerDBusService* self,
                                       const gchar* archive,
                                       const gchar* destination,
                                       gboolean use_progress_dialog,
                                       GError** error);
VALA_EXTERN void file_roller_dbus_service_extract_here (FileRollerDBusService* self,
                                            const gchar* archive,
                                            gboolean use_progress_dialog,
                                            GError** error);
VALA_EXTERN GHashTable** file_roller_dbus_service_get_supported_types (FileRollerDBusService* self,
                                                           const gchar* action,
                                                           gint* result_length1,
                                                           GError** error);
static void g_cclosure_user_marshal_VOID__DOUBLE_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GType file_roller_dbus_service_get_type_once (void);
static void file_roller_dbus_service_proxy_g_signal (GDBusProxy* proxy,
                                              const gchar* sender_name,
                                              const gchar* signal_name,
                                              GVariant* parameters);
static void _dbus_handle_file_roller_dbus_service_progress (FileRollerDBusService* self,
                                                     GVariant* parameters);
static void file_roller_dbus_service_proxy_add_to_archive (FileRollerDBusService* self,
                                                    const gchar* archive,
                                                    gchar** uris,
                                                    gint uris_length1,
                                                    gboolean use_progress_dialog,
                                                    GError** error);
static void file_roller_dbus_service_proxy_compress (FileRollerDBusService* self,
                                              gchar** uris,
                                              gint uris_length1,
                                              const gchar* destination,
                                              gboolean use_progress_dialog,
                                              GError** error);
static void file_roller_dbus_service_proxy_extract (FileRollerDBusService* self,
                                             const gchar* archive,
                                             const gchar* destination,
                                             gboolean use_progress_dialog,
                                             GError** error);
static void file_roller_dbus_service_proxy_extract_here (FileRollerDBusService* self,
                                                  const gchar* archive,
                                                  gboolean use_progress_dialog,
                                                  GError** error);
static GHashTable** file_roller_dbus_service_proxy_get_supported_types (FileRollerDBusService* self,
                                                                 const gchar* action,
                                                                 gint* result_length1,
                                                                 GError** error);
static void file_roller_dbus_service_proxy_file_roller_dbus_service_interface_init (FileRollerDBusServiceIface* iface);
static void _dbus_file_roller_dbus_service_add_to_archive (FileRollerDBusService* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_file_roller_dbus_service_compress (FileRollerDBusService* self,
                                              GVariant* _parameters_,
                                              GDBusMethodInvocation* invocation);
static void _dbus_file_roller_dbus_service_extract (FileRollerDBusService* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation);
static void _dbus_file_roller_dbus_service_extract_here (FileRollerDBusService* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation);
static void _dbus_file_roller_dbus_service_get_supported_types (FileRollerDBusService* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation);
static void file_roller_dbus_service_dbus_interface_method_call (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* method_name,
                                                          GVariant* parameters,
                                                          GDBusMethodInvocation* invocation,
                                                          gpointer user_data);
static GVariant* file_roller_dbus_service_dbus_interface_get_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GError** error,
                                                                gpointer user_data);
static gboolean file_roller_dbus_service_dbus_interface_set_property (GDBusConnection* connection,
                                                               const gchar* sender,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* property_name,
                                                               GVariant* value,
                                                               GError** error,
                                                               gpointer user_data);
static void _dbus_file_roller_dbus_service_progress (GObject* _sender,
                                              gdouble percent,
                                              const gchar* message,
                                              gpointer* _data);
static void _file_roller_dbus_service_unregister_object (gpointer user_data);
VALA_EXTERN GType font_manager_archive_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerArchiveManager, g_object_unref)
static void font_manager_archive_manager_post_error_message (FontManagerArchiveManager* self,
                                                      GError* e);
static void font_manager_archive_manager_init (FontManagerArchiveManager* self);
static void ____lambda86_ (FontManagerArchiveManager* self,
                    gdouble p,
                    const gchar* m);
static void _____lambda86__file_roller_dbus_service_progress (FileRollerDBusService* _sender,
                                                       gdouble percent,
                                                       const gchar* message,
                                                       gpointer self);
VALA_EXTERN gboolean font_manager_archive_manager_add_to_archive (FontManagerArchiveManager* self,
                                                      const gchar* archive,
                                                      gchar** uris,
                                                      gint uris_length1,
                                                      gboolean use_progress_dialog);
static FileRollerDBusService* font_manager_archive_manager_get_file_roller (FontManagerArchiveManager* self);
VALA_EXTERN gboolean font_manager_archive_manager_compress (FontManagerArchiveManager* self,
                                                gchar** uris,
                                                gint uris_length1,
                                                const gchar* destination,
                                                gboolean use_progress_dialog);
VALA_EXTERN gboolean font_manager_archive_manager_extract (FontManagerArchiveManager* self,
                                               const gchar* archive,
                                               const gchar* destination,
                                               gboolean use_progress_dialog);
VALA_EXTERN gboolean font_manager_archive_manager_extract_here (FontManagerArchiveManager* self,
                                                    const gchar* archive,
                                                    gboolean use_progress_dialog);
VALA_EXTERN FontManagerStringSet* font_manager_archive_manager_get_supported_types (FontManagerArchiveManager* self,
                                                                        const gchar* action);
static gboolean _vala_string_array_contains (const gchar* * stack,
                                      gssize stack_length,
                                      const const gchar* needle);
VALA_EXTERN FontManagerArchiveManager* font_manager_archive_manager_new (void);
VALA_EXTERN FontManagerArchiveManager* font_manager_archive_manager_construct (GType object_type);
VALA_EXTERN gboolean font_manager_archive_manager_get_available (FontManagerArchiveManager* self);
static void font_manager_archive_manager_finalize (GObject * obj);
static GType font_manager_archive_manager_get_type_once (void);
static void _vala_font_manager_archive_manager_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_add_to_archive_archive = {-1, "archive", "s", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_add_to_archive_uris = {-1, "uris", "as", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_add_to_archive_use_progress_dialog = {-1, "use_progress_dialog", "b", NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_add_to_archive_in[] = {&_file_roller_dbus_service_dbus_arg_info_add_to_archive_archive, &_file_roller_dbus_service_dbus_arg_info_add_to_archive_uris, &_file_roller_dbus_service_dbus_arg_info_add_to_archive_use_progress_dialog, NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_add_to_archive_out[] = {NULL};
static const GDBusMethodInfo _file_roller_dbus_service_dbus_method_info_add_to_archive = {-1, "AddToArchive", (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_add_to_archive_in), (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_add_to_archive_out), NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_compress_uris = {-1, "uris", "as", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_compress_destination = {-1, "destination", "s", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_compress_use_progress_dialog = {-1, "use_progress_dialog", "b", NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_compress_in[] = {&_file_roller_dbus_service_dbus_arg_info_compress_uris, &_file_roller_dbus_service_dbus_arg_info_compress_destination, &_file_roller_dbus_service_dbus_arg_info_compress_use_progress_dialog, NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_compress_out[] = {NULL};
static const GDBusMethodInfo _file_roller_dbus_service_dbus_method_info_compress = {-1, "Compress", (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_compress_in), (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_compress_out), NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_extract_archive = {-1, "archive", "s", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_extract_destination = {-1, "destination", "s", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_extract_use_progress_dialog = {-1, "use_progress_dialog", "b", NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_extract_in[] = {&_file_roller_dbus_service_dbus_arg_info_extract_archive, &_file_roller_dbus_service_dbus_arg_info_extract_destination, &_file_roller_dbus_service_dbus_arg_info_extract_use_progress_dialog, NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_extract_out[] = {NULL};
static const GDBusMethodInfo _file_roller_dbus_service_dbus_method_info_extract = {-1, "Extract", (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_extract_in), (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_extract_out), NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_extract_here_archive = {-1, "archive", "s", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_extract_here_use_progress_dialog = {-1, "use_progress_dialog", "b", NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_extract_here_in[] = {&_file_roller_dbus_service_dbus_arg_info_extract_here_archive, &_file_roller_dbus_service_dbus_arg_info_extract_here_use_progress_dialog, NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_extract_here_out[] = {NULL};
static const GDBusMethodInfo _file_roller_dbus_service_dbus_method_info_extract_here = {-1, "ExtractHere", (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_extract_here_in), (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_extract_here_out), NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_get_supported_types_action = {-1, "action", "s", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_get_supported_types_result = {-1, "result", "aa{ss}", NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_get_supported_types_in[] = {&_file_roller_dbus_service_dbus_arg_info_get_supported_types_action, NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_get_supported_types_out[] = {&_file_roller_dbus_service_dbus_arg_info_get_supported_types_result, NULL};
static const GDBusMethodInfo _file_roller_dbus_service_dbus_method_info_get_supported_types = {-1, "GetSupportedTypes", (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_get_supported_types_in), (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_get_supported_types_out), NULL};
static const GDBusMethodInfo * const _file_roller_dbus_service_dbus_method_info[] = {&_file_roller_dbus_service_dbus_method_info_add_to_archive, &_file_roller_dbus_service_dbus_method_info_compress, &_file_roller_dbus_service_dbus_method_info_extract, &_file_roller_dbus_service_dbus_method_info_extract_here, &_file_roller_dbus_service_dbus_method_info_get_supported_types, NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_progress_percent = {-1, "percent", "d", NULL};
static const GDBusArgInfo _file_roller_dbus_service_dbus_arg_info_progress_message = {-1, "message", "s", NULL};
static const GDBusArgInfo * const _file_roller_dbus_service_dbus_arg_info_progress[] = {&_file_roller_dbus_service_dbus_arg_info_progress_percent, &_file_roller_dbus_service_dbus_arg_info_progress_message, NULL};
static const GDBusSignalInfo _file_roller_dbus_service_dbus_signal_info_progress = {-1, "Progress", (GDBusArgInfo **) (&_file_roller_dbus_service_dbus_arg_info_progress), NULL};
static const GDBusSignalInfo * const _file_roller_dbus_service_dbus_signal_info[] = {&_file_roller_dbus_service_dbus_signal_info_progress, NULL};
static const GDBusPropertyInfo * const _file_roller_dbus_service_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _file_roller_dbus_service_dbus_interface_info = {-1, "org.gnome.ArchiveManager1", (GDBusMethodInfo **) (&_file_roller_dbus_service_dbus_method_info), (GDBusSignalInfo **) (&_file_roller_dbus_service_dbus_signal_info), (GDBusPropertyInfo **) (&_file_roller_dbus_service_dbus_property_info), NULL};
static const GDBusInterfaceVTable _file_roller_dbus_service_dbus_interface_vtable = {file_roller_dbus_service_dbus_interface_method_call, file_roller_dbus_service_dbus_interface_get_property, file_roller_dbus_service_dbus_interface_set_property};
const gchar* FONT_MANAGER_MIMETYPE_IGNORE_LIST[1] = {"application/x-ms-dos-executable"};

void
file_roller_dbus_service_add_to_archive (FileRollerDBusService* self,
                                         const gchar* archive,
                                         gchar** uris,
                                         gint uris_length1,
                                         gboolean use_progress_dialog,
                                         GError** error)
{
	FileRollerDBusServiceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = FILE_ROLLER_DBUS_SERVICE_GET_INTERFACE (self);
	if (_iface_->add_to_archive) {
		_iface_->add_to_archive (self, archive, uris, uris_length1, use_progress_dialog, error);
	}
}

void
file_roller_dbus_service_compress (FileRollerDBusService* self,
                                   gchar** uris,
                                   gint uris_length1,
                                   const gchar* destination,
                                   gboolean use_progress_dialog,
                                   GError** error)
{
	FileRollerDBusServiceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = FILE_ROLLER_DBUS_SERVICE_GET_INTERFACE (self);
	if (_iface_->compress) {
		_iface_->compress (self, uris, uris_length1, destination, use_progress_dialog, error);
	}
}

void
file_roller_dbus_service_extract (FileRollerDBusService* self,
                                  const gchar* archive,
                                  const gchar* destination,
                                  gboolean use_progress_dialog,
                                  GError** error)
{
	FileRollerDBusServiceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = FILE_ROLLER_DBUS_SERVICE_GET_INTERFACE (self);
	if (_iface_->extract) {
		_iface_->extract (self, archive, destination, use_progress_dialog, error);
	}
}

void
file_roller_dbus_service_extract_here (FileRollerDBusService* self,
                                       const gchar* archive,
                                       gboolean use_progress_dialog,
                                       GError** error)
{
	FileRollerDBusServiceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = FILE_ROLLER_DBUS_SERVICE_GET_INTERFACE (self);
	if (_iface_->extract_here) {
		_iface_->extract_here (self, archive, use_progress_dialog, error);
	}
}

GHashTable**
file_roller_dbus_service_get_supported_types (FileRollerDBusService* self,
                                              const gchar* action,
                                              gint* result_length1,
                                              GError** error)
{
	FileRollerDBusServiceIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = FILE_ROLLER_DBUS_SERVICE_GET_INTERFACE (self);
	if (_iface_->get_supported_types) {
		return _iface_->get_supported_types (self, action, result_length1, error);
	}
	return NULL;
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_STRING) (gpointer data1, gdouble arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DOUBLE_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_double (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
file_roller_dbus_service_default_init (FileRollerDBusServiceIface * iface,
                                       gpointer iface_data)
{
	file_roller_dbus_service_signals[FILE_ROLLER_DBUS_SERVICE_PROGRESS_SIGNAL] = g_signal_new ("progress", TYPE_FILE_ROLLER_DBUS_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_STRING, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_STRING);
}

 G_GNUC_NO_INLINE static GType
file_roller_dbus_service_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FileRollerDBusServiceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_roller_dbus_service_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType file_roller_dbus_service_type_id;
	file_roller_dbus_service_type_id = g_type_register_static (G_TYPE_INTERFACE, "FileRollerDBusService", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (file_roller_dbus_service_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (file_roller_dbus_service_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) file_roller_dbus_service_proxy_get_type);
	g_type_set_qdata (file_roller_dbus_service_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.ArchiveManager1");
	g_type_set_qdata (file_roller_dbus_service_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_file_roller_dbus_service_dbus_interface_info));
	g_type_set_qdata (file_roller_dbus_service_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) file_roller_dbus_service_register_object);
	return file_roller_dbus_service_type_id;
}

GType
file_roller_dbus_service_get_type (void)
{
	static volatile gsize file_roller_dbus_service_type_id__once = 0;
	if (g_once_init_enter (&file_roller_dbus_service_type_id__once)) {
		GType file_roller_dbus_service_type_id;
		file_roller_dbus_service_type_id = file_roller_dbus_service_get_type_once ();
		g_once_init_leave (&file_roller_dbus_service_type_id__once, file_roller_dbus_service_type_id);
	}
	return file_roller_dbus_service_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (FileRollerDBusServiceProxy, file_roller_dbus_service_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_FILE_ROLLER_DBUS_SERVICE, file_roller_dbus_service_proxy_file_roller_dbus_service_interface_init) )
static void
file_roller_dbus_service_proxy_class_init (FileRollerDBusServiceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = file_roller_dbus_service_proxy_g_signal;
}

static void
_dbus_handle_file_roller_dbus_service_progress (FileRollerDBusService* self,
                                                GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gdouble percent = 0.0;
	GVariant* _tmp12_;
	gchar* message = NULL;
	GVariant* _tmp13_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	percent = g_variant_get_double (_tmp12_);
	g_variant_unref (_tmp12_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	message = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	g_signal_emit_by_name (self, "progress", percent, message);
	_g_free0 (message);
}

static void
file_roller_dbus_service_proxy_g_signal (GDBusProxy* proxy,
                                         const gchar* sender_name,
                                         const gchar* signal_name,
                                         GVariant* parameters)
{
	if (strcmp (signal_name, "Progress") == 0) {
		_dbus_handle_file_roller_dbus_service_progress ((FileRollerDBusService*) proxy, parameters);
	}
}

static void
file_roller_dbus_service_proxy_init (FileRollerDBusServiceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_file_roller_dbus_service_dbus_interface_info));
}

static void
file_roller_dbus_service_proxy_add_to_archive (FileRollerDBusService* self,
                                               const gchar* archive,
                                               gchar** uris,
                                               gint uris_length1,
                                               gboolean use_progress_dialog,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp14_;
	GVariantBuilder _tmp15_;
	gint _tmp16_;
	GDBusMessage *_reply_message;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ArchiveManager1", "AddToArchive");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (archive));
	_tmp14_ = uris;
	g_variant_builder_init (&_tmp15_, G_VARIANT_TYPE ("as"));
	for (_tmp16_ = 0; _tmp16_ < uris_length1; _tmp16_++) {
		g_variant_builder_add_value (&_tmp15_, g_variant_new_string (*_tmp14_));
		_tmp14_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp15_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (use_progress_dialog));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
file_roller_dbus_service_proxy_compress (FileRollerDBusService* self,
                                         gchar** uris,
                                         gint uris_length1,
                                         const gchar* destination,
                                         gboolean use_progress_dialog,
                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp17_;
	GVariantBuilder _tmp18_;
	gint _tmp19_;
	GDBusMessage *_reply_message;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ArchiveManager1", "Compress");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp17_ = uris;
	g_variant_builder_init (&_tmp18_, G_VARIANT_TYPE ("as"));
	for (_tmp19_ = 0; _tmp19_ < uris_length1; _tmp19_++) {
		g_variant_builder_add_value (&_tmp18_, g_variant_new_string (*_tmp17_));
		_tmp17_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp18_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (destination));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (use_progress_dialog));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
file_roller_dbus_service_proxy_extract (FileRollerDBusService* self,
                                        const gchar* archive,
                                        const gchar* destination,
                                        gboolean use_progress_dialog,
                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ArchiveManager1", "Extract");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (archive));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (destination));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (use_progress_dialog));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
file_roller_dbus_service_proxy_extract_here (FileRollerDBusService* self,
                                             const gchar* archive,
                                             gboolean use_progress_dialog,
                                             GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ArchiveManager1", "ExtractHere");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (archive));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (use_progress_dialog));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static GHashTable**
file_roller_dbus_service_proxy_get_supported_types (FileRollerDBusService* self,
                                                    const gchar* action,
                                                    gint* result_length1,
                                                    GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable** _result = NULL;
	gint _result_length1;
	GVariant* _tmp20_;
	GHashTable** _tmp21_;
	gint _tmp21__length;
	gint _tmp21__size;
	gint _tmp21__length1;
	GVariantIter _tmp22_;
	GVariant* _tmp23_;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ArchiveManager1", "GetSupportedTypes");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (action));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp20_ = g_variant_iter_next_value (&_reply_iter);
	_tmp21_ = g_new (GHashTable*, 5);
	_tmp21__length = 0;
	_tmp21__size = 4;
	_tmp21__length1 = 0;
	g_variant_iter_init (&_tmp22_, _tmp20_);
	for (; (_tmp23_ = g_variant_iter_next_value (&_tmp22_)) != NULL; _tmp21__length1++) {
		GHashTable* _tmp24_;
		GVariantIter _tmp25_;
		GVariant* _tmp26_;
		GVariant* _tmp27_;
		if (_tmp21__size == _tmp21__length) {
			_tmp21__size = 2 * _tmp21__size;
			_tmp21_ = g_renew (GHashTable*, _tmp21_, _tmp21__size + 1);
		}
		_tmp24_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
		g_variant_iter_init (&_tmp25_, _tmp23_);
		while (g_variant_iter_loop (&_tmp25_, "{?*}", &_tmp26_, &_tmp27_)) {
			g_hash_table_insert (_tmp24_, g_variant_dup_string (_tmp26_, NULL), g_variant_dup_string (_tmp27_, NULL));
		}
		_tmp21_[_tmp21__length++] = _tmp24_;
		g_variant_unref (_tmp23_);
	}
	_result_length1 = _tmp21__length1;
	_tmp21_[_tmp21__length] = NULL;
	_result = _tmp21_;
	g_variant_unref (_tmp20_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}

static void
file_roller_dbus_service_proxy_file_roller_dbus_service_interface_init (FileRollerDBusServiceIface* iface)
{
	iface->add_to_archive = file_roller_dbus_service_proxy_add_to_archive;
	iface->compress = file_roller_dbus_service_proxy_compress;
	iface->extract = file_roller_dbus_service_proxy_extract;
	iface->extract_here = file_roller_dbus_service_proxy_extract_here;
	iface->get_supported_types = file_roller_dbus_service_proxy_get_supported_types;
}

static void
_dbus_file_roller_dbus_service_add_to_archive (FileRollerDBusService* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* archive = NULL;
	GVariant* _tmp28_;
	gchar** uris = NULL;
	gint uris_length1 = 0;
	GVariant* _tmp29_;
	gchar** _tmp30_;
	gint _tmp30__length;
	gint _tmp30__size;
	gint _tmp30__length1;
	GVariantIter _tmp31_;
	GVariant* _tmp32_;
	gboolean use_progress_dialog = FALSE;
	GVariant* _tmp33_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp28_ = g_variant_iter_next_value (&_arguments_iter);
	archive = g_variant_dup_string (_tmp28_, NULL);
	g_variant_unref (_tmp28_);
	_tmp29_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp30_ = g_new (gchar*, 5);
	_tmp30__length = 0;
	_tmp30__size = 4;
	_tmp30__length1 = 0;
	g_variant_iter_init (&_tmp31_, _tmp29_);
	for (; (_tmp32_ = g_variant_iter_next_value (&_tmp31_)) != NULL; _tmp30__length1++) {
		if (_tmp30__size == _tmp30__length) {
			_tmp30__size = 2 * _tmp30__size;
			_tmp30_ = g_renew (gchar*, _tmp30_, _tmp30__size + 1);
		}
		_tmp30_[_tmp30__length++] = g_variant_dup_string (_tmp32_, NULL);
		g_variant_unref (_tmp32_);
	}
	uris_length1 = _tmp30__length1;
	_tmp30_[_tmp30__length] = NULL;
	uris = _tmp30_;
	g_variant_unref (_tmp29_);
	_tmp33_ = g_variant_iter_next_value (&_arguments_iter);
	use_progress_dialog = g_variant_get_boolean (_tmp33_);
	g_variant_unref (_tmp33_);
	file_roller_dbus_service_add_to_archive (self, archive, uris, uris_length1, use_progress_dialog, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (archive);
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
	;
}

static void
_dbus_file_roller_dbus_service_compress (FileRollerDBusService* self,
                                         GVariant* _parameters_,
                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** uris = NULL;
	gint uris_length1 = 0;
	GVariant* _tmp34_;
	gchar** _tmp35_;
	gint _tmp35__length;
	gint _tmp35__size;
	gint _tmp35__length1;
	GVariantIter _tmp36_;
	GVariant* _tmp37_;
	gchar* destination = NULL;
	GVariant* _tmp38_;
	gboolean use_progress_dialog = FALSE;
	GVariant* _tmp39_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp34_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp35_ = g_new (gchar*, 5);
	_tmp35__length = 0;
	_tmp35__size = 4;
	_tmp35__length1 = 0;
	g_variant_iter_init (&_tmp36_, _tmp34_);
	for (; (_tmp37_ = g_variant_iter_next_value (&_tmp36_)) != NULL; _tmp35__length1++) {
		if (_tmp35__size == _tmp35__length) {
			_tmp35__size = 2 * _tmp35__size;
			_tmp35_ = g_renew (gchar*, _tmp35_, _tmp35__size + 1);
		}
		_tmp35_[_tmp35__length++] = g_variant_dup_string (_tmp37_, NULL);
		g_variant_unref (_tmp37_);
	}
	uris_length1 = _tmp35__length1;
	_tmp35_[_tmp35__length] = NULL;
	uris = _tmp35_;
	g_variant_unref (_tmp34_);
	_tmp38_ = g_variant_iter_next_value (&_arguments_iter);
	destination = g_variant_dup_string (_tmp38_, NULL);
	g_variant_unref (_tmp38_);
	_tmp39_ = g_variant_iter_next_value (&_arguments_iter);
	use_progress_dialog = g_variant_get_boolean (_tmp39_);
	g_variant_unref (_tmp39_);
	file_roller_dbus_service_compress (self, uris, uris_length1, destination, use_progress_dialog, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (destination);
	;
}

static void
_dbus_file_roller_dbus_service_extract (FileRollerDBusService* self,
                                        GVariant* _parameters_,
                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* archive = NULL;
	GVariant* _tmp40_;
	gchar* destination = NULL;
	GVariant* _tmp41_;
	gboolean use_progress_dialog = FALSE;
	GVariant* _tmp42_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp40_ = g_variant_iter_next_value (&_arguments_iter);
	archive = g_variant_dup_string (_tmp40_, NULL);
	g_variant_unref (_tmp40_);
	_tmp41_ = g_variant_iter_next_value (&_arguments_iter);
	destination = g_variant_dup_string (_tmp41_, NULL);
	g_variant_unref (_tmp41_);
	_tmp42_ = g_variant_iter_next_value (&_arguments_iter);
	use_progress_dialog = g_variant_get_boolean (_tmp42_);
	g_variant_unref (_tmp42_);
	file_roller_dbus_service_extract (self, archive, destination, use_progress_dialog, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (archive);
	_g_free0 (destination);
	;
}

static void
_dbus_file_roller_dbus_service_extract_here (FileRollerDBusService* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* archive = NULL;
	GVariant* _tmp43_;
	gboolean use_progress_dialog = FALSE;
	GVariant* _tmp44_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp43_ = g_variant_iter_next_value (&_arguments_iter);
	archive = g_variant_dup_string (_tmp43_, NULL);
	g_variant_unref (_tmp43_);
	_tmp44_ = g_variant_iter_next_value (&_arguments_iter);
	use_progress_dialog = g_variant_get_boolean (_tmp44_);
	g_variant_unref (_tmp44_);
	file_roller_dbus_service_extract_here (self, archive, use_progress_dialog, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (archive);
	;
}

static void
_dbus_file_roller_dbus_service_get_supported_types (FileRollerDBusService* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* action = NULL;
	GVariant* _tmp45_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable** result;
	gint result_length1 = 0;
	GHashTable** _tmp46_;
	GVariantBuilder _tmp47_;
	gint _tmp48_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp45_ = g_variant_iter_next_value (&_arguments_iter);
	action = g_variant_dup_string (_tmp45_, NULL);
	g_variant_unref (_tmp45_);
	result = file_roller_dbus_service_get_supported_types (self, action, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp46_ = result;
	g_variant_builder_init (&_tmp47_, G_VARIANT_TYPE ("aa{ss}"));
	for (_tmp48_ = 0; _tmp48_ < result_length1; _tmp48_++) {
		GVariantBuilder _tmp49_;
		GHashTableIter _tmp50_;
		gpointer _tmp51_;
		gpointer _tmp52_;
		g_hash_table_iter_init (&_tmp50_, *_tmp46_);
		g_variant_builder_init (&_tmp49_, G_VARIANT_TYPE ("a{ss}"));
		while (g_hash_table_iter_next (&_tmp50_, &_tmp51_, &_tmp52_)) {
			gchar* _key;
			gchar* _value;
			_key = (gchar*) _tmp51_;
			_value = (gchar*) _tmp52_;
			g_variant_builder_add (&_tmp49_, "{?*}", g_variant_new_string (_key), g_variant_new_string (_value));
		}
		g_variant_builder_add_value (&_tmp47_, g_variant_builder_end (&_tmp49_));
		_tmp46_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp47_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_hash_table_unref), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (action);
	;
}

static void
file_roller_dbus_service_dbus_interface_method_call (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* method_name,
                                                     GVariant* parameters,
                                                     GDBusMethodInvocation* invocation,
                                                     gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "AddToArchive") == 0) {
		_dbus_file_roller_dbus_service_add_to_archive (object, parameters, invocation);
	} else if (strcmp (method_name, "Compress") == 0) {
		_dbus_file_roller_dbus_service_compress (object, parameters, invocation);
	} else if (strcmp (method_name, "Extract") == 0) {
		_dbus_file_roller_dbus_service_extract (object, parameters, invocation);
	} else if (strcmp (method_name, "ExtractHere") == 0) {
		_dbus_file_roller_dbus_service_extract_here (object, parameters, invocation);
	} else if (strcmp (method_name, "GetSupportedTypes") == 0) {
		_dbus_file_roller_dbus_service_get_supported_types (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
file_roller_dbus_service_dbus_interface_get_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GError** error,
                                                      gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
file_roller_dbus_service_dbus_interface_set_property (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* property_name,
                                                      GVariant* value,
                                                      GError** error,
                                                      gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_file_roller_dbus_service_progress (GObject* _sender,
                                         gdouble percent,
                                         const gchar* message,
                                         gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_double (percent));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (message));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.ArchiveManager1", "Progress", _arguments, NULL);
}

guint
file_roller_dbus_service_register_object (gpointer object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_file_roller_dbus_service_dbus_interface_info), &_file_roller_dbus_service_dbus_interface_vtable, data, _file_roller_dbus_service_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "progress", (GCallback) _dbus_file_roller_dbus_service_progress, data);
	return result;
}

static void
_file_roller_dbus_service_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_file_roller_dbus_service_progress, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
font_manager_archive_manager_get_instance_private (FontManagerArchiveManager* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerArchiveManager_private_offset);
}

static void
font_manager_archive_manager_post_error_message (FontManagerArchiveManager* self,
                                                 GError* e)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (e != NULL);
	if (e->code == self->priv->SERVICE_UNKNOWN_ERROR) {
		font_manager_archive_manager_SERVICE_UNKNOWN = TRUE;
		g_message ("ArchiveManager.vala:59: Install file-roller to enable archive support");
	} else {
		if (e->code != self->priv->SERVICE_TIMED_OUT) {
			const gchar* _tmp0_;
			_tmp0_ = e->message;
			g_critical ("ArchiveManager.vala:61: %i : %s", e->code, _tmp0_);
		}
	}
	return;
}

static void
____lambda86_ (FontManagerArchiveManager* self,
               gdouble p,
               const gchar* m)
{
	g_return_if_fail (m != NULL);
	g_signal_emit (self, font_manager_archive_manager_signals[FONT_MANAGER_ARCHIVE_MANAGER_PROGRESS_SIGNAL], 0, p, m);
}

static void
_____lambda86__file_roller_dbus_service_progress (FileRollerDBusService* _sender,
                                                  gdouble percent,
                                                  const gchar* message,
                                                  gpointer self)
{
	____lambda86_ ((FontManagerArchiveManager*) self, percent, message);
}

static void
font_manager_archive_manager_init (FontManagerArchiveManager* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		FileRollerDBusService* _tmp0_ = NULL;
		FileRollerDBusService* _tmp1_;
		FileRollerDBusService* _tmp2_;
		GHashTable** _tmp3_ = NULL;
		FileRollerDBusService* _tmp4_;
		gint _tmp5_ = 0;
		GHashTable** _tmp6_;
		gint _tmp3__length1;
		gint __tmp3__size_;
		if (font_manager_archive_manager_SERVICE_UNKNOWN) {
			return;
		}
		_tmp1_ = (FileRollerDBusService*) g_initable_new (TYPE_FILE_ROLLER_DBUS_SERVICE_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.gnome.ArchiveManager1", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/ArchiveManager1", "g-interface-name", "org.gnome.ArchiveManager1", NULL);
		_tmp0_ = (FileRollerDBusService*) _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->service);
		self->priv->service = _tmp2_;
		_tmp4_ = self->priv->service;
		_tmp6_ = file_roller_dbus_service_get_supported_types (_tmp4_, "extract", &_tmp5_, &_inner_error0_);
		_tmp3_ = _tmp6_;
		_tmp3__length1 = _tmp5_;
		__tmp3__size_ = _tmp3__length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		if (_tmp3__length1 > 0) {
			FileRollerDBusService* _tmp7_;
			_tmp7_ = self->priv->service;
			g_signal_connect_object (_tmp7_, "progress", (GCallback) _____lambda86__file_roller_dbus_service_progress, self, 0);
		}
		_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_hash_table_unref), NULL);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_g_object_unref0 (self->priv->service);
		self->priv->service = NULL;
		_tmp8_ = e;
		font_manager_archive_manager_post_error_message (self, _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	return;
}

gboolean
font_manager_archive_manager_add_to_archive (FontManagerArchiveManager* self,
                                             const gchar* archive,
                                             gchar** uris,
                                             gint uris_length1,
                                             gboolean use_progress_dialog)
{
	FileRollerDBusService* _tmp0_;
	FileRollerDBusService* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (archive != NULL, FALSE);
	_tmp0_ = font_manager_archive_manager_get_file_roller (self);
	_tmp1_ = _tmp0_;
	_vala_return_val_if_fail (_tmp1_ != NULL, "file_roller != null", FALSE);
	{
		FileRollerDBusService* _tmp2_;
		FileRollerDBusService* _tmp3_;
		_tmp2_ = font_manager_archive_manager_get_file_roller (self);
		_tmp3_ = _tmp2_;
		file_roller_dbus_service_add_to_archive (_tmp3_, archive, uris, (gint) _vala_array_length (uris), use_progress_dialog, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		result = TRUE;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		font_manager_archive_manager_post_error_message (self, _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = FALSE;
	return result;
}

gboolean
font_manager_archive_manager_compress (FontManagerArchiveManager* self,
                                       gchar** uris,
                                       gint uris_length1,
                                       const gchar* destination,
                                       gboolean use_progress_dialog)
{
	FileRollerDBusService* _tmp0_;
	FileRollerDBusService* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (destination != NULL, FALSE);
	_tmp0_ = font_manager_archive_manager_get_file_roller (self);
	_tmp1_ = _tmp0_;
	_vala_return_val_if_fail (_tmp1_ != NULL, "file_roller != null", FALSE);
	{
		FileRollerDBusService* _tmp2_;
		FileRollerDBusService* _tmp3_;
		_tmp2_ = font_manager_archive_manager_get_file_roller (self);
		_tmp3_ = _tmp2_;
		file_roller_dbus_service_compress (_tmp3_, uris, (gint) _vala_array_length (uris), destination, use_progress_dialog, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		result = TRUE;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		font_manager_archive_manager_post_error_message (self, _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = FALSE;
	return result;
}

gboolean
font_manager_archive_manager_extract (FontManagerArchiveManager* self,
                                      const gchar* archive,
                                      const gchar* destination,
                                      gboolean use_progress_dialog)
{
	FileRollerDBusService* _tmp0_;
	FileRollerDBusService* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (archive != NULL, FALSE);
	g_return_val_if_fail (destination != NULL, FALSE);
	_tmp0_ = font_manager_archive_manager_get_file_roller (self);
	_tmp1_ = _tmp0_;
	_vala_return_val_if_fail (_tmp1_ != NULL, "file_roller != null", FALSE);
	{
		FileRollerDBusService* _tmp2_;
		FileRollerDBusService* _tmp3_;
		_tmp2_ = font_manager_archive_manager_get_file_roller (self);
		_tmp3_ = _tmp2_;
		file_roller_dbus_service_extract (_tmp3_, archive, destination, use_progress_dialog, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		result = TRUE;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		font_manager_archive_manager_post_error_message (self, _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = FALSE;
	return result;
}

gboolean
font_manager_archive_manager_extract_here (FontManagerArchiveManager* self,
                                           const gchar* archive,
                                           gboolean use_progress_dialog)
{
	FileRollerDBusService* _tmp0_;
	FileRollerDBusService* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (archive != NULL, FALSE);
	_tmp0_ = font_manager_archive_manager_get_file_roller (self);
	_tmp1_ = _tmp0_;
	_vala_return_val_if_fail (_tmp1_ != NULL, "file_roller != null", FALSE);
	{
		FileRollerDBusService* _tmp2_;
		FileRollerDBusService* _tmp3_;
		_tmp2_ = font_manager_archive_manager_get_file_roller (self);
		_tmp3_ = _tmp2_;
		file_roller_dbus_service_extract_here (_tmp3_, archive, use_progress_dialog, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		result = TRUE;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		font_manager_archive_manager_post_error_message (self, _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp5_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = FALSE;
	return result;
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

static gboolean
_vala_string_array_contains (const gchar* * stack,
                             gssize stack_length,
                             const const gchar* needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

FontManagerStringSet*
font_manager_archive_manager_get_supported_types (FontManagerArchiveManager* self,
                                                  const gchar* action)
{
	FileRollerDBusService* _tmp0_;
	FileRollerDBusService* _tmp1_;
	FontManagerStringSet* supported_types = NULL;
	FontManagerStringSet* _tmp2_;
	GError* _inner_error0_ = NULL;
	FontManagerStringSet* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (action != NULL, NULL);
	_tmp0_ = font_manager_archive_manager_get_file_roller (self);
	_tmp1_ = _tmp0_;
	_vala_return_val_if_fail (_tmp1_ != NULL, "file_roller != null", NULL);
	_tmp2_ = font_manager_string_set_new ();
	supported_types = _tmp2_;
	{
		GHashTable** array = NULL;
		FileRollerDBusService* _tmp3_;
		FileRollerDBusService* _tmp4_;
		gint _tmp5_ = 0;
		GHashTable** _tmp6_;
		gint array_length1;
		gint _array_size_;
		GHashTable** _tmp7_;
		gint _tmp7__length1;
		_tmp3_ = font_manager_archive_manager_get_file_roller (self);
		_tmp4_ = _tmp3_;
		_tmp6_ = file_roller_dbus_service_get_supported_types (_tmp4_, action, &_tmp5_, &_inner_error0_);
		array = _tmp6_;
		array_length1 = _tmp5_;
		_array_size_ = array_length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp7_ = array;
		_tmp7__length1 = array_length1;
		{
			GHashTable** hashtable_collection = NULL;
			gint hashtable_collection_length1 = 0;
			gint _hashtable_collection_size_ = 0;
			gint hashtable_it = 0;
			hashtable_collection = _tmp7_;
			hashtable_collection_length1 = _tmp7__length1;
			for (hashtable_it = 0; hashtable_it < hashtable_collection_length1; hashtable_it = hashtable_it + 1) {
				GHashTable* _tmp8_;
				GHashTable* hashtable = NULL;
				_tmp8_ = _g_hash_table_ref0 (hashtable_collection[hashtable_it]);
				hashtable = _tmp8_;
				{
					GHashTable* _tmp9_;
					gconstpointer _tmp10_;
					FontManagerStringSet* _tmp11_;
					GHashTable* _tmp12_;
					gconstpointer _tmp13_;
					_tmp9_ = hashtable;
					_tmp10_ = g_hash_table_lookup (_tmp9_, "mime-type");
					if (_vala_string_array_contains (FONT_MANAGER_MIMETYPE_IGNORE_LIST, G_N_ELEMENTS (FONT_MANAGER_MIMETYPE_IGNORE_LIST), (const gchar*) _tmp10_)) {
						_g_hash_table_unref0 (hashtable);
						continue;
					}
					_tmp11_ = supported_types;
					_tmp12_ = hashtable;
					_tmp13_ = g_hash_table_lookup (_tmp12_, "mime-type");
					font_manager_string_set_add (_tmp11_, (const gchar*) _tmp13_);
					_g_hash_table_unref0 (hashtable);
				}
			}
		}
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_hash_table_unref), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_g_object_unref0 (supported_types);
		supported_types = NULL;
		_tmp14_ = e;
		font_manager_archive_manager_post_error_message (self, _tmp14_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (supported_types);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = supported_types;
	return result;
}

FontManagerArchiveManager*
font_manager_archive_manager_construct (GType object_type)
{
	FontManagerArchiveManager * self = NULL;
	self = (FontManagerArchiveManager*) g_object_new (object_type, NULL);
	return self;
}

FontManagerArchiveManager*
font_manager_archive_manager_new (void)
{
	return font_manager_archive_manager_construct (FONT_MANAGER_TYPE_ARCHIVE_MANAGER);
}

static FileRollerDBusService*
font_manager_archive_manager_get_file_roller (FontManagerArchiveManager* self)
{
	FileRollerDBusService* result;
	FileRollerDBusService* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	font_manager_archive_manager_init (self);
	_tmp0_ = self->priv->service;
	result = _tmp0_;
	return result;
}

gboolean
font_manager_archive_manager_get_available (FontManagerArchiveManager* self)
{
	gboolean result;
	FileRollerDBusService* _tmp0_;
	FileRollerDBusService* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = font_manager_archive_manager_get_file_roller (self);
	_tmp1_ = _tmp0_;
	result = _tmp1_ != NULL;
	return result;
}

static void
font_manager_archive_manager_class_init (FontManagerArchiveManagerClass * klass,
                                         gpointer klass_data)
{
	font_manager_archive_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerArchiveManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_archive_manager_get_property;
	G_OBJECT_CLASS (klass)->finalize = font_manager_archive_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_ARCHIVE_MANAGER_AVAILABLE_PROPERTY, font_manager_archive_manager_properties[FONT_MANAGER_ARCHIVE_MANAGER_AVAILABLE_PROPERTY] = g_param_spec_boolean ("available", "available", "available", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	font_manager_archive_manager_signals[FONT_MANAGER_ARCHIVE_MANAGER_PROGRESS_SIGNAL] = g_signal_new ("progress", FONT_MANAGER_TYPE_ARCHIVE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_STRING, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_STRING);
}

static void
font_manager_archive_manager_instance_init (FontManagerArchiveManager * self,
                                            gpointer klass)
{
	self->priv = font_manager_archive_manager_get_instance_private (self);
	self->priv->SERVICE_UNKNOWN_ERROR = 2;
	self->priv->SERVICE_TIMED_OUT = 24;
	self->priv->service = NULL;
}

static void
font_manager_archive_manager_finalize (GObject * obj)
{
	FontManagerArchiveManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_ARCHIVE_MANAGER, FontManagerArchiveManager);
	_g_object_unref0 (self->priv->service);
	G_OBJECT_CLASS (font_manager_archive_manager_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_archive_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerArchiveManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_archive_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerArchiveManager), 0, (GInstanceInitFunc) font_manager_archive_manager_instance_init, NULL };
	GType font_manager_archive_manager_type_id;
	font_manager_archive_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerArchiveManager", &g_define_type_info, 0);
	FontManagerArchiveManager_private_offset = g_type_add_instance_private (font_manager_archive_manager_type_id, sizeof (FontManagerArchiveManagerPrivate));
	return font_manager_archive_manager_type_id;
}

GType
font_manager_archive_manager_get_type (void)
{
	static volatile gsize font_manager_archive_manager_type_id__once = 0;
	if (g_once_init_enter (&font_manager_archive_manager_type_id__once)) {
		GType font_manager_archive_manager_type_id;
		font_manager_archive_manager_type_id = font_manager_archive_manager_get_type_once ();
		g_once_init_leave (&font_manager_archive_manager_type_id__once, font_manager_archive_manager_type_id);
	}
	return font_manager_archive_manager_type_id__once;
}

static void
_vala_font_manager_archive_manager_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	FontManagerArchiveManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_ARCHIVE_MANAGER, FontManagerArchiveManager);
	switch (property_id) {
		case FONT_MANAGER_ARCHIVE_MANAGER_AVAILABLE_PROPERTY:
		g_value_set_boolean (value, font_manager_archive_manager_get_available (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

