/* Categories.c generated by valac 0.56.14, the Vala compiler
 * generated from Categories.vala, do not modify */

/* Categories.vala
 *
 * Copyright (C) 2009-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "font-manager.h"
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <sqlite3.h>

#define DEFAULT_LANGUAGE_FILTER_COMMENT _ ("Filter based on supported orthographies")
#define FONT_MANAGER_SELECT_FROM_FONTS "SELECT DISTINCT family, description FROM Fonts"
#define FONT_MANAGER_SELECT_FROM_METADATA_WHERE "SELECT DISTINCT Fonts.family, Fonts.description FROM Fonts JOIN Metada" \
"ta USING (filepath, findex) WHERE"
#define FONT_MANAGER_SELECT_FROM_PANOSE_WHERE "SELECT DISTINCT Fonts.family, Fonts.description FROM Fonts JOIN Panose" \
" USING (filepath, findex) WHERE"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	FONT_MANAGER_CATEGORY_INDEX_ALL,
	FONT_MANAGER_CATEGORY_INDEX_SYSTEM,
	FONT_MANAGER_CATEGORY_INDEX_USER,
	FONT_MANAGER_CATEGORY_INDEX_PANOSE,
	FONT_MANAGER_CATEGORY_INDEX_WIDTH,
	FONT_MANAGER_CATEGORY_INDEX_WEIGHT,
	FONT_MANAGER_CATEGORY_INDEX_SLANT,
	FONT_MANAGER_CATEGORY_INDEX_SPACING,
	FONT_MANAGER_CATEGORY_INDEX_LICENSE,
	FONT_MANAGER_CATEGORY_INDEX_VENDOR,
	FONT_MANAGER_CATEGORY_INDEX_FILETYPE,
	FONT_MANAGER_CATEGORY_INDEX_UNSORTED,
	FONT_MANAGER_CATEGORY_INDEX_DISABLED,
	FONT_MANAGER_CATEGORY_INDEX_LANGUAGE,
	FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES
} FontManagerCategoryIndex;

#define FONT_MANAGER_TYPE_CATEGORY_INDEX (font_manager_category_index_get_type ())
typedef enum  {
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT,
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_ICON,
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME,
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT,
	FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS
} FontManagerCategoryModelColumn;

#define FONT_MANAGER_TYPE_CATEGORY_MODEL_COLUMN (font_manager_category_model_column_get_type ())

#define FONT_MANAGER_TYPE_CATEGORY_MODEL (font_manager_category_model_get_type ())
#define FONT_MANAGER_CATEGORY_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel))
#define FONT_MANAGER_CATEGORY_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModelClass))
#define FONT_MANAGER_IS_CATEGORY_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY_MODEL))
#define FONT_MANAGER_IS_CATEGORY_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY_MODEL))
#define FONT_MANAGER_CATEGORY_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModelClass))

typedef struct _FontManagerCategoryModel FontManagerCategoryModel;
typedef struct _FontManagerCategoryModelClass FontManagerCategoryModelClass;
typedef struct _FontManagerCategoryModelPrivate FontManagerCategoryModelPrivate;

#define FONT_MANAGER_TYPE_CACHEABLE (font_manager_cacheable_get_type ())
#define FONT_MANAGER_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheable))
#define FONT_MANAGER_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheableClass))
#define FONT_MANAGER_IS_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CACHEABLE))
#define FONT_MANAGER_IS_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CACHEABLE))
#define FONT_MANAGER_CACHEABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheableClass))

typedef struct _FontManagerCacheable FontManagerCacheable;
typedef struct _FontManagerCacheableClass FontManagerCacheableClass;

#define FONT_MANAGER_TYPE_FILTER (font_manager_filter_get_type ())
#define FONT_MANAGER_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FILTER, FontManagerFilter))
#define FONT_MANAGER_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FILTER, FontManagerFilterClass))
#define FONT_MANAGER_IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FILTER))
#define FONT_MANAGER_IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FILTER))
#define FONT_MANAGER_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FILTER, FontManagerFilterClass))

typedef struct _FontManagerFilter FontManagerFilter;
typedef struct _FontManagerFilterClass FontManagerFilterClass;

#define FONT_MANAGER_TYPE_CATEGORY (font_manager_category_get_type ())
#define FONT_MANAGER_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory))
#define FONT_MANAGER_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategoryClass))
#define FONT_MANAGER_IS_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY))
#define FONT_MANAGER_IS_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY))
#define FONT_MANAGER_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategoryClass))

typedef struct _FontManagerCategory FontManagerCategory;
typedef struct _FontManagerCategoryClass FontManagerCategoryClass;
enum  {
	FONT_MANAGER_CATEGORY_MODEL_0_PROPERTY,
	FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY,
	FONT_MANAGER_CATEGORY_MODEL_NUM_PROPERTIES
};
static GParamSpec* font_manager_category_model_properties[FONT_MANAGER_CATEGORY_MODEL_NUM_PROPERTIES];
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define FONT_MANAGER_TYPE_LANGUAGE_FILTER (font_manager_language_filter_get_type ())
#define FONT_MANAGER_LANGUAGE_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter))
#define FONT_MANAGER_LANGUAGE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilterClass))
#define FONT_MANAGER_IS_LANGUAGE_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER))
#define FONT_MANAGER_IS_LANGUAGE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER))
#define FONT_MANAGER_LANGUAGE_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilterClass))

typedef struct _FontManagerLanguageFilter FontManagerLanguageFilter;
typedef struct _FontManagerLanguageFilterClass FontManagerLanguageFilterClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FONT_MANAGER_TYPE_BASE_ORTHOGRAPHY_DATA (font_manager_base_orthography_data_get_type ())
typedef struct _FontManagerBaseOrthographyData FontManagerBaseOrthographyData;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

#define FONT_MANAGER_TYPE_DISABLED (font_manager_disabled_get_type ())
#define FONT_MANAGER_DISABLED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabled))
#define FONT_MANAGER_DISABLED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabledClass))
#define FONT_MANAGER_IS_DISABLED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DISABLED))
#define FONT_MANAGER_IS_DISABLED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DISABLED))
#define FONT_MANAGER_DISABLED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DISABLED, FontManagerDisabledClass))

typedef struct _FontManagerDisabled FontManagerDisabled;
typedef struct _FontManagerDisabledClass FontManagerDisabledClass;
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block6Data Block6Data;

#define FONT_MANAGER_TYPE_APPLICATION (font_manager_application_get_type ())
#define FONT_MANAGER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplication))
#define FONT_MANAGER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))
#define FONT_MANAGER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))

typedef struct _FontManagerApplication FontManagerApplication;
typedef struct _FontManagerApplicationClass FontManagerApplicationClass;
enum  {
	FONT_MANAGER_CATEGORY_MODEL_UPDATE_BEGIN_SIGNAL,
	FONT_MANAGER_CATEGORY_MODEL_UPDATE_COMPLETE_SIGNAL,
	FONT_MANAGER_CATEGORY_MODEL_NUM_SIGNALS
};
static guint font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_NUM_SIGNALS] = {0};

#define FONT_MANAGER_TYPE_BASE_TREE_VIEW (font_manager_base_tree_view_get_type ())
#define FONT_MANAGER_BASE_TREE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeView))
#define FONT_MANAGER_BASE_TREE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeViewClass))
#define FONT_MANAGER_IS_BASE_TREE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW))
#define FONT_MANAGER_IS_BASE_TREE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_BASE_TREE_VIEW))
#define FONT_MANAGER_BASE_TREE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeViewClass))

typedef struct _FontManagerBaseTreeView FontManagerBaseTreeView;
typedef struct _FontManagerBaseTreeViewClass FontManagerBaseTreeViewClass;
typedef struct _FontManagerBaseTreeViewPrivate FontManagerBaseTreeViewPrivate;

#define FONT_MANAGER_TYPE_CATEGORY_TREE (font_manager_category_tree_get_type ())
#define FONT_MANAGER_CATEGORY_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree))
#define FONT_MANAGER_CATEGORY_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTreeClass))
#define FONT_MANAGER_IS_CATEGORY_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY_TREE))
#define FONT_MANAGER_IS_CATEGORY_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY_TREE))
#define FONT_MANAGER_CATEGORY_TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTreeClass))

typedef struct _FontManagerCategoryTree FontManagerCategoryTree;
typedef struct _FontManagerCategoryTreeClass FontManagerCategoryTreeClass;
typedef struct _FontManagerCategoryTreePrivate FontManagerCategoryTreePrivate;

#define FONT_MANAGER_TYPE_CELL_RENDERER_PILL (font_manager_cell_renderer_pill_get_type ())
#define FONT_MANAGER_CELL_RENDERER_PILL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_PILL, FontManagerCellRendererPill))
#define FONT_MANAGER_CELL_RENDERER_PILL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CELL_RENDERER_PILL, FontManagerCellRendererPillClass))
#define FONT_MANAGER_IS_CELL_RENDERER_PILL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_PILL))
#define FONT_MANAGER_IS_CELL_RENDERER_PILL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CELL_RENDERER_PILL))
#define FONT_MANAGER_CELL_RENDERER_PILL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_PILL, FontManagerCellRendererPillClass))

typedef struct _FontManagerCellRendererPill FontManagerCellRendererPill;
typedef struct _FontManagerCellRendererPillClass FontManagerCellRendererPillClass;

#define FONT_MANAGER_TYPE_CELL_RENDERER_COUNT (font_manager_cell_renderer_count_get_type ())
#define FONT_MANAGER_CELL_RENDERER_COUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT, FontManagerCellRendererCount))
#define FONT_MANAGER_CELL_RENDERER_COUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT, FontManagerCellRendererCountClass))
#define FONT_MANAGER_IS_CELL_RENDERER_COUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT))
#define FONT_MANAGER_IS_CELL_RENDERER_COUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT))
#define FONT_MANAGER_CELL_RENDERER_COUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CELL_RENDERER_COUNT, FontManagerCellRendererCountClass))

typedef struct _FontManagerCellRendererCount FontManagerCellRendererCount;
typedef struct _FontManagerCellRendererCountClass FontManagerCellRendererCountClass;
enum  {
	FONT_MANAGER_CATEGORY_TREE_0_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY,
	FONT_MANAGER_CATEGORY_TREE_NUM_PROPERTIES
};
static GParamSpec* font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_DATABASE_PROXY (font_manager_database_proxy_get_type ())
#define FONT_MANAGER_DATABASE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DATABASE_PROXY, FontManagerDatabaseProxy))
#define FONT_MANAGER_DATABASE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DATABASE_PROXY, FontManagerDatabaseProxyClass))
#define FONT_MANAGER_IS_DATABASE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DATABASE_PROXY))
#define FONT_MANAGER_IS_DATABASE_PROXY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DATABASE_PROXY))
#define FONT_MANAGER_DATABASE_PROXY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DATABASE_PROXY, FontManagerDatabaseProxyClass))

typedef struct _FontManagerDatabaseProxy FontManagerDatabaseProxy;
typedef struct _FontManagerDatabaseProxyClass FontManagerDatabaseProxyClass;
typedef struct _Block7Data Block7Data;
enum  {
	FONT_MANAGER_CATEGORY_TREE_CHANGED_SIGNAL,
	FONT_MANAGER_CATEGORY_TREE_SELECTION_CHANGED_SIGNAL,
	FONT_MANAGER_CATEGORY_TREE_UPDATE_COMPLETE_SIGNAL,
	FONT_MANAGER_CATEGORY_TREE_NUM_SIGNALS
};
static guint font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_NUM_SIGNALS] = {0};

#define FONT_MANAGER_TYPE_FILTER_DATA (font_manager_filter_data_get_type ())
typedef struct _FontManagerFilterData FontManagerFilterData;

#define FONT_MANAGER_TYPE_USER_FONTS (font_manager_user_fonts_get_type ())
#define FONT_MANAGER_USER_FONTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFonts))
#define FONT_MANAGER_USER_FONTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFontsClass))
#define FONT_MANAGER_IS_USER_FONTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_USER_FONTS))
#define FONT_MANAGER_IS_USER_FONTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_USER_FONTS))
#define FONT_MANAGER_USER_FONTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_USER_FONTS, FontManagerUserFontsClass))

typedef struct _FontManagerUserFonts FontManagerUserFonts;
typedef struct _FontManagerUserFontsClass FontManagerUserFontsClass;

#define FONT_MANAGER_TYPE_UNSORTED (font_manager_unsorted_get_type ())
#define FONT_MANAGER_UNSORTED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsorted))
#define FONT_MANAGER_UNSORTED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsortedClass))
#define FONT_MANAGER_IS_UNSORTED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_UNSORTED))
#define FONT_MANAGER_IS_UNSORTED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_UNSORTED))
#define FONT_MANAGER_UNSORTED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_UNSORTED, FontManagerUnsortedClass))

typedef struct _FontManagerUnsorted FontManagerUnsorted;
typedef struct _FontManagerUnsortedClass FontManagerUnsortedClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerCategoryModel {
	GObject parent_instance;
	FontManagerCategoryModelPrivate * priv;
};

struct _FontManagerCategoryModelClass {
	GObjectClass parent_class;
};

struct _FontManagerCategoryModelPrivate {
	GPtrArray* _categories;
	gint stamp;
	gchar* language_filter_tooltip;
};

struct _FontManagerBaseOrthographyData {
	gchar* name;
	gchar* native;
};

struct _Block5Data {
	int _ref_count_;
	FontManagerCategoryModel* self;
	FontManagerReject* reject;
	FontManagerDisabled* disabled;
};

struct _Block6Data {
	int _ref_count_;
	Block5Data * _data5_;
	FontManagerCategory* cat;
};

struct _FontManagerBaseTreeView {
	GtkTreeView parent_instance;
	FontManagerBaseTreeViewPrivate * priv;
};

struct _FontManagerBaseTreeViewClass {
	GtkTreeViewClass parent_class;
	gboolean (*show_context_menu) (FontManagerBaseTreeView* self, GdkEventButton* event);
};

struct _FontManagerCategoryTree {
	FontManagerBaseTreeView parent_instance;
	FontManagerCategoryTreePrivate * priv;
};

struct _FontManagerCategoryTreeClass {
	FontManagerBaseTreeViewClass parent_class;
};

struct _FontManagerCategoryTreePrivate {
	gboolean _update_in_progress;
	gchar* _selected_iter;
	FontManagerCategory* _selected_filter;
	FontManagerLanguageFilter* _language_filter;
	guint* change_timeout;
	gboolean refresh_required;
	GtkCellRendererText* renderer;
	FontManagerCellRendererCount* count_renderer;
	GtkCellRendererPixbuf* pixbuf_renderer;
	FontManagerCategoryModel* _model_;
};

struct _Block7Data {
	int _ref_count_;
	FontManagerCategoryTree* self;
	FontManagerDatabaseProxy* db;
};

struct _FontManagerFilterData {
	gint index;
	gchar* name;
	gchar* comment;
	gchar* column;
};

static gint FontManagerCategoryModel_private_offset;
static gpointer font_manager_category_model_parent_class = NULL;
static GtkTreeModelIface * font_manager_category_model_gtk_tree_model_parent_iface = NULL;
static gint FontManagerCategoryTree_private_offset;
static gpointer font_manager_category_tree_parent_class = NULL;

VALA_EXTERN GType font_manager_category_index_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType font_manager_category_model_column_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType font_manager_category_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategoryModel, g_object_unref)
VALA_EXTERN GType font_manager_cacheable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCacheable, g_object_unref)
VALA_EXTERN GType font_manager_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFilter, g_object_unref)
VALA_EXTERN GType font_manager_category_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategory, g_object_unref)
static gboolean font_manager_category_model_invalid_iter (FontManagerCategoryModel* self,
                                                   GtkTreeIter* iter);
static void font_manager_category_model_valid_iter (FontManagerCategoryModel* self,
                                             GtkTreeIter* result);
static void font_manager_category_model_update_language_filter_tooltip (FontManagerCategoryModel* self);
VALA_EXTERN GType font_manager_language_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerLanguageFilter, g_object_unref)
VALA_EXTERN GPtrArray* font_manager_category_model_get_categories (FontManagerCategoryModel* self);
VALA_EXTERN gint font_manager_filter_get_size (FontManagerFilter* self);
VALA_EXTERN FontManagerStringSet* font_manager_language_filter_get_selected (FontManagerLanguageFilter* self);
VALA_EXTERN GType font_manager_base_orthography_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FontManagerBaseOrthographyData* font_manager_base_orthography_data_dup (const FontManagerBaseOrthographyData* self);
VALA_EXTERN void font_manager_base_orthography_data_free (FontManagerBaseOrthographyData* self);
VALA_EXTERN void font_manager_base_orthography_data_copy (const FontManagerBaseOrthographyData* self,
                                              FontManagerBaseOrthographyData* dest);
VALA_EXTERN void font_manager_base_orthography_data_destroy (FontManagerBaseOrthographyData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (FontManagerBaseOrthographyData, font_manager_base_orthography_data_destroy)
static GtkTreeModelFlags font_manager_category_model_real_get_flags (GtkTreeModel* base);
static gint font_manager_category_model_real_get_n_columns (GtkTreeModel* base);
static GType font_manager_category_model_real_get_column_type (GtkTreeModel* base,
                                                        gint index);
static gboolean font_manager_category_model_real_get_iter (GtkTreeModel* base,
                                                    GtkTreeIter* iter,
                                                    GtkTreePath* path);
static gint* _vala_array_dup1 (gint* self,
                        gssize length);
static GtkTreePath* font_manager_category_model_real_get_path (GtkTreeModel* base,
                                                        GtkTreeIter* iter);
static void font_manager_category_model_real_get_value (GtkTreeModel* base,
                                                 GtkTreeIter* iter,
                                                 gint column,
                                                 GValue* val);
VALA_EXTERN GPtrArray* font_manager_category_get_children (FontManagerCategory* self);
VALA_EXTERN gchar* font_manager_filter_get_name (FontManagerFilter* self);
VALA_EXTERN gchar* font_manager_filter_get_icon (FontManagerFilter* self);
VALA_EXTERN gint font_manager_filter_get_index (FontManagerFilter* self);
VALA_EXTERN gchar* font_manager_filter_get_comment (FontManagerFilter* self);
static gboolean font_manager_category_model_real_iter_next (GtkTreeModel* base,
                                                     GtkTreeIter* iter);
static gboolean font_manager_category_model_real_iter_previous (GtkTreeModel* base,
                                                         GtkTreeIter* iter);
static gboolean font_manager_category_model_real_iter_children (GtkTreeModel* base,
                                                         GtkTreeIter* iter,
                                                         GtkTreeIter* parent);
static gboolean font_manager_category_model_real_iter_has_child (GtkTreeModel* base,
                                                          GtkTreeIter* iter);
static gint font_manager_category_model_real_iter_n_children (GtkTreeModel* base,
                                                       GtkTreeIter* iter);
static gboolean font_manager_category_model_real_iter_nth_child (GtkTreeModel* base,
                                                          GtkTreeIter* iter,
                                                          GtkTreeIter* parent,
                                                          gint n);
static gboolean font_manager_category_model_real_iter_parent (GtkTreeModel* base,
                                                       GtkTreeIter* iter,
                                                       GtkTreeIter* child);
static void font_manager_category_model_emit_row_changed_signal (FontManagerCategoryModel* self,
                                                          gint index);
static void _vala_GtkTreePath_free (GtkTreePath* self);
VALA_EXTERN void font_manager_category_model_update (FontManagerCategoryModel* self);
VALA_EXTERN GType font_manager_disabled_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerDisabled, g_object_unref)
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_category_model_set_categories (FontManagerCategoryModel* self,
                                                 GPtrArray* value);
VALA_EXTERN GPtrArray* font_manager_get_default_categories (FontManagerDatabase* db);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_category_update (FontManagerCategory* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void font_manager_category_update_finish (FontManagerCategory* self,
                                          GAsyncResult* _res_);
static void _____lambda40_ (Block6Data* _data6_,
                     GObject* obj,
                     GAsyncResult* res);
static void ______lambda40__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static void __lambda41_ (FontManagerCategoryModel* self);
static void ___lambda41__font_manager_language_filter_selections_changed (FontManagerLanguageFilter* _sender,
                                                                   gpointer self);
VALA_EXTERN GType font_manager_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerApplication, g_object_unref)
VALA_EXTERN guint font_manager_application_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
VALA_EXTERN FontManagerApplication* font_manager_get_default_application (void);
VALA_EXTERN FontManagerReject* font_manager_application_get_reject (FontManagerApplication* self);
VALA_EXTERN void font_manager_disabled_update (FontManagerDisabled* self,
                                   FontManagerStringSet* reject,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void font_manager_disabled_update_finish (FontManagerDisabled* self,
                                          GAsyncResult* _res_);
static void __lambda42_ (Block5Data* _data5_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda42__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda43_ (Block5Data* _data5_);
static void __lambda44_ (Block5Data* _data5_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda44__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ___lambda43__font_manager_selections_changed (FontManagerSelections* _sender,
                                                   gpointer self);
VALA_EXTERN FontManagerCategoryModel* font_manager_category_model_new (void);
VALA_EXTERN FontManagerCategoryModel* font_manager_category_model_construct (GType object_type);
static GObject * font_manager_category_model_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void font_manager_category_model_finalize (GObject * obj);
static GType font_manager_category_model_get_type_once (void);
static void _vala_font_manager_category_model_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_font_manager_category_model_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
VALA_EXTERN GType font_manager_base_tree_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerBaseTreeView, g_object_unref)
VALA_EXTERN GType font_manager_category_tree_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategoryTree, g_object_unref)
VALA_EXTERN GType font_manager_cell_renderer_pill_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCellRendererPill, g_object_unref)
VALA_EXTERN GType font_manager_cell_renderer_count_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCellRendererCount, g_object_unref)
static void font_manager_category_tree_connect_signals (FontManagerCategoryTree* self);
VALA_EXTERN GType font_manager_database_proxy_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerDatabaseProxy, g_object_unref)
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void font_manager_category_tree_on_selection_changed (FontManagerCategoryTree* self,
                                                      GtkTreeSelection* selection);
static void _font_manager_category_tree_on_selection_changed_gtk_tree_selection_changed (GtkTreeSelection* _sender,
                                                                                  gpointer self);
static void __lambda49_ (FontManagerCategoryTree* self);
static void __lambda50_ (FontManagerCategoryTree* self);
VALA_EXTERN void font_manager_category_tree_set_update_in_progress (FontManagerCategoryTree* self,
                                                        gboolean value);
static void ___lambda50__font_manager_category_model_update_begin (FontManagerCategoryModel* _sender,
                                                            gpointer self);
static void __lambda51_ (FontManagerCategoryTree* self);
static void ___lambda51__font_manager_category_model_update_complete (FontManagerCategoryModel* _sender,
                                                               gpointer self);
static void __lambda52_ (FontManagerCategoryTree* self,
                  GtkTreePath* path,
                  GtkTreeIter* iter);
VALA_EXTERN const gchar* font_manager_category_tree_get_selected_iter (FontManagerCategoryTree* self);
static gboolean ____lambda53_ (FontManagerCategoryTree* self);
static gboolean _____lambda53__gsource_func (gpointer self);
static guint* _uint_dup (guint* self);
static void ___lambda52__gtk_tree_model_row_changed (GtkTreeModel* _sender,
                                              GtkTreePath* path,
                                              GtkTreeIter* iter,
                                              gpointer self);
static void ___lambda49__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN FontManagerDatabaseProxy* font_manager_application_get_db (FontManagerApplication* self);
static void __lambda57_ (FontManagerCategoryTree* self);
static void ___lambda57__font_manager_database_proxy_update_started (FontManagerDatabaseProxy* _sender,
                                                              gpointer self);
static void __lambda58_ (Block7Data* _data7_);
VALA_EXTERN gboolean font_manager_database_proxy_ready (FontManagerDatabaseProxy* self,
                                            FontManagerDatabaseType type);
VALA_EXTERN void font_manager_category_tree_update (FontManagerCategoryTree* self);
static void ___lambda58__font_manager_database_proxy_status_changed (FontManagerDatabaseProxy* _sender,
                                                              gpointer self);
static void __lambda59_ (FontManagerCategoryTree* self);
static void ___lambda59__font_manager_database_proxy_update_complete (FontManagerDatabaseProxy* _sender,
                                                               gpointer self);
VALA_EXTERN void font_manager_category_tree_select_first_row (FontManagerCategoryTree* self);
VALA_EXTERN FontManagerCategory* font_manager_category_tree_get_selected_filter (FontManagerCategoryTree* self);
static void font_manager_category_tree_count_cell_data_func (FontManagerCategoryTree* self,
                                                      GtkTreeViewColumn* layout,
                                                      GtkCellRenderer* cell,
                                                      GtkTreeModel* model,
                                                      GtkTreeIter* treeiter);
static void font_manager_category_tree_pixbuf_cell_data_func (FontManagerCategoryTree* self,
                                                       GtkTreeViewColumn* layout,
                                                       GtkCellRenderer* cell,
                                                       GtkTreeModel* model,
                                                       GtkTreeIter* treeiter);
VALA_EXTERN void font_manager_category_tree_set_selected_filter (FontManagerCategoryTree* self,
                                                     FontManagerCategory* value);
VALA_EXTERN void font_manager_category_tree_set_selected_iter (FontManagerCategoryTree* self,
                                                   const gchar* value);
static gboolean __lambda45_ (FontManagerCategoryTree* self);
VALA_EXTERN FontManagerLanguageFilter* font_manager_category_tree_get_language_filter (FontManagerCategoryTree* self);
VALA_EXTERN void font_manager_category_tree_set_language_filter (FontManagerCategoryTree* self,
                                                     FontManagerLanguageFilter* value);
static void ___lambda46_ (FontManagerCategoryTree* self);
static void ____lambda46__font_manager_language_filter_selections_changed (FontManagerLanguageFilter* _sender,
                                                                    gpointer self);
static gboolean ___lambda45__gsource_func (gpointer self);
VALA_EXTERN gboolean font_manager_filter_get_requires_update (FontManagerFilter* self);
static gboolean ___lambda47_ (FontManagerCategoryTree* self);
static gboolean ____lambda47__gsource_func (gpointer self);
static void ____lambda48_ (FontManagerCategoryTree* self,
                    GObject* obj,
                    GAsyncResult* res);
VALA_EXTERN void font_manager_filter_set_requires_update (FontManagerFilter* self,
                                              gboolean value);
static void _____lambda48__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN FontManagerCategoryTree* font_manager_category_tree_new (void);
VALA_EXTERN FontManagerCategoryTree* font_manager_category_tree_construct (GType object_type);
VALA_EXTERN FontManagerBaseTreeView* font_manager_base_tree_view_new (void);
VALA_EXTERN FontManagerBaseTreeView* font_manager_base_tree_view_construct (GType object_type);
VALA_EXTERN gboolean font_manager_category_tree_get_update_in_progress (FontManagerCategoryTree* self);
static GObject * font_manager_category_tree_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
VALA_EXTERN FontManagerCellRendererCount* font_manager_cell_renderer_count_new (void);
VALA_EXTERN FontManagerCellRendererCount* font_manager_cell_renderer_count_construct (GType object_type);
static void _font_manager_category_tree_pixbuf_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                                GtkCellRenderer* cell,
                                                                                GtkTreeModel* tree_model,
                                                                                GtkTreeIter* iter,
                                                                                gpointer self);
static void _font_manager_category_tree_count_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                               GtkCellRenderer* cell,
                                                                               GtkTreeModel* tree_model,
                                                                               GtkTreeIter* iter,
                                                                               gpointer self);
static gboolean _font_manager_category_tree___lambda60_ (FontManagerCategoryTree* self,
                                                  GtkTreeView* t,
                                                  GtkTreeIter* i,
                                                  GtkTreePath* p);
static gboolean __font_manager_category_tree___lambda60__gtk_tree_view_test_expand_row (GtkTreeView* _sender,
                                                                                 GtkTreeIter* iter,
                                                                                 GtkTreePath* path,
                                                                                 gpointer self);
static void font_manager_category_tree_finalize (GObject * obj);
static GType font_manager_category_tree_get_type_once (void);
static void _vala_font_manager_category_tree_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_font_manager_category_tree_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
VALA_EXTERN GType font_manager_filter_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FontManagerFilterData* font_manager_filter_data_dup (const FontManagerFilterData* self);
VALA_EXTERN void font_manager_filter_data_free (FontManagerFilterData* self);
VALA_EXTERN void font_manager_filter_data_copy (const FontManagerFilterData* self,
                                    FontManagerFilterData* dest);
VALA_EXTERN void font_manager_filter_data_destroy (FontManagerFilterData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (FontManagerFilterData, font_manager_filter_data_destroy)
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN FontManagerCategory* font_manager_category_new (const gchar* name,
                                                const gchar* comment,
                                                const gchar* icon,
                                                const gchar* sql,
                                                gint index);
VALA_EXTERN FontManagerCategory* font_manager_category_construct (GType object_type,
                                                      const gchar* name,
                                                      const gchar* comment,
                                                      const gchar* icon,
                                                      const gchar* sql,
                                                      gint index);
VALA_EXTERN FontManagerUserFonts* font_manager_user_fonts_new (void);
VALA_EXTERN FontManagerUserFonts* font_manager_user_fonts_construct (GType object_type);
VALA_EXTERN GType font_manager_user_fonts_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerUserFonts, g_object_unref)
VALA_EXTERN FontManagerCategory* font_manager_construct_panose_filter (void);
VALA_EXTERN FontManagerCategory* font_manager_construct_attribute_filter (FontManagerDatabase* db,
                                                              FontManagerFilterData* data);
VALA_EXTERN FontManagerCategory* font_manager_construct_info_filter (FontManagerDatabase* db,
                                                         FontManagerFilterData* data);
VALA_EXTERN FontManagerUnsorted* font_manager_unsorted_new (void);
VALA_EXTERN FontManagerUnsorted* font_manager_unsorted_construct (GType object_type);
VALA_EXTERN GType font_manager_unsorted_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerUnsorted, g_object_unref)
VALA_EXTERN FontManagerDisabled* font_manager_disabled_new (void);
VALA_EXTERN FontManagerDisabled* font_manager_disabled_construct (GType object_type);
VALA_EXTERN FontManagerLanguageFilter* font_manager_language_filter_new (void);
VALA_EXTERN FontManagerLanguageFilter* font_manager_language_filter_construct (GType object_type);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const FontManagerBaseOrthographyData FONT_MANAGER_Orthographies[132];
const FontManagerFilterData FONT_MANAGER_attributes[4] = {{(gint) FONT_MANAGER_CATEGORY_INDEX_WIDTH, N_ ("Width"), N_ ("Grouped by font width"), "width"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_WEIGHT, N_ ("Weight"), N_ ("Grouped by font weight"), "weight"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_SLANT, N_ ("Slant"), N_ ("Grouped by font angle"), "slant"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_SPACING, N_ ("Spacing"), N_ ("Grouped by font spacing"), "spacing"}};
const FontManagerFilterData FONT_MANAGER_metadata[3] = {{(gint) FONT_MANAGER_CATEGORY_INDEX_LICENSE, N_ ("License"), N_ ("Grouped by license type"), "license-type"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_VENDOR, N_ ("Vendor"), N_ ("Grouped by vendor"), "vendor"}, {(gint) FONT_MANAGER_CATEGORY_INDEX_FILETYPE, N_ ("Filetype"), N_ ("Grouped by filetype"), "filetype"}};

 G_GNUC_NO_INLINE static GType
font_manager_category_index_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_CATEGORY_INDEX_ALL, "FONT_MANAGER_CATEGORY_INDEX_ALL", "all"}, {FONT_MANAGER_CATEGORY_INDEX_SYSTEM, "FONT_MANAGER_CATEGORY_INDEX_SYSTEM", "system"}, {FONT_MANAGER_CATEGORY_INDEX_USER, "FONT_MANAGER_CATEGORY_INDEX_USER", "user"}, {FONT_MANAGER_CATEGORY_INDEX_PANOSE, "FONT_MANAGER_CATEGORY_INDEX_PANOSE", "panose"}, {FONT_MANAGER_CATEGORY_INDEX_WIDTH, "FONT_MANAGER_CATEGORY_INDEX_WIDTH", "width"}, {FONT_MANAGER_CATEGORY_INDEX_WEIGHT, "FONT_MANAGER_CATEGORY_INDEX_WEIGHT", "weight"}, {FONT_MANAGER_CATEGORY_INDEX_SLANT, "FONT_MANAGER_CATEGORY_INDEX_SLANT", "slant"}, {FONT_MANAGER_CATEGORY_INDEX_SPACING, "FONT_MANAGER_CATEGORY_INDEX_SPACING", "spacing"}, {FONT_MANAGER_CATEGORY_INDEX_LICENSE, "FONT_MANAGER_CATEGORY_INDEX_LICENSE", "license"}, {FONT_MANAGER_CATEGORY_INDEX_VENDOR, "FONT_MANAGER_CATEGORY_INDEX_VENDOR", "vendor"}, {FONT_MANAGER_CATEGORY_INDEX_FILETYPE, "FONT_MANAGER_CATEGORY_INDEX_FILETYPE", "filetype"}, {FONT_MANAGER_CATEGORY_INDEX_UNSORTED, "FONT_MANAGER_CATEGORY_INDEX_UNSORTED", "unsorted"}, {FONT_MANAGER_CATEGORY_INDEX_DISABLED, "FONT_MANAGER_CATEGORY_INDEX_DISABLED", "disabled"}, {FONT_MANAGER_CATEGORY_INDEX_LANGUAGE, "FONT_MANAGER_CATEGORY_INDEX_LANGUAGE", "language"}, {FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES, "FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES", "n-categories"}, {0, NULL, NULL}};
	GType font_manager_category_index_type_id;
	font_manager_category_index_type_id = g_enum_register_static ("FontManagerCategoryIndex", values);
	return font_manager_category_index_type_id;
}

GType
font_manager_category_index_get_type (void)
{
	static volatile gsize font_manager_category_index_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_index_type_id__once)) {
		GType font_manager_category_index_type_id;
		font_manager_category_index_type_id = font_manager_category_index_get_type_once ();
		g_once_init_leave (&font_manager_category_index_type_id__once, font_manager_category_index_type_id);
	}
	return font_manager_category_index_type_id__once;
}

 G_GNUC_NO_INLINE static GType
font_manager_category_model_column_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT", "object"}, {FONT_MANAGER_CATEGORY_MODEL_COLUMN_ICON, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_ICON", "icon"}, {FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME", "name"}, {FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT", "comment"}, {FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS, "FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType font_manager_category_model_column_type_id;
	font_manager_category_model_column_type_id = g_enum_register_static ("FontManagerCategoryModelColumn", values);
	return font_manager_category_model_column_type_id;
}

GType
font_manager_category_model_column_get_type (void)
{
	static volatile gsize font_manager_category_model_column_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_model_column_type_id__once)) {
		GType font_manager_category_model_column_type_id;
		font_manager_category_model_column_type_id = font_manager_category_model_column_get_type_once ();
		g_once_init_leave (&font_manager_category_model_column_type_id__once, font_manager_category_model_column_type_id);
	}
	return font_manager_category_model_column_type_id__once;
}

static inline gpointer
font_manager_category_model_get_instance_private (FontManagerCategoryModel* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerCategoryModel_private_offset);
}

static gboolean
font_manager_category_model_invalid_iter (FontManagerCategoryModel* self,
                                          GtkTreeIter* iter)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	(*iter).stamp = 0;
	result = FALSE;
	return result;
}

static void
font_manager_category_model_valid_iter (FontManagerCategoryModel* self,
                                        GtkTreeIter* result)
{
	gint none = 0;
	GtkTreeIter iter = {0};
	void* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	none = -1;
	_tmp0_ = GINT_TO_POINTER (none);
	memset (&_tmp1_, 0, sizeof (GtkTreeIter));
	_tmp1_.stamp = self->priv->stamp;
	_tmp1_.user_data2 = _tmp0_;
	iter = _tmp1_;
	*result = iter;
	return;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
font_manager_category_model_update_language_filter_tooltip (FontManagerCategoryModel* self)
{
	FontManagerLanguageFilter* filter = NULL;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	FontManagerLanguageFilter* _tmp2_;
	FontManagerLanguageFilter* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GString* builder = NULL;
	GString* _tmp7_;
	FontManagerLanguageFilter* _tmp8_;
	FontManagerStringSet* _tmp9_;
	FontManagerStringSet* _tmp10_;
	GString* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_categories;
	_tmp1_ = g_ptr_array_index (_tmp0_, (guint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((FontManagerCategory*) _tmp1_, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter));
	filter = _tmp2_;
	_tmp3_ = filter;
	_tmp4_ = font_manager_filter_get_size ((FontManagerFilter*) _tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == 0) {
		gchar* _tmp6_;
		_tmp6_ = g_strdup (DEFAULT_LANGUAGE_FILTER_COMMENT);
		_g_free0 (self->priv->language_filter_tooltip);
		self->priv->language_filter_tooltip = _tmp6_;
		_g_object_unref0 (filter);
		return;
	}
	_tmp7_ = g_string_new ("");
	builder = _tmp7_;
	_tmp8_ = filter;
	_tmp9_ = font_manager_language_filter_get_selected (_tmp8_);
	_tmp10_ = _tmp9_;
	font_manager_string_set_sort (_tmp10_, (GCompareFunc) font_manager_natural_sort);
	{
		FontManagerStringSet* _lang_list = NULL;
		FontManagerLanguageFilter* _tmp11_;
		FontManagerStringSet* _tmp12_;
		FontManagerStringSet* _tmp13_;
		guint _lang_size = 0U;
		FontManagerStringSet* _tmp14_;
		guint _tmp15_;
		guint _tmp16_;
		gint _lang_index = 0;
		_tmp11_ = filter;
		_tmp12_ = font_manager_language_filter_get_selected (_tmp11_);
		_tmp13_ = _tmp12_;
		_lang_list = _tmp13_;
		_tmp14_ = _lang_list;
		g_object_get (_tmp14_, "size", &_tmp15_, NULL);
		_tmp16_ = _tmp15_;
		_lang_size = _tmp16_;
		_lang_index = -1;
		while (TRUE) {
			gint _tmp17_;
			guint _tmp18_;
			gchar* lang = NULL;
			FontManagerStringSet* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* language = NULL;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			GString* _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			_lang_index = _lang_index + 1;
			_tmp17_ = _lang_index;
			_tmp18_ = _lang_size;
			if (!(((guint) _tmp17_) < _tmp18_)) {
				break;
			}
			_tmp19_ = _lang_list;
			_tmp20_ = font_manager_string_set_get (_tmp19_, (guint) _lang_index);
			_tmp21_ = g_strdup (_tmp20_);
			lang = _tmp21_;
			_tmp22_ = lang;
			_tmp23_ = g_strdup (_tmp22_);
			language = _tmp23_;
			{
				FontManagerBaseOrthographyData* orth_collection = NULL;
				gint orth_collection_length1 = 0;
				gint _orth_collection_size_ = 0;
				gint orth_it = 0;
				orth_collection = FONT_MANAGER_Orthographies;
				orth_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_Orthographies);
				for (orth_it = 0; orth_it < orth_collection_length1; orth_it = orth_it + 1) {
					FontManagerBaseOrthographyData orth = {0};
					orth = orth_collection[orth_it];
					{
						FontManagerBaseOrthographyData _tmp24_;
						const gchar* _tmp25_;
						const gchar* _tmp26_;
						_tmp24_ = orth;
						_tmp25_ = _tmp24_.name;
						_tmp26_ = lang;
						if (g_strcmp0 (_tmp25_, _tmp26_) == 0) {
							FontManagerBaseOrthographyData _tmp27_;
							const gchar* _tmp28_;
							gchar* _tmp29_;
							_tmp27_ = orth;
							_tmp28_ = _tmp27_.native;
							_tmp29_ = g_strdup (_tmp28_);
							_g_free0 (language);
							language = _tmp29_;
							break;
						}
					}
				}
			}
			_tmp30_ = builder;
			_tmp31_ = language;
			_tmp32_ = g_strdup_printf ("   %s   ", _tmp31_);
			_tmp33_ = _tmp32_;
			g_string_append (_tmp30_, _tmp33_);
			_g_free0 (_tmp33_);
			_g_free0 (language);
			_g_free0 (lang);
		}
	}
	_tmp34_ = builder;
	_tmp35_ = _tmp34_->str;
	_tmp36_ = g_markup_escape_text (_tmp35_, (gssize) -1);
	_g_free0 (self->priv->language_filter_tooltip);
	self->priv->language_filter_tooltip = _tmp36_;
	_g_string_free0 (builder);
	_g_object_unref0 (filter);
	return;
}

static GtkTreeModelFlags
font_manager_category_model_real_get_flags (GtkTreeModel* base)
{
	FontManagerCategoryModel * self;
	GtkTreeModelFlags result;
	self = (FontManagerCategoryModel*) base;
	result = GTK_TREE_MODEL_ITERS_PERSIST;
	return result;
}

static gint
font_manager_category_model_real_get_n_columns (GtkTreeModel* base)
{
	FontManagerCategoryModel * self;
	gint result;
	self = (FontManagerCategoryModel*) base;
	result = (gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS;
	return result;
}

static GType
font_manager_category_model_real_get_column_type (GtkTreeModel* base,
                                                  gint index)
{
	FontManagerCategoryModel * self;
	GType result;
	self = (FontManagerCategoryModel*) base;
	if (index == ((gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT)) {
		result = G_TYPE_OBJECT;
		return result;
	}
	result = G_TYPE_STRING;
	return result;
}

static gint*
_vala_array_dup1 (gint* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gint));
	}
	return NULL;
}

static gboolean
font_manager_category_model_real_get_iter (GtkTreeModel* base,
                                           GtkTreeIter* iter,
                                           GtkTreePath* path)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter _tmp0_ = {0};
	GPtrArray* _tmp1_;
	gint depth = 0;
	gint* indices = NULL;
	gint _tmp3_ = 0;
	gint* _tmp4_;
	gint* _tmp5_;
	gint _tmp5__length1;
	gint indices_length1;
	gint _indices_size_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_;
	void* _tmp8_;
	gboolean result;
	self = (FontManagerCategoryModel*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	font_manager_category_model_valid_iter (self, &_tmp0_);
	_vala_iter = _tmp0_;
	_tmp1_ = self->priv->_categories;
	if (_tmp1_ == NULL) {
		GtkTreeIter _tmp2_;
		_tmp2_ = _vala_iter;
		result = font_manager_category_model_invalid_iter (self, &_tmp2_);
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	depth = gtk_tree_path_get_depth (path);
	_tmp4_ = gtk_tree_path_get_indices_with_depth (path, &_tmp3_);
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup1 (_tmp4_, _tmp3_) : _tmp4_;
	_tmp5__length1 = _tmp3_;
	indices = _tmp5_;
	indices_length1 = _tmp5__length1;
	_indices_size_ = indices_length1;
	_tmp6_ = indices;
	_tmp6__length1 = indices_length1;
	_tmp7_ = _tmp6_[0];
	_tmp8_ = GINT_TO_POINTER (_tmp7_);
	_vala_iter.user_data = _tmp8_;
	if (depth > 1) {
		gint n_child = 0;
		gint* _tmp9_;
		gint _tmp9__length1;
		gint _tmp10_;
		gint n_children = 0;
		GtkTreeIter _tmp11_;
		gboolean _tmp12_ = FALSE;
		void* _tmp14_;
		_tmp9_ = indices;
		_tmp9__length1 = indices_length1;
		_tmp10_ = _tmp9_[1];
		n_child = _tmp10_;
		_tmp11_ = _vala_iter;
		n_children = gtk_tree_model_iter_n_children ((GtkTreeModel*) self, &_tmp11_);
		if (n_child < 0) {
			_tmp12_ = TRUE;
		} else {
			_tmp12_ = n_child >= n_children;
		}
		if (_tmp12_) {
			GtkTreeIter _tmp13_;
			_tmp13_ = _vala_iter;
			result = font_manager_category_model_invalid_iter (self, &_tmp13_);
			indices = (g_free (indices), NULL);
			if (iter) {
				*iter = _vala_iter;
			}
			return result;
		}
		_tmp14_ = GINT_TO_POINTER (n_child);
		_vala_iter.user_data2 = _tmp14_;
	}
	result = TRUE;
	indices = (g_free (indices), NULL);
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static GtkTreePath*
font_manager_category_model_real_get_path (GtkTreeModel* base,
                                           GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _tmp0_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GtkTreeIter _tmp5_;
	void* _tmp6_;
	GtkTreePath* result;
	self = (FontManagerCategoryModel*) base;
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = *iter;
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp", NULL);
	_tmp1_ = gtk_tree_path_new ();
	path = _tmp1_;
	_tmp2_ = path;
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.user_data;
	gtk_tree_path_append_index (_tmp2_, (gint) _tmp4_);
	_tmp5_ = *iter;
	_tmp6_ = _tmp5_.user_data2;
	if (((gint) _tmp6_) != -1) {
		GtkTreePath* _tmp7_;
		GtkTreeIter _tmp8_;
		void* _tmp9_;
		_tmp7_ = path;
		_tmp8_ = *iter;
		_tmp9_ = _tmp8_.user_data2;
		gtk_tree_path_append_index (_tmp7_, (gint) _tmp9_);
	}
	result = path;
	return result;
}

static void
font_manager_category_model_real_get_value (GtkTreeModel* base,
                                            GtkTreeIter* iter,
                                            gint column,
                                            GValue* val)
{
	FontManagerCategoryModel * self;
	GValue _vala_val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	FontManagerCategory* parent = NULL;
	GPtrArray* _tmp2_;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	gconstpointer _tmp5_;
	FontManagerCategory* _tmp6_;
	FontManagerCategory* child = NULL;
	GtkTreeIter _tmp7_;
	void* _tmp8_;
	FontManagerCategory* _tmp16_ = NULL;
	FontManagerCategory* _tmp17_;
	FontManagerCategory* target = NULL;
	FontManagerCategory* _tmp20_;
	self = (FontManagerCategoryModel*) base;
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	_vala_return_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp");
	_vala_return_if_fail ((column >= 0) && (column < ((gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_N_COLUMNS)), "column >= 0 && column < CategoryModelColumn.N_COLUMNS");
	g_value_init (&_tmp1_, gtk_tree_model_get_column_type ((GtkTreeModel*) self, column));
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	_vala_val = _tmp1_;
	_tmp2_ = self->priv->_categories;
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.user_data;
	_tmp5_ = g_ptr_array_index (_tmp2_, (guint) ((gint) _tmp4_));
	_tmp6_ = _g_object_ref0 ((FontManagerCategory*) _tmp5_);
	parent = _tmp6_;
	child = NULL;
	_tmp7_ = *iter;
	_tmp8_ = _tmp7_.user_data2;
	if (((gint) _tmp8_) != -1) {
		FontManagerCategory* _tmp9_;
		GPtrArray* _tmp10_;
		GPtrArray* _tmp11_;
		GtkTreeIter _tmp12_;
		void* _tmp13_;
		gconstpointer _tmp14_;
		FontManagerCategory* _tmp15_;
		_tmp9_ = parent;
		_tmp10_ = font_manager_category_get_children (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = *iter;
		_tmp13_ = _tmp12_.user_data2;
		_tmp14_ = g_ptr_array_index (_tmp11_, (guint) ((gint) _tmp13_));
		_tmp15_ = _g_object_ref0 ((FontManagerCategory*) _tmp14_);
		_g_object_unref0 (child);
		child = _tmp15_;
	}
	_tmp17_ = child;
	if (_tmp17_ != NULL) {
		FontManagerCategory* _tmp18_;
		_tmp18_ = child;
		_tmp16_ = _tmp18_;
	} else {
		FontManagerCategory* _tmp19_;
		_tmp19_ = parent;
		_tmp16_ = _tmp19_;
	}
	_tmp20_ = _g_object_ref0 (_tmp16_);
	target = _tmp20_;
	switch (column) {
		case FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME:
		{
			FontManagerCategory* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			_tmp21_ = target;
			_tmp22_ = font_manager_filter_get_name ((FontManagerFilter*) _tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = _tmp23_;
			g_value_set_string (&_vala_val, _tmp24_);
			_g_free0 (_tmp24_);
			break;
		}
		case FONT_MANAGER_CATEGORY_MODEL_COLUMN_ICON:
		{
			FontManagerCategory* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			_tmp25_ = target;
			_tmp26_ = font_manager_filter_get_icon ((FontManagerFilter*) _tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = _tmp27_;
			g_value_set_string (&_vala_val, _tmp28_);
			_g_free0 (_tmp28_);
			break;
		}
		case FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT:
		{
			FontManagerCategory* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			_tmp29_ = target;
			_tmp30_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp29_);
			_tmp31_ = _tmp30_;
			if (_tmp31_ == ((gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE)) {
				const gchar* _tmp32_;
				_tmp32_ = self->priv->language_filter_tooltip;
				g_value_set_string (&_vala_val, _tmp32_);
			} else {
				FontManagerCategory* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				_tmp33_ = target;
				_tmp34_ = font_manager_filter_get_comment ((FontManagerFilter*) _tmp33_);
				_tmp35_ = _tmp34_;
				_tmp36_ = _tmp35_;
				_tmp37_ = g_markup_escape_text (_tmp36_, (gssize) -1);
				_tmp38_ = _tmp37_;
				g_value_set_string (&_vala_val, _tmp38_);
				_g_free0 (_tmp38_);
				_g_free0 (_tmp36_);
			}
			break;
		}
		case FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT:
		{
			FontManagerCategory* _tmp39_;
			_tmp39_ = target;
			g_value_set_object (&_vala_val, (GObject*) _tmp39_);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_g_object_unref0 (target);
	_g_object_unref0 (child);
	_g_object_unref0 (parent);
	if (val) {
		*val = _vala_val;
	} else {
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	}
	return;
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static gboolean
font_manager_category_model_real_iter_next (GtkTreeModel* base,
                                            GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _tmp0_;
	gint parent = 0;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	gint child = 0;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	gboolean result;
	self = (FontManagerCategoryModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp", FALSE);
	_tmp1_ = *iter;
	_tmp2_ = _tmp1_.user_data;
	parent = (gint) _tmp2_;
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.user_data2;
	child = (gint) _tmp4_;
	if (child != -1) {
		gint next_child = 0;
		GPtrArray* _tmp5_;
		gconstpointer _tmp6_;
		GPtrArray* _tmp7_;
		GPtrArray* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		void* _tmp12_;
		next_child = child + 1;
		_tmp5_ = self->priv->_categories;
		_tmp6_ = g_ptr_array_index (_tmp5_, (guint) parent);
		_tmp7_ = font_manager_category_get_children ((FontManagerCategory*) _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = vala_g_ptr_array_get_length (_tmp8_);
		_tmp10_ = _tmp9_;
		if (next_child >= _tmp10_) {
			GtkTreeIter _tmp11_;
			_tmp11_ = *iter;
			result = font_manager_category_model_invalid_iter (self, &_tmp11_);
			return result;
		}
		_tmp12_ = GINT_TO_POINTER (next_child);
		(*iter).user_data2 = _tmp12_;
	} else {
		gint next_parent = 0;
		GPtrArray* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		void* _tmp17_;
		next_parent = parent + 1;
		_tmp13_ = self->priv->_categories;
		_tmp14_ = vala_g_ptr_array_get_length (_tmp13_);
		_tmp15_ = _tmp14_;
		if (next_parent >= _tmp15_) {
			GtkTreeIter _tmp16_;
			_tmp16_ = *iter;
			result = font_manager_category_model_invalid_iter (self, &_tmp16_);
			return result;
		}
		_tmp17_ = GINT_TO_POINTER (next_parent);
		(*iter).user_data = _tmp17_;
	}
	result = TRUE;
	return result;
}

static gboolean
font_manager_category_model_real_iter_previous (GtkTreeModel* base,
                                                GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _tmp0_;
	gint parent = 0;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	gint child = 0;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	gboolean result;
	self = (FontManagerCategoryModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp", FALSE);
	_tmp1_ = *iter;
	_tmp2_ = _tmp1_.user_data;
	parent = (gint) _tmp2_;
	_tmp3_ = *iter;
	_tmp4_ = _tmp3_.user_data2;
	child = (gint) _tmp4_;
	if (child != -1) {
		gint next_child = 0;
		void* _tmp6_;
		next_child = child - 1;
		if (next_child <= 0) {
			GtkTreeIter _tmp5_;
			_tmp5_ = *iter;
			result = font_manager_category_model_invalid_iter (self, &_tmp5_);
			return result;
		}
		_tmp6_ = GINT_TO_POINTER (next_child);
		(*iter).user_data2 = _tmp6_;
	} else {
		gint next_parent = 0;
		void* _tmp8_;
		next_parent = parent - 1;
		if (next_parent <= 0) {
			GtkTreeIter _tmp7_;
			_tmp7_ = *iter;
			result = font_manager_category_model_invalid_iter (self, &_tmp7_);
			return result;
		}
		_tmp8_ = GINT_TO_POINTER (next_parent);
		(*iter).user_data = _tmp8_;
	}
	result = TRUE;
	return result;
}

static gboolean
font_manager_category_model_real_iter_children (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                GtkTreeIter* parent)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	GPtrArray* _tmp2_;
	gint first_index = 0;
	gboolean result;
	self = (FontManagerCategoryModel*) base;
	_vala_return_val_if_fail ((*parent).stamp == self->priv->stamp, "parent.stamp == stamp", FALSE);
	font_manager_category_model_valid_iter (self, &_tmp0_);
	_vala_iter = _tmp0_;
	_tmp2_ = self->priv->_categories;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		void* _tmp3_;
		_tmp3_ = (*parent).user_data2;
		_tmp1_ = ((gint) _tmp3_) != -1;
	}
	if (_tmp1_) {
		GtkTreeIter _tmp4_;
		_tmp4_ = _vala_iter;
		result = font_manager_category_model_invalid_iter (self, &_tmp4_);
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	first_index = 0;
	if (parent == NULL) {
		void* _tmp5_;
		_tmp5_ = GINT_TO_POINTER (first_index);
		_vala_iter.user_data = _tmp5_;
	} else {
		void* _tmp6_;
		void* _tmp7_;
		_tmp6_ = (*parent).user_data;
		_vala_iter.user_data = _tmp6_;
		_tmp7_ = GINT_TO_POINTER (first_index);
		_vala_iter.user_data2 = _tmp7_;
	}
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static gboolean
font_manager_category_model_real_iter_has_child (GtkTreeModel* base,
                                                 GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _tmp0_;
	GPtrArray* _tmp1_;
	GtkTreeIter _tmp2_;
	gboolean result;
	self = (FontManagerCategoryModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "iter.stamp == stamp", FALSE);
	_tmp1_ = self->priv->_categories;
	if (_tmp1_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp2_ = *iter;
	result = gtk_tree_model_iter_n_children ((GtkTreeModel*) self, &_tmp2_) > 0;
	return result;
}

static gint
font_manager_category_model_real_iter_n_children (GtkTreeModel* base,
                                                  GtkTreeIter* iter)
{
	FontManagerCategoryModel * self;
	GPtrArray* _tmp0_;
	void* _tmp4_;
	FontManagerCategory* parent = NULL;
	GPtrArray* _tmp5_;
	void* _tmp6_;
	gconstpointer _tmp7_;
	FontManagerCategory* _tmp8_;
	FontManagerCategory* _tmp9_;
	GPtrArray* _tmp10_;
	GPtrArray* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint result;
	self = (FontManagerCategoryModel*) base;
	_vala_return_val_if_fail ((iter == NULL) || ((*iter).stamp == self->priv->stamp), "iter == null || iter.stamp == stamp", 0);
	_tmp0_ = self->priv->_categories;
	if (_tmp0_ == NULL) {
		result = 0;
		return result;
	}
	if (iter == NULL) {
		GPtrArray* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		_tmp1_ = self->priv->_categories;
		_tmp2_ = vala_g_ptr_array_get_length (_tmp1_);
		_tmp3_ = _tmp2_;
		result = _tmp3_;
		return result;
	}
	_tmp4_ = (*iter).user_data2;
	if (((gint) _tmp4_) != -1) {
		result = 0;
		return result;
	}
	_tmp5_ = self->priv->_categories;
	_tmp6_ = (*iter).user_data;
	_tmp7_ = g_ptr_array_index (_tmp5_, (guint) ((gint) _tmp6_));
	_tmp8_ = _g_object_ref0 ((FontManagerCategory*) _tmp7_);
	parent = _tmp8_;
	_tmp9_ = parent;
	_tmp10_ = font_manager_category_get_children (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = vala_g_ptr_array_get_length (_tmp11_);
	_tmp13_ = _tmp12_;
	result = _tmp13_;
	_g_object_unref0 (parent);
	return result;
}

static gboolean
font_manager_category_model_real_iter_nth_child (GtkTreeModel* base,
                                                 GtkTreeIter* iter,
                                                 GtkTreeIter* parent,
                                                 gint n)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter _tmp0_ = {0};
	GPtrArray* _tmp1_;
	gint n_children = 0;
	gboolean result;
	self = (FontManagerCategoryModel*) base;
	_vala_return_val_if_fail ((parent == NULL) || ((*parent).stamp == self->priv->stamp), "parent == null || parent.stamp == stamp", FALSE);
	font_manager_category_model_valid_iter (self, &_tmp0_);
	_vala_iter = _tmp0_;
	_tmp1_ = self->priv->_categories;
	if (_tmp1_ == NULL) {
		GtkTreeIter _tmp2_;
		_tmp2_ = _vala_iter;
		result = font_manager_category_model_invalid_iter (self, &_tmp2_);
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	if (parent == NULL) {
		GPtrArray* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		void* _tmp7_;
		_tmp3_ = self->priv->_categories;
		_tmp4_ = vala_g_ptr_array_get_length (_tmp3_);
		_tmp5_ = _tmp4_;
		if (n >= _tmp5_) {
			GtkTreeIter _tmp6_;
			_tmp6_ = _vala_iter;
			result = font_manager_category_model_invalid_iter (self, &_tmp6_);
			if (iter) {
				*iter = _vala_iter;
			}
			return result;
		}
		_tmp7_ = GINT_TO_POINTER (n);
		_vala_iter.user_data = _tmp7_;
		result = TRUE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	n_children = gtk_tree_model_iter_n_children ((GtkTreeModel*) self, parent);
	if (n > (n_children - 1)) {
		GtkTreeIter _tmp8_;
		_tmp8_ = _vala_iter;
		result = font_manager_category_model_invalid_iter (self, &_tmp8_);
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	} else {
		void* _tmp9_;
		void* _tmp10_;
		_tmp9_ = (*parent).user_data;
		_vala_iter.user_data = _tmp9_;
		_tmp10_ = GINT_TO_POINTER (n);
		_vala_iter.user_data2 = _tmp10_;
	}
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static gboolean
font_manager_category_model_real_iter_parent (GtkTreeModel* base,
                                              GtkTreeIter* iter,
                                              GtkTreeIter* child)
{
	FontManagerCategoryModel * self;
	GtkTreeIter _vala_iter = {0};
	GtkTreeIter _tmp0_;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkTreeIter _tmp4_;
	void* _tmp5_;
	gboolean result;
	self = (FontManagerCategoryModel*) base;
	g_return_val_if_fail (child != NULL, FALSE);
	_tmp0_ = *child;
	_vala_return_val_if_fail (_tmp0_.stamp == self->priv->stamp, "child.stamp == stamp", FALSE);
	_tmp1_ = *child;
	_tmp2_ = _tmp1_.user_data2;
	_vala_return_val_if_fail (((gint) _tmp2_) != -1, "((int) child.user_data2) != -1", FALSE);
	font_manager_category_model_valid_iter (self, &_tmp3_);
	_vala_iter = _tmp3_;
	_tmp4_ = *child;
	_tmp5_ = _tmp4_.user_data;
	_vala_iter.user_data = _tmp5_;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
font_manager_category_model_emit_row_changed_signal (FontManagerCategoryModel* self,
                                                     gint index)
{
	GtkTreeIter iter = {0};
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkTreeIter _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_tree_path_new ();
	path = _tmp0_;
	gtk_tree_path_append_index (path, index);
	gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp1_, path);
	iter = _tmp1_;
	_tmp2_ = iter;
	gtk_tree_model_row_changed ((GtkTreeModel*) self, path, &_tmp2_);
	__vala_GtkTreePath_free0 (path);
	return;
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		FontManagerCategoryModel* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->disabled);
		_g_object_unref0 (_data5_->reject);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		FontManagerCategoryModel* self;
		self = _data6_->_data5_->self;
		_g_object_unref0 (_data6_->cat);
		block5_data_unref (_data6_->_data5_);
		_data6_->_data5_ = NULL;
		g_slice_free (Block6Data, _data6_);
	}
}

static void
_____lambda40_ (Block6Data* _data6_,
                GObject* obj,
                GAsyncResult* res)
{
	Block5Data* _data5_;
	FontManagerCategoryModel* self;
	FontManagerCategory* _tmp0_;
	_data5_ = _data6_->_data5_;
	self = _data5_->self;
	g_return_if_fail (res != NULL);
	_tmp0_ = _data6_->cat;
	font_manager_category_update_finish (_tmp0_, res);
}

static void
______lambda40__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
	_____lambda40_ (self, source_object, res);
	block6_data_unref (self);
}

static void
__lambda41_ (FontManagerCategoryModel* self)
{
	font_manager_category_model_update_language_filter_tooltip (self);
	font_manager_category_model_emit_row_changed_signal (self, (gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
}

static void
___lambda41__font_manager_language_filter_selections_changed (FontManagerLanguageFilter* _sender,
                                                              gpointer self)
{
	__lambda41_ ((FontManagerCategoryModel*) self);
}

static void
__lambda42_ (Block5Data* _data5_,
             GObject* obj,
             GAsyncResult* res)
{
	FontManagerCategoryModel* self;
	self = _data5_->self;
	g_return_if_fail (res != NULL);
	font_manager_disabled_update_finish (_data5_->disabled, res);
}

static void
___lambda42__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda42_ (self, source_object, res);
	block5_data_unref (self);
}

static void
__lambda44_ (Block5Data* _data5_,
             GObject* obj,
             GAsyncResult* res)
{
	FontManagerCategoryModel* self;
	self = _data5_->self;
	g_return_if_fail (res != NULL);
	font_manager_disabled_update_finish (_data5_->disabled, res);
	font_manager_category_model_emit_row_changed_signal (self, (gint) FONT_MANAGER_CATEGORY_INDEX_DISABLED);
}

static void
___lambda44__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda44_ (self, source_object, res);
	block5_data_unref (self);
}

static void
__lambda43_ (Block5Data* _data5_)
{
	FontManagerCategoryModel* self;
	GPtrArray* _tmp0_;
	self = _data5_->self;
	_tmp0_ = self->priv->_categories;
	if (_tmp0_ == NULL) {
		return;
	}
	font_manager_disabled_update (_data5_->disabled, (FontManagerStringSet*) _data5_->reject, ___lambda44__gasync_ready_callback, block5_data_ref (_data5_));
}

static void
___lambda43__font_manager_selections_changed (FontManagerSelections* _sender,
                                              gpointer self)
{
	__lambda43_ (self);
}

void
font_manager_category_model_update (FontManagerCategoryModel* self)
{
	Block5Data* _data5_;
	FontManagerLanguageFilter* lang_filter = NULL;
	GPtrArray* _tmp11_;
	gconstpointer _tmp12_;
	FontManagerLanguageFilter* _tmp13_;
	FontManagerApplication* _tmp14_;
	FontManagerApplication* _tmp15_;
	FontManagerReject* _tmp16_;
	FontManagerReject* _tmp17_;
	FontManagerReject* _tmp18_;
	FontManagerReject* _tmp19_;
	GPtrArray* _tmp20_;
	gconstpointer _tmp21_;
	FontManagerDisabled* _tmp22_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = g_object_ref (self);
	g_signal_emit (self, font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_UPDATE_BEGIN_SIGNAL], 0);
	font_manager_category_model_set_categories (self, NULL);
	{
		FontManagerDatabase* db = NULL;
		FontManagerDatabase* _tmp0_;
		GPtrArray* _tmp1_;
		GPtrArray* _tmp2_;
		_tmp0_ = font_manager_get_database (FONT_MANAGER_DATABASE_TYPE_BASE, &_inner_error0_);
		db = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
				goto __catch0_font_manager_database_error;
			}
			block5_data_unref (_data5_);
			_data5_ = NULL;
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp1_ = font_manager_get_default_categories (db);
		_tmp2_ = _tmp1_;
		font_manager_category_model_set_categories (self, _tmp2_);
		_g_ptr_array_unref0 (_tmp2_);
		_g_object_unref0 (db);
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_critical ("Categories.vala:283: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		block5_data_unref (_data5_);
		_data5_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	{
		gint i = 0;
		i = (gint) FONT_MANAGER_CATEGORY_INDEX_ALL;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				Block6Data* _data6_;
				GPtrArray* _tmp7_;
				gconstpointer _tmp8_;
				FontManagerCategory* _tmp9_;
				FontManagerCategory* _tmp10_;
				_data6_ = g_slice_new0 (Block6Data);
				_data6_->_ref_count_ = 1;
				_data6_->_data5_ = block5_data_ref (_data5_);
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(i < ((gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE))) {
					block6_data_unref (_data6_);
					_data6_ = NULL;
					break;
				}
				_tmp7_ = self->priv->_categories;
				_tmp8_ = g_ptr_array_index (_tmp7_, (guint) i);
				_tmp9_ = _g_object_ref0 ((FontManagerCategory*) _tmp8_);
				_data6_->cat = _tmp9_;
				_tmp10_ = _data6_->cat;
				font_manager_category_update (_tmp10_, ______lambda40__gasync_ready_callback, block6_data_ref (_data6_));
				block6_data_unref (_data6_);
				_data6_ = NULL;
			}
		}
	}
	g_signal_emit (self, font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_UPDATE_COMPLETE_SIGNAL], 0);
	_tmp11_ = self->priv->_categories;
	_tmp12_ = g_ptr_array_index (_tmp11_, (guint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((FontManagerCategory*) _tmp12_, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter));
	lang_filter = _tmp13_;
	g_signal_connect_object (lang_filter, "selections-changed", (GCallback) ___lambda41__font_manager_language_filter_selections_changed, self, 0);
	_tmp14_ = font_manager_get_default_application ();
	_tmp15_ = _tmp14_;
	_tmp16_ = font_manager_application_get_reject (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = _g_object_ref0 (_tmp17_);
	_tmp19_ = _tmp18_;
	_g_object_unref0 (_tmp15_);
	_data5_->reject = _tmp19_;
	_vala_assert (_data5_->reject != NULL, "reject != null");
	_tmp20_ = self->priv->_categories;
	_tmp21_ = g_ptr_array_index (_tmp20_, (guint) FONT_MANAGER_CATEGORY_INDEX_DISABLED);
	_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((FontManagerCategory*) _tmp21_, FONT_MANAGER_TYPE_DISABLED, FontManagerDisabled));
	_data5_->disabled = _tmp22_;
	font_manager_disabled_update (_data5_->disabled, (FontManagerStringSet*) _data5_->reject, ___lambda42__gasync_ready_callback, block5_data_ref (_data5_));
	g_signal_connect_data ((FontManagerSelections*) _data5_->reject, "changed", (GCallback) ___lambda43__font_manager_selections_changed, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_g_object_unref0 (lang_filter);
	block5_data_unref (_data5_);
	_data5_ = NULL;
	return;
}

FontManagerCategoryModel*
font_manager_category_model_construct (GType object_type)
{
	FontManagerCategoryModel * self = NULL;
	self = (FontManagerCategoryModel*) g_object_new (object_type, NULL);
	return self;
}

FontManagerCategoryModel*
font_manager_category_model_new (void)
{
	return font_manager_category_model_construct (FONT_MANAGER_TYPE_CATEGORY_MODEL);
}

GPtrArray*
font_manager_category_model_get_categories (FontManagerCategoryModel* self)
{
	GPtrArray* result;
	GPtrArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_categories;
	result = _tmp0_;
	return result;
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
	return self ? g_ptr_array_ref (self) : NULL;
}

void
font_manager_category_model_set_categories (FontManagerCategoryModel* self,
                                            GPtrArray* value)
{
	GPtrArray* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_category_model_get_categories (self);
	if (old_value != value) {
		GPtrArray* _tmp0_;
		_tmp0_ = _g_ptr_array_ref0 (value);
		_g_ptr_array_unref0 (self->priv->_categories);
		self->priv->_categories = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_model_properties[FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY]);
	}
}

static GObject *
font_manager_category_model_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerCategoryModel * self;
	parent_class = G_OBJECT_CLASS (font_manager_category_model_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel);
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			if (!_tmp0_) {
				if (!(self->priv->stamp == 0)) {
					break;
				}
			}
			_tmp0_ = FALSE;
			self->priv->stamp = (gint) g_random_int ();
		}
	}
	return obj;
}

static void
font_manager_category_model_class_init (FontManagerCategoryModelClass * klass,
                                        gpointer klass_data)
{
	font_manager_category_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerCategoryModel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_category_model_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_category_model_set_property;
	G_OBJECT_CLASS (klass)->constructor = font_manager_category_model_constructor;
	G_OBJECT_CLASS (klass)->finalize = font_manager_category_model_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY, font_manager_category_model_properties[FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY] = g_param_spec_boxed ("categories", "categories", "categories", G_TYPE_PTR_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_UPDATE_BEGIN_SIGNAL] = g_signal_new ("update-begin", FONT_MANAGER_TYPE_CATEGORY_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	font_manager_category_model_signals[FONT_MANAGER_CATEGORY_MODEL_UPDATE_COMPLETE_SIGNAL] = g_signal_new ("update-complete", FONT_MANAGER_TYPE_CATEGORY_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
font_manager_category_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface,
                                                           gpointer iface_data)
{
	font_manager_category_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel*)) font_manager_category_model_real_get_flags;
	iface->get_n_columns = (gint (*) (GtkTreeModel*)) font_manager_category_model_real_get_n_columns;
	iface->get_column_type = (GType (*) (GtkTreeModel*, gint)) font_manager_category_model_real_get_column_type;
	iface->get_iter = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreePath*)) font_manager_category_model_real_get_iter;
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_get_path;
	iface->get_value = (void (*) (GtkTreeModel*, GtkTreeIter*, gint, GValue*)) font_manager_category_model_real_get_value;
	iface->iter_next = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_iter_next;
	iface->iter_previous = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_iter_previous;
	iface->iter_children = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) font_manager_category_model_real_iter_children;
	iface->iter_has_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_iter_has_child;
	iface->iter_n_children = (gint (*) (GtkTreeModel*, GtkTreeIter*)) font_manager_category_model_real_iter_n_children;
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*, gint)) font_manager_category_model_real_iter_nth_child;
	iface->iter_parent = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) font_manager_category_model_real_iter_parent;
}

static void
font_manager_category_model_instance_init (FontManagerCategoryModel * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
	self->priv = font_manager_category_model_get_instance_private (self);
	self->priv->_categories = NULL;
	self->priv->stamp = 0;
	_tmp0_ = g_strdup (DEFAULT_LANGUAGE_FILTER_COMMENT);
	self->priv->language_filter_tooltip = _tmp0_;
}

static void
font_manager_category_model_finalize (GObject * obj)
{
	FontManagerCategoryModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel);
	_g_ptr_array_unref0 (self->priv->_categories);
	_g_free0 (self->priv->language_filter_tooltip);
	G_OBJECT_CLASS (font_manager_category_model_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_category_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerCategoryModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_category_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerCategoryModel), 0, (GInstanceInitFunc) font_manager_category_model_instance_init, NULL };
	static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) font_manager_category_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType font_manager_category_model_type_id;
	font_manager_category_model_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerCategoryModel", &g_define_type_info, 0);
	g_type_add_interface_static (font_manager_category_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
	FontManagerCategoryModel_private_offset = g_type_add_instance_private (font_manager_category_model_type_id, sizeof (FontManagerCategoryModelPrivate));
	return font_manager_category_model_type_id;
}

GType
font_manager_category_model_get_type (void)
{
	static volatile gsize font_manager_category_model_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_model_type_id__once)) {
		GType font_manager_category_model_type_id;
		font_manager_category_model_type_id = font_manager_category_model_get_type_once ();
		g_once_init_leave (&font_manager_category_model_type_id__once, font_manager_category_model_type_id);
	}
	return font_manager_category_model_type_id__once;
}

static void
_vala_font_manager_category_model_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	FontManagerCategoryModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel);
	switch (property_id) {
		case FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY:
		g_value_set_boxed (value, font_manager_category_model_get_categories (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_category_model_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	FontManagerCategoryModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel);
	switch (property_id) {
		case FONT_MANAGER_CATEGORY_MODEL_CATEGORIES_PROPERTY:
		font_manager_category_model_set_categories (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
font_manager_category_tree_get_instance_private (FontManagerCategoryTree* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerCategoryTree_private_offset);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		FontManagerCategoryTree* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->db);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
_font_manager_category_tree_on_selection_changed_gtk_tree_selection_changed (GtkTreeSelection* _sender,
                                                                             gpointer self)
{
	font_manager_category_tree_on_selection_changed ((FontManagerCategoryTree*) self, _sender);
}

static void
__lambda50_ (FontManagerCategoryTree* self)
{
	gtk_tree_view_set_model ((GtkTreeView*) self, NULL);
	font_manager_category_tree_set_update_in_progress (self, TRUE);
}

static void
___lambda50__font_manager_category_model_update_begin (FontManagerCategoryModel* _sender,
                                                       gpointer self)
{
	__lambda50_ ((FontManagerCategoryTree*) self);
}

static void
__lambda51_ (FontManagerCategoryTree* self)
{
	FontManagerCategoryModel* _tmp0_;
	font_manager_category_tree_set_update_in_progress (self, FALSE);
	_tmp0_ = self->priv->_model_;
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp0_);
	g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_UPDATE_COMPLETE_SIGNAL], 0);
}

static void
___lambda51__font_manager_category_model_update_complete (FontManagerCategoryModel* _sender,
                                                          gpointer self)
{
	__lambda51_ ((FontManagerCategoryTree*) self);
}

static gboolean
____lambda53_ (FontManagerCategoryTree* self)
{
	gboolean result;
	g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_CHANGED_SIGNAL], 0);
	_g_free0 (self->priv->change_timeout);
	self->priv->change_timeout = NULL;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
_____lambda53__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda53_ ((FontManagerCategoryTree*) self);
	return result;
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
	dup = g_new0 (guint, 1);
	memcpy (dup, self, sizeof (guint));
	return dup;
}

static gpointer
__uint_dup0 (gpointer self)
{
	return self ? _uint_dup (self) : NULL;
}

static void
__lambda52_ (FontManagerCategoryTree* self,
             GtkTreePath* path,
             GtkTreeIter* iter)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (path != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = gtk_tree_path_to_string (path);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_selected_iter;
	_tmp3_ = g_strcmp0 (_tmp1_, _tmp2_) == 0;
	_g_free0 (_tmp1_);
	if (_tmp3_) {
		guint* _tmp4_;
		_tmp4_ = self->priv->change_timeout;
		if (_tmp4_ == NULL) {
			guint _tmp5_;
			guint* _tmp6_;
			_tmp5_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _____lambda53__gsource_func, g_object_ref (self), g_object_unref);
			_tmp6_ = __uint_dup0 (&_tmp5_);
			_g_free0 (self->priv->change_timeout);
			self->priv->change_timeout = _tmp6_;
		}
	}
}

static void
___lambda52__gtk_tree_model_row_changed (GtkTreeModel* _sender,
                                         GtkTreePath* path,
                                         GtkTreeIter* iter,
                                         gpointer self)
{
	__lambda52_ ((FontManagerCategoryTree*) self, path, iter);
}

static void
__lambda49_ (FontManagerCategoryTree* self)
{
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	FontManagerCategoryModel* _tmp5_;
	FontManagerCategoryModel* _tmp6_;
	FontManagerCategoryModel* _tmp7_;
	_tmp0_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		return;
	} else {
		GtkTreeModel* _tmp2_;
		GtkTreeModel* _tmp3_;
		FontManagerCategoryModel* _tmp4_;
		_tmp2_ = gtk_tree_view_get_model ((GtkTreeView*) self);
		_tmp3_ = _tmp2_;
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, FONT_MANAGER_TYPE_CATEGORY_MODEL, FontManagerCategoryModel));
		_g_object_unref0 (self->priv->_model_);
		self->priv->_model_ = _tmp4_;
	}
	gtk_widget_queue_draw ((GtkWidget*) self);
	_tmp5_ = self->priv->_model_;
	g_signal_connect_object (_tmp5_, "update-begin", (GCallback) ___lambda50__font_manager_category_model_update_begin, self, 0);
	_tmp6_ = self->priv->_model_;
	g_signal_connect_object (_tmp6_, "update-complete", (GCallback) ___lambda51__font_manager_category_model_update_complete, self, 0);
	_tmp7_ = self->priv->_model_;
	g_signal_connect_object ((GtkTreeModel*) _tmp7_, "row-changed", (GCallback) ___lambda52__gtk_tree_model_row_changed, self, 0);
}

static void
___lambda49__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda49_ ((FontManagerCategoryTree*) self);
}

static void
__lambda57_ (FontManagerCategoryTree* self)
{
	self->priv->refresh_required = TRUE;
}

static void
___lambda57__font_manager_database_proxy_update_started (FontManagerDatabaseProxy* _sender,
                                                         gpointer self)
{
	__lambda57_ ((FontManagerCategoryTree*) self);
}

static void
__lambda58_ (Block7Data* _data7_)
{
	FontManagerCategoryTree* self;
	gboolean _tmp0_ = FALSE;
	self = _data7_->self;
	if (self->priv->refresh_required) {
		_tmp0_ = font_manager_database_proxy_ready (_data7_->db, FONT_MANAGER_DATABASE_TYPE_METADATA);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		self->priv->refresh_required = FALSE;
		font_manager_category_tree_update (self);
	}
}

static void
___lambda58__font_manager_database_proxy_status_changed (FontManagerDatabaseProxy* _sender,
                                                         gpointer self)
{
	__lambda58_ (self);
}

static void
__lambda59_ (FontManagerCategoryTree* self)
{
	if (self->priv->refresh_required) {
		self->priv->refresh_required = FALSE;
		font_manager_category_tree_update (self);
	}
}

static void
___lambda59__font_manager_database_proxy_update_complete (FontManagerDatabaseProxy* _sender,
                                                          gpointer self)
{
	__lambda59_ ((FontManagerCategoryTree*) self);
}

static void
font_manager_category_tree_connect_signals (FontManagerCategoryTree* self)
{
	Block7Data* _data7_;
	GtkTreeSelection* _tmp0_;
	FontManagerApplication* _tmp1_;
	FontManagerApplication* _tmp2_;
	FontManagerDatabaseProxy* _tmp3_;
	FontManagerDatabaseProxy* _tmp4_;
	FontManagerDatabaseProxy* _tmp5_;
	FontManagerDatabaseProxy* _tmp6_;
	g_return_if_fail (self != NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	g_signal_connect_object (_tmp0_, "changed", (GCallback) _font_manager_category_tree_on_selection_changed_gtk_tree_selection_changed, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::model", (GCallback) ___lambda49__g_object_notify, self, 0);
	_tmp1_ = font_manager_get_default_application ();
	_tmp2_ = _tmp1_;
	_tmp3_ = font_manager_application_get_db (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_object_unref0 (_tmp2_);
	_data7_->db = _tmp6_;
	_vala_assert (_data7_->db != NULL, "db != null");
	g_signal_connect_object (_data7_->db, "update-started", (GCallback) ___lambda57__font_manager_database_proxy_update_started, self, 0);
	g_signal_connect_data (_data7_->db, "status-changed", (GCallback) ___lambda58__font_manager_database_proxy_status_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	g_signal_connect_object (_data7_->db, "update-complete", (GCallback) ___lambda59__font_manager_database_proxy_update_complete, self, 0);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return;
}

void
font_manager_category_tree_select_first_row (FontManagerCategoryTree* self)
{
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp2_;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp3_;
	GtkTreeSelection* _tmp4_;
	GtkTreeSelection* _tmp5_;
	GtkTreeSelection* _tmp6_;
	GtkTreePath* _tmp7_;
	GtkTreeSelection* _tmp8_;
	GtkTreePath* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		return;
	}
	_tmp2_ = gtk_tree_path_new_first ();
	path = _tmp2_;
	_tmp3_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	selection = _tmp4_;
	_tmp5_ = selection;
	gtk_tree_selection_unselect_all (_tmp5_);
	_tmp6_ = selection;
	_tmp7_ = path;
	gtk_tree_selection_select_path (_tmp6_, _tmp7_);
	_tmp8_ = selection;
	_tmp9_ = path;
	if (gtk_tree_selection_path_is_selected (_tmp8_, _tmp9_)) {
		GtkTreePath* _tmp10_;
		_tmp10_ = path;
		gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp10_, NULL, TRUE, 0.5f, 0.5f);
	}
	_g_object_unref0 (selection);
	__vala_GtkTreePath_free0 (path);
	return;
}

void
font_manager_category_tree_update (FontManagerCategoryTree* self)
{
	gboolean _tmp0_ = FALSE;
	GtkTreeModel* _tmp1_;
	GtkTreeModel* _tmp2_;
	FontManagerCategory* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp1_ = gtk_tree_view_get_model ((GtkTreeView*) self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		FontManagerCategoryModel* _tmp3_;
		_tmp3_ = self->priv->_model_;
		_tmp0_ = _tmp3_ == NULL;
	}
	if (_tmp0_) {
		return;
	}
	_tmp4_ = self->priv->_selected_filter;
	if (_tmp4_ != NULL) {
		gint index = 0;
		FontManagerCategory* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp8_;
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp9_;
		GtkTreeSelection* _tmp10_;
		GtkTreeSelection* _tmp11_;
		FontManagerCategoryModel* _tmp12_;
		GtkTreeSelection* _tmp13_;
		GtkTreePath* _tmp14_;
		_tmp5_ = self->priv->_selected_filter;
		_tmp6_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp5_);
		_tmp7_ = _tmp6_;
		index = _tmp7_;
		_tmp8_ = gtk_tree_path_new_from_indices (index, -1, -1);
		path = _tmp8_;
		_tmp9_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
		_tmp10_ = _g_object_ref0 (_tmp9_);
		selection = _tmp10_;
		_tmp11_ = selection;
		gtk_tree_selection_unselect_all (_tmp11_);
		_tmp12_ = self->priv->_model_;
		font_manager_category_model_update (_tmp12_);
		_tmp13_ = selection;
		_tmp14_ = path;
		gtk_tree_selection_select_path (_tmp13_, _tmp14_);
		_g_object_unref0 (selection);
		__vala_GtkTreePath_free0 (path);
	} else {
		FontManagerCategoryModel* _tmp15_;
		_tmp15_ = self->priv->_model_;
		font_manager_category_model_update (_tmp15_);
		font_manager_category_tree_select_first_row (self);
	}
	return;
}

static void
font_manager_category_tree_count_cell_data_func (FontManagerCategoryTree* self,
                                                 GtkTreeViewColumn* layout,
                                                 GtkCellRenderer* cell,
                                                 GtkTreeModel* model,
                                                 GtkTreeIter* treeiter)
{
	GValue _tmp0_ = {0};
	GtkTreeIter _tmp1_;
	GValue val = {0};
	GtkTreeIter _tmp2_;
	GValue _tmp3_ = {0};
	FontManagerCategory* obj = NULL;
	GObject* _tmp4_;
	FontManagerCategory* _tmp5_;
	gboolean _tmp6_ = FALSE;
	FontManagerCategory* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (treeiter != NULL);
	g_value_init (&_tmp0_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp0_, FALSE);
	g_object_set_property ((GObject*) cell, "visible", &_tmp0_);
	G_IS_VALUE (&_tmp0_) ? (g_value_unset (&_tmp0_), NULL) : NULL;
	_tmp1_ = *treeiter;
	if (gtk_tree_model_iter_has_child (model, &_tmp1_)) {
		return;
	}
	_tmp2_ = *treeiter;
	gtk_tree_model_get_value (model, &_tmp2_, (gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT, &_tmp3_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp3_;
	_tmp4_ = g_value_get_object (&val);
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory));
	obj = _tmp5_;
	_tmp7_ = obj;
	_tmp8_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp7_);
	_tmp9_ = _tmp8_;
	if (_tmp9_ < ((gint) FONT_MANAGER_CATEGORY_INDEX_UNSORTED)) {
		_tmp6_ = TRUE;
	} else {
		FontManagerCategory* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		_tmp10_ = obj;
		_tmp11_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp6_ = _tmp12_ == ((gint) FONT_MANAGER_CATEGORY_INDEX_DISABLED);
	}
	if (_tmp6_) {
		FontManagerCategory* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GValue _tmp16_ = {0};
		GValue _tmp17_ = {0};
		_tmp13_ = obj;
		_tmp14_ = font_manager_filter_get_size ((FontManagerFilter*) _tmp13_);
		_tmp15_ = _tmp14_;
		g_value_init (&_tmp16_, G_TYPE_INT);
		g_value_set_int (&_tmp16_, _tmp15_);
		g_object_set_property ((GObject*) cell, "count", &_tmp16_);
		G_IS_VALUE (&_tmp16_) ? (g_value_unset (&_tmp16_), NULL) : NULL;
		g_value_init (&_tmp17_, G_TYPE_BOOLEAN);
		g_value_set_boolean (&_tmp17_, TRUE);
		g_object_set_property ((GObject*) cell, "visible", &_tmp17_);
		G_IS_VALUE (&_tmp17_) ? (g_value_unset (&_tmp17_), NULL) : NULL;
	}
	g_value_unset (&val);
	_g_object_unref0 (obj);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return;
}

static void
font_manager_category_tree_pixbuf_cell_data_func (FontManagerCategoryTree* self,
                                                  GtkTreeViewColumn* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* model,
                                                  GtkTreeIter* treeiter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	GObject* obj = NULL;
	GObject* _tmp2_;
	GObject* _tmp3_;
	GtkTreeIter _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (treeiter != NULL);
	_tmp0_ = *treeiter;
	gtk_tree_model_get_value (model, &_tmp0_, (gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_OBJECT, &_tmp1_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp1_;
	_tmp2_ = g_value_get_object (&val);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	obj = _tmp3_;
	_tmp4_ = *treeiter;
	_tmp5_ = gtk_tree_model_get_path (model, &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = gtk_tree_view_row_expanded ((GtkTreeView*) self, _tmp6_);
	__vala_GtkTreePath_free0 (_tmp6_);
	if (_tmp7_) {
		GValue _tmp8_ = {0};
		g_value_init (&_tmp8_, G_TYPE_STRING);
		g_value_set_string (&_tmp8_, "folder-open-symbolic");
		g_object_set_property ((GObject*) cell, "icon-name", &_tmp8_);
		G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
	} else {
		GObject* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GValue _tmp12_ = {0};
		_tmp9_ = obj;
		_tmp10_ = font_manager_filter_get_icon ((FontManagerFilter*) G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory));
		_tmp11_ = _tmp10_;
		g_value_init (&_tmp12_, G_TYPE_STRING);
		g_value_take_string (&_tmp12_, _tmp11_);
		g_object_set_property ((GObject*) cell, "icon-name", &_tmp12_);
		G_IS_VALUE (&_tmp12_) ? (g_value_unset (&_tmp12_), NULL) : NULL;
	}
	g_value_unset (&val);
	_g_object_unref0 (obj);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return;
}

static void
___lambda46_ (FontManagerCategoryTree* self)
{
	g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_CHANGED_SIGNAL], 0);
}

static void
____lambda46__font_manager_language_filter_selections_changed (FontManagerLanguageFilter* _sender,
                                                               gpointer self)
{
	___lambda46_ ((FontManagerCategoryTree*) self);
}

static gboolean
__lambda45_ (FontManagerCategoryTree* self)
{
	gboolean is_language_filter = FALSE;
	FontManagerCategory* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	FontManagerLanguageFilter* _tmp3_;
	gboolean result;
	_tmp0_ = self->priv->_selected_filter;
	_tmp1_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp0_);
	_tmp2_ = _tmp1_;
	is_language_filter = _tmp2_ == ((gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
	_tmp3_ = self->priv->_language_filter;
	if (_tmp3_ != NULL) {
		result = G_SOURCE_REMOVE;
		return result;
	}
	if (is_language_filter) {
		FontManagerCategory* _tmp4_;
		FontManagerLanguageFilter* _tmp5_;
		_tmp4_ = self->priv->_selected_filter;
		font_manager_category_tree_set_language_filter (self, FONT_MANAGER_IS_LANGUAGE_FILTER (_tmp4_) ? ((FontManagerLanguageFilter*) _tmp4_) : NULL);
		_tmp5_ = self->priv->_language_filter;
		g_signal_connect_object (_tmp5_, "selections-changed", (GCallback) ____lambda46__font_manager_language_filter_selections_changed, self, 0);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda45__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda45_ ((FontManagerCategoryTree*) self);
	return result;
}

static gboolean
___lambda47_ (FontManagerCategoryTree* self)
{
	gboolean _tmp0_ = FALSE;
	FontManagerCategory* _tmp1_;
	gboolean _tmp5_ = FALSE;
	FontManagerCategory* _tmp6_;
	gboolean result;
	_tmp1_ = self->priv->_selected_filter;
	if (_tmp1_ != NULL) {
		FontManagerCategory* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = self->priv->_selected_filter;
		_tmp3_ = font_manager_filter_get_requires_update ((FontManagerFilter*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = !_tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
	_tmp6_ = self->priv->_selected_filter;
	if (_tmp6_ != NULL) {
		FontManagerCategory* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp7_ = self->priv->_selected_filter;
		_tmp8_ = font_manager_filter_get_requires_update ((FontManagerFilter*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp5_ = _tmp9_;
	} else {
		_tmp5_ = FALSE;
	}
	result = _tmp5_;
	return result;
}

static gboolean
____lambda47__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda47_ ((FontManagerCategoryTree*) self);
	return result;
}

static void
____lambda48_ (FontManagerCategoryTree* self,
               GObject* obj,
               GAsyncResult* res)
{
	FontManagerCategory* _tmp0_;
	FontManagerCategory* _tmp1_;
	g_return_if_fail (res != NULL);
	_tmp0_ = self->priv->_selected_filter;
	font_manager_category_update_finish (_tmp0_, res);
	_tmp1_ = self->priv->_selected_filter;
	font_manager_filter_set_requires_update ((FontManagerFilter*) _tmp1_, FALSE);
}

static void
_____lambda48__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	____lambda48_ ((FontManagerCategoryTree*) self, source_object, res);
	g_object_unref (self);
}

static void
font_manager_category_tree_on_selection_changed (FontManagerCategoryTree* self,
                                                 GtkTreeSelection* selection)
{
	GtkTreeIter iter = {0};
	GtkTreeModel* model = NULL;
	GValue val = {0};
	GtkTreeModel* _tmp0_ = NULL;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	GValue _tmp6_ = {0};
	GtkTreePath* path = NULL;
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	GtkTreePath* _tmp9_;
	GValue _tmp10_;
	FontManagerCategory* _tmp11_;
	GtkTreeModel* _tmp12_;
	GtkTreeIter _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkTreePath* _tmp16_;
	GtkTreePath* _tmp18_;
	gboolean _tmp19_ = FALSE;
	FontManagerCategory* _tmp20_;
	FontManagerCategory* _tmp30_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (selection != NULL);
	font_manager_category_tree_set_selected_filter (self, NULL);
	font_manager_category_tree_set_selected_iter (self, "-1");
	_tmp2_ = gtk_tree_selection_get_selected (selection, &_tmp0_, &_tmp1_);
	_g_object_unref0 (model);
	_tmp3_ = _g_object_ref0 (_tmp0_);
	model = _tmp3_;
	iter = _tmp1_;
	if (!_tmp2_) {
		g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_SELECTION_CHANGED_SIGNAL], 0, NULL);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		_g_object_unref0 (model);
		return;
	}
	_tmp4_ = model;
	_tmp5_ = iter;
	gtk_tree_model_get_value (_tmp4_, &_tmp5_, 0, &_tmp6_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp6_;
	_tmp7_ = model;
	_tmp8_ = iter;
	_tmp9_ = gtk_tree_model_get_path (_tmp7_, &_tmp8_);
	path = _tmp9_;
	_tmp10_ = val;
	font_manager_category_tree_set_selected_filter (self, g_value_get_object (&_tmp10_));
	g_value_unset (&val);
	_tmp11_ = self->priv->_selected_filter;
	if (_tmp11_ == NULL) {
		__vala_GtkTreePath_free0 (path);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		_g_object_unref0 (model);
		return;
	}
	_tmp12_ = model;
	_tmp13_ = iter;
	_tmp14_ = gtk_tree_model_get_string_from_iter (_tmp12_, &_tmp13_);
	_tmp15_ = _tmp14_;
	font_manager_category_tree_set_selected_iter (self, _tmp15_);
	_g_free0 (_tmp15_);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda45__gsource_func, g_object_ref (self), g_object_unref);
	_tmp16_ = path;
	if (gtk_tree_path_get_depth (_tmp16_) < 2) {
		GtkTreeViewColumn* _tmp17_;
		gtk_tree_view_collapse_all ((GtkTreeView*) self);
		_tmp17_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
		gtk_tree_view_column_queue_resize (_tmp17_);
	}
	_tmp18_ = path;
	gtk_tree_view_expand_to_path ((GtkTreeView*) self, _tmp18_);
	_tmp20_ = self->priv->_selected_filter;
	if (_tmp20_ != NULL) {
		FontManagerCategory* _tmp21_;
		gboolean _tmp22_;
		gboolean _tmp23_;
		_tmp21_ = self->priv->_selected_filter;
		_tmp22_ = font_manager_filter_get_requires_update ((FontManagerFilter*) _tmp21_);
		_tmp23_ = _tmp22_;
		_tmp19_ = _tmp23_;
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		gboolean _tmp24_ = FALSE;
		FontManagerCategory* _tmp25_;
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda47__gsource_func, g_object_ref (self), g_object_unref);
		_tmp25_ = self->priv->_selected_filter;
		if (_tmp25_ != NULL) {
			FontManagerCategory* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			_tmp26_ = self->priv->_selected_filter;
			_tmp27_ = font_manager_filter_get_index ((FontManagerFilter*) _tmp26_);
			_tmp28_ = _tmp27_;
			_tmp24_ = _tmp28_ < ((gint) FONT_MANAGER_CATEGORY_INDEX_UNSORTED);
		} else {
			_tmp24_ = FALSE;
		}
		if (_tmp24_) {
			FontManagerCategory* _tmp29_;
			_tmp29_ = self->priv->_selected_filter;
			font_manager_category_update (_tmp29_, _____lambda48__gasync_ready_callback, g_object_ref (self));
		}
	}
	_tmp30_ = self->priv->_selected_filter;
	g_signal_emit (self, font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_SELECTION_CHANGED_SIGNAL], 0, _tmp30_);
	__vala_GtkTreePath_free0 (path);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_object_unref0 (model);
	return;
}

FontManagerCategoryTree*
font_manager_category_tree_construct (GType object_type)
{
	FontManagerCategoryTree * self = NULL;
	self = (FontManagerCategoryTree*) font_manager_base_tree_view_construct (object_type);
	return self;
}

FontManagerCategoryTree*
font_manager_category_tree_new (void)
{
	return font_manager_category_tree_construct (FONT_MANAGER_TYPE_CATEGORY_TREE);
}

gboolean
font_manager_category_tree_get_update_in_progress (FontManagerCategoryTree* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_update_in_progress;
	return result;
}

void
font_manager_category_tree_set_update_in_progress (FontManagerCategoryTree* self,
                                                   gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_category_tree_get_update_in_progress (self);
	if (old_value != value) {
		self->priv->_update_in_progress = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY]);
	}
}

const gchar*
font_manager_category_tree_get_selected_iter (FontManagerCategoryTree* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_selected_iter;
	result = _tmp0_;
	return result;
}

void
font_manager_category_tree_set_selected_iter (FontManagerCategoryTree* self,
                                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_category_tree_get_selected_iter (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_selected_iter);
		self->priv->_selected_iter = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY]);
	}
}

FontManagerCategory*
font_manager_category_tree_get_selected_filter (FontManagerCategoryTree* self)
{
	FontManagerCategory* result;
	FontManagerCategory* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_selected_filter;
	result = _tmp0_;
	return result;
}

void
font_manager_category_tree_set_selected_filter (FontManagerCategoryTree* self,
                                                FontManagerCategory* value)
{
	FontManagerCategory* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_category_tree_get_selected_filter (self);
	if (old_value != value) {
		FontManagerCategory* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_selected_filter);
		self->priv->_selected_filter = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY]);
	}
}

FontManagerLanguageFilter*
font_manager_category_tree_get_language_filter (FontManagerCategoryTree* self)
{
	FontManagerLanguageFilter* result;
	FontManagerLanguageFilter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_language_filter;
	result = _tmp0_;
	return result;
}

void
font_manager_category_tree_set_language_filter (FontManagerCategoryTree* self,
                                                FontManagerLanguageFilter* value)
{
	FontManagerLanguageFilter* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_category_tree_get_language_filter (self);
	if (old_value != value) {
		FontManagerLanguageFilter* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_language_filter);
		self->priv->_language_filter = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY]);
	}
}

static void
_font_manager_category_tree_pixbuf_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self)
{
	font_manager_category_tree_pixbuf_cell_data_func ((FontManagerCategoryTree*) self, tree_column, cell, tree_model, iter);
}

static void
_font_manager_category_tree_count_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                          GtkCellRenderer* cell,
                                                                          GtkTreeModel* tree_model,
                                                                          GtkTreeIter* iter,
                                                                          gpointer self)
{
	font_manager_category_tree_count_cell_data_func ((FontManagerCategoryTree*) self, tree_column, cell, tree_model, iter);
}

static gboolean
_font_manager_category_tree___lambda60_ (FontManagerCategoryTree* self,
                                         GtkTreeView* t,
                                         GtkTreeIter* i,
                                         GtkTreePath* p)
{
	gboolean result;
	g_return_val_if_fail (t != NULL, FALSE);
	g_return_val_if_fail (i != NULL, FALSE);
	g_return_val_if_fail (p != NULL, FALSE);
	gtk_tree_view_collapse_all (t);
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
__font_manager_category_tree___lambda60__gtk_tree_view_test_expand_row (GtkTreeView* _sender,
                                                                        GtkTreeIter* iter,
                                                                        GtkTreePath* path,
                                                                        gpointer self)
{
	gboolean result;
	result = _font_manager_category_tree___lambda60_ ((FontManagerCategoryTree*) self, _sender, iter, path);
	return result;
}

static GObject *
font_manager_category_tree_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerCategoryTree * self;
	GtkCellRendererText* _tmp0_;
	FontManagerCellRendererCount* _tmp1_;
	GtkCellRendererPixbuf* _tmp2_;
	GtkCellRendererPixbuf* _tmp3_;
	GtkCellRendererText* _tmp4_;
	GValue _tmp5_ = {0};
	GtkCellRendererText* _tmp6_;
	GValue _tmp7_ = {0};
	GtkCellRendererPixbuf* _tmp8_;
	GtkCellRendererText* _tmp9_;
	FontManagerCellRendererCount* _tmp10_;
	FontManagerCategoryModel* _tmp14_;
	FontManagerCategoryModel* _tmp15_;
	parent_class = G_OBJECT_CLASS (font_manager_category_tree_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree);
	gtk_widget_set_name ((GtkWidget*) self, "FontManagerCategoryTree");
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
	gtk_tree_view_set_level_indentation ((GtkTreeView*) self, 12);
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, FALSE);
	gtk_tree_view_set_show_expanders ((GtkTreeView*) self, FALSE);
	gtk_tree_view_set_tooltip_column ((GtkTreeView*) self, (gint) FONT_MANAGER_CATEGORY_MODEL_COLUMN_COMMENT);
	_tmp0_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->renderer);
	self->priv->renderer = _tmp0_;
	_tmp1_ = font_manager_cell_renderer_count_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->count_renderer);
	self->priv->count_renderer = _tmp1_;
	_tmp2_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->pixbuf_renderer);
	self->priv->pixbuf_renderer = _tmp2_;
	_tmp3_ = self->priv->pixbuf_renderer;
	g_object_set ((GtkCellRenderer*) _tmp3_, "xpad", (guint) 2, NULL);
	_tmp4_ = self->priv->renderer;
	g_value_init (&_tmp5_, pango_ellipsize_mode_get_type ());
	g_value_set_enum (&_tmp5_, PANGO_ELLIPSIZE_END);
	g_object_set_property ((GObject*) _tmp4_, "ellipsize", &_tmp5_);
	G_IS_VALUE (&_tmp5_) ? (g_value_unset (&_tmp5_), NULL) : NULL;
	_tmp6_ = self->priv->renderer;
	g_value_init (&_tmp7_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp7_, TRUE);
	g_object_set_property ((GObject*) _tmp6_, "ellipsize-set", &_tmp7_);
	G_IS_VALUE (&_tmp7_) ? (g_value_unset (&_tmp7_), NULL) : NULL;
	_tmp8_ = self->priv->pixbuf_renderer;
	gtk_tree_view_insert_column_with_data_func ((GtkTreeView*) self, 0, "", (GtkCellRenderer*) _tmp8_, _font_manager_category_tree_pixbuf_cell_data_func_gtk_tree_cell_data_func, g_object_ref (self), g_object_unref);
	_tmp9_ = self->priv->renderer;
	gtk_tree_view_insert_column_with_attributes ((GtkTreeView*) self, 1, "", (GtkCellRenderer*) _tmp9_, "text", FONT_MANAGER_CATEGORY_MODEL_COLUMN_NAME, NULL, NULL);
	_tmp10_ = self->priv->count_renderer;
	gtk_tree_view_insert_column_with_data_func ((GtkTreeView*) self, 2, "", (GtkCellRenderer*) _tmp10_, _font_manager_category_tree_count_cell_data_func_gtk_tree_cell_data_func, g_object_ref (self), g_object_unref);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				GtkTreeViewColumn* _tmp13_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = i;
					i = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				if (!(i < 3)) {
					break;
				}
				_tmp13_ = gtk_tree_view_get_column ((GtkTreeView*) self, i);
				gtk_tree_view_column_set_expand (_tmp13_, i == 1);
			}
		}
	}
	g_signal_connect_object ((GtkTreeView*) self, "test-expand-row", (GCallback) __font_manager_category_tree___lambda60__gtk_tree_view_test_expand_row, self, 0);
	font_manager_category_tree_connect_signals (self);
	_tmp14_ = font_manager_category_model_new ();
	_tmp15_ = _tmp14_;
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp15_);
	_g_object_unref0 (_tmp15_);
	font_manager_category_tree_update (self);
	gtk_widget_show ((GtkWidget*) self);
	return obj;
}

static void
font_manager_category_tree_class_init (FontManagerCategoryTreeClass * klass,
                                       gpointer klass_data)
{
	font_manager_category_tree_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerCategoryTree_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_category_tree_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_category_tree_set_property;
	G_OBJECT_CLASS (klass)->constructor = font_manager_category_tree_constructor;
	G_OBJECT_CLASS (klass)->finalize = font_manager_category_tree_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY] = g_param_spec_boolean ("update-in-progress", "update-in-progress", "update-in-progress", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY] = g_param_spec_string ("selected-iter", "selected-iter", "selected-iter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY] = g_param_spec_object ("selected-filter", "selected-filter", "selected-filter", FONT_MANAGER_TYPE_CATEGORY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY, font_manager_category_tree_properties[FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY] = g_param_spec_object ("language-filter", "language-filter", "language-filter", FONT_MANAGER_TYPE_LANGUAGE_FILTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_CHANGED_SIGNAL] = g_signal_new ("changed", FONT_MANAGER_TYPE_CATEGORY_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", FONT_MANAGER_TYPE_CATEGORY_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, FONT_MANAGER_TYPE_CATEGORY);
	font_manager_category_tree_signals[FONT_MANAGER_CATEGORY_TREE_UPDATE_COMPLETE_SIGNAL] = g_signal_new ("update-complete", FONT_MANAGER_TYPE_CATEGORY_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
font_manager_category_tree_instance_init (FontManagerCategoryTree * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
	self->priv = font_manager_category_tree_get_instance_private (self);
	self->priv->_update_in_progress = TRUE;
	_tmp0_ = g_strdup ("0");
	self->priv->_selected_iter = _tmp0_;
	self->priv->_selected_filter = NULL;
	self->priv->_language_filter = NULL;
	self->priv->change_timeout = NULL;
	self->priv->refresh_required = FALSE;
}

static void
font_manager_category_tree_finalize (GObject * obj)
{
	FontManagerCategoryTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree);
	_g_free0 (self->priv->_selected_iter);
	_g_object_unref0 (self->priv->_selected_filter);
	_g_object_unref0 (self->priv->_language_filter);
	_g_free0 (self->priv->change_timeout);
	_g_object_unref0 (self->priv->renderer);
	_g_object_unref0 (self->priv->count_renderer);
	_g_object_unref0 (self->priv->pixbuf_renderer);
	_g_object_unref0 (self->priv->_model_);
	G_OBJECT_CLASS (font_manager_category_tree_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_category_tree_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerCategoryTreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_category_tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerCategoryTree), 0, (GInstanceInitFunc) font_manager_category_tree_instance_init, NULL };
	GType font_manager_category_tree_type_id;
	font_manager_category_tree_type_id = g_type_register_static (FONT_MANAGER_TYPE_BASE_TREE_VIEW, "FontManagerCategoryTree", &g_define_type_info, 0);
	FontManagerCategoryTree_private_offset = g_type_add_instance_private (font_manager_category_tree_type_id, sizeof (FontManagerCategoryTreePrivate));
	return font_manager_category_tree_type_id;
}

GType
font_manager_category_tree_get_type (void)
{
	static volatile gsize font_manager_category_tree_type_id__once = 0;
	if (g_once_init_enter (&font_manager_category_tree_type_id__once)) {
		GType font_manager_category_tree_type_id;
		font_manager_category_tree_type_id = font_manager_category_tree_get_type_once ();
		g_once_init_leave (&font_manager_category_tree_type_id__once, font_manager_category_tree_type_id);
	}
	return font_manager_category_tree_type_id__once;
}

static void
_vala_font_manager_category_tree_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	FontManagerCategoryTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree);
	switch (property_id) {
		case FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY:
		g_value_set_boolean (value, font_manager_category_tree_get_update_in_progress (self));
		break;
		case FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY:
		g_value_set_string (value, font_manager_category_tree_get_selected_iter (self));
		break;
		case FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY:
		g_value_set_object (value, font_manager_category_tree_get_selected_filter (self));
		break;
		case FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY:
		g_value_set_object (value, font_manager_category_tree_get_language_filter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_category_tree_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	FontManagerCategoryTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_CATEGORY_TREE, FontManagerCategoryTree);
	switch (property_id) {
		case FONT_MANAGER_CATEGORY_TREE_UPDATE_IN_PROGRESS_PROPERTY:
		font_manager_category_tree_set_update_in_progress (self, g_value_get_boolean (value));
		break;
		case FONT_MANAGER_CATEGORY_TREE_SELECTED_ITER_PROPERTY:
		font_manager_category_tree_set_selected_iter (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_CATEGORY_TREE_SELECTED_FILTER_PROPERTY:
		font_manager_category_tree_set_selected_filter (self, g_value_get_object (value));
		break;
		case FONT_MANAGER_CATEGORY_TREE_LANGUAGE_FILTER_PROPERTY:
		font_manager_category_tree_set_language_filter (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

void
font_manager_filter_data_copy (const FontManagerFilterData* self,
                               FontManagerFilterData* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	(*dest).index = (*self).index;
	_tmp0_ = (*self).name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).name);
	(*dest).name = _tmp1_;
	_tmp2_ = (*self).comment;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).comment);
	(*dest).comment = _tmp3_;
	_tmp4_ = (*self).column;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).column);
	(*dest).column = _tmp5_;
}

void
font_manager_filter_data_destroy (FontManagerFilterData* self)
{
	_g_free0 ((*self).name);
	_g_free0 ((*self).comment);
	_g_free0 ((*self).column);
}

FontManagerFilterData*
font_manager_filter_data_dup (const FontManagerFilterData* self)
{
	FontManagerFilterData* dup;
	dup = g_new0 (FontManagerFilterData, 1);
	font_manager_filter_data_copy (self, dup);
	return dup;
}

void
font_manager_filter_data_free (FontManagerFilterData* self)
{
	font_manager_filter_data_destroy (self);
	g_free (self);
}

 G_GNUC_NO_INLINE static GType
font_manager_filter_data_get_type_once (void)
{
	GType font_manager_filter_data_type_id;
	font_manager_filter_data_type_id = g_boxed_type_register_static ("FontManagerFilterData", (GBoxedCopyFunc) font_manager_filter_data_dup, (GBoxedFreeFunc) font_manager_filter_data_free);
	return font_manager_filter_data_type_id;
}

GType
font_manager_filter_data_get_type (void)
{
	static volatile gsize font_manager_filter_data_type_id__once = 0;
	if (g_once_init_enter (&font_manager_filter_data_type_id__once)) {
		GType font_manager_filter_data_type_id;
		font_manager_filter_data_type_id = font_manager_filter_data_get_type_once ();
		g_once_init_leave (&font_manager_filter_data_type_id__once, font_manager_filter_data_type_id);
	}
	return font_manager_filter_data_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

GPtrArray*
font_manager_get_default_categories (FontManagerDatabase* db)
{
	GPtrArray* filters = NULL;
	GPtrArray* _tmp0_;
	GPtrArray* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	FontManagerCategory* _tmp4_;
	GPtrArray* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	FontManagerCategory* _tmp8_;
	GPtrArray* _tmp9_;
	FontManagerUserFonts* _tmp10_;
	GPtrArray* _tmp11_;
	FontManagerCategory* _tmp12_;
	GPtrArray* _tmp19_;
	FontManagerUnsorted* _tmp20_;
	GPtrArray* _tmp21_;
	FontManagerDisabled* _tmp22_;
	GPtrArray* _tmp23_;
	FontManagerLanguageFilter* _tmp24_;
	GPtrArray* result;
	g_return_val_if_fail (db != NULL, NULL);
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
	filters = _tmp0_;
	_tmp1_ = filters;
	_tmp2_ = g_strdup_printf ("%s;", FONT_MANAGER_SELECT_FROM_FONTS);
	_tmp3_ = _tmp2_;
	_tmp4_ = font_manager_category_new (_ ("All"), _ ("All Fonts"), "format-text-bold-symbolic", _tmp3_, (gint) FONT_MANAGER_CATEGORY_INDEX_ALL);
	g_ptr_array_add (_tmp1_, _tmp4_);
	_g_free0 (_tmp3_);
	_tmp5_ = filters;
	_tmp6_ = g_strdup_printf ("%s owner!=0 AND filepath LIKE '/usr%';", FONT_MANAGER_SELECT_FROM_METADATA_WHERE);
	_tmp7_ = _tmp6_;
	_tmp8_ = font_manager_category_new (_ ("System"), _ ("Fonts available to all users"), "computer-symbolic", _tmp7_, (gint) FONT_MANAGER_CATEGORY_INDEX_SYSTEM);
	g_ptr_array_add (_tmp5_, _tmp8_);
	_g_free0 (_tmp7_);
	_tmp9_ = filters;
	_tmp10_ = font_manager_user_fonts_new ();
	g_ptr_array_add (_tmp9_, (FontManagerCategory*) _tmp10_);
	_tmp11_ = filters;
	_tmp12_ = font_manager_construct_panose_filter ();
	g_ptr_array_add (_tmp11_, _tmp12_);
	{
		FontManagerFilterData* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = FONT_MANAGER_attributes;
		entry_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_attributes);
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
			FontManagerFilterData entry = {0};
			entry = entry_collection[entry_it];
			{
				GPtrArray* _tmp13_;
				FontManagerFilterData _tmp14_;
				FontManagerCategory* _tmp15_;
				_tmp13_ = filters;
				_tmp14_ = entry;
				_tmp15_ = font_manager_construct_attribute_filter (db, &_tmp14_);
				g_ptr_array_add (_tmp13_, _tmp15_);
			}
		}
	}
	{
		FontManagerFilterData* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = FONT_MANAGER_metadata;
		entry_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_metadata);
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
			FontManagerFilterData entry = {0};
			entry = entry_collection[entry_it];
			{
				GPtrArray* _tmp16_;
				FontManagerFilterData _tmp17_;
				FontManagerCategory* _tmp18_;
				_tmp16_ = filters;
				_tmp17_ = entry;
				_tmp18_ = font_manager_construct_info_filter (db, &_tmp17_);
				g_ptr_array_add (_tmp16_, _tmp18_);
			}
		}
	}
	_tmp19_ = filters;
	_tmp20_ = font_manager_unsorted_new ();
	g_ptr_array_add (_tmp19_, (FontManagerCategory*) _tmp20_);
	_tmp21_ = filters;
	_tmp22_ = font_manager_disabled_new ();
	g_ptr_array_add (_tmp21_, (FontManagerCategory*) _tmp22_);
	_tmp23_ = filters;
	_tmp24_ = font_manager_language_filter_new ();
	g_ptr_array_add (_tmp23_, (FontManagerCategory*) _tmp24_);
	result = filters;
	return result;
}

FontManagerCategory*
font_manager_construct_panose_filter (void)
{
	FontManagerCategory* panose = NULL;
	FontManagerCategory* _tmp0_;
	gchar** kind = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint kind_length1;
	gint _kind_size_;
	FontManagerCategory* result;
	_tmp0_ = font_manager_category_new (_ ("Family Kind"), _ ("Only fonts which include Panose information will be grouped here."), "folder-symbolic", NULL, (gint) FONT_MANAGER_CATEGORY_INDEX_PANOSE);
	panose = _tmp0_;
	_tmp1_ = g_strdup (_ ("Any"));
	_tmp2_ = g_strdup (_ ("No Fit"));
	_tmp3_ = g_strdup (_ ("Text and Display"));
	_tmp4_ = g_strdup (_ ("Script"));
	_tmp5_ = g_strdup (_ ("Decorative"));
	_tmp6_ = g_strdup (_ ("Pictorial"));
	_tmp7_ = g_new0 (gchar*, 6 + 1);
	_tmp7_[0] = _tmp1_;
	_tmp7_[1] = _tmp2_;
	_tmp7_[2] = _tmp3_;
	_tmp7_[3] = _tmp4_;
	_tmp7_[4] = _tmp5_;
	_tmp7_[5] = _tmp6_;
	kind = _tmp7_;
	kind_length1 = 6;
	_kind_size_ = kind_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				gchar** _tmp10_;
				gint _tmp10__length1;
				FontManagerCategory* _tmp11_;
				GPtrArray* _tmp12_;
				GPtrArray* _tmp13_;
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp15_;
				gchar** _tmp16_;
				gint _tmp16__length1;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				FontManagerCategory* _tmp20_;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = i;
					i = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = kind;
				_tmp10__length1 = kind_length1;
				if (!(i < _tmp10__length1)) {
					break;
				}
				_tmp11_ = panose;
				_tmp12_ = font_manager_category_get_children (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = kind;
				_tmp14__length1 = kind_length1;
				_tmp15_ = _tmp14_[i];
				_tmp16_ = kind;
				_tmp16__length1 = kind_length1;
				_tmp17_ = _tmp16_[i];
				_tmp18_ = g_strdup_printf ("%s P0 = '%i';", FONT_MANAGER_SELECT_FROM_PANOSE_WHERE, i);
				_tmp19_ = _tmp18_;
				_tmp20_ = font_manager_category_new (_tmp15_, _tmp17_, "emblem-documents-symbolic", _tmp19_, i);
				g_ptr_array_add (_tmp13_, _tmp20_);
				_g_free0 (_tmp19_);
			}
		}
	}
	result = panose;
	kind = (_vala_array_free (kind, kind_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

FontManagerCategory*
font_manager_construct_attribute_filter (FontManagerDatabase* db,
                                         FontManagerFilterData* data)
{
	gchar* name = NULL;
	FontManagerFilterData _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* comment = NULL;
	FontManagerFilterData _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	FontManagerCategory* filter = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	FontManagerFilterData _tmp8_;
	FontManagerCategory* _tmp9_;
	GError* _inner_error0_ = NULL;
	FontManagerCategory* result;
	g_return_val_if_fail (db != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_tmp0_ = *data;
	_tmp1_ = _tmp0_.name;
	_tmp2_ = g_strdup (g_dgettext (NULL, _tmp1_));
	name = _tmp2_;
	_tmp3_ = *data;
	_tmp4_ = _tmp3_.comment;
	_tmp5_ = g_strdup (g_dgettext (NULL, _tmp4_));
	comment = _tmp5_;
	_tmp6_ = name;
	_tmp7_ = comment;
	_tmp8_ = *data;
	_tmp9_ = font_manager_category_new (_tmp6_, _tmp7_, "folder-symbolic", NULL, _tmp8_.index);
	filter = _tmp9_;
	{
		gchar* keyword = NULL;
		FontManagerFilterData _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp10_ = *data;
		_tmp11_ = _tmp10_.column;
		_tmp12_ = g_strdup (_tmp11_);
		keyword = _tmp12_;
		_tmp13_ = keyword;
		_tmp14_ = keyword;
		_tmp15_ = g_strdup_printf ("SELECT DISTINCT %s FROM Fonts ORDER BY %s;", _tmp13_, _tmp14_);
		_tmp16_ = _tmp15_;
		font_manager_database_execute_query (db, _tmp16_, &_inner_error0_);
		_g_free0 (_tmp16_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (keyword);
			if (_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
				goto __catch0_font_manager_database_error;
			}
			_g_object_unref0 (filter);
			_g_free0 (comment);
			_g_free0 (name);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		{
			FontManagerDatabaseIterator* _row_it = NULL;
			FontManagerDatabaseIterator* _tmp17_;
			_tmp17_ = font_manager_database_iterator (db);
			_row_it = _tmp17_;
			while (TRUE) {
				FontManagerDatabaseIterator* _tmp18_;
				sqlite3_stmt* row = NULL;
				FontManagerDatabaseIterator* _tmp19_;
				sqlite3_stmt* _tmp20_;
				gint val = 0;
				sqlite3_stmt* _tmp21_;
				gchar* type = NULL;
				const gchar* _tmp22_;
				const gchar* _tmp34_;
				FontManagerCategory* _tmp45_;
				GPtrArray* _tmp46_;
				GPtrArray* _tmp47_;
				const gchar* _tmp48_;
				const gchar* _tmp49_;
				const gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				FontManagerFilterData _tmp53_;
				FontManagerCategory* _tmp54_;
				_tmp18_ = _row_it;
				if (!font_manager_database_iterator_next (_tmp18_)) {
					break;
				}
				_tmp19_ = _row_it;
				_tmp20_ = font_manager_database_iterator_get (_tmp19_);
				row = _tmp20_;
				_tmp21_ = row;
				val = sqlite3_column_int (_tmp21_, 0);
				type = NULL;
				_tmp22_ = keyword;
				if (g_strcmp0 (_tmp22_, "slant") == 0) {
					const gchar* _tmp23_;
					gchar* _tmp24_;
					_tmp23_ = font_manager_slant_to_string ((FontManagerSlant) val);
					_tmp24_ = g_strdup (_tmp23_);
					_g_free0 (type);
					type = _tmp24_;
				} else {
					const gchar* _tmp25_;
					_tmp25_ = keyword;
					if (g_strcmp0 (_tmp25_, "spacing") == 0) {
						const gchar* _tmp26_;
						gchar* _tmp27_;
						_tmp26_ = font_manager_spacing_to_string ((FontManagerSpacing) val);
						_tmp27_ = g_strdup (_tmp26_);
						_g_free0 (type);
						type = _tmp27_;
					} else {
						const gchar* _tmp28_;
						_tmp28_ = keyword;
						if (g_strcmp0 (_tmp28_, "weight") == 0) {
							const gchar* _tmp29_;
							gchar* _tmp30_;
							_tmp29_ = font_manager_weight_to_string ((FontManagerWeight) val);
							_tmp30_ = g_strdup (_tmp29_);
							_g_free0 (type);
							type = _tmp30_;
						} else {
							const gchar* _tmp31_;
							_tmp31_ = keyword;
							if (g_strcmp0 (_tmp31_, "width") == 0) {
								const gchar* _tmp32_;
								gchar* _tmp33_;
								_tmp32_ = font_manager_width_to_string ((FontManagerWidth) val);
								_tmp33_ = g_strdup (_tmp32_);
								_g_free0 (type);
								type = _tmp33_;
							}
						}
					}
				}
				_tmp34_ = type;
				if (_tmp34_ == NULL) {
					gboolean _tmp35_ = FALSE;
					const gchar* _tmp36_;
					_tmp36_ = keyword;
					if (g_strcmp0 (_tmp36_, "slant") == 0) {
						_tmp35_ = TRUE;
					} else {
						gboolean _tmp37_ = FALSE;
						const gchar* _tmp38_;
						_tmp38_ = keyword;
						if (g_strcmp0 (_tmp38_, "width") == 0) {
							_tmp37_ = font_manager_width_defined ((FontManagerWidth) val);
						} else {
							_tmp37_ = FALSE;
						}
						_tmp35_ = _tmp37_;
					}
					if (_tmp35_) {
						gchar* _tmp39_;
						_tmp39_ = g_strdup (_ ("Normal"));
						_g_free0 (type);
						type = _tmp39_;
					} else {
						gboolean _tmp40_ = FALSE;
						const gchar* _tmp41_;
						_tmp41_ = keyword;
						if (g_strcmp0 (_tmp41_, "width") == 0) {
							_tmp40_ = TRUE;
						} else {
							gboolean _tmp42_ = FALSE;
							const gchar* _tmp43_;
							_tmp43_ = keyword;
							if (g_strcmp0 (_tmp43_, "weight") == 0) {
								_tmp42_ = !font_manager_weight_defined ((FontManagerWeight) val);
							} else {
								_tmp42_ = FALSE;
							}
							_tmp40_ = _tmp42_;
						}
						if (_tmp40_) {
							_g_free0 (type);
							continue;
						} else {
							gchar* _tmp44_;
							_tmp44_ = g_strdup (_ ("Regular"));
							_g_free0 (type);
							type = _tmp44_;
						}
					}
				}
				_tmp45_ = filter;
				_tmp46_ = font_manager_category_get_children (_tmp45_);
				_tmp47_ = _tmp46_;
				_tmp48_ = type;
				_tmp49_ = type;
				_tmp50_ = keyword;
				_tmp51_ = g_strdup_printf ("%s WHERE %s=\"%i\";", FONT_MANAGER_SELECT_FROM_FONTS, _tmp50_, val);
				_tmp52_ = _tmp51_;
				_tmp53_ = *data;
				_tmp54_ = font_manager_category_new (_tmp48_, _tmp49_, "emblem-documents-symbolic", _tmp52_, _tmp53_.index);
				g_ptr_array_add (_tmp47_, _tmp54_);
				_g_free0 (_tmp52_);
				_g_free0 (type);
			}
			_g_object_unref0 (_row_it);
		}
		_g_free0 (keyword);
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (filter);
		_g_free0 (comment);
		_g_free0 (name);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = filter;
	_g_free0 (comment);
	_g_free0 (name);
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

FontManagerCategory*
font_manager_construct_info_filter (FontManagerDatabase* db,
                                    FontManagerFilterData* data)
{
	gchar* keyword = NULL;
	FontManagerFilterData _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* name = NULL;
	FontManagerFilterData _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* comment = NULL;
	FontManagerFilterData _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	FontManagerCategory* filter = NULL;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	FontManagerFilterData _tmp14_;
	FontManagerCategory* _tmp15_;
	GError* _inner_error0_ = NULL;
	FontManagerCategory* result;
	g_return_val_if_fail (db != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_tmp0_ = *data;
	_tmp1_ = _tmp0_.column;
	_tmp2_ = string_replace (_tmp1_, "\"", "\\\"");
	_tmp3_ = _tmp2_;
	_tmp4_ = string_replace (_tmp3_, "'", "''");
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	keyword = _tmp5_;
	_tmp6_ = *data;
	_tmp7_ = _tmp6_.name;
	_tmp8_ = g_strdup (g_dgettext (NULL, _tmp7_));
	name = _tmp8_;
	_tmp9_ = *data;
	_tmp10_ = _tmp9_.comment;
	_tmp11_ = g_strdup (g_dgettext (NULL, _tmp10_));
	comment = _tmp11_;
	_tmp12_ = name;
	_tmp13_ = comment;
	_tmp14_ = *data;
	_tmp15_ = font_manager_category_new (_tmp12_, _tmp13_, "folder-symbolic", NULL, _tmp14_.index);
	filter = _tmp15_;
	{
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		_tmp16_ = keyword;
		_tmp17_ = keyword;
		_tmp18_ = g_strdup_printf ("SELECT DISTINCT [%s] FROM Metadata ORDER BY [%s];", _tmp16_, _tmp17_);
		_tmp19_ = _tmp18_;
		font_manager_database_execute_query (db, _tmp19_, &_inner_error0_);
		_g_free0 (_tmp19_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
				goto __catch0_font_manager_database_error;
			}
			_g_object_unref0 (filter);
			_g_free0 (comment);
			_g_free0 (name);
			_g_free0 (keyword);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		{
			FontManagerDatabaseIterator* _row_it = NULL;
			FontManagerDatabaseIterator* _tmp20_;
			_tmp20_ = font_manager_database_iterator (db);
			_row_it = _tmp20_;
			while (TRUE) {
				FontManagerDatabaseIterator* _tmp21_;
				sqlite3_stmt* row = NULL;
				FontManagerDatabaseIterator* _tmp22_;
				sqlite3_stmt* _tmp23_;
				gchar* _type = NULL;
				sqlite3_stmt* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* type = NULL;
				const gchar* _tmp27_;
				gchar* _tmp28_;
				FontManagerCategory* _tmp29_;
				GPtrArray* _tmp30_;
				GPtrArray* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				FontManagerFilterData _tmp38_;
				FontManagerCategory* _tmp39_;
				_tmp21_ = _row_it;
				if (!font_manager_database_iterator_next (_tmp21_)) {
					break;
				}
				_tmp22_ = _row_it;
				_tmp23_ = font_manager_database_iterator_get (_tmp22_);
				row = _tmp23_;
				_tmp24_ = row;
				_tmp25_ = (const gchar*) sqlite3_column_text (_tmp24_, 0);
				_tmp26_ = g_strdup (_tmp25_);
				_type = _tmp26_;
				_tmp27_ = _type;
				_tmp28_ = g_strdup (g_dgettext (NULL, _tmp27_));
				type = _tmp28_;
				_tmp29_ = filter;
				_tmp30_ = font_manager_category_get_children (_tmp29_);
				_tmp31_ = _tmp30_;
				_tmp32_ = type;
				_tmp33_ = type;
				_tmp34_ = keyword;
				_tmp35_ = _type;
				_tmp36_ = g_strdup_printf ("%s [%s]=\"%s\";", FONT_MANAGER_SELECT_FROM_METADATA_WHERE, _tmp34_, _tmp35_);
				_tmp37_ = _tmp36_;
				_tmp38_ = *data;
				_tmp39_ = font_manager_category_new (_tmp32_, _tmp33_, "emblem-documents", _tmp37_, _tmp38_.index);
				g_ptr_array_add (_tmp31_, _tmp39_);
				_g_free0 (_tmp37_);
				_g_free0 (type);
				_g_free0 (_type);
			}
			_g_object_unref0 (_row_it);
		}
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (filter);
		_g_free0 (comment);
		_g_free0 (name);
		_g_free0 (keyword);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = filter;
	_g_free0 (comment);
	_g_free0 (name);
	_g_free0 (keyword);
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

