/* LanguageFilter.c generated by valac 0.56.14, the Vala compiler
 * generated from LanguageFilter.vala, do not modify */

/* LanguageFilter.vala
 *
 * Copyright (C) 2009-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <gtk/gtk.h>
#include "font-manager.h"
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <locale.h>
#include <pango/pango.h>

#define SELECT_ON_LANGUAGE "\n" \
"SELECT DISTINCT Fonts.family, Fonts.description\n" \
"FROM Fonts, json_tree(Orthography.support, '$.%s')\n" \
"JOIN Orthography USING (filepath, findex)\n" \
"WHERE json_tree.key = 'coverage' AND json_tree.value > %f;\n"
#define DEFAULT_LANGUAGE_FILTER_COMMENT _ ("Filter based on supported orthographies")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FONT_MANAGER_TYPE_CACHEABLE (font_manager_cacheable_get_type ())
#define FONT_MANAGER_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheable))
#define FONT_MANAGER_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheableClass))
#define FONT_MANAGER_IS_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CACHEABLE))
#define FONT_MANAGER_IS_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CACHEABLE))
#define FONT_MANAGER_CACHEABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CACHEABLE, FontManagerCacheableClass))

typedef struct _FontManagerCacheable FontManagerCacheable;
typedef struct _FontManagerCacheableClass FontManagerCacheableClass;
typedef struct _FontManagerCacheablePrivate FontManagerCacheablePrivate;

#define FONT_MANAGER_TYPE_FILTER (font_manager_filter_get_type ())
#define FONT_MANAGER_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FILTER, FontManagerFilter))
#define FONT_MANAGER_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FILTER, FontManagerFilterClass))
#define FONT_MANAGER_IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FILTER))
#define FONT_MANAGER_IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FILTER))
#define FONT_MANAGER_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FILTER, FontManagerFilterClass))

typedef struct _FontManagerFilter FontManagerFilter;
typedef struct _FontManagerFilterClass FontManagerFilterClass;
typedef struct _FontManagerFilterPrivate FontManagerFilterPrivate;

#define FONT_MANAGER_TYPE_CATEGORY (font_manager_category_get_type ())
#define FONT_MANAGER_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategory))
#define FONT_MANAGER_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategoryClass))
#define FONT_MANAGER_IS_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_CATEGORY))
#define FONT_MANAGER_IS_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_CATEGORY))
#define FONT_MANAGER_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_CATEGORY, FontManagerCategoryClass))

typedef struct _FontManagerCategory FontManagerCategory;
typedef struct _FontManagerCategoryClass FontManagerCategoryClass;
typedef struct _FontManagerCategoryPrivate FontManagerCategoryPrivate;

#define FONT_MANAGER_TYPE_LANGUAGE_FILTER (font_manager_language_filter_get_type ())
#define FONT_MANAGER_LANGUAGE_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter))
#define FONT_MANAGER_LANGUAGE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilterClass))
#define FONT_MANAGER_IS_LANGUAGE_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER))
#define FONT_MANAGER_IS_LANGUAGE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER))
#define FONT_MANAGER_LANGUAGE_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilterClass))

typedef struct _FontManagerLanguageFilter FontManagerLanguageFilter;
typedef struct _FontManagerLanguageFilterClass FontManagerLanguageFilterClass;
typedef struct _FontManagerLanguageFilterPrivate FontManagerLanguageFilterPrivate;

#define FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS (font_manager_language_filter_settings_get_type ())
#define FONT_MANAGER_LANGUAGE_FILTER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS, FontManagerLanguageFilterSettings))
#define FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS, FontManagerLanguageFilterSettingsClass))
#define FONT_MANAGER_IS_LANGUAGE_FILTER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS))
#define FONT_MANAGER_IS_LANGUAGE_FILTER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS))
#define FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS, FontManagerLanguageFilterSettingsClass))

typedef struct _FontManagerLanguageFilterSettings FontManagerLanguageFilterSettings;
typedef struct _FontManagerLanguageFilterSettingsClass FontManagerLanguageFilterSettingsClass;
enum  {
	FONT_MANAGER_LANGUAGE_FILTER_0_PROPERTY,
	FONT_MANAGER_LANGUAGE_FILTER_SELECTED_PROPERTY,
	FONT_MANAGER_LANGUAGE_FILTER_COVERAGE_PROPERTY,
	FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_PROPERTY,
	FONT_MANAGER_LANGUAGE_FILTER_SIZE_PROPERTY,
	FONT_MANAGER_LANGUAGE_FILTER_NUM_PROPERTIES
};
static GParamSpec* font_manager_language_filter_properties[FONT_MANAGER_LANGUAGE_FILTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	FONT_MANAGER_CATEGORY_INDEX_ALL,
	FONT_MANAGER_CATEGORY_INDEX_SYSTEM,
	FONT_MANAGER_CATEGORY_INDEX_USER,
	FONT_MANAGER_CATEGORY_INDEX_PANOSE,
	FONT_MANAGER_CATEGORY_INDEX_WIDTH,
	FONT_MANAGER_CATEGORY_INDEX_WEIGHT,
	FONT_MANAGER_CATEGORY_INDEX_SLANT,
	FONT_MANAGER_CATEGORY_INDEX_SPACING,
	FONT_MANAGER_CATEGORY_INDEX_LICENSE,
	FONT_MANAGER_CATEGORY_INDEX_VENDOR,
	FONT_MANAGER_CATEGORY_INDEX_FILETYPE,
	FONT_MANAGER_CATEGORY_INDEX_UNSORTED,
	FONT_MANAGER_CATEGORY_INDEX_DISABLED,
	FONT_MANAGER_CATEGORY_INDEX_LANGUAGE,
	FONT_MANAGER_CATEGORY_INDEX_N_CATEGORIES
} FontManagerCategoryIndex;

#define FONT_MANAGER_TYPE_CATEGORY_INDEX (font_manager_category_index_get_type ())

#define FONT_MANAGER_TYPE_APPLICATION (font_manager_application_get_type ())
#define FONT_MANAGER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplication))
#define FONT_MANAGER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))
#define FONT_MANAGER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))

typedef struct _FontManagerApplication FontManagerApplication;
typedef struct _FontManagerApplicationClass FontManagerApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FontManagerLanguageFilterUpdateData FontManagerLanguageFilterUpdateData;
enum  {
	FONT_MANAGER_LANGUAGE_FILTER_SELECTIONS_CHANGED_SIGNAL,
	FONT_MANAGER_LANGUAGE_FILTER_NUM_SIGNALS
};
static guint font_manager_language_filter_signals[FONT_MANAGER_LANGUAGE_FILTER_NUM_SIGNALS] = {0};
typedef struct _FontManagerLanguageFilterSettingsPrivate FontManagerLanguageFilterSettingsPrivate;
enum  {
	FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_0_PROPERTY,
	FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* font_manager_language_filter_settings_properties[FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_MAIN_WINDOW (font_manager_main_window_get_type ())
#define FONT_MANAGER_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindow))
#define FONT_MANAGER_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindowClass))
#define FONT_MANAGER_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindowClass))

typedef struct _FontManagerMainWindow FontManagerMainWindow;
typedef struct _FontManagerMainWindowClass FontManagerMainWindowClass;

#define FONT_MANAGER_TYPE_SIDEBAR (font_manager_sidebar_get_type ())
#define FONT_MANAGER_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_SIDEBAR, FontManagerSidebar))
#define FONT_MANAGER_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_SIDEBAR, FontManagerSidebarClass))
#define FONT_MANAGER_IS_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_SIDEBAR))
#define FONT_MANAGER_IS_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_SIDEBAR))
#define FONT_MANAGER_SIDEBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_SIDEBAR, FontManagerSidebarClass))

typedef struct _FontManagerSidebar FontManagerSidebar;
typedef struct _FontManagerSidebarClass FontManagerSidebarClass;

#define FONT_MANAGER_TYPE_BASE_ORTHOGRAPHY_DATA (font_manager_base_orthography_data_get_type ())
typedef struct _FontManagerBaseOrthographyData FontManagerBaseOrthographyData;
typedef enum  {
	FONT_MANAGER_FONT_LIST_COLUMN_TOGGLE,
	FONT_MANAGER_FONT_LIST_COLUMN_TEXT,
	FONT_MANAGER_FONT_LIST_COLUMN_PREVIEW,
	FONT_MANAGER_FONT_LIST_COLUMN_COUNT,
	FONT_MANAGER_FONT_LIST_COLUMN_N_COLUMNS
} FontManagerFontListColumn;

#define FONT_MANAGER_TYPE_FONT_LIST_COLUMN (font_manager_font_list_column_get_type ())
enum  {
	FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_SELECTIONS_CHANGED_SIGNAL,
	FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_NUM_SIGNALS
};
static guint font_manager_language_filter_settings_signals[FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerCacheable {
	GObject parent_instance;
	FontManagerCacheablePrivate * priv;
};

struct _FontManagerCacheableClass {
	GObjectClass parent_class;
	gboolean (*deserialize_property) (FontManagerCacheable* self, const gchar* prop_name, GValue* val, GParamSpec* pspec, JsonNode* node);
	JsonNode* (*serialize_property) (FontManagerCacheable* self, const gchar* prop_name, GValue* val, GParamSpec* pspec);
};

struct _FontManagerFilter {
	FontManagerCacheable parent_instance;
	FontManagerFilterPrivate * priv;
};

struct _FontManagerFilterClass {
	FontManagerCacheableClass parent_class;
	void (*update) (FontManagerFilter* self);
	gboolean (*visible_func) (FontManagerFilter* self, GtkTreeModel* model, GtkTreeIter* iter);
	gchar* (*get_name) (FontManagerFilter* self);
	void (*set_name) (FontManagerFilter* self, const gchar* value);
	gchar* (*get_icon) (FontManagerFilter* self);
	void (*set_icon) (FontManagerFilter* self, const gchar* value);
	gchar* (*get_comment) (FontManagerFilter* self);
	void (*set_comment) (FontManagerFilter* self, const gchar* value);
	gint (*get_index) (FontManagerFilter* self);
	void (*set_index) (FontManagerFilter* self, gint value);
	gint (*get_size) (FontManagerFilter* self);
};

struct _FontManagerCategory {
	FontManagerFilter parent_instance;
	FontManagerCategoryPrivate * priv;
};

struct _FontManagerCategoryClass {
	FontManagerFilterClass parent_class;
};

struct _FontManagerLanguageFilter {
	FontManagerCategory parent_instance;
	FontManagerLanguageFilterPrivate * priv;
};

struct _FontManagerLanguageFilterClass {
	FontManagerCategoryClass parent_class;
};

struct _FontManagerLanguageFilterPrivate {
	FontManagerStringSet* _selected;
	gdouble _coverage;
	FontManagerLanguageFilterSettings* _settings;
};

struct _FontManagerLanguageFilterUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FontManagerLanguageFilter* self;
	FontManagerStringSet* _tmp0_;
	FontManagerStringSet* _tmp1_;
	FontManagerStringSet* _tmp2_;
	FontManagerStringSet* _tmp3_;
	FontManagerDatabase* db;
	FontManagerDatabaseType _tmp4_;
	FontManagerDatabaseType _tmp5_;
	FontManagerDatabase* _tmp6_;
	FontManagerStringSet* _language_list;
	FontManagerStringSet* _tmp7_;
	guint _language_size;
	FontManagerStringSet* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	gint _language_index;
	gint _tmp11_;
	guint _tmp12_;
	gchar* language;
	FontManagerStringSet* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* pref_loc;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _sql_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gdouble _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	FontManagerDatabase* _tmp24_;
	FontManagerStringSet* _tmp25_;
	FontManagerStringSet* _tmp26_;
	FontManagerStringSet* _tmp27_;
	FontManagerStringSet* _tmp28_;
	const gchar* _tmp29_;
	GError* _error_;
	GError* _tmp30_;
	const gchar* _tmp31_;
	FontManagerStringSet* available_families;
	FontManagerApplication* _tmp32_;
	FontManagerApplication* _tmp33_;
	FontManagerStringSet* _tmp34_;
	FontManagerStringSet* _tmp35_;
	FontManagerStringSet* _tmp36_;
	FontManagerStringSet* _tmp37_;
	FontManagerStringSet* _tmp38_;
	FontManagerStringSet* _tmp39_;
	GError* _inner_error0_;
};

struct _FontManagerLanguageFilterSettings {
	GtkBox parent_instance;
	FontManagerLanguageFilterSettingsPrivate * priv;
};

struct _FontManagerLanguageFilterSettingsClass {
	GtkBoxClass parent_class;
};

struct _FontManagerLanguageFilterSettingsPrivate {
	FontManagerLanguageFilter* filter;
	GtkSpinButton* coverage_spin;
	GtkSearchEntry* search_entry;
	GtkTreeView* treeview;
	guint* search_timeout;
	guint16 text_length;
	GtkListStore* real_model;
	GtkTreeModelFilter* search_filter;
};

struct _FontManagerBaseOrthographyData {
	gchar* name;
	gchar* native;
};

static gint FontManagerLanguageFilter_private_offset;
static gpointer font_manager_language_filter_parent_class = NULL;
static gint FontManagerLanguageFilterSettings_private_offset;
static gpointer font_manager_language_filter_settings_parent_class = NULL;

VALA_EXTERN GType font_manager_cacheable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCacheable, g_object_unref)
VALA_EXTERN GType font_manager_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFilter, g_object_unref)
VALA_EXTERN GType font_manager_category_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerCategory, g_object_unref)
VALA_EXTERN GType font_manager_language_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerLanguageFilter, g_object_unref)
VALA_EXTERN GType font_manager_language_filter_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerLanguageFilterSettings, g_object_unref)
VALA_EXTERN gint font_manager_filter_get_size (FontManagerFilter* self);
VALA_EXTERN FontManagerLanguageFilter* font_manager_language_filter_new (void);
VALA_EXTERN FontManagerLanguageFilter* font_manager_language_filter_construct (GType object_type);
VALA_EXTERN GType font_manager_category_index_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FontManagerCategory* font_manager_category_new (const gchar* name,
                                                const gchar* comment,
                                                const gchar* icon,
                                                const gchar* sql,
                                                gint index);
VALA_EXTERN FontManagerCategory* font_manager_category_construct (GType object_type,
                                                      const gchar* name,
                                                      const gchar* comment,
                                                      const gchar* icon,
                                                      const gchar* sql,
                                                      gint index);
VALA_EXTERN GType font_manager_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerApplication, g_object_unref)
VALA_EXTERN guint font_manager_application_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
VALA_EXTERN FontManagerApplication* font_manager_get_default_application (void);
VALA_EXTERN GSettings* font_manager_application_get_settings (FontManagerApplication* self);
VALA_EXTERN void font_manager_language_filter_restore_state (FontManagerLanguageFilter* self,
                                                 GSettings* settings);
VALA_EXTERN FontManagerStringSet* font_manager_language_filter_get_selected (FontManagerLanguageFilter* self);
VALA_EXTERN void font_manager_language_filter_update (FontManagerLanguageFilter* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN void font_manager_language_filter_update_finish (FontManagerLanguageFilter* self,
                                                 GAsyncResult* _res_);
static void __lambda32_ (FontManagerLanguageFilter* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda32__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN void font_manager_language_filter_save_state (FontManagerLanguageFilter* self,
                                              GSettings* settings);
VALA_EXTERN gchar** font_manager_language_filter_list (FontManagerLanguageFilter* self,
                                           gint* result_length1);
VALA_EXTERN void font_manager_language_filter_add (FontManagerLanguageFilter* self,
                                       const gchar* language);
static void __lambda33_ (FontManagerLanguageFilter* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda33__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void font_manager_language_filter_update_data_free (gpointer _data);
static gboolean font_manager_language_filter_update_co (FontManagerLanguageFilterUpdateData* _data_);
VALA_EXTERN FontManagerStringSet* font_manager_category_get_descriptions (FontManagerCategory* self);
VALA_EXTERN FontManagerStringSet* font_manager_category_get_families (FontManagerCategory* self);
VALA_EXTERN FontManagerDatabaseType font_manager_category_get_db_type (FontManagerCategory* self);
VALA_EXTERN const gchar* font_manager_category_get_sql (FontManagerCategory* self);
VALA_EXTERN gdouble font_manager_language_filter_get_coverage (FontManagerLanguageFilter* self);
static gboolean _font_manager_language_filter_update_co_gsource_func (gpointer self);
VALA_EXTERN FontManagerStringSet* font_manager_application_get_available_families (FontManagerApplication* self);
static gboolean __lambda31_ (FontManagerLanguageFilter* self);
static gboolean ___lambda31__gsource_func (gpointer self);
VALA_EXTERN void font_manager_language_filter_set_selected (FontManagerLanguageFilter* self,
                                                FontManagerStringSet* value);
VALA_EXTERN void font_manager_language_filter_set_coverage (FontManagerLanguageFilter* self,
                                                gdouble value);
VALA_EXTERN FontManagerLanguageFilterSettings* font_manager_language_filter_get_settings (FontManagerLanguageFilter* self);
static void font_manager_language_filter_set_settings (FontManagerLanguageFilter* self,
                                                FontManagerLanguageFilterSettings* value);
static GObject * font_manager_language_filter_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
VALA_EXTERN FontManagerLanguageFilterSettings* font_manager_language_filter_settings_new (FontManagerLanguageFilter* filter);
VALA_EXTERN FontManagerLanguageFilterSettings* font_manager_language_filter_settings_construct (GType object_type,
                                                                                    FontManagerLanguageFilter* filter);
static void _font_manager_language_filter___lambda34_ (FontManagerLanguageFilter* self);
static gboolean __lambda35_ (FontManagerLanguageFilter* self);
static void __lambda36_ (FontManagerLanguageFilter* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda36__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gboolean ___lambda35__gsource_func (gpointer self);
static void __font_manager_language_filter___lambda34__font_manager_language_filter_settings_selections_changed (FontManagerLanguageFilterSettings* _sender,
                                                                                                          gpointer self);
static void font_manager_language_filter_finalize (GObject * obj);
static GType font_manager_language_filter_get_type_once (void);
static void _vala_font_manager_language_filter_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_font_manager_language_filter_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static gboolean font_manager_language_filter_settings_refilter (FontManagerLanguageFilterSettings* self);
static void font_manager_language_filter_settings_on_search_changed (FontManagerLanguageFilterSettings* self);
static void font_manager_language_filter_settings_queue_refilter (FontManagerLanguageFilterSettings* self);
static void _font_manager_language_filter_settings_on_search_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                                               gpointer self);
static void font_manager_language_filter_settings_on_back_button_clicked (FontManagerLanguageFilterSettings* self);
VALA_EXTERN GType font_manager_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerMainWindow, g_object_unref)
VALA_EXTERN FontManagerMainWindow* font_manager_application_get_main_window (FontManagerApplication* self);
VALA_EXTERN GType font_manager_sidebar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerSidebar, g_object_unref)
VALA_EXTERN FontManagerSidebar* font_manager_main_window_get_sidebar (FontManagerMainWindow* self);
VALA_EXTERN void font_manager_sidebar_set_mode (FontManagerSidebar* self,
                                    const gchar* value);
static void _font_manager_language_filter_settings_on_back_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                       gpointer self);
static void font_manager_language_filter_settings_on_clear_button_clicked (FontManagerLanguageFilterSettings* self);
static void _font_manager_language_filter_settings_on_clear_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                        gpointer self);
static void font_manager_language_filter_settings_on_toggled (FontManagerLanguageFilterSettings* self,
                                                       const gchar* path);
static void font_manager_language_filter_settings_toggle_cell_data_func (FontManagerLanguageFilterSettings* self,
                                                                  GtkTreeViewColumn* layout,
                                                                  GtkCellRenderer* cell,
                                                                  GtkTreeModel* model,
                                                                  GtkTreeIter* treeiter);
static gboolean _font_manager_language_filter_settings_refilter_gsource_func (gpointer self);
static guint* _uint_dup (guint* self);
static gboolean font_manager_language_filter_settings_visible_func (FontManagerLanguageFilterSettings* self,
                                                             GtkTreeModel* model,
                                                             GtkTreeIter* iter);
static GObject * font_manager_language_filter_settings_constructor (GType type,
                                                             guint n_construct_properties,
                                                             GObjectConstructParam * construct_properties);
static gboolean _font_manager_language_filter_settings___lambda29_ (FontManagerLanguageFilterSettings* self,
                                                             GtkTreeModel* m,
                                                             GtkTreeIter* i);
static gboolean __font_manager_language_filter_settings___lambda29__gtk_tree_model_filter_visible_func (GtkTreeModel* model,
                                                                                                 GtkTreeIter* iter,
                                                                                                 gpointer self);
VALA_EXTERN GType font_manager_base_orthography_data_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FontManagerBaseOrthographyData* font_manager_base_orthography_data_dup (const FontManagerBaseOrthographyData* self);
VALA_EXTERN void font_manager_base_orthography_data_free (FontManagerBaseOrthographyData* self);
VALA_EXTERN void font_manager_base_orthography_data_copy (const FontManagerBaseOrthographyData* self,
                                              FontManagerBaseOrthographyData* dest);
VALA_EXTERN void font_manager_base_orthography_data_destroy (FontManagerBaseOrthographyData* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (FontManagerBaseOrthographyData, font_manager_base_orthography_data_destroy)
static void _font_manager_language_filter_settings_on_toggled_gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                                                         const gchar* path,
                                                                                         gpointer self);
static void _font_manager_language_filter_settings___lambda30_ (FontManagerLanguageFilterSettings* self,
                                                         GtkTreePath* path,
                                                         GtkTreeViewColumn* col);
static void __font_manager_language_filter_settings___lambda30__gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                                      GtkTreePath* path,
                                                                                      GtkTreeViewColumn* column,
                                                                                      gpointer self);
VALA_EXTERN GType font_manager_font_list_column_get_type (void) G_GNUC_CONST ;
static void _font_manager_language_filter_settings_toggle_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                                           GtkCellRenderer* cell,
                                                                                           GtkTreeModel* tree_model,
                                                                                           GtkTreeIter* iter,
                                                                                           gpointer self);
static void font_manager_language_filter_settings_finalize (GObject * obj);
static GType font_manager_language_filter_settings_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const FontManagerBaseOrthographyData FONT_MANAGER_Orthographies[132];

static inline gpointer
font_manager_language_filter_get_instance_private (FontManagerLanguageFilter* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerLanguageFilter_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

FontManagerLanguageFilter*
font_manager_language_filter_construct (GType object_type)
{
	FontManagerLanguageFilter * self = NULL;
	GSettings* settings = NULL;
	FontManagerApplication* _tmp0_;
	FontManagerApplication* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	self = (FontManagerLanguageFilter*) font_manager_category_construct (object_type, _ ("Supported Orthographies"), DEFAULT_LANGUAGE_FILTER_COMMENT, "preferences-desktop-locale-symbolic", SELECT_ON_LANGUAGE, (gint) FONT_MANAGER_CATEGORY_INDEX_LANGUAGE);
	_tmp0_ = font_manager_get_default_application ();
	_tmp1_ = _tmp0_;
	_tmp2_ = font_manager_application_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp1_);
	settings = _tmp5_;
	_tmp6_ = settings;
	if (_tmp6_ != NULL) {
		GSettings* _tmp7_;
		_tmp7_ = settings;
		font_manager_language_filter_restore_state (self, _tmp7_);
	}
	_g_object_unref0 (settings);
	return self;
}

FontManagerLanguageFilter*
font_manager_language_filter_new (void)
{
	return font_manager_language_filter_construct (FONT_MANAGER_TYPE_LANGUAGE_FILTER);
}

static void
__lambda32_ (FontManagerLanguageFilter* self,
             GObject* obj,
             GAsyncResult* res)
{
	g_return_if_fail (res != NULL);
	font_manager_language_filter_update_finish (self, res);
}

static void
___lambda32__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda32_ ((FontManagerLanguageFilter*) self, source_object, res);
	g_object_unref (self);
}

void
font_manager_language_filter_restore_state (FontManagerLanguageFilter* self,
                                            GSettings* settings)
{
	gchar** _tmp0_;
	gchar** _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (settings != NULL);
	_tmp1_ = _tmp0_ = g_settings_get_strv (settings, "language-filter-list");
	{
		gchar** entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = _tmp1_;
		entry_collection_length1 = _vala_array_length (_tmp0_);
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
			gchar* _tmp2_;
			gchar* entry = NULL;
			_tmp2_ = g_strdup (entry_collection[entry_it]);
			entry = _tmp2_;
			{
				FontManagerStringSet* _tmp3_;
				const gchar* _tmp4_;
				_tmp3_ = self->priv->_selected;
				_tmp4_ = entry;
				font_manager_string_set_add (_tmp3_, _tmp4_);
				_g_free0 (entry);
			}
		}
		entry_collection = (_vala_array_free (entry_collection, entry_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	font_manager_language_filter_update (self, ___lambda32__gasync_ready_callback, g_object_ref (self));
	return;
}

void
font_manager_language_filter_save_state (FontManagerLanguageFilter* self,
                                         GSettings* settings)
{
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (settings != NULL);
	_tmp1_ = font_manager_language_filter_list (self, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp0_;
	g_settings_set_strv (settings, "language-filter-list", _tmp2_);
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	return;
}

static void
__lambda33_ (FontManagerLanguageFilter* self,
             GObject* obj,
             GAsyncResult* res)
{
	g_return_if_fail (res != NULL);
	font_manager_language_filter_update_finish (self, res);
}

static void
___lambda33__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda33_ ((FontManagerLanguageFilter*) self, source_object, res);
	g_object_unref (self);
}

void
font_manager_language_filter_add (FontManagerLanguageFilter* self,
                                  const gchar* language)
{
	FontManagerStringSet* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (language != NULL);
	_tmp0_ = self->priv->_selected;
	font_manager_string_set_add (_tmp0_, language);
	font_manager_language_filter_update (self, ___lambda33__gasync_ready_callback, g_object_ref (self));
	return;
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

gchar**
font_manager_language_filter_list (FontManagerLanguageFilter* self,
                                   gint* result_length1)
{
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar** result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	_result_ = _tmp0_;
	_result__length1 = 0;
	__result__size_ = _result__length1;
	{
		FontManagerStringSet* _language_list = NULL;
		FontManagerStringSet* _tmp1_;
		guint _language_size = 0U;
		FontManagerStringSet* _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		gint _language_index = 0;
		_tmp1_ = self->priv->_selected;
		_language_list = _tmp1_;
		_tmp2_ = _language_list;
		g_object_get (_tmp2_, "size", &_tmp3_, NULL);
		_tmp4_ = _tmp3_;
		_language_size = _tmp4_;
		_language_index = -1;
		while (TRUE) {
			gint _tmp5_;
			guint _tmp6_;
			gchar* language = NULL;
			FontManagerStringSet* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_language_index = _language_index + 1;
			_tmp5_ = _language_index;
			_tmp6_ = _language_size;
			if (!(((guint) _tmp5_) < _tmp6_)) {
				break;
			}
			_tmp7_ = _language_list;
			_tmp8_ = font_manager_string_set_get (_tmp7_, (guint) _language_index);
			_tmp9_ = g_strdup (_tmp8_);
			language = _tmp9_;
			_tmp10_ = language;
			_tmp11_ = g_strdup (_tmp10_);
			_vala_array_add6 (&_result_, &_result__length1, &__result__size_, _tmp11_);
			_g_free0 (language);
		}
	}
	_tmp12_ = _result_;
	_tmp12__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp12__length1;
	}
	result = _tmp12_;
	return result;
}

static void
font_manager_language_filter_update_data_free (gpointer _data)
{
	FontManagerLanguageFilterUpdateData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (FontManagerLanguageFilterUpdateData, _data_);
}

void
font_manager_language_filter_update (FontManagerLanguageFilter* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	FontManagerLanguageFilterUpdateData* _data_;
	FontManagerLanguageFilter* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (FontManagerLanguageFilterUpdateData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, font_manager_language_filter_update_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	font_manager_language_filter_update_co (_data_);
}

void
font_manager_language_filter_update_finish (FontManagerLanguageFilter* self,
                                            GAsyncResult* _res_)
{
	FontManagerLanguageFilterUpdateData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
_font_manager_language_filter_update_co_gsource_func (gpointer self)
{
	gboolean result;
	result = font_manager_language_filter_update_co (self);
	return result;
}

static gboolean
__lambda31_ (FontManagerLanguageFilter* self)
{
	gboolean result;
	g_signal_emit (self, font_manager_language_filter_signals[FONT_MANAGER_LANGUAGE_FILTER_SELECTIONS_CHANGED_SIGNAL], 0);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda31__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda31_ ((FontManagerLanguageFilter*) self);
	return result;
}

static gboolean
font_manager_language_filter_update_co (FontManagerLanguageFilterUpdateData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = font_manager_category_get_descriptions ((FontManagerCategory*) _data_->self);
	_data_->_tmp1_ = _data_->_tmp0_;
	font_manager_string_set_clear (_data_->_tmp1_);
	_data_->_tmp2_ = font_manager_category_get_families ((FontManagerCategory*) _data_->self);
	_data_->_tmp3_ = _data_->_tmp2_;
	font_manager_string_set_clear (_data_->_tmp3_);
	{
		_data_->_tmp4_ = font_manager_category_get_db_type ((FontManagerCategory*) _data_->self);
		_data_->_tmp5_ = _data_->_tmp4_;
		_data_->_tmp6_ = font_manager_get_database (_data_->_tmp5_, &_data_->_inner_error0_);
		_data_->db = _data_->_tmp6_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
				goto __catch0_font_manager_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		{
			_data_->_tmp7_ = _data_->self->priv->_selected;
			_data_->_language_list = _data_->_tmp7_;
			_data_->_tmp8_ = _data_->_language_list;
			g_object_get (_data_->_tmp8_, "size", &_data_->_tmp9_, NULL);
			_data_->_tmp10_ = _data_->_tmp9_;
			_data_->_language_size = _data_->_tmp10_;
			_data_->_language_index = -1;
			while (TRUE) {
				_data_->_language_index = _data_->_language_index + 1;
				_data_->_tmp11_ = _data_->_language_index;
				_data_->_tmp12_ = _data_->_language_size;
				if (!(((guint) _data_->_tmp11_) < _data_->_tmp12_)) {
					break;
				}
				_data_->_tmp13_ = _data_->_language_list;
				_data_->_tmp14_ = font_manager_string_set_get (_data_->_tmp13_, (guint) _data_->_language_index);
				_data_->_tmp15_ = g_strdup (_data_->_tmp14_);
				_data_->language = _data_->_tmp15_;
				_data_->_tmp16_ = setlocale (LC_ALL, "");
				_data_->_tmp17_ = g_strdup (_data_->_tmp16_);
				_data_->pref_loc = _data_->_tmp17_;
				setlocale (LC_ALL, "C");
				_data_->_tmp18_ = font_manager_category_get_sql ((FontManagerCategory*) _data_->self);
				_data_->_tmp19_ = _data_->_tmp18_;
				_data_->_tmp20_ = _data_->language;
				_data_->_tmp21_ = _data_->self->priv->_coverage;
				_data_->_tmp22_ = g_strdup_printf (_data_->_tmp19_, _data_->_tmp20_, _data_->_tmp21_);
				_data_->_sql_ = _data_->_tmp22_;
				_data_->_tmp23_ = _data_->pref_loc;
				setlocale (LC_ALL, _data_->_tmp23_);
				_data_->_tmp24_ = _data_->db;
				_data_->_tmp25_ = font_manager_category_get_families ((FontManagerCategory*) _data_->self);
				_data_->_tmp26_ = _data_->_tmp25_;
				_data_->_tmp27_ = font_manager_category_get_descriptions ((FontManagerCategory*) _data_->self);
				_data_->_tmp28_ = _data_->_tmp27_;
				_data_->_tmp29_ = _data_->_sql_;
				font_manager_get_matching_families_and_fonts (_data_->_tmp24_, _data_->_tmp26_, _data_->_tmp28_, _data_->_tmp29_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					_g_free0 (_data_->_sql_);
					_g_free0 (_data_->pref_loc);
					_g_free0 (_data_->language);
					_g_object_unref0 (_data_->db);
					if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
						goto __catch0_font_manager_database_error;
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
					g_clear_error (&_data_->_inner_error0_);
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _font_manager_language_filter_update_co_gsource_func, _data_, NULL);
				_data_->_state_ = 1;
				return FALSE;
				_state_1:
				;
				_g_free0 (_data_->_sql_);
				_g_free0 (_data_->pref_loc);
				_g_free0 (_data_->language);
			}
		}
		_g_object_unref0 (_data_->db);
	}
	goto __finally0;
	__catch0_font_manager_database_error:
	{
		_data_->_error_ = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp30_ = _data_->_error_;
		_data_->_tmp31_ = _data_->_tmp30_->message;
		g_warning ("LanguageFilter.vala:108: %s", _data_->_tmp31_);
		_g_error_free0 (_data_->_error_);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp32_ = font_manager_get_default_application ();
	_data_->_tmp33_ = _data_->_tmp32_;
	_data_->_tmp34_ = font_manager_application_get_available_families (_data_->_tmp33_);
	_data_->_tmp35_ = _data_->_tmp34_;
	_data_->_tmp36_ = _g_object_ref0 (_data_->_tmp35_);
	_data_->_tmp37_ = _data_->_tmp36_;
	_g_object_unref0 (_data_->_tmp33_);
	_data_->available_families = _data_->_tmp37_;
	_vala_assert (_data_->available_families != NULL, "available_families != null");
	_data_->_tmp38_ = font_manager_category_get_families ((FontManagerCategory*) _data_->self);
	_data_->_tmp39_ = _data_->_tmp38_;
	font_manager_string_set_retain_all (_data_->_tmp39_, _data_->available_families);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda31__gsource_func, g_object_ref (_data_->self), g_object_unref);
	_g_object_unref0 (_data_->available_families);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

FontManagerStringSet*
font_manager_language_filter_get_selected (FontManagerLanguageFilter* self)
{
	FontManagerStringSet* result;
	FontManagerStringSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_selected;
	result = _tmp0_;
	return result;
}

void
font_manager_language_filter_set_selected (FontManagerLanguageFilter* self,
                                           FontManagerStringSet* value)
{
	FontManagerStringSet* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_language_filter_get_selected (self);
	if (old_value != value) {
		FontManagerStringSet* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_selected);
		self->priv->_selected = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_language_filter_properties[FONT_MANAGER_LANGUAGE_FILTER_SELECTED_PROPERTY]);
	}
}

gdouble
font_manager_language_filter_get_coverage (FontManagerLanguageFilter* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_coverage;
	return result;
}

void
font_manager_language_filter_set_coverage (FontManagerLanguageFilter* self,
                                           gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_language_filter_get_coverage (self);
	if (old_value != value) {
		self->priv->_coverage = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_language_filter_properties[FONT_MANAGER_LANGUAGE_FILTER_COVERAGE_PROPERTY]);
	}
}

FontManagerLanguageFilterSettings*
font_manager_language_filter_get_settings (FontManagerLanguageFilter* self)
{
	FontManagerLanguageFilterSettings* result;
	FontManagerLanguageFilterSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}

static void
font_manager_language_filter_set_settings (FontManagerLanguageFilter* self,
                                           FontManagerLanguageFilterSettings* value)
{
	FontManagerLanguageFilterSettings* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_language_filter_get_settings (self);
	if (old_value != value) {
		FontManagerLanguageFilterSettings* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_settings);
		self->priv->_settings = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_language_filter_properties[FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_PROPERTY]);
	}
}

static gint
font_manager_language_filter_real_get_size (FontManagerFilter* base)
{
	gint result;
	FontManagerLanguageFilter* self;
	FontManagerStringSet* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	self = (FontManagerLanguageFilter*) base;
	_tmp0_ = self->priv->_selected;
	g_object_get (_tmp0_, "size", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	result = (gint) _tmp2_;
	return result;
}

static void
__lambda36_ (FontManagerLanguageFilter* self,
             GObject* obj,
             GAsyncResult* res)
{
	g_return_if_fail (res != NULL);
	font_manager_language_filter_update_finish (self, res);
}

static void
___lambda36__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda36_ ((FontManagerLanguageFilter*) self, source_object, res);
	g_object_unref (self);
}

static gboolean
__lambda35_ (FontManagerLanguageFilter* self)
{
	gboolean result;
	font_manager_language_filter_update (self, ___lambda36__gasync_ready_callback, g_object_ref (self));
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda35__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda35_ ((FontManagerLanguageFilter*) self);
	return result;
}

static void
_font_manager_language_filter___lambda34_ (FontManagerLanguageFilter* self)
{
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda35__gsource_func, g_object_ref (self), g_object_unref);
}

static void
__font_manager_language_filter___lambda34__font_manager_language_filter_settings_selections_changed (FontManagerLanguageFilterSettings* _sender,
                                                                                                     gpointer self)
{
	_font_manager_language_filter___lambda34_ ((FontManagerLanguageFilter*) self);
}

static GObject *
font_manager_language_filter_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerLanguageFilter * self;
	FontManagerStringSet* _tmp0_;
	FontManagerStringSet* _tmp1_;
	FontManagerLanguageFilterSettings* _tmp2_;
	FontManagerLanguageFilterSettings* _tmp3_;
	FontManagerLanguageFilterSettings* _tmp4_;
	parent_class = G_OBJECT_CLASS (font_manager_language_filter_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter);
	_tmp0_ = font_manager_string_set_new ();
	_tmp1_ = _tmp0_;
	font_manager_language_filter_set_selected (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = font_manager_language_filter_settings_new (self);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	font_manager_language_filter_set_settings (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->_settings;
	g_signal_connect_object (_tmp4_, "selections-changed", (GCallback) __font_manager_language_filter___lambda34__font_manager_language_filter_settings_selections_changed, self, 0);
	return obj;
}

static void
font_manager_language_filter_class_init (FontManagerLanguageFilterClass * klass,
                                         gpointer klass_data)
{
	font_manager_language_filter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerLanguageFilter_private_offset);
	FONT_MANAGER_FILTER_CLASS (klass)->get_size = (gint (*) (FontManagerFilter*)) font_manager_language_filter_real_get_size;
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_language_filter_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_language_filter_set_property;
	G_OBJECT_CLASS (klass)->constructor = font_manager_language_filter_constructor;
	G_OBJECT_CLASS (klass)->finalize = font_manager_language_filter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_LANGUAGE_FILTER_SELECTED_PROPERTY, font_manager_language_filter_properties[FONT_MANAGER_LANGUAGE_FILTER_SELECTED_PROPERTY] = g_param_spec_object ("selected", "selected", "selected", font_manager_string_set_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_LANGUAGE_FILTER_COVERAGE_PROPERTY, font_manager_language_filter_properties[FONT_MANAGER_LANGUAGE_FILTER_COVERAGE_PROPERTY] = g_param_spec_double ("coverage", "coverage", "coverage", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 90, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_PROPERTY, font_manager_language_filter_properties[FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_LANGUAGE_FILTER_SIZE_PROPERTY, font_manager_language_filter_properties[FONT_MANAGER_LANGUAGE_FILTER_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	font_manager_language_filter_signals[FONT_MANAGER_LANGUAGE_FILTER_SELECTIONS_CHANGED_SIGNAL] = g_signal_new ("selections-changed", FONT_MANAGER_TYPE_LANGUAGE_FILTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
font_manager_language_filter_instance_init (FontManagerLanguageFilter * self,
                                            gpointer klass)
{
	self->priv = font_manager_language_filter_get_instance_private (self);
	self->priv->_coverage = (gdouble) 90;
}

static void
font_manager_language_filter_finalize (GObject * obj)
{
	FontManagerLanguageFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter);
	_g_object_unref0 (self->priv->_selected);
	_g_object_unref0 (self->priv->_settings);
	G_OBJECT_CLASS (font_manager_language_filter_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_language_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerLanguageFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_language_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerLanguageFilter), 0, (GInstanceInitFunc) font_manager_language_filter_instance_init, NULL };
	GType font_manager_language_filter_type_id;
	font_manager_language_filter_type_id = g_type_register_static (FONT_MANAGER_TYPE_CATEGORY, "FontManagerLanguageFilter", &g_define_type_info, 0);
	FontManagerLanguageFilter_private_offset = g_type_add_instance_private (font_manager_language_filter_type_id, sizeof (FontManagerLanguageFilterPrivate));
	return font_manager_language_filter_type_id;
}

GType
font_manager_language_filter_get_type (void)
{
	static volatile gsize font_manager_language_filter_type_id__once = 0;
	if (g_once_init_enter (&font_manager_language_filter_type_id__once)) {
		GType font_manager_language_filter_type_id;
		font_manager_language_filter_type_id = font_manager_language_filter_get_type_once ();
		g_once_init_leave (&font_manager_language_filter_type_id__once, font_manager_language_filter_type_id);
	}
	return font_manager_language_filter_type_id__once;
}

static void
_vala_font_manager_language_filter_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	FontManagerLanguageFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter);
	switch (property_id) {
		case FONT_MANAGER_LANGUAGE_FILTER_SELECTED_PROPERTY:
		g_value_set_object (value, font_manager_language_filter_get_selected (self));
		break;
		case FONT_MANAGER_LANGUAGE_FILTER_COVERAGE_PROPERTY:
		g_value_set_double (value, font_manager_language_filter_get_coverage (self));
		break;
		case FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_PROPERTY:
		g_value_set_object (value, font_manager_language_filter_get_settings (self));
		break;
		case FONT_MANAGER_LANGUAGE_FILTER_SIZE_PROPERTY:
		g_value_set_int (value, font_manager_filter_get_size ((FontManagerFilter*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_language_filter_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	FontManagerLanguageFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_LANGUAGE_FILTER, FontManagerLanguageFilter);
	switch (property_id) {
		case FONT_MANAGER_LANGUAGE_FILTER_SELECTED_PROPERTY:
		font_manager_language_filter_set_selected (self, g_value_get_object (value));
		break;
		case FONT_MANAGER_LANGUAGE_FILTER_COVERAGE_PROPERTY:
		font_manager_language_filter_set_coverage (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_PROPERTY:
		font_manager_language_filter_set_settings (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
font_manager_language_filter_settings_get_instance_private (FontManagerLanguageFilterSettings* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerLanguageFilterSettings_private_offset);
}

FontManagerLanguageFilterSettings*
font_manager_language_filter_settings_construct (GType object_type,
                                                 FontManagerLanguageFilter* filter)
{
	FontManagerLanguageFilterSettings * self = NULL;
	GBindingFlags flags = 0U;
	GtkSpinButton* _tmp0_;
	g_return_val_if_fail (filter != NULL, NULL);
	self = (FontManagerLanguageFilterSettings*) g_object_new (object_type, NULL);
	self->priv->filter = filter;
	flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
	_tmp0_ = self->priv->coverage_spin;
	g_object_bind_property_with_closures ((GObject*) filter, "coverage", (GObject*) _tmp0_, "value", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	return self;
}

FontManagerLanguageFilterSettings*
font_manager_language_filter_settings_new (FontManagerLanguageFilter* filter)
{
	return font_manager_language_filter_settings_construct (FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS, filter);
}

static gboolean
font_manager_language_filter_settings_refilter (FontManagerLanguageFilterSettings* self)
{
	GtkTreeView* _tmp0_;
	GtkTreeModelFilter* _tmp1_;
	GtkTreeView* _tmp2_;
	GtkTreeModelFilter* _tmp3_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->treeview;
	gtk_tree_view_set_model (_tmp0_, NULL);
	_tmp1_ = self->priv->search_filter;
	gtk_tree_model_filter_refilter (_tmp1_);
	_tmp2_ = self->priv->treeview;
	_tmp3_ = self->priv->search_filter;
	gtk_tree_view_set_model (_tmp2_, (GtkTreeModel*) _tmp3_);
	_g_free0 (self->priv->search_timeout);
	self->priv->search_timeout = NULL;
	result = FALSE;
	return result;
}

static void
font_manager_language_filter_settings_on_search_changed (FontManagerLanguageFilterSettings* self)
{
	GtkSearchEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	font_manager_language_filter_settings_queue_refilter (self);
	_tmp0_ = self->priv->search_entry;
	self->priv->text_length = gtk_entry_get_text_length ((GtkEntry*) _tmp0_);
	return;
}

static void
_font_manager_language_filter_settings_on_search_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                                          gpointer self)
{
	font_manager_language_filter_settings_on_search_changed ((FontManagerLanguageFilterSettings*) self);
}

static void
font_manager_language_filter_settings_on_back_button_clicked (FontManagerLanguageFilterSettings* self)
{
	FontManagerApplication* _tmp0_;
	FontManagerApplication* _tmp1_;
	FontManagerMainWindow* _tmp2_;
	FontManagerMainWindow* _tmp3_;
	FontManagerSidebar* _tmp4_;
	FontManagerSidebar* _tmp5_;
	GtkSearchEntry* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = font_manager_get_default_application ();
	_tmp1_ = _tmp0_;
	_tmp2_ = font_manager_application_get_main_window (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = font_manager_main_window_get_sidebar (_tmp3_);
	_tmp5_ = _tmp4_;
	font_manager_sidebar_set_mode (_tmp5_, "Standard");
	_g_object_unref0 (_tmp1_);
	_tmp6_ = self->priv->search_entry;
	gtk_entry_set_text ((GtkEntry*) _tmp6_, "");
	return;
}

static void
_font_manager_language_filter_settings_on_back_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self)
{
	font_manager_language_filter_settings_on_back_button_clicked ((FontManagerLanguageFilterSettings*) self);
}

static void
font_manager_language_filter_settings_on_clear_button_clicked (FontManagerLanguageFilterSettings* self)
{
	FontManagerLanguageFilter* _tmp0_;
	FontManagerStringSet* _tmp1_;
	FontManagerStringSet* _tmp2_;
	GtkTreeView* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->filter;
	_tmp1_ = font_manager_language_filter_get_selected (_tmp0_);
	_tmp2_ = _tmp1_;
	font_manager_string_set_clear (_tmp2_);
	_tmp3_ = self->priv->treeview;
	gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
	g_signal_emit (self, font_manager_language_filter_settings_signals[FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_SELECTIONS_CHANGED_SIGNAL], 0);
	return;
}

static void
_font_manager_language_filter_settings_on_clear_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                   gpointer self)
{
	font_manager_language_filter_settings_on_clear_button_clicked ((FontManagerLanguageFilterSettings*) self);
}

static void
font_manager_language_filter_settings_on_toggled (FontManagerLanguageFilterSettings* self,
                                                  const gchar* path)
{
	GtkTreeIter iter = {0};
	GValue val = {0};
	GtkTreeModelFilter* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkTreeModelFilter* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	gchar* lang = NULL;
	GValue _tmp5_;
	gchar* _tmp6_;
	FontManagerLanguageFilter* _tmp7_;
	FontManagerStringSet* _tmp8_;
	FontManagerStringSet* _tmp9_;
	const gchar* _tmp10_;
	GtkTreeView* _tmp19_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->search_filter;
	gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp0_, &_tmp1_, path);
	iter = _tmp1_;
	_tmp2_ = self->priv->search_filter;
	_tmp3_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, 0, &_tmp4_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp4_;
	_tmp5_ = val;
	_tmp6_ = g_strdup (g_value_get_string (&_tmp5_));
	lang = _tmp6_;
	_tmp7_ = self->priv->filter;
	_tmp8_ = font_manager_language_filter_get_selected (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = lang;
	if (font_manager_string_set_contains (_tmp9_, _tmp10_)) {
		FontManagerLanguageFilter* _tmp11_;
		FontManagerStringSet* _tmp12_;
		FontManagerStringSet* _tmp13_;
		const gchar* _tmp14_;
		_tmp11_ = self->priv->filter;
		_tmp12_ = font_manager_language_filter_get_selected (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = lang;
		font_manager_string_set_remove (_tmp13_, _tmp14_);
	} else {
		FontManagerLanguageFilter* _tmp15_;
		FontManagerStringSet* _tmp16_;
		FontManagerStringSet* _tmp17_;
		const gchar* _tmp18_;
		_tmp15_ = self->priv->filter;
		_tmp16_ = font_manager_language_filter_get_selected (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = lang;
		font_manager_string_set_add (_tmp17_, _tmp18_);
	}
	g_value_unset (&val);
	_tmp19_ = self->priv->treeview;
	gtk_widget_queue_draw ((GtkWidget*) _tmp19_);
	g_signal_emit (self, font_manager_language_filter_settings_signals[FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_SELECTIONS_CHANGED_SIGNAL], 0);
	_g_free0 (lang);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return;
}

static void
font_manager_language_filter_settings_toggle_cell_data_func (FontManagerLanguageFilterSettings* self,
                                                             GtkTreeViewColumn* layout,
                                                             GtkCellRenderer* cell,
                                                             GtkTreeModel* model,
                                                             GtkTreeIter* treeiter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	FontManagerLanguageFilter* _tmp2_;
	FontManagerStringSet* _tmp3_;
	FontManagerStringSet* _tmp4_;
	GValue _tmp5_;
	GValue _tmp6_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (layout != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (treeiter != NULL);
	_tmp0_ = *treeiter;
	gtk_tree_model_get_value (model, &_tmp0_, 0, &_tmp1_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp1_;
	_tmp2_ = self->priv->filter;
	_tmp3_ = font_manager_language_filter_get_selected (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = val;
	g_value_init (&_tmp6_, G_TYPE_BOOLEAN);
	g_value_set_boolean (&_tmp6_, font_manager_string_set_contains (_tmp4_, g_value_get_string (&_tmp5_)));
	g_object_set_property ((GObject*) cell, "active", &_tmp6_);
	G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
	g_value_unset (&val);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return;
}

static gboolean
_font_manager_language_filter_settings_refilter_gsource_func (gpointer self)
{
	gboolean result;
	result = font_manager_language_filter_settings_refilter ((FontManagerLanguageFilterSettings*) self);
	return result;
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
	dup = g_new0 (guint, 1);
	memcpy (dup, self, sizeof (guint));
	return dup;
}

static gpointer
__uint_dup0 (gpointer self)
{
	return self ? _uint_dup (self) : NULL;
}

static void
font_manager_language_filter_settings_queue_refilter (FontManagerLanguageFilterSettings* self)
{
	guint* _tmp0_;
	guint _tmp2_;
	guint* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->search_timeout;
	if (_tmp0_ != NULL) {
		guint* _tmp1_;
		_tmp1_ = self->priv->search_timeout;
		g_source_remove (*_tmp1_);
	}
	_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 333, _font_manager_language_filter_settings_refilter_gsource_func, g_object_ref (self), g_object_unref);
	_tmp3_ = __uint_dup0 (&_tmp2_);
	_g_free0 (self->priv->search_timeout);
	self->priv->search_timeout = _tmp3_;
	return;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
font_manager_language_filter_settings_visible_func (FontManagerLanguageFilterSettings* self,
                                                    GtkTreeModel* model,
                                                    GtkTreeIter* iter)
{
	gboolean search_match = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	search_match = TRUE;
	if (((gint) self->priv->text_length) > 0) {
		gchar* needle = NULL;
		GtkSearchEntry* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->search_entry;
		_tmp1_ = gtk_entry_get_text ((GtkEntry*) _tmp0_);
		_tmp2_ = g_utf8_casefold (_tmp1_, (gssize) -1);
		needle = _tmp2_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					GValue val = {0};
					GtkTreeIter _tmp5_;
					GValue _tmp6_ = {0};
					gchar* haystack = NULL;
					GValue _tmp7_;
					gchar* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					const gchar* _tmp12_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = i;
						i = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					if (!(i <= 2)) {
						break;
					}
					_tmp5_ = *iter;
					gtk_tree_model_get_value (model, &_tmp5_, i, &_tmp6_);
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
					val = _tmp6_;
					_tmp7_ = val;
					_tmp8_ = g_strdup (g_value_get_string (&_tmp7_));
					haystack = _tmp8_;
					_tmp9_ = haystack;
					_tmp10_ = g_utf8_casefold (_tmp9_, (gssize) -1);
					_tmp11_ = _tmp10_;
					_tmp12_ = needle;
					search_match = string_contains (_tmp11_, _tmp12_);
					_g_free0 (_tmp11_);
					if (search_match) {
						_g_free0 (haystack);
						G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
						break;
					}
					_g_free0 (haystack);
					G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
				}
			}
		}
		_g_free0 (needle);
	}
	result = search_match;
	return result;
}

static gboolean
_font_manager_language_filter_settings___lambda29_ (FontManagerLanguageFilterSettings* self,
                                                    GtkTreeModel* m,
                                                    GtkTreeIter* i)
{
	GtkTreeIter _tmp0_;
	gboolean result;
	g_return_val_if_fail (m != NULL, FALSE);
	g_return_val_if_fail (i != NULL, FALSE);
	_tmp0_ = *i;
	result = font_manager_language_filter_settings_visible_func (self, m, &_tmp0_);
	return result;
}

static gboolean
__font_manager_language_filter_settings___lambda29__gtk_tree_model_filter_visible_func (GtkTreeModel* model,
                                                                                        GtkTreeIter* iter,
                                                                                        gpointer self)
{
	gboolean result;
	result = _font_manager_language_filter_settings___lambda29_ ((FontManagerLanguageFilterSettings*) self, model, iter);
	return result;
}

static void
_font_manager_language_filter_settings_on_toggled_gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                                                    const gchar* path,
                                                                                    gpointer self)
{
	font_manager_language_filter_settings_on_toggled ((FontManagerLanguageFilterSettings*) self, path);
}

static void
_font_manager_language_filter_settings___lambda30_ (FontManagerLanguageFilterSettings* self,
                                                    GtkTreePath* path,
                                                    GtkTreeViewColumn* col)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (path != NULL);
	g_return_if_fail (col != NULL);
	_tmp0_ = gtk_tree_path_to_string (path);
	_tmp1_ = _tmp0_;
	font_manager_language_filter_settings_on_toggled (self, _tmp1_);
	_g_free0 (_tmp1_);
}

static void
__font_manager_language_filter_settings___lambda30__gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                                 GtkTreePath* path,
                                                                                 GtkTreeViewColumn* column,
                                                                                 gpointer self)
{
	_font_manager_language_filter_settings___lambda30_ ((FontManagerLanguageFilterSettings*) self, path, column);
}

static void
_font_manager_language_filter_settings_toggle_cell_data_func_gtk_tree_cell_data_func (GtkTreeViewColumn* tree_column,
                                                                                      GtkCellRenderer* cell,
                                                                                      GtkTreeModel* tree_model,
                                                                                      GtkTreeIter* iter,
                                                                                      gpointer self)
{
	font_manager_language_filter_settings_toggle_cell_data_func ((FontManagerLanguageFilterSettings*) self, tree_column, cell, tree_model, iter);
}

static GObject *
font_manager_language_filter_settings_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerLanguageFilterSettings * self;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkTreeModelFilter* _tmp2_;
	GtkTreeModelFilter* _tmp3_;
	GtkTreeView* _tmp4_;
	GtkTreeModelFilter* _tmp5_;
	GtkTreeView* _tmp6_;
	GtkTreeSelection* _tmp7_;
	GtkTreeIter iter = {0};
	GtkCellRendererText* text = NULL;
	GtkCellRendererText* _tmp28_;
	GtkCellRendererText* _tmp29_;
	GtkCellRendererToggle* toggle = NULL;
	GtkCellRendererToggle* _tmp30_;
	GtkCellRendererToggle* _tmp31_;
	GtkTreeView* _tmp32_;
	GtkTreeView* _tmp33_;
	GtkCellRendererToggle* _tmp34_;
	GtkTreeView* _tmp35_;
	GtkCellRendererText* _tmp36_;
	GtkTreeView* _tmp37_;
	GtkSearchEntry* _tmp38_;
	GtkSearchEntry* _tmp39_;
	parent_class = G_OBJECT_CLASS (font_manager_language_filter_settings_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS, FontManagerLanguageFilterSettings);
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, -1);
	_g_object_unref0 (self->priv->real_model);
	self->priv->real_model = _tmp0_;
	_tmp1_ = self->priv->real_model;
	_tmp2_ = (GtkTreeModelFilter*) gtk_tree_model_filter_new ((GtkTreeModel*) _tmp1_, NULL);
	_g_object_unref0 (self->priv->search_filter);
	self->priv->search_filter = _tmp2_;
	_tmp3_ = self->priv->search_filter;
	gtk_tree_model_filter_set_visible_func (_tmp3_, __font_manager_language_filter_settings___lambda29__gtk_tree_model_filter_visible_func, g_object_ref (self), g_object_unref);
	_tmp4_ = self->priv->treeview;
	_tmp5_ = self->priv->search_filter;
	gtk_tree_view_set_model (_tmp4_, (GtkTreeModel*) _tmp5_);
	_tmp6_ = self->priv->treeview;
	_tmp7_ = gtk_tree_view_get_selection (_tmp6_);
	gtk_tree_selection_set_mode (_tmp7_, GTK_SELECTION_NONE);
	{
		FontManagerBaseOrthographyData* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
		entry_collection = FONT_MANAGER_Orthographies;
		entry_collection_length1 = G_N_ELEMENTS (FONT_MANAGER_Orthographies);
		for (entry_it = 0; entry_it < entry_collection_length1; entry_it = entry_it + 1) {
			FontManagerBaseOrthographyData entry = {0};
			entry = entry_collection[entry_it];
			{
				GtkListStore* _tmp8_;
				GtkTreeIter _tmp9_ = {0};
				gchar* local = NULL;
				FontManagerBaseOrthographyData _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				const gchar* _tmp13_ = NULL;
				FontManagerBaseOrthographyData _tmp14_;
				const gchar* _tmp15_;
				FontManagerBaseOrthographyData _tmp16_;
				const gchar* _tmp17_;
				gchar* native = NULL;
				gchar* _tmp21_;
				GtkListStore* _tmp22_;
				GtkTreeIter _tmp23_;
				FontManagerBaseOrthographyData _tmp24_;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				_tmp8_ = self->priv->real_model;
				gtk_list_store_append (_tmp8_, &_tmp9_);
				iter = _tmp9_;
				_tmp10_ = entry;
				_tmp11_ = _tmp10_.name;
				_tmp12_ = g_strdup (g_dgettext (NULL, _tmp11_));
				local = _tmp12_;
				_tmp14_ = entry;
				_tmp15_ = _tmp14_.native;
				_tmp16_ = entry;
				_tmp17_ = _tmp16_.name;
				if (g_strcmp0 (_tmp15_, _tmp17_) != 0) {
					FontManagerBaseOrthographyData _tmp18_;
					const gchar* _tmp19_;
					_tmp18_ = entry;
					_tmp19_ = _tmp18_.native;
					_tmp13_ = _tmp19_;
				} else {
					const gchar* _tmp20_;
					_tmp20_ = local;
					_tmp13_ = _tmp20_;
				}
				_tmp21_ = g_strdup (_tmp13_);
				native = _tmp21_;
				_tmp22_ = self->priv->real_model;
				_tmp23_ = iter;
				_tmp24_ = entry;
				_tmp25_ = _tmp24_.name;
				_tmp26_ = native;
				_tmp27_ = local;
				gtk_list_store_set (_tmp22_, &_tmp23_, 0, _tmp25_, 1, _tmp26_, 2, _tmp27_, -1, -1);
				_g_free0 (native);
				_g_free0 (local);
			}
		}
	}
	_tmp28_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp28_);
	text = _tmp28_;
	_tmp29_ = text;
	g_object_set (_tmp29_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	_tmp30_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
	g_object_ref_sink (_tmp30_);
	toggle = _tmp30_;
	_tmp31_ = toggle;
	g_signal_connect_object (_tmp31_, "toggled", (GCallback) _font_manager_language_filter_settings_on_toggled_gtk_cell_renderer_toggle_toggled, self, 0);
	_tmp32_ = self->priv->treeview;
	g_signal_connect_object (_tmp32_, "row-activated", (GCallback) __font_manager_language_filter_settings___lambda30__gtk_tree_view_row_activated, self, 0);
	_tmp33_ = self->priv->treeview;
	_tmp34_ = toggle;
	gtk_tree_view_insert_column_with_data_func (_tmp33_, (gint) FONT_MANAGER_FONT_LIST_COLUMN_TOGGLE, "", (GtkCellRenderer*) _tmp34_, _font_manager_language_filter_settings_toggle_cell_data_func_gtk_tree_cell_data_func, g_object_ref (self), g_object_unref);
	_tmp35_ = self->priv->treeview;
	_tmp36_ = text;
	gtk_tree_view_insert_column_with_attributes (_tmp35_, -1, "", (GtkCellRenderer*) _tmp36_, "text", 1, NULL, NULL);
	_tmp37_ = self->priv->treeview;
	_tmp38_ = self->priv->search_entry;
	gtk_tree_view_set_search_entry (_tmp37_, (GtkEntry*) _tmp38_);
	_tmp39_ = self->priv->search_entry;
	gtk_entry_set_icon_from_icon_name ((GtkEntry*) _tmp39_, GTK_ENTRY_ICON_SECONDARY, NULL);
	G_OBJECT_CLASS (font_manager_language_filter_settings_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox));
	_g_object_unref0 (toggle);
	_g_object_unref0 (text);
	return obj;
	_g_object_unref0 (toggle);
	_g_object_unref0 (text);
	return obj;
}

static void
font_manager_language_filter_settings_class_init (FontManagerLanguageFilterSettingsClass * klass,
                                                  gpointer klass_data)
{
	font_manager_language_filter_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerLanguageFilterSettings_private_offset);
	G_OBJECT_CLASS (klass)->constructor = font_manager_language_filter_settings_constructor;
	G_OBJECT_CLASS (klass)->finalize = font_manager_language_filter_settings_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/FontManager/ui/font-manager-language-filter-settings.ui");
	font_manager_language_filter_settings_signals[FONT_MANAGER_LANGUAGE_FILTER_SETTINGS_SELECTIONS_CHANGED_SIGNAL] = g_signal_new ("selections-changed", FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "coverage_spin", FALSE, FontManagerLanguageFilterSettings_private_offset + G_STRUCT_OFFSET (FontManagerLanguageFilterSettingsPrivate, coverage_spin));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_entry", FALSE, FontManagerLanguageFilterSettings_private_offset + G_STRUCT_OFFSET (FontManagerLanguageFilterSettingsPrivate, search_entry));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "treeview", FALSE, FontManagerLanguageFilterSettings_private_offset + G_STRUCT_OFFSET (FontManagerLanguageFilterSettingsPrivate, treeview));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_search_changed", G_CALLBACK(_font_manager_language_filter_settings_on_search_changed_gtk_search_entry_search_changed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_back_button_clicked", G_CALLBACK(_font_manager_language_filter_settings_on_back_button_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_clear_button_clicked", G_CALLBACK(_font_manager_language_filter_settings_on_clear_button_clicked_gtk_button_clicked));
}

static void
font_manager_language_filter_settings_instance_init (FontManagerLanguageFilterSettings * self,
                                                     gpointer klass)
{
	self->priv = font_manager_language_filter_settings_get_instance_private (self);
	self->priv->text_length = (guint16) 0;
	self->priv->search_filter = NULL;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
font_manager_language_filter_settings_finalize (GObject * obj)
{
	FontManagerLanguageFilterSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_LANGUAGE_FILTER_SETTINGS, FontManagerLanguageFilterSettings);
	_g_free0 (self->priv->search_timeout);
	_g_object_unref0 (self->priv->real_model);
	_g_object_unref0 (self->priv->search_filter);
	G_OBJECT_CLASS (font_manager_language_filter_settings_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_language_filter_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerLanguageFilterSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_language_filter_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerLanguageFilterSettings), 0, (GInstanceInitFunc) font_manager_language_filter_settings_instance_init, NULL };
	GType font_manager_language_filter_settings_type_id;
	font_manager_language_filter_settings_type_id = g_type_register_static (gtk_box_get_type (), "FontManagerLanguageFilterSettings", &g_define_type_info, 0);
	FontManagerLanguageFilterSettings_private_offset = g_type_add_instance_private (font_manager_language_filter_settings_type_id, sizeof (FontManagerLanguageFilterSettingsPrivate));
	return font_manager_language_filter_settings_type_id;
}

GType
font_manager_language_filter_settings_get_type (void)
{
	static volatile gsize font_manager_language_filter_settings_type_id__once = 0;
	if (g_once_init_enter (&font_manager_language_filter_settings_type_id__once)) {
		GType font_manager_language_filter_settings_type_id;
		font_manager_language_filter_settings_type_id = font_manager_language_filter_settings_get_type_once ();
		g_once_init_leave (&font_manager_language_filter_settings_type_id__once, font_manager_language_filter_settings_type_id);
	}
	return font_manager_language_filter_settings_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

