/* PreviewPane.c generated by valac 0.56.14, the Vala compiler
 * generated from PreviewPane.vala, do not modify */

/* PreviewPane.vala
 *
 * Copyright (C) 2020-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <webkit2/webkit2.h>
#include "font-manager.h"
#include <gdk/gdk.h>
#include "config.h"
#include <libsoup/soup.h>
#include <pango/pango.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#define HEADER "\n" \
"<html dir=\"%s\">\n" \
"  <head>\n" \
"    <style>\n" \
"      body {\n" \
"        color: %s;\n" \
"        background-color: %s;\n" \
"      }\n" \
"      .noWrap {\n" \
"        overflow: visible;\n" \
"        white-space: nowrap;\n" \
"        display:block;\n" \
"        width:100%;\n" \
"      }\n" \
"      .bodyText {\n" \
"        margin: 12px 8px 12px 8px;\n" \
"        text-align: justify;\n" \
"      }\n" \
"      .previewText {\n" \
"        font-family: %s;\n" \
"        font-style: %s;\n" \
"        font-weight: %i;\n" \
"      }\n" \
"      %s\n" \
"    </style>\n" \
"  </head>\n" \
"  <body oncontextmenu=\"return false;\">\n" \
"    <div>\n"
#define WATERFALL_ROW "\n" \
"      <p id=\"%.0lf\" class=\"noWrap\">\n" \
"        <span style=\"font-family: monospace;font-size: 10px;\">%s</sp" \
"an>\n" \
"        <span class=\"previewText\" style=\"font-size:%.0lfpx;\">%s</s" \
"pan>\n" \
"      </p>\n"
#define BODY_TEXT "\n" \
"      <p class=\"bodyText\" style=\"font-size:%0.1fpx;\">\n" \
"        <span class=\"previewText\">%s</span>\n" \
"      </p>\n"
#define FOOTER "\n    </div>\n  </body>\n</html>\n"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM
} FontManagerGoogleFontsPreviewMode;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_MODE (font_manager_google_fonts_preview_mode_get_type ())

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE (font_manager_google_fonts_preview_pane_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane))
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPaneClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_PREVIEW_PANE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE))
#define FONT_MANAGER_GOOGLE_FONTS_IS_PREVIEW_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE))
#define FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPaneClass))

typedef struct _FontManagerGoogleFontsPreviewPane FontManagerGoogleFontsPreviewPane;
typedef struct _FontManagerGoogleFontsPreviewPaneClass FontManagerGoogleFontsPreviewPaneClass;
typedef struct _FontManagerGoogleFontsPreviewPanePrivate FontManagerGoogleFontsPreviewPanePrivate;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY (font_manager_google_fonts_family_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))

typedef struct _FontManagerGoogleFontsFamily FontManagerGoogleFontsFamily;
typedef struct _FontManagerGoogleFontsFamilyClass FontManagerGoogleFontsFamilyClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT (font_manager_google_fonts_font_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FONT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))

typedef struct _FontManagerGoogleFontsFont FontManagerGoogleFontsFont;
typedef struct _FontManagerGoogleFontsFontClass FontManagerGoogleFontsFontClass;

#define FONT_MANAGER_TYPE_PREVIEW_ENTRY (font_manager_preview_entry_get_type ())
#define FONT_MANAGER_PREVIEW_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntry))
#define FONT_MANAGER_PREVIEW_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntryClass))
#define FONT_MANAGER_IS_PREVIEW_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY))
#define FONT_MANAGER_IS_PREVIEW_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_PREVIEW_ENTRY))
#define FONT_MANAGER_PREVIEW_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_PREVIEW_ENTRY, FontManagerPreviewEntryClass))

typedef struct _FontManagerPreviewEntry FontManagerPreviewEntry;
typedef struct _FontManagerPreviewEntryClass FontManagerPreviewEntryClass;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST (font_manager_google_fonts_sample_list_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleList))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleListClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_LIST, FontManagerGoogleFontsSampleListClass))

typedef struct _FontManagerGoogleFontsSampleList FontManagerGoogleFontsSampleList;
typedef struct _FontManagerGoogleFontsSampleListClass FontManagerGoogleFontsSampleListClass;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pango_layout_line_unref0(var) ((var == NULL) ? NULL : (var = (pango_layout_line_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE
} FontManagerGoogleFontsFileStatus;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FILE_STATUS (font_manager_google_fonts_file_status_get_type ())

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL (font_manager_google_fonts_sample_model_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModel))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModelClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL))
#define FONT_MANAGER_GOOGLE_FONTS_IS_SAMPLE_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL))
#define FONT_MANAGER_GOOGLE_FONTS_SAMPLE_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_SAMPLE_MODEL, FontManagerGoogleFontsSampleModelClass))

typedef struct _FontManagerGoogleFontsSampleModel FontManagerGoogleFontsSampleModel;
typedef struct _FontManagerGoogleFontsSampleModelClass FontManagerGoogleFontsSampleModelClass;
typedef struct _Block76Data Block76Data;
typedef struct _Block77Data Block77Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define FONT_MANAGER_TYPE_APPLICATION (font_manager_application_get_type ())
#define FONT_MANAGER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplication))
#define FONT_MANAGER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))
#define FONT_MANAGER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_APPLICATION))
#define FONT_MANAGER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_APPLICATION, FontManagerApplicationClass))

typedef struct _FontManagerApplication FontManagerApplication;
typedef struct _FontManagerApplicationClass FontManagerApplicationClass;

#define FONT_MANAGER_TYPE_MAIN_WINDOW (font_manager_main_window_get_type ())
#define FONT_MANAGER_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindow))
#define FONT_MANAGER_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindowClass))
#define FONT_MANAGER_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_MAIN_WINDOW, FontManagerMainWindowClass))

typedef struct _FontManagerMainWindow FontManagerMainWindow;
typedef struct _FontManagerMainWindowClass FontManagerMainWindowClass;
typedef struct _Block78Data Block78Data;

struct _FontManagerGoogleFontsPreviewPane {
	GtkBox parent_instance;
	FontManagerGoogleFontsPreviewPanePrivate * priv;
};

struct _FontManagerGoogleFontsPreviewPaneClass {
	GtkBoxClass parent_class;
};

struct _FontManagerGoogleFontsPreviewPanePrivate {
	FontManagerGoogleFontsFamily* _family;
	FontManagerGoogleFontsFont* _font;
	gboolean _refresh_required;
	gboolean _show_line_size;
	gdouble _preview_size;
	gdouble _min_waterfall_size;
	gdouble _max_waterfall_size;
	gdouble _waterfall_size_ratio;
	WebKitWebView* _preview;
	FontManagerGoogleFontsPreviewMode _mode;
	GtkBox* controls;
	GtkBox* scale_container;
	GtkButton* download_button;
	GtkScrolledWindow* preview_box;
	GtkColorButton* bg_color_button;
	GtkColorButton* fg_color_button;
	GtkMenuButton* menu_button;
	FontManagerPreviewEntry* entry;
	FontManagerFontScale* fontscale;
	GtkRadioButton* lorem_ipsum;
	gchar* _preview_text;
	gchar* default_preview_text;
	gboolean restore_default_preview;
	FontManagerGoogleFontsFont* stored_font;
	FontManagerGoogleFontsSampleList* sample_list;
};

struct _Block76Data {
	int _ref_count_;
	FontManagerGoogleFontsPreviewPane* self;
	GSettings* settings;
};

struct _Block77Data {
	int _ref_count_;
	FontManagerGoogleFontsPreviewPane* self;
	FontManagerGoogleFontsFont** update;
	gint update_length1;
	gint _update_size_;
};

struct _Block78Data {
	int _ref_count_;
	FontManagerGoogleFontsPreviewPane* self;
	FontManagerMainWindow* main_window;
};

static gint FontManagerGoogleFontsPreviewPane_private_offset;
static gpointer font_manager_google_fonts_preview_pane_parent_class = NULL;

VALA_EXTERN GType font_manager_google_fonts_preview_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType font_manager_google_fonts_preview_pane_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsPreviewPane, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_family_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFamily, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_font_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFont, g_object_unref)
VALA_EXTERN GType font_manager_preview_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerPreviewEntry, g_object_unref)
VALA_EXTERN GType font_manager_google_fonts_sample_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsSampleList, g_object_unref)
static WebKitWebContext* font_manager_google_fonts_preview_pane_get_webkit_context (FontManagerGoogleFontsPreviewPane* self);
static WebKitWebView* font_manager_google_fonts_preview_pane_get_webkit_webview (FontManagerGoogleFontsPreviewPane* self);
static gboolean font_manager_google_fonts_preview_pane_on_event (FontManagerGoogleFontsPreviewPane* self,
                                                          GtkWidget* widget,
                                                          GdkEvent* event);
static gboolean _font_manager_google_fonts_preview_pane_on_event_gtk_widget_event (GtkWidget* _sender,
                                                                            GdkEvent* event,
                                                                            gpointer self);
static void __lambda208_ (FontManagerGoogleFontsPreviewPane* self,
                   WebKitWebView* view,
                   WebKitWebResource* resource,
                   WebKitURIRequest* request);
static void __lambda209_ (FontManagerGoogleFontsPreviewPane* self,
                   WebKitWebResource* resource,
                   GError* _error_);
static void ___lambda209__webkit_web_resource_failed (WebKitWebResource* _sender,
                                               GError* _error_,
                                               gpointer self);
static void __lambda210_ (FontManagerGoogleFontsPreviewPane* self,
                   WebKitWebResource* resource);
static void ___lambda210__webkit_web_resource_finished (WebKitWebResource* _sender,
                                                 gpointer self);
static void ___lambda208__webkit_web_view_resource_load_started (WebKitWebView* _sender,
                                                          WebKitWebResource* resource,
                                                          WebKitURIRequest* request,
                                                          gpointer self);
static gboolean _vala_gdk_event_type_array_contains (GdkEventType * stack,
                                              gssize stack_length,
                                              const GdkEventType needle);
static gchar* font_manager_google_fonts_preview_pane_generate_lorem_ipsum (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_preview_pane_get_font (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_pane_get_preview_size (FontManagerGoogleFontsPreviewPane* self);
static gdouble font_manager_google_fonts_preview_pane_get_next_line_size (FontManagerGoogleFontsPreviewPane* self,
                                                                   gdouble current);
VALA_EXTERN gdouble font_manager_google_fonts_preview_pane_get_waterfall_size_ratio (FontManagerGoogleFontsPreviewPane* self);
static gchar* font_manager_google_fonts_preview_pane_generate_waterfall (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_pane_get_min_waterfall_size (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN gdouble font_manager_google_fonts_preview_pane_get_max_waterfall_size (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN gboolean font_manager_google_fonts_preview_pane_get_show_line_size (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN const gchar* font_manager_google_fonts_preview_pane_get_preview_text (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN GType font_manager_google_fonts_file_status_get_type (void) G_GNUC_CONST ;
static void font_manager_google_fonts_preview_pane_selection_changed (FontManagerGoogleFontsPreviewPane* self,
                                                               FontManagerGoogleFontsFileStatus* status);
VALA_EXTERN FontManagerGoogleFontsFamily* font_manager_google_fonts_preview_pane_get_family (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_family_get_subsets (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_sample_list_set_items (FontManagerGoogleFontsSampleList* self,
                                                      FontManagerStringSet* value);
VALA_EXTERN GType font_manager_google_fonts_sample_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsSampleModel, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsSampleModel* font_manager_google_fonts_sample_list_get_model (FontManagerGoogleFontsSampleList* self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_update_preview (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN WebKitWebView* font_manager_google_fonts_preview_pane_get_preview (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_preview_text (FontManagerGoogleFontsPreviewPane* self,
                                                              const gchar* value);
VALA_EXTERN FontManagerGoogleFontsPreviewMode font_manager_google_fonts_preview_pane_get_mode (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                                gdouble min_size,
                                                                gdouble max_size,
                                                                gdouble ratio);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_min_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                                    gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_max_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                                    gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_waterfall_size_ratio (FontManagerGoogleFontsPreviewPane* self,
                                                                      gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_restore_state (FontManagerGoogleFontsPreviewPane* self,
                                                           GSettings* settings);
static Block76Data* block76_data_ref (Block76Data* _data76_);
static void block76_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_preview_size (FontManagerGoogleFontsPreviewPane* self,
                                                              gdouble value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_mode (FontManagerGoogleFontsPreviewPane* self,
                                                      FontManagerGoogleFontsPreviewMode value);
static gboolean __lambda211_ (Block76Data* _data76_);
static gboolean ___lambda211__gsource_func (gpointer self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_save_state (FontManagerGoogleFontsPreviewPane* self,
                                                        GSettings* settings);
static void font_manager_google_fonts_preview_pane_on_mode_toggled (FontManagerGoogleFontsPreviewPane* self,
                                                             GtkToggleButton* widget);
static void _font_manager_google_fonts_preview_pane_on_mode_toggled_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                                        gpointer self);
static void font_manager_google_fonts_preview_pane_on_download_button_clicked (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_family_get_installation_status (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_font_get_installation_status (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_family_get_family (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gchar* font_manager_google_fonts_get_font_directory (void);
static Block77Data* block77_data_ref (Block77Data* _data77_);
static void block77_data_unref (void * _userdata_);
VALA_EXTERN GPtrArray* font_manager_google_fonts_family_get_variants (FontManagerGoogleFontsFamily* self);
static void _vala_array_add9 (FontManagerGoogleFontsFont** * array,
                       gint* length,
                       gint* size,
                       FontManagerGoogleFontsFont* value);
VALA_EXTERN gboolean font_manager_remove_directory (GFile* dir,
                                        gboolean recursive);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_refresh_required (FontManagerGoogleFontsPreviewPane* self,
                                                                  gboolean value);
static FontManagerGoogleFontsFont** _vala_array_dup10 (FontManagerGoogleFontsFont** self,
                                                gssize length);
VALA_EXTERN void font_manager_google_fonts_download_font_files (FontManagerGoogleFontsFont** fonts,
                                                    gint fonts_length1,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
VALA_EXTERN gboolean font_manager_google_fonts_download_font_files_finish (GAsyncResult* _res_);
static void ____lambda213_ (Block77Data* _data77_,
                     GObject* obj,
                     GAsyncResult* res);
static void _____lambda213__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_url (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_description (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_version (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_get_filename (FontManagerGoogleFontsFont* self);
VALA_EXTERN gboolean font_manager_remove_directory_tree_if_empty (GFile* dir);
static void ____lambda214_ (FontManagerGoogleFontsPreviewPane* self,
                     GObject* obj,
                     GAsyncResult* res);
static void _____lambda214__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static void _font_manager_google_fonts_preview_pane_on_download_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                            gpointer self);
static void font_manager_google_fonts_preview_pane_on_entry_changed (FontManagerGoogleFontsPreviewPane* self);
static void _font_manager_google_fonts_preview_pane_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                                    gpointer self);
VALA_EXTERN FontManagerGoogleFontsPreviewPane* font_manager_google_fonts_preview_pane_new (void);
VALA_EXTERN FontManagerGoogleFontsPreviewPane* font_manager_google_fonts_preview_pane_construct (GType object_type);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_family (FontManagerGoogleFontsPreviewPane* self,
                                                        FontManagerGoogleFontsFamily* value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_font (FontManagerGoogleFontsPreviewPane* self,
                                                      FontManagerGoogleFontsFont* value);
VALA_EXTERN gboolean font_manager_google_fonts_preview_pane_get_refresh_required (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_show_line_size (FontManagerGoogleFontsPreviewPane* self,
                                                                gboolean value);
VALA_EXTERN void font_manager_google_fonts_preview_pane_set_preview (FontManagerGoogleFontsPreviewPane* self,
                                                         WebKitWebView* value);
static GObject * font_manager_google_fonts_preview_pane_constructor (GType type,
                                                              guint n_construct_properties,
                                                              GObjectConstructParam * construct_properties);
static void _font_manager_google_fonts_preview_pane___lambda215_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda215__gtk_widget_map (GtkWidget* _sender,
                                                                           gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda216_ (FontManagerGoogleFontsPreviewPane* self);
static gboolean __lambda217_ (FontManagerGoogleFontsPreviewPane* self);
VALA_EXTERN GType font_manager_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerApplication, g_object_unref)
VALA_EXTERN guint font_manager_application_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
VALA_EXTERN FontManagerApplication* font_manager_get_default_application (void);
VALA_EXTERN void font_manager_application_refresh (FontManagerApplication* self);
static gboolean ___lambda217__gsource_func (gpointer self);
static void __font_manager_google_fonts_preview_pane___lambda216__gtk_widget_unmap (GtkWidget* _sender,
                                                                             gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda218_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
VALA_EXTERN GType font_manager_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerMainWindow, g_object_unref)
static Block78Data* block78_data_ref (Block78Data* _data78_);
static void block78_data_unref (void * _userdata_);
VALA_EXTERN FontManagerMainWindow* font_manager_application_get_main_window (FontManagerApplication* self);
static gboolean ___lambda219_ (Block78Data* _data78_);
VALA_EXTERN void font_manager_main_window_set_model (FontManagerMainWindow* self,
                                         FontManagerFontModel* value);
static gboolean ____lambda219__gsource_func (gpointer self);
static void __font_manager_google_fonts_preview_pane___lambda218__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda220_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda220__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda221_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda221__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda222_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda222__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda223_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda223__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda224_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GObject* obj,
                                                           GParamSpec* pspec);
static void __font_manager_google_fonts_preview_pane___lambda224__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda225_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda225__gtk_color_button_color_set (GtkColorButton* _sender,
                                                                                       gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda226_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda226__gtk_color_button_color_set (GtkColorButton* _sender,
                                                                                       gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda227_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda227__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda228_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda228__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda229_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda229__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda230_ (FontManagerGoogleFontsPreviewPane* self);
static void __font_manager_google_fonts_preview_pane___lambda230__g_object_notify (GObject* _sender,
                                                                            GParamSpec* pspec,
                                                                            gpointer self);
VALA_EXTERN void font_manager_set_button_relief_style (GtkContainer* container,
                                           GtkReliefStyle relief);
VALA_EXTERN FontManagerGoogleFontsSampleList* font_manager_google_fonts_sample_list_new (void);
VALA_EXTERN FontManagerGoogleFontsSampleList* font_manager_google_fonts_sample_list_construct (GType object_type);
static void _font_manager_google_fonts_preview_pane___lambda231_ (FontManagerGoogleFontsPreviewPane* self,
                                                           GtkEntry* entry,
                                                           GtkEntryIconPosition position,
                                                           GdkEvent* event);
VALA_EXTERN void font_manager_google_fonts_sample_list_unselect_all (FontManagerGoogleFontsSampleList* self);
static void __font_manager_google_fonts_preview_pane___lambda231__gtk_entry_icon_press (GtkEntry* _sender,
                                                                                 GtkEntryIconPosition icon_pos,
                                                                                 GdkEvent* event,
                                                                                 gpointer self);
static void _font_manager_google_fonts_preview_pane___lambda232_ (FontManagerGoogleFontsPreviewPane* self,
                                                           const gchar* s);
static void __font_manager_google_fonts_preview_pane___lambda232__font_manager_google_fonts_sample_list_row_selected (FontManagerGoogleFontsSampleList* _sender,
                                                                                                               const gchar* sample,
                                                                                                               gpointer self);
static void font_manager_google_fonts_preview_pane_finalize (GObject * obj);
static GType font_manager_google_fonts_preview_pane_get_type_once (void);
static void _vala_font_manager_google_fonts_preview_pane_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_font_manager_google_fonts_preview_pane_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_preview_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL, "FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL", "waterfall"}, {FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM, "FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM", "lorem-ipsum"}, {0, NULL, NULL}};
	GType font_manager_google_fonts_preview_mode_type_id;
	font_manager_google_fonts_preview_mode_type_id = g_enum_register_static ("FontManagerGoogleFontsPreviewMode", values);
	return font_manager_google_fonts_preview_mode_type_id;
}

GType
font_manager_google_fonts_preview_mode_get_type (void)
{
	static volatile gsize font_manager_google_fonts_preview_mode_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_preview_mode_type_id__once)) {
		GType font_manager_google_fonts_preview_mode_type_id;
		font_manager_google_fonts_preview_mode_type_id = font_manager_google_fonts_preview_mode_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_preview_mode_type_id__once, font_manager_google_fonts_preview_mode_type_id);
	}
	return font_manager_google_fonts_preview_mode_type_id__once;
}

static inline gpointer
font_manager_google_fonts_preview_pane_get_instance_private (FontManagerGoogleFontsPreviewPane* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsPreviewPane_private_offset);
}

static WebKitWebContext*
font_manager_google_fonts_preview_pane_get_webkit_context (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebContext* web_context = NULL;
	WebKitWebContext* _tmp0_;
	WebKitWebContext* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = webkit_web_context_new_ephemeral ();
	web_context = _tmp0_;
	webkit_web_context_set_cache_model (web_context, WEBKIT_CACHE_MODEL_DOCUMENT_BROWSER);
	webkit_web_context_prefetch_dns (web_context, "http://fonts.gstatic.com/");
	result = web_context;
	return result;
}

static gboolean
_font_manager_google_fonts_preview_pane_on_event_gtk_widget_event (GtkWidget* _sender,
                                                                   GdkEvent* event,
                                                                   gpointer self)
{
	gboolean result;
	result = font_manager_google_fonts_preview_pane_on_event ((FontManagerGoogleFontsPreviewPane*) self, _sender, event);
	return result;
}

static void
__lambda209_ (FontManagerGoogleFontsPreviewPane* self,
              WebKitWebResource* resource,
              GError* _error_)
{
	g_return_if_fail (resource != NULL);
	g_return_if_fail (_error_ != NULL);
	if (_error_->code != 302) {
		const gchar* _tmp0_;
		_tmp0_ = _error_->message;
		g_warning ("PreviewPane.vala:149: %i : %s", _error_->code, _tmp0_);
	}
}

static void
___lambda209__webkit_web_resource_failed (WebKitWebResource* _sender,
                                          GError* _error_,
                                          gpointer self)
{
	__lambda209_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, _error_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda210_ (FontManagerGoogleFontsPreviewPane* self,
              WebKitWebResource* resource)
{
	WebKitURIResponse* response = NULL;
	WebKitURIResponse* _tmp0_;
	WebKitURIResponse* _tmp1_;
	WebKitURIResponse* _tmp2_;
	SoupStatus status = 0;
	WebKitURIResponse* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* uri = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	g_return_if_fail (resource != NULL);
	_tmp0_ = webkit_web_resource_get_response (resource);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	response = _tmp1_;
	_tmp2_ = response;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (response);
		return;
	}
	_tmp3_ = response;
	_tmp4_ = webkit_uri_response_get_status_code (_tmp3_);
	_tmp5_ = _tmp4_;
	status = (SoupStatus) _tmp5_;
	if (status == SOUP_STATUS_OK) {
		_g_object_unref0 (response);
		return;
	}
	_tmp6_ = webkit_web_resource_get_uri (resource);
	_tmp7_ = g_strdup (_tmp6_);
	uri = _tmp7_;
	_tmp9_ = uri;
	if (g_str_has_suffix (_tmp9_, "ttf")) {
		_tmp8_ = TRUE;
	} else {
		const gchar* _tmp10_;
		_tmp10_ = uri;
		_tmp8_ = g_str_has_suffix (_tmp10_, "otf");
	}
	if (_tmp8_) {
		const gchar* _tmp11_;
		_tmp11_ = uri;
		g_warning ("PreviewPane.vala:160: Failed to load font resource : %s", _tmp11_);
		g_message ("PreviewPane.vala:161: HTTP status code : %i", (gint) status);
	}
	_g_free0 (uri);
	_g_object_unref0 (response);
}

static void
___lambda210__webkit_web_resource_finished (WebKitWebResource* _sender,
                                            gpointer self)
{
	__lambda210_ ((FontManagerGoogleFontsPreviewPane*) self, _sender);
}

static void
__lambda208_ (FontManagerGoogleFontsPreviewPane* self,
              WebKitWebView* view,
              WebKitWebResource* resource,
              WebKitURIRequest* request)
{
	g_return_if_fail (view != NULL);
	g_return_if_fail (resource != NULL);
	g_return_if_fail (request != NULL);
	g_signal_connect_object (resource, "failed", (GCallback) ___lambda209__webkit_web_resource_failed, self, 0);
	g_signal_connect_object (resource, "finished", (GCallback) ___lambda210__webkit_web_resource_finished, self, 0);
}

static void
___lambda208__webkit_web_view_resource_load_started (WebKitWebView* _sender,
                                                     WebKitWebResource* resource,
                                                     WebKitURIRequest* request,
                                                     gpointer self)
{
	__lambda208_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, resource, request);
}

static WebKitWebView*
font_manager_google_fonts_preview_pane_get_webkit_webview (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebView* preview = NULL;
	WebKitWebContext* _tmp0_;
	WebKitWebContext* _tmp1_;
	WebKitWebView* _tmp2_;
	WebKitWebView* _tmp3_;
	GtkScrolledWindow* _tmp4_;
	WebKitSettings* settings = NULL;
	WebKitSettings* _tmp5_ = NULL;
	WebKitWebView* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = font_manager_google_fonts_preview_pane_get_webkit_context (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = (WebKitWebView*) webkit_web_view_new_with_context (_tmp1_);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	preview = _tmp3_;
	_tmp4_ = self->priv->preview_box;
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) preview);
	gtk_widget_show ((GtkWidget*) preview);
	g_signal_connect_object ((GtkWidget*) preview, "event", (GCallback) _font_manager_google_fonts_preview_pane_on_event_gtk_widget_event, self, 0);
	_tmp5_ = webkit_settings_new ();
	webkit_settings_set_enable_fullscreen (_tmp5_, FALSE);
	webkit_settings_set_enable_java (_tmp5_, FALSE);
	webkit_settings_set_enable_media (_tmp5_, FALSE);
	webkit_settings_set_enable_mediasource (_tmp5_, FALSE);
	webkit_settings_set_enable_plugins (_tmp5_, FALSE);
	webkit_settings_set_enable_site_specific_quirks (_tmp5_, FALSE);
	webkit_settings_set_enable_smooth_scrolling (_tmp5_, TRUE);
	webkit_settings_set_enable_webaudio (_tmp5_, FALSE);
	webkit_settings_set_enable_xss_auditor (_tmp5_, FALSE);
	settings = _tmp5_;
	webkit_settings_set_user_agent_with_application_details (settings, PACKAGE_NAME, PACKAGE_VERSION);
	webkit_web_view_set_settings (preview, settings);
	g_signal_connect_object (preview, "resource-load-started", (GCallback) ___lambda208__webkit_web_view_resource_load_started, self, 0);
	result = preview;
	_g_object_unref0 (settings);
	return result;
}

static gboolean
_vala_gdk_event_type_array_contains (GdkEventType * stack,
                                     gssize stack_length,
                                     const GdkEventType needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

static gboolean
font_manager_google_fonts_preview_pane_on_event (FontManagerGoogleFontsPreviewPane* self,
                                                 GtkWidget* widget,
                                                 GdkEvent* event)
{
	GdkEventType* allowed_events = NULL;
	GdkEventType* _tmp0_;
	gint allowed_events_length1;
	gint _allowed_events_size_;
	GdkEventType* _tmp1_;
	gint _tmp1__length1;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = g_new0 (GdkEventType, 4);
	_tmp0_[0] = GDK_SCROLL;
	_tmp0_[1] = GDK_TOUCH_BEGIN;
	_tmp0_[2] = GDK_TOUCH_END;
	_tmp0_[3] = GDK_TOUCH_UPDATE;
	allowed_events = _tmp0_;
	allowed_events_length1 = 4;
	_allowed_events_size_ = allowed_events_length1;
	_tmp1_ = allowed_events;
	_tmp1__length1 = allowed_events_length1;
	if (_vala_gdk_event_type_array_contains (_tmp1_, _tmp1__length1, event->type)) {
		result = GDK_EVENT_PROPAGATE;
		allowed_events = (g_free (allowed_events), NULL);
		return result;
	}
	result = GDK_EVENT_STOP;
	allowed_events = (g_free (allowed_events), NULL);
	return result;
}

static gpointer
_pango_layout_line_ref0 (gpointer self)
{
	return self ? pango_layout_line_ref (self) : NULL;
}

static gchar*
font_manager_google_fonts_preview_pane_generate_lorem_ipsum (FontManagerGoogleFontsPreviewPane* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	PangoLayoutLine* line = NULL;
	FontManagerPreviewEntry* _tmp1_;
	PangoLayout* _tmp2_;
	PangoLayoutLine* _tmp3_;
	PangoLayoutLine* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	PangoLayoutLine* _tmp7_;
	gchar* text_direction = NULL;
	gchar* _tmp9_;
	GString* _tmp10_;
	GtkColorButton* _tmp11_;
	GdkRGBA _tmp12_ = {0};
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkColorButton* _tmp15_;
	GdkRGBA _tmp16_ = {0};
	gchar* _tmp17_;
	gchar* _tmp18_;
	FontManagerGoogleFontsFont* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	FontManagerGoogleFontsFont* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	FontManagerGoogleFontsFont* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	FontManagerGoogleFontsFont* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* pref_loc = NULL;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	GString* _tmp35_;
	gdouble _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GString* _tmp39_;
	GString* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = self->priv->entry;
	_tmp2_ = gtk_entry_get_layout ((GtkEntry*) _tmp1_);
	_tmp3_ = pango_layout_get_line (_tmp2_, 0);
	_tmp4_ = _pango_layout_line_ref0 (_tmp3_);
	line = _tmp4_;
	_tmp7_ = line;
	if (_tmp7_ != NULL) {
		PangoLayoutLine* _tmp8_;
		_tmp8_ = line;
		_tmp6_ = _tmp8_->resolved_dir == ((guint) PANGO_DIRECTION_RTL);
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		_tmp5_ = "rtl";
	} else {
		_tmp5_ = "ltr";
	}
	_tmp9_ = g_strdup (_tmp5_);
	text_direction = _tmp9_;
	_tmp10_ = builder;
	_tmp11_ = self->priv->fg_color_button;
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp11_, &_tmp12_);
	_tmp13_ = gdk_rgba_to_string (&_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = self->priv->bg_color_button;
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp15_, &_tmp16_);
	_tmp17_ = gdk_rgba_to_string (&_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = self->priv->_font;
	_tmp20_ = font_manager_google_fonts_font_get_family (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = self->priv->_font;
	_tmp23_ = font_manager_google_fonts_font_get_style (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = self->priv->_font;
	_tmp26_ = font_manager_google_fonts_font_get_weight (_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = self->priv->_font;
	_tmp29_ = font_manager_google_fonts_font_to_font_face_rule (_tmp28_);
	_tmp30_ = _tmp29_;
	_tmp31_ = g_strdup_printf (HEADER, text_direction, _tmp14_, _tmp18_, _tmp21_, _tmp24_, _tmp27_, _tmp30_);
	_tmp32_ = _tmp31_;
	g_string_append (_tmp10_, _tmp32_);
	_g_free0 (_tmp32_);
	_g_free0 (_tmp30_);
	_g_free0 (_tmp18_);
	_g_free0 (_tmp14_);
	_tmp33_ = setlocale (LC_ALL, "");
	_tmp34_ = g_strdup (_tmp33_);
	pref_loc = _tmp34_;
	setlocale (LC_ALL, "C");
	_tmp35_ = builder;
	_tmp36_ = self->priv->_preview_size;
	_tmp37_ = g_strdup_printf (BODY_TEXT, _tmp36_, FONT_MANAGER_LOREM_IPSUM);
	_tmp38_ = _tmp37_;
	g_string_append (_tmp35_, _tmp38_);
	_g_free0 (_tmp38_);
	setlocale (LC_ALL, pref_loc);
	_tmp39_ = builder;
	g_string_append (_tmp39_, FOOTER);
	_tmp40_ = builder;
	_tmp41_ = _tmp40_->str;
	_tmp42_ = g_strdup (_tmp41_);
	result = _tmp42_;
	_g_free0 (pref_loc);
	_g_free0 (text_direction);
	_pango_layout_line_unref0 (line);
	_g_string_free0 (builder);
	return result;
}

static gdouble
font_manager_google_fonts_preview_pane_get_next_line_size (FontManagerGoogleFontsPreviewPane* self,
                                                           gdouble current)
{
	gdouble _tmp0_;
	gdouble next = 0.0;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_waterfall_size_ratio;
	if (_tmp0_ <= 1.0) {
		result = current + 1.0;
		return result;
	}
	_tmp1_ = self->priv->_waterfall_size_ratio;
	next = current * _tmp1_;
	_tmp3_ = self->priv->_waterfall_size_ratio;
	if (_tmp3_ > 1.1) {
		_tmp2_ = floor (next);
	} else {
		_tmp2_ = ceil (next);
	}
	result = _tmp2_;
	return result;
}

static gchar*
font_manager_google_fonts_preview_pane_generate_waterfall (FontManagerGoogleFontsPreviewPane* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	PangoLayoutLine* line = NULL;
	FontManagerPreviewEntry* _tmp1_;
	PangoLayout* _tmp2_;
	PangoLayoutLine* _tmp3_;
	PangoLayoutLine* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	PangoLayoutLine* _tmp7_;
	gchar* text_direction = NULL;
	gchar* _tmp9_;
	GString* _tmp10_;
	const gchar* _tmp11_;
	GtkColorButton* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkColorButton* _tmp16_;
	GdkRGBA _tmp17_ = {0};
	gchar* _tmp18_;
	gchar* _tmp19_;
	FontManagerGoogleFontsFont* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	FontManagerGoogleFontsFont* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	FontManagerGoogleFontsFont* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	FontManagerGoogleFontsFont* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GString* _tmp49_;
	GString* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = self->priv->entry;
	_tmp2_ = gtk_entry_get_layout ((GtkEntry*) _tmp1_);
	_tmp3_ = pango_layout_get_line (_tmp2_, 0);
	_tmp4_ = _pango_layout_line_ref0 (_tmp3_);
	line = _tmp4_;
	_tmp7_ = line;
	if (_tmp7_ != NULL) {
		PangoLayoutLine* _tmp8_;
		_tmp8_ = line;
		_tmp6_ = _tmp8_->resolved_dir == ((guint) PANGO_DIRECTION_RTL);
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		_tmp5_ = "rtl";
	} else {
		_tmp5_ = "ltr";
	}
	_tmp9_ = g_strdup (_tmp5_);
	text_direction = _tmp9_;
	_tmp10_ = builder;
	_tmp11_ = text_direction;
	_tmp12_ = self->priv->fg_color_button;
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp12_, &_tmp13_);
	_tmp14_ = gdk_rgba_to_string (&_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = self->priv->bg_color_button;
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp16_, &_tmp17_);
	_tmp18_ = gdk_rgba_to_string (&_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = self->priv->_font;
	_tmp21_ = font_manager_google_fonts_font_get_family (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = self->priv->_font;
	_tmp24_ = font_manager_google_fonts_font_get_style (_tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = self->priv->_font;
	_tmp27_ = font_manager_google_fonts_font_get_weight (_tmp26_);
	_tmp28_ = _tmp27_;
	_tmp29_ = self->priv->_font;
	_tmp30_ = font_manager_google_fonts_font_to_font_face_rule (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = g_strdup_printf (HEADER, _tmp11_, _tmp15_, _tmp19_, _tmp22_, _tmp25_, _tmp28_, _tmp31_);
	_tmp33_ = _tmp32_;
	g_string_append (_tmp10_, _tmp33_);
	_g_free0 (_tmp33_);
	_g_free0 (_tmp31_);
	_g_free0 (_tmp19_);
	_g_free0 (_tmp15_);
	{
		gdouble i = 0.0;
		gdouble _tmp34_;
		_tmp34_ = self->priv->_min_waterfall_size;
		i = _tmp34_;
		{
			gboolean _tmp35_ = FALSE;
			_tmp35_ = TRUE;
			while (TRUE) {
				gdouble _tmp36_;
				gchar* pixels = NULL;
				gchar* _tmp37_;
				gboolean _tmp38_;
				GString* _tmp43_;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				const gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
				if (!_tmp35_) {
					i = font_manager_google_fonts_preview_pane_get_next_line_size (self, i);
				}
				_tmp35_ = FALSE;
				_tmp36_ = self->priv->_max_waterfall_size;
				if (!(i <= _tmp36_)) {
					break;
				}
				_tmp37_ = g_strdup ("&nbsp;");
				pixels = _tmp37_;
				_tmp38_ = self->priv->_show_line_size;
				if (_tmp38_) {
					gchar* _tmp39_ = NULL;
					gchar* _tmp42_;
					if (i < ((gdouble) 10)) {
						gchar* _tmp40_;
						_tmp40_ = g_strdup_printf ("&nbsp;&nbsp;%.0lfpx&nbsp", i);
						_g_free0 (_tmp39_);
						_tmp39_ = _tmp40_;
					} else {
						gchar* _tmp41_;
						_tmp41_ = g_strdup_printf ("&nbsp;%.0lfpx&nbsp;", i);
						_g_free0 (_tmp39_);
						_tmp39_ = _tmp41_;
					}
					_tmp42_ = g_strdup (_tmp39_);
					_g_free0 (pixels);
					pixels = _tmp42_;
					_g_free0 (_tmp39_);
				}
				_tmp43_ = builder;
				_tmp44_ = pixels;
				_tmp45_ = font_manager_google_fonts_preview_pane_get_preview_text (self);
				_tmp46_ = _tmp45_;
				_tmp47_ = g_strdup_printf (WATERFALL_ROW, i, _tmp44_, i, _tmp46_);
				_tmp48_ = _tmp47_;
				g_string_append (_tmp43_, _tmp48_);
				_g_free0 (_tmp48_);
				_g_free0 (pixels);
			}
		}
	}
	_tmp49_ = builder;
	g_string_append (_tmp49_, FOOTER);
	_tmp50_ = builder;
	_tmp51_ = _tmp50_->str;
	_tmp52_ = g_strdup (_tmp51_);
	result = _tmp52_;
	_g_free0 (text_direction);
	_pango_layout_line_unref0 (line);
	_g_string_free0 (builder);
	return result;
}

static void
font_manager_google_fonts_preview_pane_selection_changed (FontManagerGoogleFontsPreviewPane* self,
                                                          FontManagerGoogleFontsFileStatus* status)
{
	gchar* label = NULL;
	GtkStyleContext* ctx = NULL;
	GtkButton* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkButton* _tmp18_;
	const gchar* _tmp19_;
	FontManagerStringSet* _tmp20_ = NULL;
	FontManagerGoogleFontsFamily* _tmp21_;
	FontManagerGoogleFontsSampleList* _tmp28_;
	guint langs = 0U;
	FontManagerGoogleFontsSampleList* _tmp29_;
	FontManagerGoogleFontsSampleModel* _tmp30_;
	FontManagerGoogleFontsSampleModel* _tmp31_;
	FontManagerPreviewEntry* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->download_button;
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	ctx = _tmp2_;
	switch (*status) {
		case FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE:
		{
			const gchar* _tmp3_ = NULL;
			FontManagerGoogleFontsFamily* _tmp4_;
			gchar* _tmp5_;
			GtkStyleContext* _tmp6_;
			GtkStyleContext* _tmp7_;
			_tmp4_ = self->priv->_family;
			if (_tmp4_ != NULL) {
				_tmp3_ = _ ("Update Family");
			} else {
				_tmp3_ = _ ("Update Font");
			}
			_tmp5_ = g_strdup (_tmp3_);
			_g_free0 (label);
			label = _tmp5_;
			_tmp6_ = ctx;
			gtk_style_context_remove_class (_tmp6_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			_tmp7_ = ctx;
			gtk_style_context_add_class (_tmp7_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
			break;
		}
		case FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED:
		{
			const gchar* _tmp8_ = NULL;
			FontManagerGoogleFontsFamily* _tmp9_;
			gchar* _tmp10_;
			GtkStyleContext* _tmp11_;
			GtkStyleContext* _tmp12_;
			_tmp9_ = self->priv->_family;
			if (_tmp9_ != NULL) {
				_tmp8_ = _ ("Remove Family");
			} else {
				_tmp8_ = _ ("Remove Font");
			}
			_tmp10_ = g_strdup (_tmp8_);
			_g_free0 (label);
			label = _tmp10_;
			_tmp11_ = ctx;
			gtk_style_context_remove_class (_tmp11_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
			_tmp12_ = ctx;
			gtk_style_context_add_class (_tmp12_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			break;
		}
		default:
		{
			const gchar* _tmp13_ = NULL;
			FontManagerGoogleFontsFamily* _tmp14_;
			gchar* _tmp15_;
			GtkStyleContext* _tmp16_;
			GtkStyleContext* _tmp17_;
			_tmp14_ = self->priv->_family;
			if (_tmp14_ != NULL) {
				_tmp13_ = _ ("Download Family");
			} else {
				_tmp13_ = _ ("Download Font");
			}
			_tmp15_ = g_strdup (_tmp13_);
			_g_free0 (label);
			label = _tmp15_;
			_tmp16_ = ctx;
			gtk_style_context_remove_class (_tmp16_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
			_tmp17_ = ctx;
			gtk_style_context_remove_class (_tmp17_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
			break;
		}
	}
	_tmp18_ = self->priv->download_button;
	_tmp19_ = label;
	gtk_button_set_label (_tmp18_, _tmp19_);
	_tmp21_ = self->priv->_family;
	if (_tmp21_ != NULL) {
		FontManagerGoogleFontsFamily* _tmp22_;
		FontManagerStringSet* _tmp23_;
		FontManagerStringSet* _tmp24_;
		_tmp22_ = self->priv->_family;
		_tmp23_ = font_manager_google_fonts_family_get_subsets (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp20_ = _tmp24_;
	} else {
		FontManagerGoogleFontsFont* _tmp25_;
		FontManagerStringSet* _tmp26_;
		FontManagerStringSet* _tmp27_;
		_tmp25_ = self->priv->_font;
		_tmp26_ = font_manager_google_fonts_font_get_subsets (_tmp25_);
		_tmp27_ = _tmp26_;
		_tmp20_ = _tmp27_;
	}
	_tmp28_ = self->priv->sample_list;
	font_manager_google_fonts_sample_list_set_items (_tmp28_, _tmp20_);
	_tmp29_ = self->priv->sample_list;
	_tmp30_ = font_manager_google_fonts_sample_list_get_model (_tmp29_);
	_tmp31_ = _tmp30_;
	langs = g_list_model_get_n_items ((GListModel*) _tmp31_);
	_tmp32_ = self->priv->entry;
	_tmp33_ = g_strdup_printf (ngettext ("%i Language Sample Available ", "%i Language Samples Available", (gulong) langs), (gint) langs);
	_tmp34_ = _tmp33_;
	gtk_entry_set_icon_tooltip_text ((GtkEntry*) _tmp32_, GTK_ENTRY_ICON_PRIMARY, _tmp34_);
	_g_free0 (_tmp34_);
	_g_object_unref0 (ctx);
	_g_free0 (label);
	return;
}

void
font_manager_google_fonts_preview_pane_update_preview (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	FontManagerGoogleFontsFont* _tmp2_;
	FontManagerGoogleFontsFont* _tmp3_;
	gchar* html = NULL;
	gchar* _tmp6_;
	FontManagerGoogleFontsFont* _tmp7_;
	WebKitWebView* _tmp11_;
	const gchar* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_preview;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp2_ = self->priv->_font;
	_tmp3_ = self->priv->stored_font;
	if (_tmp2_ != _tmp3_) {
		_tmp1_ = self->priv->restore_default_preview;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		FontManagerPreviewEntry* _tmp4_;
		const gchar* _tmp5_;
		_tmp4_ = self->priv->entry;
		gtk_entry_set_text ((GtkEntry*) _tmp4_, "");
		_tmp5_ = self->priv->default_preview_text;
		font_manager_google_fonts_preview_pane_set_preview_text (self, _tmp5_);
		self->priv->restore_default_preview = FALSE;
	}
	_tmp6_ = g_strdup ("<html><body><p> </p></body></html>");
	html = _tmp6_;
	_tmp7_ = self->priv->_font;
	if (_tmp7_ != NULL) {
		FontManagerGoogleFontsPreviewMode _tmp8_;
		_tmp8_ = self->priv->_mode;
		switch (_tmp8_) {
			case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL:
			{
				gchar* _tmp9_;
				_tmp9_ = font_manager_google_fonts_preview_pane_generate_waterfall (self);
				_g_free0 (html);
				html = _tmp9_;
				break;
			}
			case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM:
			{
				gchar* _tmp10_;
				_tmp10_ = font_manager_google_fonts_preview_pane_generate_lorem_ipsum (self);
				_g_free0 (html);
				html = _tmp10_;
				break;
			}
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
	_tmp11_ = self->priv->_preview;
	_tmp12_ = html;
	webkit_web_view_load_html (_tmp11_, _tmp12_, NULL);
	_g_free0 (html);
	return;
}

void
font_manager_google_fonts_preview_pane_set_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                           gdouble min_size,
                                                           gdouble max_size,
                                                           gdouble ratio)
{
	g_return_if_fail (self != NULL);
	font_manager_google_fonts_preview_pane_set_min_waterfall_size (self, min_size);
	font_manager_google_fonts_preview_pane_set_max_waterfall_size (self, max_size);
	font_manager_google_fonts_preview_pane_set_waterfall_size_ratio (self, ratio);
	font_manager_google_fonts_preview_pane_update_preview (self);
	return;
}

static Block76Data*
block76_data_ref (Block76Data* _data76_)
{
	g_atomic_int_inc (&_data76_->_ref_count_);
	return _data76_;
}

static void
block76_data_unref (void * _userdata_)
{
	Block76Data* _data76_;
	_data76_ = (Block76Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data76_->_ref_count_)) {
		FontManagerGoogleFontsPreviewPane* self;
		self = _data76_->self;
		_g_object_unref0 (_data76_->settings);
		_g_object_unref0 (self);
		g_slice_free (Block76Data, _data76_);
	}
}

static gboolean
__lambda211_ (Block76Data* _data76_)
{
	FontManagerGoogleFontsPreviewPane* self;
	GdkRGBA foreground = {0};
	GdkRGBA background = {0};
	gboolean foreground_set = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean background_set = FALSE;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
	self = _data76_->self;
	memset (&foreground, 0, sizeof (GdkRGBA));
	memset (&background, 0, sizeof (GdkRGBA));
	_tmp0_ = g_settings_get_string (_data76_->settings, "google-fonts-foreground-color");
	_tmp1_ = _tmp0_;
	_tmp2_ = gdk_rgba_parse (&foreground, _tmp1_);
	_g_free0 (_tmp1_);
	foreground_set = _tmp2_;
	_tmp3_ = g_settings_get_string (_data76_->settings, "google-fonts-background-color");
	_tmp4_ = _tmp3_;
	_tmp5_ = gdk_rgba_parse (&background, _tmp4_);
	_g_free0 (_tmp4_);
	background_set = _tmp5_;
	if (foreground_set) {
		GdkRGBA _tmp6_;
		GtkColorButton* _tmp7_;
		GdkRGBA _tmp8_;
		_tmp6_ = foreground;
		if (_tmp6_.alpha == 0.0) {
			foreground.alpha = 1.0;
		}
		_tmp7_ = self->priv->fg_color_button;
		_tmp8_ = foreground;
		gtk_color_chooser_set_rgba (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_color_chooser_get_type (), GtkColorChooser), &_tmp8_);
	}
	if (background_set) {
		GdkRGBA _tmp9_;
		GtkColorButton* _tmp10_;
		GdkRGBA _tmp11_;
		_tmp9_ = background;
		if (_tmp9_.alpha == 0.0) {
			background.alpha = 1.0;
		}
		_tmp10_ = self->priv->bg_color_button;
		_tmp11_ = background;
		gtk_color_chooser_set_rgba (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_color_chooser_get_type (), GtkColorChooser), &_tmp11_);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda211__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda211_ (self);
	return result;
}

void
font_manager_google_fonts_preview_pane_restore_state (FontManagerGoogleFontsPreviewPane* self,
                                                      GSettings* settings)
{
	Block76Data* _data76_;
	GSettings* _tmp0_;
	FontManagerPreviewEntry* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkRadioButton* _tmp4_;
	FontManagerGoogleFontsPreviewMode _tmp5_;
	FontManagerPreviewEntry* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (settings != NULL);
	_data76_ = g_slice_new0 (Block76Data);
	_data76_->_ref_count_ = 1;
	_data76_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (_data76_->settings);
	_data76_->settings = _tmp0_;
	font_manager_google_fonts_preview_pane_set_preview_size (self, g_settings_get_double (_data76_->settings, "google-fonts-font-size"));
	_tmp1_ = self->priv->entry;
	_tmp2_ = g_settings_get_string (_data76_->settings, "google-fonts-preview-text");
	_tmp3_ = _tmp2_;
	gtk_entry_set_text ((GtkEntry*) _tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	font_manager_google_fonts_preview_pane_set_mode (self, (FontManagerGoogleFontsPreviewMode) g_settings_get_enum (_data76_->settings, "google-fonts-preview-mode"));
	_tmp4_ = self->priv->lorem_ipsum;
	_tmp5_ = self->priv->_mode;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp4_, _tmp5_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda211__gsource_func, block76_data_ref (_data76_), block76_data_unref);
	_tmp6_ = self->priv->entry;
	g_settings_bind (_data76_->settings, "google-fonts-preview-text", (GObject*) _tmp6_, "text", G_SETTINGS_BIND_DEFAULT);
	g_settings_bind (_data76_->settings, "google-fonts-font-size", (GObject*) self, "preview-size", G_SETTINGS_BIND_DEFAULT);
	g_settings_bind (_data76_->settings, "google-fonts-preview-mode", (GObject*) self, "mode", G_SETTINGS_BIND_DEFAULT);
	block76_data_unref (_data76_);
	_data76_ = NULL;
	return;
}

void
font_manager_google_fonts_preview_pane_save_state (FontManagerGoogleFontsPreviewPane* self,
                                                   GSettings* settings)
{
	GtkColorButton* _tmp0_;
	GdkRGBA _tmp1_ = {0};
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkColorButton* _tmp4_;
	GdkRGBA _tmp5_ = {0};
	gchar* _tmp6_;
	gchar* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (settings != NULL);
	_tmp0_ = self->priv->fg_color_button;
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp0_, &_tmp1_);
	_tmp2_ = gdk_rgba_to_string (&_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_string (settings, "google-fonts-foreground-color", _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = self->priv->bg_color_button;
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp4_, &_tmp5_);
	_tmp6_ = gdk_rgba_to_string (&_tmp5_);
	_tmp7_ = _tmp6_;
	g_settings_set_string (settings, "google-fonts-background-color", _tmp7_);
	_g_free0 (_tmp7_);
	return;
}

static void
font_manager_google_fonts_preview_pane_on_mode_toggled (FontManagerGoogleFontsPreviewPane* self,
                                                        GtkToggleButton* widget)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkMenuButton* _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = gtk_toggle_button_get_active (widget);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = gtk_widget_get_name ((GtkWidget*) widget);
	_tmp3_ = _tmp2_;
	font_manager_google_fonts_preview_pane_set_mode (self, (FontManagerGoogleFontsPreviewMode) atoi (_tmp3_));
	_tmp4_ = self->priv->menu_button;
	_tmp5_ = gtk_menu_button_get_popover (_tmp4_);
	_tmp6_ = _tmp5_;
	gtk_popover_popdown (_tmp6_);
	font_manager_google_fonts_preview_pane_update_preview (self);
	return;
}

static void
_font_manager_google_fonts_preview_pane_on_mode_toggled_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                                   gpointer self)
{
	font_manager_google_fonts_preview_pane_on_mode_toggled ((FontManagerGoogleFontsPreviewPane*) self, _sender);
}

static Block77Data*
block77_data_ref (Block77Data* _data77_)
{
	g_atomic_int_inc (&_data77_->_ref_count_);
	return _data77_;
}

static void
block77_data_unref (void * _userdata_)
{
	Block77Data* _data77_;
	_data77_ = (Block77Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data77_->_ref_count_)) {
		FontManagerGoogleFontsPreviewPane* self;
		self = _data77_->self;
		_data77_->update = (_vala_array_free (_data77_->update, _data77_->update_length1, (GDestroyNotify) g_object_unref), NULL);
		_g_object_unref0 (self);
		g_slice_free (Block77Data, _data77_);
	}
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

static void
_vala_array_add9 (FontManagerGoogleFontsFont** * array,
                  gint* length,
                  gint* size,
                  FontManagerGoogleFontsFont* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (FontManagerGoogleFontsFont*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static FontManagerGoogleFontsFont**
_vala_array_dup10 (FontManagerGoogleFontsFont** self,
                   gssize length)
{
	if (length >= 0) {
		FontManagerGoogleFontsFont** result;
		gssize i;
		result = g_new0 (FontManagerGoogleFontsFont*, length + 1);
		for (i = 0; i < length; i++) {
			FontManagerGoogleFontsFont* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
____lambda213_ (Block77Data* _data77_,
                GObject* obj,
                GAsyncResult* res)
{
	FontManagerGoogleFontsPreviewPane* self;
	FontManagerGoogleFontsFont** _tmp1_;
	gint _tmp1__length1;
	self = _data77_->self;
	g_return_if_fail (res != NULL);
	if (font_manager_google_fonts_download_font_files_finish (res)) {
		FontManagerGoogleFontsFileStatus _tmp0_;
		_tmp0_ = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED;
		font_manager_google_fonts_preview_pane_selection_changed (self, &_tmp0_);
		font_manager_google_fonts_preview_pane_set_refresh_required (self, TRUE);
	}
	_tmp1_ = _data77_->update;
	_tmp1__length1 = _data77_->update_length1;
	{
		FontManagerGoogleFontsFont** font_collection = NULL;
		gint font_collection_length1 = 0;
		gint _font_collection_size_ = 0;
		gint font_it = 0;
		font_collection = _tmp1_;
		font_collection_length1 = _tmp1__length1;
		for (font_it = 0; font_it < font_collection_length1; font_it = font_it + 1) {
			FontManagerGoogleFontsFont* _tmp2_;
			FontManagerGoogleFontsFont* font = NULL;
			_tmp2_ = _g_object_ref0 (font_collection[font_it]);
			font = _tmp2_;
			{
				FontManagerGoogleFontsFont* _tmp3_;
				_tmp3_ = font;
				g_object_unref ((GObject*) _tmp3_);
				_g_object_unref0 (font);
			}
		}
	}
}

static void
_____lambda213__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
	____lambda213_ (self, source_object, res);
	block77_data_unref (self);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
____lambda214_ (FontManagerGoogleFontsPreviewPane* self,
                GObject* obj,
                GAsyncResult* res)
{
	FontManagerGoogleFontsFont* _tmp1_;
	g_return_if_fail (res != NULL);
	if (font_manager_google_fonts_download_font_files_finish (res)) {
		FontManagerGoogleFontsFileStatus _tmp0_;
		_tmp0_ = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED;
		font_manager_google_fonts_preview_pane_selection_changed (self, &_tmp0_);
		font_manager_google_fonts_preview_pane_set_refresh_required (self, TRUE);
	}
	_tmp1_ = self->priv->_font;
	g_object_unref ((GObject*) _tmp1_);
}

static void
_____lambda214__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
	____lambda214_ ((FontManagerGoogleFontsPreviewPane*) self, source_object, res);
	g_object_unref (self);
}

static void
font_manager_google_fonts_preview_pane_on_download_button_clicked (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerGoogleFontsFileStatus _tmp0_ = 0;
	FontManagerGoogleFontsFamily* _tmp1_;
	FontManagerGoogleFontsFileStatus status = 0;
	const gchar* _tmp4_ = NULL;
	FontManagerGoogleFontsFamily* _tmp5_;
	gchar* dirname = NULL;
	gchar* _tmp12_;
	GFile* font_dir = NULL;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	FontManagerGoogleFontsFamily* _tmp20_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_family;
	if (_tmp1_ != NULL) {
		FontManagerGoogleFontsFamily* _tmp2_;
		_tmp2_ = self->priv->_family;
		_tmp0_ = font_manager_google_fonts_family_get_installation_status (_tmp2_);
	} else {
		FontManagerGoogleFontsFont* _tmp3_;
		_tmp3_ = self->priv->_font;
		_tmp0_ = font_manager_google_fonts_font_get_installation_status (_tmp3_);
	}
	status = _tmp0_;
	_tmp5_ = self->priv->_family;
	if (_tmp5_ != NULL) {
		FontManagerGoogleFontsFamily* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp6_ = self->priv->_family;
		_tmp7_ = font_manager_google_fonts_family_get_family (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp4_ = _tmp8_;
	} else {
		FontManagerGoogleFontsFont* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		_tmp9_ = self->priv->_font;
		_tmp10_ = font_manager_google_fonts_font_get_family (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp4_ = _tmp11_;
	}
	_tmp12_ = g_strdup (_tmp4_);
	dirname = _tmp12_;
	_tmp13_ = font_manager_google_fonts_get_font_directory ();
	_tmp14_ = _tmp13_;
	_tmp15_ = dirname;
	_tmp16_ = g_build_filename (_tmp14_, _tmp15_, NULL);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_file_new_for_path (_tmp17_);
	_tmp19_ = _tmp18_;
	_g_free0 (_tmp17_);
	_g_free0 (_tmp14_);
	font_dir = _tmp19_;
	_tmp20_ = self->priv->_family;
	if (_tmp20_ != NULL) {
		Block77Data* _data77_;
		GFile* _tmp36_;
		_data77_ = g_slice_new0 (Block77Data);
		_data77_->_ref_count_ = 1;
		_data77_->self = g_object_ref (self);
		_data77_->update = NULL;
		_data77_->update_length1 = 0;
		_data77_->_update_size_ = _data77_->update_length1;
		if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE) {
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp21_ = FALSE;
					_tmp21_ = TRUE;
					while (TRUE) {
						FontManagerGoogleFontsFamily* _tmp23_;
						GPtrArray* _tmp24_;
						GPtrArray* _tmp25_;
						gint _tmp26_;
						gint _tmp27_;
						FontManagerGoogleFontsFont* variant = NULL;
						FontManagerGoogleFontsFamily* _tmp28_;
						GPtrArray* _tmp29_;
						GPtrArray* _tmp30_;
						gconstpointer _tmp31_;
						FontManagerGoogleFontsFont* _tmp32_;
						FontManagerGoogleFontsFont* _tmp33_;
						if (!_tmp21_) {
							gint _tmp22_;
							_tmp22_ = i;
							i = _tmp22_ + 1;
						}
						_tmp21_ = FALSE;
						_tmp23_ = self->priv->_family;
						_tmp24_ = font_manager_google_fonts_family_get_variants (_tmp23_);
						_tmp25_ = _tmp24_;
						_tmp26_ = vala_g_ptr_array_get_length (_tmp25_);
						_tmp27_ = _tmp26_;
						if (!(i < _tmp27_)) {
							break;
						}
						_tmp28_ = self->priv->_family;
						_tmp29_ = font_manager_google_fonts_family_get_variants (_tmp28_);
						_tmp30_ = _tmp29_;
						_tmp31_ = g_ptr_array_index (_tmp30_, (guint) i);
						_tmp32_ = _g_object_ref0 ((FontManagerGoogleFontsFont*) _tmp31_);
						variant = _tmp32_;
						_tmp33_ = variant;
						if (font_manager_google_fonts_font_get_installation_status (_tmp33_) != FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED) {
							FontManagerGoogleFontsFont* _tmp34_;
							FontManagerGoogleFontsFont* _tmp35_;
							_tmp34_ = variant;
							_tmp35_ = _g_object_ref0 (_tmp34_);
							_vala_array_add9 (&_data77_->update, &_data77_->update_length1, &_data77_->_update_size_, _tmp35_);
						}
						_g_object_unref0 (variant);
					}
				}
			}
		}
		_tmp36_ = font_dir;
		if (g_file_query_exists (_tmp36_, NULL)) {
			GFile* _tmp37_;
			_tmp37_ = font_dir;
			font_manager_remove_directory (_tmp37_, TRUE);
		}
		if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED) {
			FontManagerGoogleFontsFileStatus _tmp38_;
			_tmp38_ = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
			font_manager_google_fonts_preview_pane_selection_changed (self, &_tmp38_);
			font_manager_google_fonts_preview_pane_set_refresh_required (self, TRUE);
		} else {
			FontManagerGoogleFontsFont** _tmp39_;
			gint _tmp39__length1;
			FontManagerGoogleFontsFont** _tmp45_;
			gint _tmp45__length1;
			FontManagerGoogleFontsFont** _tmp48_;
			gint _tmp48__length1;
			_tmp39_ = _data77_->update;
			_tmp39__length1 = _data77_->update_length1;
			if (_tmp39_ == NULL) {
				FontManagerGoogleFontsFamily* _tmp40_;
				GPtrArray* _tmp41_;
				GPtrArray* _tmp42_;
				gpointer* _tmp43_;
				gint _tmp43__length1;
				FontManagerGoogleFontsFont** _tmp44_;
				gint _tmp44__length1;
				_tmp40_ = self->priv->_family;
				_tmp41_ = font_manager_google_fonts_family_get_variants (_tmp40_);
				_tmp42_ = _tmp41_;
				_tmp43_ = _tmp42_->pdata;
				_tmp43__length1 = _tmp42_->len;
				_tmp44_ = (_tmp43_ != NULL) ? _vala_array_dup10 (_tmp43_, _tmp43__length1) : _tmp43_;
				_tmp44__length1 = _tmp43__length1;
				_data77_->update = (_vala_array_free (_data77_->update, _data77_->update_length1, (GDestroyNotify) g_object_unref), NULL);
				_data77_->update = _tmp44_;
				_data77_->update_length1 = _tmp44__length1;
				_data77_->_update_size_ = _data77_->update_length1;
			}
			_tmp45_ = _data77_->update;
			_tmp45__length1 = _data77_->update_length1;
			{
				FontManagerGoogleFontsFont** font_collection = NULL;
				gint font_collection_length1 = 0;
				gint _font_collection_size_ = 0;
				gint font_it = 0;
				font_collection = _tmp45_;
				font_collection_length1 = _tmp45__length1;
				for (font_it = 0; font_it < font_collection_length1; font_it = font_it + 1) {
					FontManagerGoogleFontsFont* _tmp46_;
					FontManagerGoogleFontsFont* font = NULL;
					_tmp46_ = _g_object_ref0 (font_collection[font_it]);
					font = _tmp46_;
					{
						FontManagerGoogleFontsFont* _tmp47_;
						_tmp47_ = font;
						g_object_ref ((GObject*) _tmp47_);
						_g_object_unref0 (font);
					}
				}
			}
			_tmp48_ = _data77_->update;
			_tmp48__length1 = _data77_->update_length1;
			font_manager_google_fonts_download_font_files (_tmp48_, (gint) _tmp48__length1, _____lambda213__gasync_ready_callback, block77_data_ref (_data77_));
		}
		block77_data_unref (_data77_);
		_data77_ = NULL;
	} else {
		GFile* font_file = NULL;
		GFile* _tmp85_;
		gboolean _tmp95_ = FALSE;
		font_file = NULL;
		if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE) {
			gchar* ext = NULL;
			FontManagerGoogleFontsFont* _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* style = NULL;
			FontManagerGoogleFontsFont* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* family = NULL;
			FontManagerGoogleFontsFont* _tmp58_;
			const gchar* _tmp59_;
			const gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* filename = NULL;
			const gchar* _tmp62_;
			const gchar* _tmp63_;
			FontManagerGoogleFontsFont* _tmp64_;
			gint _tmp65_;
			gint _tmp66_;
			const gchar* _tmp67_;
			gchar* _tmp68_;
			GFile* _tmp69_;
			gchar* _tmp70_;
			gchar* _tmp71_;
			const gchar* _tmp72_;
			gchar* _tmp73_;
			gchar* _tmp74_;
			GFile* _tmp75_;
			_tmp49_ = self->priv->_font;
			_tmp50_ = font_manager_google_fonts_font_get_url (_tmp49_);
			_tmp51_ = _tmp50_;
			_tmp52_ = font_manager_get_file_extension (_tmp51_);
			ext = _tmp52_;
			_tmp53_ = self->priv->_font;
			_tmp54_ = font_manager_google_fonts_font_to_description (_tmp53_);
			_tmp55_ = _tmp54_;
			_tmp56_ = string_replace (_tmp55_, " ", "_");
			_tmp57_ = _tmp56_;
			_g_free0 (_tmp55_);
			style = _tmp57_;
			_tmp58_ = self->priv->_font;
			_tmp59_ = font_manager_google_fonts_font_get_family (_tmp58_);
			_tmp60_ = _tmp59_;
			_tmp61_ = string_replace (_tmp60_, " ", "_");
			family = _tmp61_;
			_tmp62_ = family;
			_tmp63_ = style;
			_tmp64_ = self->priv->_font;
			_tmp65_ = font_manager_google_fonts_font_get_version (_tmp64_);
			_tmp66_ = _tmp65_;
			_tmp67_ = ext;
			_tmp68_ = g_strdup_printf ("%s_%s.%i.%s", _tmp62_, _tmp63_, _tmp66_ - 1, _tmp67_);
			filename = _tmp68_;
			_tmp69_ = font_dir;
			_tmp70_ = g_file_get_path (_tmp69_);
			_tmp71_ = _tmp70_;
			_tmp72_ = filename;
			_tmp73_ = g_build_filename (_tmp71_, _tmp72_, NULL);
			_tmp74_ = _tmp73_;
			_tmp75_ = g_file_new_for_path (_tmp74_);
			_g_object_unref0 (font_file);
			font_file = _tmp75_;
			_g_free0 (_tmp74_);
			_g_free0 (_tmp71_);
			_g_free0 (filename);
			_g_free0 (family);
			_g_free0 (style);
			_g_free0 (ext);
		} else {
			if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED) {
				GFile* _tmp76_;
				gchar* _tmp77_;
				gchar* _tmp78_;
				FontManagerGoogleFontsFont* _tmp79_;
				gchar* _tmp80_;
				gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				GFile* _tmp84_;
				_tmp76_ = font_dir;
				_tmp77_ = g_file_get_path (_tmp76_);
				_tmp78_ = _tmp77_;
				_tmp79_ = self->priv->_font;
				_tmp80_ = font_manager_google_fonts_font_get_filename (_tmp79_);
				_tmp81_ = _tmp80_;
				_tmp82_ = g_build_filename (_tmp78_, _tmp81_, NULL);
				_tmp83_ = _tmp82_;
				_tmp84_ = g_file_new_for_path (_tmp83_);
				_g_object_unref0 (font_file);
				font_file = _tmp84_;
				_g_free0 (_tmp83_);
				_g_free0 (_tmp81_);
				_g_free0 (_tmp78_);
			}
		}
		_tmp85_ = font_file;
		if (_tmp85_ != NULL) {
			{
				GFile* _tmp86_;
				GFile* _tmp87_;
				FontManagerGoogleFontsFileStatus _tmp88_;
				_tmp86_ = font_file;
				g_file_delete (_tmp86_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp87_ = font_dir;
				font_manager_remove_directory_tree_if_empty (_tmp87_);
				_tmp88_ = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
				font_manager_google_fonts_preview_pane_selection_changed (self, &_tmp88_);
				font_manager_google_fonts_preview_pane_set_refresh_required (self, TRUE);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GFile* _tmp89_;
				gchar* _tmp90_;
				gchar* _tmp91_;
				GError* _tmp92_;
				GError* _tmp93_;
				const gchar* _tmp94_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp89_ = font_file;
				_tmp90_ = g_file_get_path (_tmp89_);
				_tmp91_ = _tmp90_;
				g_warning ("PreviewPane.vala:450: Failed to remove file : %s", _tmp91_);
				_g_free0 (_tmp91_);
				_tmp92_ = e;
				_tmp93_ = e;
				_tmp94_ = _tmp93_->message;
				g_critical ("PreviewPane.vala:451: %i : %s", _tmp92_->code, _tmp94_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (font_file);
				_g_object_unref0 (font_dir);
				_g_free0 (dirname);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		if (status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED) {
			_tmp95_ = TRUE;
		} else {
			_tmp95_ = status == FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE;
		}
		if (_tmp95_) {
			FontManagerGoogleFontsFont* _tmp96_;
			FontManagerGoogleFontsFont* _tmp97_;
			FontManagerGoogleFontsFont* _tmp98_;
			FontManagerGoogleFontsFont** _tmp99_;
			FontManagerGoogleFontsFont** _tmp100_;
			gint _tmp100__length1;
			_tmp96_ = self->priv->_font;
			g_object_ref ((GObject*) _tmp96_);
			_tmp97_ = self->priv->_font;
			_tmp98_ = _g_object_ref0 (_tmp97_);
			_tmp99_ = g_new0 (FontManagerGoogleFontsFont*, 1 + 1);
			_tmp99_[0] = _tmp98_;
			_tmp100_ = _tmp99_;
			_tmp100__length1 = 1;
			font_manager_google_fonts_download_font_files (_tmp100_, (gint) 1, _____lambda214__gasync_ready_callback, g_object_ref (self));
			_tmp100_ = (_vala_array_free (_tmp100_, _tmp100__length1, (GDestroyNotify) g_object_unref), NULL);
		}
		_g_object_unref0 (font_file);
	}
	_g_object_unref0 (font_dir);
	_g_free0 (dirname);
	return;
}

static void
_font_manager_google_fonts_preview_pane_on_download_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                       gpointer self)
{
	font_manager_google_fonts_preview_pane_on_download_button_clicked ((FontManagerGoogleFontsPreviewPane*) self);
}

static void
font_manager_google_fonts_preview_pane_on_entry_changed (FontManagerGoogleFontsPreviewPane* self)
{
	const gchar* _tmp0_ = NULL;
	FontManagerPreviewEntry* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->entry;
	_tmp2_ = gtk_entry_get_text_length ((GtkEntry*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ > ((guint) 0)) {
		FontManagerPreviewEntry* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = self->priv->entry;
		_tmp5_ = gtk_entry_get_text ((GtkEntry*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_;
	} else {
		_tmp0_ = NULL;
	}
	font_manager_google_fonts_preview_pane_set_preview_text (self, _tmp0_);
	font_manager_google_fonts_preview_pane_update_preview (self);
	return;
}

static void
_font_manager_google_fonts_preview_pane_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                               gpointer self)
{
	font_manager_google_fonts_preview_pane_on_entry_changed ((FontManagerGoogleFontsPreviewPane*) self);
}

FontManagerGoogleFontsPreviewPane*
font_manager_google_fonts_preview_pane_construct (GType object_type)
{
	FontManagerGoogleFontsPreviewPane * self = NULL;
	self = (FontManagerGoogleFontsPreviewPane*) g_object_new (object_type, NULL);
	return self;
}

FontManagerGoogleFontsPreviewPane*
font_manager_google_fonts_preview_pane_new (void)
{
	return font_manager_google_fonts_preview_pane_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE);
}

FontManagerGoogleFontsFamily*
font_manager_google_fonts_preview_pane_get_family (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerGoogleFontsFamily* result;
	FontManagerGoogleFontsFamily* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_family;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_family (FontManagerGoogleFontsPreviewPane* self,
                                                   FontManagerGoogleFontsFamily* value)
{
	FontManagerGoogleFontsFamily* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_family (self);
	if (old_value != value) {
		FontManagerGoogleFontsFamily* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_family);
		self->priv->_family = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY]);
	}
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_preview_pane_get_font (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerGoogleFontsFont* result;
	FontManagerGoogleFontsFont* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_font;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_font (FontManagerGoogleFontsPreviewPane* self,
                                                 FontManagerGoogleFontsFont* value)
{
	FontManagerGoogleFontsFont* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_font (self);
	if (old_value != value) {
		FontManagerGoogleFontsFont* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_font);
		self->priv->_font = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY]);
	}
}

gboolean
font_manager_google_fonts_preview_pane_get_refresh_required (FontManagerGoogleFontsPreviewPane* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_refresh_required;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_refresh_required (FontManagerGoogleFontsPreviewPane* self,
                                                             gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_refresh_required (self);
	if (old_value != value) {
		self->priv->_refresh_required = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY]);
	}
}

gboolean
font_manager_google_fonts_preview_pane_get_show_line_size (FontManagerGoogleFontsPreviewPane* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_line_size;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_show_line_size (FontManagerGoogleFontsPreviewPane* self,
                                                           gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_show_line_size (self);
	if (old_value != value) {
		self->priv->_show_line_size = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY]);
	}
}

gdouble
font_manager_google_fonts_preview_pane_get_preview_size (FontManagerGoogleFontsPreviewPane* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_preview_size;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_preview_size (FontManagerGoogleFontsPreviewPane* self,
                                                         gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_preview_size (self);
	if (old_value != value) {
		self->priv->_preview_size = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY]);
	}
}

gdouble
font_manager_google_fonts_preview_pane_get_min_waterfall_size (FontManagerGoogleFontsPreviewPane* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_min_waterfall_size;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_min_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                               gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_min_waterfall_size (self);
	if (old_value != value) {
		self->priv->_min_waterfall_size = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY]);
	}
}

gdouble
font_manager_google_fonts_preview_pane_get_max_waterfall_size (FontManagerGoogleFontsPreviewPane* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_max_waterfall_size;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_max_waterfall_size (FontManagerGoogleFontsPreviewPane* self,
                                                               gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_max_waterfall_size (self);
	if (old_value != value) {
		self->priv->_max_waterfall_size = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY]);
	}
}

gdouble
font_manager_google_fonts_preview_pane_get_waterfall_size_ratio (FontManagerGoogleFontsPreviewPane* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_waterfall_size_ratio;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_waterfall_size_ratio (FontManagerGoogleFontsPreviewPane* self,
                                                                 gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_waterfall_size_ratio (self);
	if (old_value != value) {
		self->priv->_waterfall_size_ratio = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY]);
	}
}

WebKitWebView*
font_manager_google_fonts_preview_pane_get_preview (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebView* result;
	WebKitWebView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_preview;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_preview (FontManagerGoogleFontsPreviewPane* self,
                                                    WebKitWebView* value)
{
	WebKitWebView* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_preview (self);
	if (old_value != value) {
		WebKitWebView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_preview);
		self->priv->_preview = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY]);
	}
}

FontManagerGoogleFontsPreviewMode
font_manager_google_fonts_preview_pane_get_mode (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerGoogleFontsPreviewMode result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_mode;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_mode (FontManagerGoogleFontsPreviewPane* self,
                                                 FontManagerGoogleFontsPreviewMode value)
{
	FontManagerGoogleFontsPreviewMode old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_preview_pane_get_mode (self);
	if (old_value != value) {
		self->priv->_mode = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY]);
	}
}

const gchar*
font_manager_google_fonts_preview_pane_get_preview_text (FontManagerGoogleFontsPreviewPane* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_preview_text;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_preview_text;
		_tmp0_ = _tmp2_;
	} else {
		const gchar* _tmp3_;
		_tmp3_ = self->priv->default_preview_text;
		_tmp0_ = _tmp3_;
	}
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_preview_pane_set_preview_text (FontManagerGoogleFontsPreviewPane* self,
                                                         const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_preview_text);
	self->priv->_preview_text = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY]);
}

static void
_font_manager_google_fonts_preview_pane___lambda215_ (FontManagerGoogleFontsPreviewPane* self)
{
	WebKitWebView* _tmp0_;
	_tmp0_ = self->priv->_preview;
	if (_tmp0_ == NULL) {
		WebKitWebView* _tmp1_;
		WebKitWebView* _tmp2_;
		_tmp1_ = font_manager_google_fonts_preview_pane_get_webkit_webview (self);
		_tmp2_ = _tmp1_;
		font_manager_google_fonts_preview_pane_set_preview (self, _tmp2_);
		_g_object_unref0 (_tmp2_);
	}
	font_manager_google_fonts_preview_pane_set_refresh_required (self, FALSE);
}

static void
__font_manager_google_fonts_preview_pane___lambda215__gtk_widget_map (GtkWidget* _sender,
                                                                      gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda215_ ((FontManagerGoogleFontsPreviewPane*) self);
}

static gboolean
__lambda217_ (FontManagerGoogleFontsPreviewPane* self)
{
	FontManagerApplication* _tmp0_;
	FontManagerApplication* _tmp1_;
	gboolean result;
	_tmp0_ = font_manager_get_default_application ();
	_tmp1_ = _tmp0_;
	font_manager_application_refresh (_tmp1_);
	_g_object_unref0 (_tmp1_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda217__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda217_ ((FontManagerGoogleFontsPreviewPane*) self);
	return result;
}

static void
_font_manager_google_fonts_preview_pane___lambda216_ (FontManagerGoogleFontsPreviewPane* self)
{
	gboolean _tmp0_;
	_tmp0_ = self->priv->_refresh_required;
	if (!_tmp0_) {
		return;
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda217__gsource_func, g_object_ref (self), g_object_unref);
}

static void
__font_manager_google_fonts_preview_pane___lambda216__gtk_widget_unmap (GtkWidget* _sender,
                                                                        gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda216_ ((FontManagerGoogleFontsPreviewPane*) self);
}

static Block78Data*
block78_data_ref (Block78Data* _data78_)
{
	g_atomic_int_inc (&_data78_->_ref_count_);
	return _data78_;
}

static void
block78_data_unref (void * _userdata_)
{
	Block78Data* _data78_;
	_data78_ = (Block78Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data78_->_ref_count_)) {
		FontManagerGoogleFontsPreviewPane* self;
		self = _data78_->self;
		_g_object_unref0 (_data78_->main_window);
		_g_object_unref0 (self);
		g_slice_free (Block78Data, _data78_);
	}
}

static gboolean
___lambda219_ (Block78Data* _data78_)
{
	FontManagerGoogleFontsPreviewPane* self;
	FontManagerMainWindow* _tmp0_;
	gboolean result;
	self = _data78_->self;
	_tmp0_ = _data78_->main_window;
	font_manager_main_window_set_model (_tmp0_, NULL);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda219__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda219_ (self);
	return result;
}

static void
_font_manager_google_fonts_preview_pane___lambda218_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	Block78Data* _data78_;
	FontManagerApplication* _tmp0_;
	FontManagerApplication* _tmp1_;
	FontManagerMainWindow* _tmp2_;
	FontManagerMainWindow* _tmp3_;
	FontManagerMainWindow* _tmp4_;
	FontManagerMainWindow* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	_data78_ = g_slice_new0 (Block78Data);
	_data78_->_ref_count_ = 1;
	_data78_->self = g_object_ref (self);
	_tmp0_ = font_manager_get_default_application ();
	_tmp1_ = _tmp0_;
	_tmp2_ = font_manager_application_get_main_window (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp1_);
	_data78_->main_window = _tmp5_;
	_tmp7_ = self->priv->_refresh_required;
	if (_tmp7_) {
		FontManagerMainWindow* _tmp8_;
		_tmp8_ = _data78_->main_window;
		_tmp6_ = _tmp8_ != NULL;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda219__gsource_func, block78_data_ref (_data78_), block78_data_unref);
	}
	block78_data_unref (_data78_);
	_data78_ = NULL;
}

static void
__font_manager_google_fonts_preview_pane___lambda218__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda218_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
}

static void
_font_manager_google_fonts_preview_pane___lambda220_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	FontManagerGoogleFontsFileStatus _tmp0_ = 0;
	FontManagerGoogleFontsFamily* _tmp1_;
	FontManagerGoogleFontsFileStatus status = 0;
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp1_ = self->priv->_family;
	if (_tmp1_ != NULL) {
		FontManagerGoogleFontsFamily* _tmp2_;
		_tmp2_ = self->priv->_family;
		_tmp0_ = font_manager_google_fonts_family_get_installation_status (_tmp2_);
	} else {
		FontManagerGoogleFontsFont* _tmp3_;
		_tmp3_ = self->priv->_font;
		_tmp0_ = font_manager_google_fonts_font_get_installation_status (_tmp3_);
	}
	status = _tmp0_;
	font_manager_google_fonts_preview_pane_selection_changed (self, &status);
}

static void
__font_manager_google_fonts_preview_pane___lambda220__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda220_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
}

static void
_font_manager_google_fonts_preview_pane___lambda221_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	FontManagerGoogleFontsFileStatus status = 0;
	FontManagerGoogleFontsFont* _tmp0_;
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	font_manager_google_fonts_preview_pane_update_preview (self);
	_tmp0_ = self->priv->_font;
	status = font_manager_google_fonts_font_get_installation_status (_tmp0_);
	font_manager_google_fonts_preview_pane_selection_changed (self, &status);
}

static void
__font_manager_google_fonts_preview_pane___lambda221__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda221_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
}

static void
_font_manager_google_fonts_preview_pane___lambda222_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	FontManagerPreviewEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = self->priv->entry;
	_tmp1_ = font_manager_google_fonts_preview_pane_get_preview_text (self);
	_tmp2_ = _tmp1_;
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp0_, _tmp2_);
}

static void
__font_manager_google_fonts_preview_pane___lambda222__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda222_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
}

static void
_font_manager_google_fonts_preview_pane___lambda223_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	GtkBox* _tmp0_;
	FontManagerGoogleFontsPreviewMode _tmp1_;
	FontManagerPreviewEntry* _tmp2_;
	FontManagerGoogleFontsPreviewMode _tmp3_;
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = self->priv->scale_container;
	_tmp1_ = self->priv->_mode;
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, _tmp1_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM);
	_tmp2_ = self->priv->entry;
	_tmp3_ = self->priv->_mode;
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, _tmp3_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL);
}

static void
__font_manager_google_fonts_preview_pane___lambda223__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda223_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
}

static void
_font_manager_google_fonts_preview_pane___lambda224_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GObject* obj,
                                                      GParamSpec* pspec)
{
	g_return_if_fail (obj != NULL);
	g_return_if_fail (pspec != NULL);
	font_manager_google_fonts_preview_pane_update_preview (self);
}

static void
__font_manager_google_fonts_preview_pane___lambda224__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda224_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, pspec);
}

static void
_font_manager_google_fonts_preview_pane___lambda225_ (FontManagerGoogleFontsPreviewPane* self)
{
	font_manager_google_fonts_preview_pane_update_preview (self);
}

static void
__font_manager_google_fonts_preview_pane___lambda225__gtk_color_button_color_set (GtkColorButton* _sender,
                                                                                  gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda225_ ((FontManagerGoogleFontsPreviewPane*) self);
}

static void
_font_manager_google_fonts_preview_pane___lambda226_ (FontManagerGoogleFontsPreviewPane* self)
{
	font_manager_google_fonts_preview_pane_update_preview (self);
}

static void
__font_manager_google_fonts_preview_pane___lambda226__gtk_color_button_color_set (GtkColorButton* _sender,
                                                                                  gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda226_ ((FontManagerGoogleFontsPreviewPane*) self);
}

static void
_font_manager_google_fonts_preview_pane___lambda227_ (FontManagerGoogleFontsPreviewPane* self)
{
	font_manager_google_fonts_preview_pane_update_preview (self);
}

static void
__font_manager_google_fonts_preview_pane___lambda227__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda227_ ((FontManagerGoogleFontsPreviewPane*) self);
}

static void
_font_manager_google_fonts_preview_pane___lambda228_ (FontManagerGoogleFontsPreviewPane* self)
{
	font_manager_google_fonts_preview_pane_update_preview (self);
}

static void
__font_manager_google_fonts_preview_pane___lambda228__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda228_ ((FontManagerGoogleFontsPreviewPane*) self);
}

static void
_font_manager_google_fonts_preview_pane___lambda229_ (FontManagerGoogleFontsPreviewPane* self)
{
	font_manager_google_fonts_preview_pane_update_preview (self);
}

static void
__font_manager_google_fonts_preview_pane___lambda229__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda229_ ((FontManagerGoogleFontsPreviewPane*) self);
}

static void
_font_manager_google_fonts_preview_pane___lambda230_ (FontManagerGoogleFontsPreviewPane* self)
{
	font_manager_google_fonts_preview_pane_update_preview (self);
}

static void
__font_manager_google_fonts_preview_pane___lambda230__g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda230_ ((FontManagerGoogleFontsPreviewPane*) self);
}

static void
_font_manager_google_fonts_preview_pane___lambda231_ (FontManagerGoogleFontsPreviewPane* self,
                                                      GtkEntry* entry,
                                                      GtkEntryIconPosition position,
                                                      GdkEvent* event)
{
	g_return_if_fail (entry != NULL);
	g_return_if_fail (event != NULL);
	if (position == GTK_ENTRY_ICON_PRIMARY) {
		FontManagerGoogleFontsSampleList* _tmp0_;
		FontManagerGoogleFontsSampleList* _tmp1_;
		_tmp0_ = self->priv->sample_list;
		gtk_popover_popup ((GtkPopover*) _tmp0_);
		_tmp1_ = self->priv->sample_list;
		font_manager_google_fonts_sample_list_unselect_all (_tmp1_);
	}
}

static void
__font_manager_google_fonts_preview_pane___lambda231__gtk_entry_icon_press (GtkEntry* _sender,
                                                                            GtkEntryIconPosition icon_pos,
                                                                            GdkEvent* event,
                                                                            gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda231_ ((FontManagerGoogleFontsPreviewPane*) self, _sender, icon_pos, event);
}

static void
_font_manager_google_fonts_preview_pane___lambda232_ (FontManagerGoogleFontsPreviewPane* self,
                                                      const gchar* s)
{
	FontManagerPreviewEntry* _tmp0_;
	FontManagerGoogleFontsSampleList* _tmp1_;
	FontManagerGoogleFontsFont* _tmp2_;
	FontManagerGoogleFontsFont* _tmp3_;
	g_return_if_fail (s != NULL);
	_tmp0_ = self->priv->entry;
	gtk_entry_set_text ((GtkEntry*) _tmp0_, s);
	_tmp1_ = self->priv->sample_list;
	gtk_popover_popdown ((GtkPopover*) _tmp1_);
	self->priv->restore_default_preview = TRUE;
	_tmp2_ = self->priv->_font;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->stored_font);
	self->priv->stored_font = _tmp3_;
}

static void
__font_manager_google_fonts_preview_pane___lambda232__font_manager_google_fonts_sample_list_row_selected (FontManagerGoogleFontsSampleList* _sender,
                                                                                                          const gchar* sample,
                                                                                                          gpointer self)
{
	_font_manager_google_fonts_preview_pane___lambda232_ ((FontManagerGoogleFontsPreviewPane*) self, sample);
}

static GObject *
font_manager_google_fonts_preview_pane_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerGoogleFontsPreviewPane * self;
	FontManagerPreviewEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkColorButton* _tmp3_;
	GtkColorButton* _tmp4_;
	GtkBox* _tmp5_;
	GtkButton* _tmp6_;
	GtkMenuButton* _tmp7_;
	GtkBox* _tmp8_;
	FontManagerGoogleFontsPreviewMode _tmp9_;
	FontManagerPreviewEntry* _tmp10_;
	FontManagerGoogleFontsPreviewMode _tmp11_;
	FontManagerFontScale* _tmp12_;
	FontManagerPreviewEntry* _tmp13_;
	GtkWidget* _tmp14_;
	FontManagerGoogleFontsSampleList* _tmp15_ = NULL;
	FontManagerPreviewEntry* _tmp16_;
	FontManagerPreviewEntry* _tmp17_;
	FontManagerGoogleFontsSampleList* _tmp18_;
	parent_class = G_OBJECT_CLASS (font_manager_google_fonts_preview_pane_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane);
	g_signal_connect_object ((GtkWidget*) self, "map", (GCallback) __font_manager_google_fonts_preview_pane___lambda215__gtk_widget_map, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "unmap", (GCallback) __font_manager_google_fonts_preview_pane___lambda216__gtk_widget_unmap, self, 0);
	_tmp0_ = self->priv->entry;
	_tmp1_ = font_manager_google_fonts_preview_pane_get_preview_text (self);
	_tmp2_ = _tmp1_;
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp0_, _tmp2_);
	g_signal_connect_object ((GObject*) self, "notify::refresh-required", (GCallback) __font_manager_google_fonts_preview_pane___lambda218__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::family", (GCallback) __font_manager_google_fonts_preview_pane___lambda220__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::font", (GCallback) __font_manager_google_fonts_preview_pane___lambda221__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::preview-text", (GCallback) __font_manager_google_fonts_preview_pane___lambda222__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::mode", (GCallback) __font_manager_google_fonts_preview_pane___lambda223__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::preview-size", (GCallback) __font_manager_google_fonts_preview_pane___lambda224__g_object_notify, self, 0);
	_tmp3_ = self->priv->bg_color_button;
	g_signal_connect_object (_tmp3_, "color-set", (GCallback) __font_manager_google_fonts_preview_pane___lambda225__gtk_color_button_color_set, self, G_CONNECT_AFTER);
	_tmp4_ = self->priv->fg_color_button;
	g_signal_connect_object (_tmp4_, "color-set", (GCallback) __font_manager_google_fonts_preview_pane___lambda226__gtk_color_button_color_set, self, G_CONNECT_AFTER);
	g_signal_connect_object ((GObject*) self, "notify::min-waterfall-size", (GCallback) __font_manager_google_fonts_preview_pane___lambda227__g_object_notify, self, G_CONNECT_AFTER);
	g_signal_connect_object ((GObject*) self, "notify::max-waterfall-size", (GCallback) __font_manager_google_fonts_preview_pane___lambda228__g_object_notify, self, G_CONNECT_AFTER);
	g_signal_connect_object ((GObject*) self, "notify::waterfall-size-ratio", (GCallback) __font_manager_google_fonts_preview_pane___lambda229__g_object_notify, self, G_CONNECT_AFTER);
	g_signal_connect_object ((GObject*) self, "notify::show-line-size", (GCallback) __font_manager_google_fonts_preview_pane___lambda230__g_object_notify, self, G_CONNECT_AFTER);
	_tmp5_ = self->priv->controls;
	font_manager_set_button_relief_style ((GtkContainer*) _tmp5_, GTK_RELIEF_NONE);
	_tmp6_ = self->priv->download_button;
	gtk_button_set_relief (_tmp6_, GTK_RELIEF_NORMAL);
	_tmp7_ = self->priv->menu_button;
	gtk_button_set_relief ((GtkButton*) _tmp7_, GTK_RELIEF_NORMAL);
	_tmp8_ = self->priv->scale_container;
	_tmp9_ = self->priv->_mode;
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, _tmp9_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_LOREM_IPSUM);
	_tmp10_ = self->priv->entry;
	_tmp11_ = self->priv->_mode;
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, _tmp11_ == FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL);
	_tmp12_ = self->priv->fontscale;
	g_object_bind_property_with_closures ((GObject*) self, "preview-size", (GObject*) _tmp12_, "value", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp13_ = self->priv->entry;
	_tmp14_ = _g_object_ref0 ((GtkWidget*) _tmp13_);
	_tmp15_ = font_manager_google_fonts_sample_list_new ();
	gtk_popover_set_relative_to ((GtkPopover*) _tmp15_, _tmp14_);
	_g_object_unref0 (_tmp14_);
	gtk_popover_set_position ((GtkPopover*) _tmp15_, GTK_POS_BOTTOM);
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->sample_list);
	self->priv->sample_list = _tmp15_;
	_tmp16_ = self->priv->entry;
	gtk_entry_set_icon_from_icon_name ((GtkEntry*) _tmp16_, GTK_ENTRY_ICON_PRIMARY, "preferences-desktop-locale-symbolic");
	_tmp17_ = self->priv->entry;
	g_signal_connect_object ((GtkEntry*) _tmp17_, "icon-press", (GCallback) __font_manager_google_fonts_preview_pane___lambda231__gtk_entry_icon_press, self, 0);
	_tmp18_ = self->priv->sample_list;
	g_signal_connect_object (_tmp18_, "row-selected", (GCallback) __font_manager_google_fonts_preview_pane___lambda232__font_manager_google_fonts_sample_list_row_selected, self, 0);
	return obj;
}

static void
font_manager_google_fonts_preview_pane_class_init (FontManagerGoogleFontsPreviewPaneClass * klass,
                                                   gpointer klass_data)
{
	font_manager_google_fonts_preview_pane_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsPreviewPane_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_preview_pane_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_preview_pane_set_property;
	G_OBJECT_CLASS (klass)->constructor = font_manager_google_fonts_preview_pane_constructor;
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_preview_pane_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY] = g_param_spec_object ("family", "family", "family", FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY] = g_param_spec_object ("font", "font", "font", FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY] = g_param_spec_boolean ("refresh-required", "refresh-required", "refresh-required", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY] = g_param_spec_boolean ("show-line-size", "show-line-size", "show-line-size", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY] = g_param_spec_double ("preview-size", "preview-size", "preview-size", -G_MAXDOUBLE, G_MAXDOUBLE, 16.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY] = g_param_spec_double ("min-waterfall-size", "min-waterfall-size", "min-waterfall-size", -G_MAXDOUBLE, G_MAXDOUBLE, FONT_MANAGER_MIN_FONT_SIZE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY] = g_param_spec_double ("max-waterfall-size", "max-waterfall-size", "max-waterfall-size", -G_MAXDOUBLE, G_MAXDOUBLE, FONT_MANAGER_MAX_FONT_SIZE * 2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY] = g_param_spec_double ("waterfall-size-ratio", "waterfall-size-ratio", "waterfall-size-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 1.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY] = g_param_spec_object ("preview", "preview", "preview", webkit_web_view_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_MODE, FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY, font_manager_google_fonts_preview_pane_properties[FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY] = g_param_spec_string ("preview-text", "preview-text", "preview-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/FontManager/web/google/ui/google-fonts-preview-pane.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "controls", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, controls));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scale_container", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, scale_container));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "download_button", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, download_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview_box", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, preview_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "bg_color_button", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, bg_color_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fg_color_button", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, fg_color_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_button", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, menu_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, entry));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fontscale", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, fontscale));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "lorem_ipsum", FALSE, FontManagerGoogleFontsPreviewPane_private_offset + G_STRUCT_OFFSET (FontManagerGoogleFontsPreviewPanePrivate, lorem_ipsum));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_mode_toggled", G_CALLBACK(_font_manager_google_fonts_preview_pane_on_mode_toggled_gtk_toggle_button_toggled));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_download_button_clicked", G_CALLBACK(_font_manager_google_fonts_preview_pane_on_download_button_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_entry_changed", G_CALLBACK(_font_manager_google_fonts_preview_pane_on_entry_changed_gtk_editable_changed));
}

static void
font_manager_google_fonts_preview_pane_instance_init (FontManagerGoogleFontsPreviewPane * self,
                                                      gpointer klass)
{
	gchar* _tmp0_;
	self->priv = font_manager_google_fonts_preview_pane_get_instance_private (self);
	self->priv->_family = NULL;
	self->priv->_font = NULL;
	self->priv->_refresh_required = FALSE;
	self->priv->_show_line_size = TRUE;
	self->priv->_preview_size = 16.0;
	self->priv->_min_waterfall_size = FONT_MANAGER_MIN_FONT_SIZE;
	self->priv->_max_waterfall_size = FONT_MANAGER_MAX_FONT_SIZE * 2;
	self->priv->_waterfall_size_ratio = 1.1;
	self->priv->_preview = NULL;
	self->priv->_mode = FONT_MANAGER_GOOGLE_FONTS_PREVIEW_MODE_WATERFALL;
	self->priv->_preview_text = NULL;
	_tmp0_ = g_strdup ("The quick brown fox jumps over the lazy dog.");
	self->priv->default_preview_text = _tmp0_;
	self->priv->restore_default_preview = FALSE;
	self->priv->stored_font = NULL;
	g_type_ensure (FONT_MANAGER_TYPE_PREVIEW_ENTRY);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
font_manager_google_fonts_preview_pane_finalize (GObject * obj)
{
	FontManagerGoogleFontsPreviewPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane);
	_g_object_unref0 (self->priv->_family);
	_g_object_unref0 (self->priv->_font);
	_g_object_unref0 (self->priv->_preview);
	_g_free0 (self->priv->_preview_text);
	_g_free0 (self->priv->default_preview_text);
	_g_object_unref0 (self->priv->stored_font);
	_g_object_unref0 (self->priv->sample_list);
	G_OBJECT_CLASS (font_manager_google_fonts_preview_pane_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_preview_pane_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsPreviewPaneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_preview_pane_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsPreviewPane), 0, (GInstanceInitFunc) font_manager_google_fonts_preview_pane_instance_init, NULL };
	GType font_manager_google_fonts_preview_pane_type_id;
	font_manager_google_fonts_preview_pane_type_id = g_type_register_static (gtk_box_get_type (), "FontManagerGoogleFontsPreviewPane", &g_define_type_info, 0);
	FontManagerGoogleFontsPreviewPane_private_offset = g_type_add_instance_private (font_manager_google_fonts_preview_pane_type_id, sizeof (FontManagerGoogleFontsPreviewPanePrivate));
	return font_manager_google_fonts_preview_pane_type_id;
}

GType
font_manager_google_fonts_preview_pane_get_type (void)
{
	static volatile gsize font_manager_google_fonts_preview_pane_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_preview_pane_type_id__once)) {
		GType font_manager_google_fonts_preview_pane_type_id;
		font_manager_google_fonts_preview_pane_type_id = font_manager_google_fonts_preview_pane_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_preview_pane_type_id__once, font_manager_google_fonts_preview_pane_type_id);
	}
	return font_manager_google_fonts_preview_pane_type_id__once;
}

static void
_vala_font_manager_google_fonts_preview_pane_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	FontManagerGoogleFontsPreviewPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane);
	switch (property_id) {
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY:
		g_value_set_object (value, font_manager_google_fonts_preview_pane_get_family (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY:
		g_value_set_object (value, font_manager_google_fonts_preview_pane_get_font (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY:
		g_value_set_boolean (value, font_manager_google_fonts_preview_pane_get_refresh_required (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY:
		g_value_set_boolean (value, font_manager_google_fonts_preview_pane_get_show_line_size (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY:
		g_value_set_double (value, font_manager_google_fonts_preview_pane_get_preview_size (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY:
		g_value_set_double (value, font_manager_google_fonts_preview_pane_get_min_waterfall_size (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY:
		g_value_set_double (value, font_manager_google_fonts_preview_pane_get_max_waterfall_size (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY:
		g_value_set_double (value, font_manager_google_fonts_preview_pane_get_waterfall_size_ratio (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY:
		g_value_set_object (value, font_manager_google_fonts_preview_pane_get_preview (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY:
		g_value_set_enum (value, font_manager_google_fonts_preview_pane_get_mode (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY:
		g_value_set_string (value, font_manager_google_fonts_preview_pane_get_preview_text (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_google_fonts_preview_pane_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	FontManagerGoogleFontsPreviewPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_PREVIEW_PANE, FontManagerGoogleFontsPreviewPane);
	switch (property_id) {
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FAMILY_PROPERTY:
		font_manager_google_fonts_preview_pane_set_family (self, g_value_get_object (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_FONT_PROPERTY:
		font_manager_google_fonts_preview_pane_set_font (self, g_value_get_object (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_REFRESH_REQUIRED_PROPERTY:
		font_manager_google_fonts_preview_pane_set_refresh_required (self, g_value_get_boolean (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_SHOW_LINE_SIZE_PROPERTY:
		font_manager_google_fonts_preview_pane_set_show_line_size (self, g_value_get_boolean (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_SIZE_PROPERTY:
		font_manager_google_fonts_preview_pane_set_preview_size (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MIN_WATERFALL_SIZE_PROPERTY:
		font_manager_google_fonts_preview_pane_set_min_waterfall_size (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MAX_WATERFALL_SIZE_PROPERTY:
		font_manager_google_fonts_preview_pane_set_max_waterfall_size (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_WATERFALL_SIZE_RATIO_PROPERTY:
		font_manager_google_fonts_preview_pane_set_waterfall_size_ratio (self, g_value_get_double (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_PROPERTY:
		font_manager_google_fonts_preview_pane_set_preview (self, g_value_get_object (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_MODE_PROPERTY:
		font_manager_google_fonts_preview_pane_set_mode (self, g_value_get_enum (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_PREVIEW_PANE_PREVIEW_TEXT_PROPERTY:
		font_manager_google_fonts_preview_pane_set_preview_text (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

