/* WebFont.c generated by valac 0.56.14, the Vala compiler
 * generated from WebFont.vala, do not modify */

/* WebFont.vala
 *
 * Copyright (C) 2020-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <glib/gstdio.h>
#include "font-manager.h"
#include <json-glib/json-glib.h>
#include <glib/gi18n-lib.h>

#define FONT_MANAGER_GOOGLE_FONTS_FONT_FACE "@font-face { font-family: '%s'; font-style: %s; font-weight: %i; src: " \
"local('%s'), local('%s'), url(%s) format('truetype'); }"
#define FONT_MANAGER_GOOGLE_FONTS_GET "GET"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED,
	FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE
} FontManagerGoogleFontsFileStatus;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FILE_STATUS (font_manager_google_fonts_file_status_get_type ())

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT (font_manager_google_fonts_font_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FONT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT))
#define FONT_MANAGER_GOOGLE_FONTS_FONT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFontClass))

typedef struct _FontManagerGoogleFontsFont FontManagerGoogleFontsFont;
typedef struct _FontManagerGoogleFontsFontClass FontManagerGoogleFontsFontClass;
typedef struct _Block79Data Block79Data;
typedef struct _Block80Data Block80Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block81Data Block81Data;
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FontManagerGoogleFontsDownloadFontFilesData FontManagerGoogleFontsDownloadFontFilesData;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY (font_manager_google_fonts_family_get_type ())
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_IS_FAMILY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY))
#define FONT_MANAGER_GOOGLE_FONTS_FAMILY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamilyClass))

typedef struct _FontManagerGoogleFontsFamily FontManagerGoogleFontsFamily;
typedef struct _FontManagerGoogleFontsFamilyClass FontManagerGoogleFontsFamilyClass;
typedef struct _FontManagerGoogleFontsFamilyPrivate FontManagerGoogleFontsFamilyPrivate;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FAMILY_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_NUM_PROPERTIES];
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block82Data Block82Data;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block83Data Block83Data;
typedef enum  {
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_THIN = 100,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_LIGHT = 200,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_LIGHT = 300,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR = 400,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_MEDIUM = 500,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_SEMI_BOLD = 600,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BOLD = 700,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_EXTRA_BOLD = 800,
	FONT_MANAGER_GOOGLE_FONTS_WEIGHT_BLACK = 900
} FontManagerGoogleFontsWeight;

#define FONT_MANAGER_GOOGLE_FONTS_TYPE_WEIGHT (font_manager_google_fonts_weight_get_type ())
typedef struct _Block84Data Block84Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _FontManagerGoogleFontsFontPrivate FontManagerGoogleFontsFontPrivate;
enum  {
	FONT_MANAGER_GOOGLE_FONTS_FONT_0_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY,
	FONT_MANAGER_GOOGLE_FONTS_FONT_NUM_PROPERTIES
};
static GParamSpec* font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_NUM_PROPERTIES];

struct _Block79Data {
	int _ref_count_;
	gboolean retval;
	gpointer _async_data_;
};

struct _Block80Data {
	int _ref_count_;
	Block79Data * _data79_;
	gchar* filename;
};

struct _Block81Data {
	int _ref_count_;
	Block80Data * _data80_;
	GFileOutputStream* stream;
};

struct _FontManagerGoogleFontsDownloadFontFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FontManagerGoogleFontsFont** fonts;
	gint fonts_length1;
	gboolean result;
	Block79Data* _data79_;
	SoupSession* session;
	SoupSession* _tmp0_;
	FontManagerGoogleFontsFont** font_collection;
	gint font_collection_length1;
	gint _font_collection_size_;
	gint font_it;
	FontManagerGoogleFontsFont* _tmp1_;
	FontManagerGoogleFontsFont* font;
	Block80Data* _data80_;
	gchar* font_dir;
	gchar* _tmp2_;
	gchar* _tmp3_;
	FontManagerGoogleFontsFont* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	FontManagerGoogleFontsFont* _tmp11_;
	gchar* _tmp12_;
	gchar* filepath;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	SoupMessage* message;
	FontManagerGoogleFontsFont* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	SoupMessage* _tmp19_;
	SoupSession* _tmp20_;
	SoupMessage* _tmp21_;
	Block81Data* _data81_;
	GBytes* bytes;
	SoupMessage* _tmp22_;
	SoupMessageBody* _tmp23_;
	SoupBuffer* _tmp24_;
	SoupBuffer* _tmp25_;
	GBytes* _tmp26_;
	GBytes* _tmp27_;
	GFile* font_file;
	const gchar* _tmp28_;
	GFile* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	GFile* _tmp32_;
	GFileOutputStream* _tmp33_;
	GFileOutputStream* _tmp34_;
	GBytes* _tmp35_;
	GError* e;
	const gchar* _tmp36_;
	GError* _tmp37_;
	GError* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	SoupMessage* _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	GError* _inner_error0_;
};

struct _FontManagerGoogleFontsFamily {
	GObject parent_instance;
	FontManagerGoogleFontsFamilyPrivate * priv;
};

struct _FontManagerGoogleFontsFamilyClass {
	GObjectClass parent_class;
};

struct _FontManagerGoogleFontsFamilyPrivate {
	gchar* _family;
	gchar* _category;
	GPtrArray* _variants;
	FontManagerStringSet* _subsets;
	gint _count;
	gint _version;
};

struct _Block82Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	JsonObject* filelist;
};

struct _Block83Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	FontManagerGoogleFontsFont* _result_;
};

struct _Block84Data {
	int _ref_count_;
	FontManagerGoogleFontsFamily* self;
	GString* builder;
};

struct _FontManagerGoogleFontsFont {
	GObject parent_instance;
	FontManagerGoogleFontsFontPrivate * priv;
};

struct _FontManagerGoogleFontsFontClass {
	GObjectClass parent_class;
};

struct _FontManagerGoogleFontsFontPrivate {
	gchar* _family;
	gchar* _url;
	gint _weight;
	gboolean _italic;
	gint _version;
	FontManagerStringSet* _subsets;
};

static gint FontManagerGoogleFontsFamily_private_offset;
static gpointer font_manager_google_fonts_family_parent_class = NULL;
static gint FontManagerGoogleFontsFont_private_offset;
static gpointer font_manager_google_fonts_font_parent_class = NULL;

VALA_EXTERN GType font_manager_google_fonts_file_status_get_type (void) G_GNUC_CONST ;
static void font_manager_google_fonts_download_font_files_data_free (gpointer _data);
VALA_EXTERN GType font_manager_google_fonts_font_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFont, g_object_unref)
VALA_EXTERN void font_manager_google_fonts_download_font_files (FontManagerGoogleFontsFont** fonts,
                                                    gint fonts_length1,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
VALA_EXTERN gboolean font_manager_google_fonts_download_font_files_finish (GAsyncResult* _res_);
static gboolean font_manager_google_fonts_download_font_files_co (FontManagerGoogleFontsDownloadFontFilesData* _data_);
static Block79Data* block79_data_ref (Block79Data* _data79_);
static void block79_data_unref (void * _userdata_);
static Block80Data* block80_data_ref (Block80Data* _data80_);
static void block80_data_unref (void * _userdata_);
VALA_EXTERN gchar* font_manager_google_fonts_get_font_directory (void);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_font_get_filename (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_url (FontManagerGoogleFontsFont* self);
static Block81Data* block81_data_ref (Block81Data* _data81_);
static void block81_data_unref (void * _userdata_);
static void _vala_SoupBuffer_free (SoupBuffer* self);
static void ______lambda212_ (Block81Data* _data81_,
                       GObject* obj,
                       GAsyncResult* res);
static void _______lambda212__gasync_ready_callback (GObject* source_object,
                                              GAsyncResult* res,
                                              gpointer self);
static gboolean _font_manager_google_fonts_download_font_files_co_gsource_func (gpointer self);
VALA_EXTERN GType font_manager_google_fonts_family_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerGoogleFontsFamily, g_object_unref)
VALA_EXTERN FontManagerGoogleFontsFamily* font_manager_google_fonts_family_new (JsonObject* source);
VALA_EXTERN FontManagerGoogleFontsFamily* font_manager_google_fonts_family_construct (GType object_type,
                                                                          JsonObject* source);
static Block82Data* block82_data_ref (Block82Data* _data82_);
static void block82_data_unref (void * _userdata_);
VALA_EXTERN void font_manager_google_fonts_family_set_family (FontManagerGoogleFontsFamily* self,
                                                  const gchar* value);
VALA_EXTERN void font_manager_google_fonts_family_set_category (FontManagerGoogleFontsFamily* self,
                                                    const gchar* value);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN void font_manager_google_fonts_family_set_variants (FontManagerGoogleFontsFamily* self,
                                                    GPtrArray* value);
VALA_EXTERN void font_manager_google_fonts_family_set_subsets (FontManagerGoogleFontsFamily* self,
                                                   FontManagerStringSet* value);
static void __lambda192_ (Block82Data* _data82_,
                   JsonArray* array,
                   guint index,
                   JsonNode* node);
VALA_EXTERN const gchar* font_manager_google_fonts_family_get_family (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_family_get_subsets (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_font_new (const gchar* family,
                                                                const gchar* variant,
                                                                const gchar* url,
                                                                FontManagerStringSet* subsets);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_font_construct (GType object_type,
                                                                      const gchar* family,
                                                                      const gchar* variant,
                                                                      const gchar* url,
                                                                      FontManagerStringSet* subsets);
VALA_EXTERN GPtrArray* font_manager_google_fonts_family_get_variants (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gint font_manager_google_fonts_family_get_count (FontManagerGoogleFontsFamily* self);
static void font_manager_google_fonts_family_set_count (FontManagerGoogleFontsFamily* self,
                                                 gint value);
static void ___lambda192__json_array_foreach (JsonArray* array,
                                       guint index_,
                                       JsonNode* element_node,
                                       gpointer self);
static void __lambda193_ (FontManagerGoogleFontsFamily* self,
                   JsonArray* array,
                   guint index,
                   JsonNode* node);
static void ___lambda193__json_array_foreach (JsonArray* array,
                                       guint index_,
                                       JsonNode* element_node,
                                       gpointer self);
static void font_manager_google_fonts_family_set_version (FontManagerGoogleFontsFamily* self,
                                                   gint value);
VALA_EXTERN FontManagerGoogleFontsFont* font_manager_google_fonts_family_get_default_variant (FontManagerGoogleFontsFamily* self);
static Block83Data* block83_data_ref (Block83Data* _data83_);
static void block83_data_unref (void * _userdata_);
static void __lambda194_ (Block83Data* _data83_,
                   FontManagerGoogleFontsFont* variant);
VALA_EXTERN gboolean font_manager_google_fonts_font_get_italic (FontManagerGoogleFontsFont* self);
VALA_EXTERN gint font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self);
VALA_EXTERN GType font_manager_google_fonts_weight_get_type (void) G_GNUC_CONST ;
static void ___lambda194__gfunc (gconstpointer data,
                          gpointer self);
VALA_EXTERN gchar* font_manager_google_fonts_family_to_stylesheet (FontManagerGoogleFontsFamily* self);
static Block84Data* block84_data_ref (Block84Data* _data84_);
static void block84_data_unref (void * _userdata_);
static void __lambda195_ (Block84Data* _data84_,
                   FontManagerGoogleFontsFont* variant);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self);
static void ___lambda195__gfunc (gconstpointer data,
                          gpointer self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_family_get_installation_status (FontManagerGoogleFontsFamily* self);
VALA_EXTERN FontManagerGoogleFontsFileStatus font_manager_google_fonts_font_get_installation_status (FontManagerGoogleFontsFont* self);
VALA_EXTERN const gchar* font_manager_google_fonts_family_get_category (FontManagerGoogleFontsFamily* self);
VALA_EXTERN gint font_manager_google_fonts_family_get_version (FontManagerGoogleFontsFamily* self);
static void font_manager_google_fonts_family_finalize (GObject * obj);
static GType font_manager_google_fonts_family_get_type_once (void);
static void _vala_font_manager_google_fonts_family_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_font_manager_google_fonts_family_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
VALA_EXTERN void font_manager_google_fonts_font_set_italic (FontManagerGoogleFontsFont* self,
                                                gboolean value);
VALA_EXTERN void font_manager_google_fonts_font_set_weight (FontManagerGoogleFontsFont* self,
                                                gint value);
static void font_manager_google_fonts_font_set_version (FontManagerGoogleFontsFont* self,
                                                 gint value);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_display_name (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_weight_to_translatable_string (FontManagerGoogleFontsWeight self);
VALA_EXTERN gchar* font_manager_google_fonts_font_to_description (FontManagerGoogleFontsFont* self);
VALA_EXTERN gchar* font_manager_google_fonts_weight_to_string (FontManagerGoogleFontsWeight self);
VALA_EXTERN gint font_manager_google_fonts_font_get_version (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_font_set_family (FontManagerGoogleFontsFont* self,
                                                const gchar* value);
VALA_EXTERN void font_manager_google_fonts_font_set_url (FontManagerGoogleFontsFont* self,
                                             const gchar* value);
VALA_EXTERN const gchar* font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self);
VALA_EXTERN FontManagerStringSet* font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self);
VALA_EXTERN void font_manager_google_fonts_font_set_subsets (FontManagerGoogleFontsFont* self,
                                                 FontManagerStringSet* value);
static void font_manager_google_fonts_font_finalize (GObject * obj);
static GType font_manager_google_fonts_font_get_type_once (void);
static void _vala_font_manager_google_fonts_font_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_font_manager_google_fonts_font_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_file_status_get_type_once (void)
{
	static const GEnumValue values[] = {{FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED", "not-installed"}, {FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED", "installed"}, {FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE, "FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE", "requires-update"}, {0, NULL, NULL}};
	GType font_manager_google_fonts_file_status_type_id;
	font_manager_google_fonts_file_status_type_id = g_enum_register_static ("FontManagerGoogleFontsFileStatus", values);
	return font_manager_google_fonts_file_status_type_id;
}

GType
font_manager_google_fonts_file_status_get_type (void)
{
	static volatile gsize font_manager_google_fonts_file_status_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_file_status_type_id__once)) {
		GType font_manager_google_fonts_file_status_type_id;
		font_manager_google_fonts_file_status_type_id = font_manager_google_fonts_file_status_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_file_status_type_id__once, font_manager_google_fonts_file_status_type_id);
	}
	return font_manager_google_fonts_file_status_type_id__once;
}

static void
font_manager_google_fonts_download_font_files_data_free (gpointer _data)
{
	FontManagerGoogleFontsDownloadFontFilesData* _data_;
	_data_ = _data;
	g_slice_free (FontManagerGoogleFontsDownloadFontFilesData, _data_);
}

void
font_manager_google_fonts_download_font_files (FontManagerGoogleFontsFont** fonts,
                                               gint fonts_length1,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	FontManagerGoogleFontsDownloadFontFilesData* _data_;
	_data_ = g_slice_new0 (FontManagerGoogleFontsDownloadFontFilesData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, font_manager_google_fonts_download_font_files_data_free);
	_data_->fonts = fonts;
	_data_->fonts_length1 = fonts_length1;
	font_manager_google_fonts_download_font_files_co (_data_);
}

gboolean
font_manager_google_fonts_download_font_files_finish (GAsyncResult* _res_)
{
	gboolean result;
	FontManagerGoogleFontsDownloadFontFilesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static Block79Data*
block79_data_ref (Block79Data* _data79_)
{
	g_atomic_int_inc (&_data79_->_ref_count_);
	return _data79_;
}

static void
block79_data_unref (void * _userdata_)
{
	Block79Data* _data79_;
	_data79_ = (Block79Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data79_->_ref_count_)) {
		g_slice_free (Block79Data, _data79_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block80Data*
block80_data_ref (Block80Data* _data80_)
{
	g_atomic_int_inc (&_data80_->_ref_count_);
	return _data80_;
}

static void
block80_data_unref (void * _userdata_)
{
	Block80Data* _data80_;
	_data80_ = (Block80Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data80_->_ref_count_)) {
		_g_free0 (_data80_->filename);
		block79_data_unref (_data80_->_data79_);
		_data80_->_data79_ = NULL;
		g_slice_free (Block80Data, _data80_);
	}
}

static Block81Data*
block81_data_ref (Block81Data* _data81_)
{
	g_atomic_int_inc (&_data81_->_ref_count_);
	return _data81_;
}

static void
block81_data_unref (void * _userdata_)
{
	Block81Data* _data81_;
	_data81_ = (Block81Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data81_->_ref_count_)) {
		_g_object_unref0 (_data81_->stream);
		block80_data_unref (_data81_->_data80_);
		_data81_->_data80_ = NULL;
		g_slice_free (Block81Data, _data81_);
	}
}

static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
	g_boxed_free (soup_buffer_get_type (), self);
}

static void
______lambda212_ (Block81Data* _data81_,
                  GObject* obj,
                  GAsyncResult* res)
{
	Block80Data* _data80_;
	Block79Data* _data79_;
	GError* _inner_error0_ = NULL;
	_data80_ = _data81_->_data80_;
	_data79_ = _data80_->_data79_;
	g_return_if_fail (res != NULL);
	{
		GFileOutputStream* _tmp0_;
		GFileOutputStream* _tmp1_;
		_tmp0_ = _data81_->stream;
		g_output_stream_write_bytes_finish ((GOutputStream*) _tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp1_ = _data81_->stream;
		g_output_stream_close ((GOutputStream*) _tmp1_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = _data80_->filename;
		_tmp3_ = e;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_warning ("WebFont.vala:57: Failed to write data for : %s :: %i : %s", _tmp2_, _tmp3_->code, _tmp5_);
		_data79_->retval = FALSE;
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
_______lambda212__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self)
{
	______lambda212_ (self, source_object, res);
	block81_data_unref (self);
}

static gboolean
_font_manager_google_fonts_download_font_files_co_gsource_func (gpointer self)
{
	gboolean result;
	result = font_manager_google_fonts_download_font_files_co (self);
	return result;
}

static gboolean
font_manager_google_fonts_download_font_files_co (FontManagerGoogleFontsDownloadFontFilesData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data79_ = g_slice_new0 (Block79Data);
	_data_->_data79_->_ref_count_ = 1;
	_data_->_data79_->_async_data_ = _data_;
	_data_->_tmp0_ = soup_session_new ();
	_data_->session = _data_->_tmp0_;
	_data_->_data79_->retval = TRUE;
	{
		_data_->font_collection_length1 = 0;
		_data_->_font_collection_size_ = 0;
		_data_->font_collection = _data_->fonts;
		_data_->font_collection_length1 = _data_->fonts_length1;
		for (_data_->font_it = 0; _data_->font_it < _data_->font_collection_length1; _data_->font_it = _data_->font_it + 1) {
			_data_->_tmp1_ = _g_object_ref0 (_data_->font_collection[_data_->font_it]);
			_data_->font = _data_->_tmp1_;
			{
				_data_->_data80_ = g_slice_new0 (Block80Data);
				_data_->_data80_->_ref_count_ = 1;
				_data_->_data80_->_data79_ = block79_data_ref (_data_->_data79_);
				_data_->_tmp2_ = font_manager_google_fonts_get_font_directory ();
				_data_->_tmp3_ = _data_->_tmp2_;
				_data_->_tmp4_ = _data_->font;
				_data_->_tmp5_ = font_manager_google_fonts_font_get_family (_data_->_tmp4_);
				_data_->_tmp6_ = _data_->_tmp5_;
				_data_->_tmp7_ = g_build_filename (_data_->_tmp3_, _data_->_tmp6_, NULL);
				_data_->_tmp8_ = _data_->_tmp7_;
				_g_free0 (_data_->_tmp3_);
				_data_->font_dir = _data_->_tmp8_;
				_data_->_tmp9_ = _data_->font_dir;
				if (g_mkdir_with_parents (_data_->_tmp9_, 0755) != 0) {
					_data_->_tmp10_ = _data_->font_dir;
					g_warning ("WebFont.vala:39: Failed to create directory : %s", _data_->_tmp10_);
					_data_->result = FALSE;
					_g_free0 (_data_->font_dir);
					_g_object_unref0 (_data_->font);
					block80_data_unref (_data_->_data80_);
					_data_->_data80_ = NULL;
					_g_object_unref0 (_data_->session);
					block79_data_unref (_data_->_data79_);
					_data_->_data79_ = NULL;
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
					if (_data_->_state_ != 0) {
						while (!g_task_get_completed (_data_->_async_result)) {
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
						}
					}
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
				_data_->_tmp11_ = _data_->font;
				_data_->_tmp12_ = font_manager_google_fonts_font_get_filename (_data_->_tmp11_);
				_data_->_data80_->filename = _data_->_tmp12_;
				_data_->_tmp13_ = _data_->font_dir;
				_data_->_tmp14_ = _data_->_data80_->filename;
				_data_->_tmp15_ = g_build_filename (_data_->_tmp13_, _data_->_tmp14_, NULL);
				_data_->filepath = _data_->_tmp15_;
				_data_->_tmp16_ = _data_->font;
				_data_->_tmp17_ = font_manager_google_fonts_font_get_url (_data_->_tmp16_);
				_data_->_tmp18_ = _data_->_tmp17_;
				_data_->_tmp19_ = soup_message_new (FONT_MANAGER_GOOGLE_FONTS_GET, _data_->_tmp18_);
				_data_->message = _data_->_tmp19_;
				_data_->_tmp20_ = _data_->session;
				_data_->_tmp21_ = _data_->message;
				if (soup_session_send_message (_data_->_tmp20_, _data_->_tmp21_) == ((guint) SOUP_STATUS_OK)) {
					{
						_data_->_data81_ = g_slice_new0 (Block81Data);
						_data_->_data81_->_ref_count_ = 1;
						_data_->_data81_->_data80_ = block80_data_ref (_data_->_data80_);
						_data_->_tmp22_ = _data_->message;
						_data_->_tmp23_ = _data_->_tmp22_->response_body;
						_data_->_tmp24_ = soup_message_body_flatten (_data_->_tmp23_);
						_data_->_tmp25_ = _data_->_tmp24_;
						_data_->_tmp26_ = soup_buffer_get_as_bytes (_data_->_tmp25_);
						_data_->_tmp27_ = _data_->_tmp26_;
						__vala_SoupBuffer_free0 (_data_->_tmp25_);
						_data_->bytes = _data_->_tmp27_;
						_data_->_tmp28_ = _data_->filepath;
						_data_->_tmp29_ = g_file_new_for_path (_data_->_tmp28_);
						_data_->font_file = _data_->_tmp29_;
						_data_->_tmp30_ = _data_->font_file;
						if (g_file_query_exists (_data_->_tmp30_, NULL)) {
							_data_->_tmp31_ = _data_->font_file;
							g_file_delete (_data_->_tmp31_, NULL, &_data_->_inner_error0_);
							if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
								_g_object_unref0 (_data_->font_file);
								_g_bytes_unref0 (_data_->bytes);
								block81_data_unref (_data_->_data81_);
								_data_->_data81_ = NULL;
								goto __catch0_g_error;
							}
						}
						_data_->_tmp32_ = _data_->font_file;
						_data_->_tmp33_ = g_file_create (_data_->_tmp32_, G_FILE_CREATE_PRIVATE, NULL, &_data_->_inner_error0_);
						_data_->_data81_->stream = _data_->_tmp33_;
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
							_g_object_unref0 (_data_->font_file);
							_g_bytes_unref0 (_data_->bytes);
							block81_data_unref (_data_->_data81_);
							_data_->_data81_ = NULL;
							goto __catch0_g_error;
						}
						_data_->_tmp34_ = _data_->_data81_->stream;
						_data_->_tmp35_ = _data_->bytes;
						g_output_stream_write_bytes_async ((GOutputStream*) _data_->_tmp34_, _data_->_tmp35_, G_PRIORITY_DEFAULT, NULL, _______lambda212__gasync_ready_callback, block81_data_ref (_data_->_data81_));
						if (!_data_->_data79_->retval) {
							_data_->result = FALSE;
							_g_object_unref0 (_data_->font_file);
							_g_bytes_unref0 (_data_->bytes);
							block81_data_unref (_data_->_data81_);
							_data_->_data81_ = NULL;
							_g_object_unref0 (_data_->message);
							_g_free0 (_data_->filepath);
							_g_free0 (_data_->font_dir);
							_g_object_unref0 (_data_->font);
							block80_data_unref (_data_->_data80_);
							_data_->_data80_ = NULL;
							_g_object_unref0 (_data_->session);
							block79_data_unref (_data_->_data79_);
							_data_->_data79_ = NULL;
							g_task_return_pointer (_data_->_async_result, _data_, NULL);
							if (_data_->_state_ != 0) {
								while (!g_task_get_completed (_data_->_async_result)) {
									g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
								}
							}
							g_object_unref (_data_->_async_result);
							return FALSE;
						}
						_g_object_unref0 (_data_->font_file);
						_g_bytes_unref0 (_data_->bytes);
						block81_data_unref (_data_->_data81_);
						_data_->_data81_ = NULL;
					}
					goto __finally0;
					__catch0_g_error:
					{
						_data_->e = _data_->_inner_error0_;
						_data_->_inner_error0_ = NULL;
						_data_->_tmp36_ = _data_->_data80_->filename;
						_data_->_tmp37_ = _data_->e;
						_data_->_tmp38_ = _data_->e;
						_data_->_tmp39_ = _data_->_tmp38_->message;
						g_warning ("WebFont.vala:65: Failed to write data for : %s :: %i : %s", _data_->_tmp36_, _data_->_tmp37_->code, _data_->_tmp39_);
						_data_->result = FALSE;
						_g_error_free0 (_data_->e);
						_g_object_unref0 (_data_->message);
						_g_free0 (_data_->filepath);
						_g_free0 (_data_->font_dir);
						_g_object_unref0 (_data_->font);
						block80_data_unref (_data_->_data80_);
						_data_->_data80_ = NULL;
						_g_object_unref0 (_data_->session);
						block79_data_unref (_data_->_data79_);
						_data_->_data79_ = NULL;
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
						if (_data_->_state_ != 0) {
							while (!g_task_get_completed (_data_->_async_result)) {
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
							}
						}
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
					__finally0:
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						_g_object_unref0 (_data_->message);
						_g_free0 (_data_->filepath);
						_g_free0 (_data_->font_dir);
						_g_object_unref0 (_data_->font);
						block80_data_unref (_data_->_data80_);
						_data_->_data80_ = NULL;
						_g_object_unref0 (_data_->session);
						block79_data_unref (_data_->_data79_);
						_data_->_data79_ = NULL;
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
						g_clear_error (&_data_->_inner_error0_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
					g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _font_manager_google_fonts_download_font_files_co_gsource_func, _data_, NULL);
					_data_->_state_ = 1;
					return FALSE;
					_state_1:
					;
				} else {
					_data_->_tmp40_ = _data_->_data80_->filename;
					_data_->_tmp41_ = _data_->message;
					g_object_get (_data_->_tmp41_, "status-code", &_data_->_tmp42_, NULL);
					_data_->_tmp43_ = _data_->_tmp42_;
					g_warning ("WebFont.vala:71: Failed to download data for : %s :: %i", _data_->_tmp40_, (gint) _data_->_tmp43_);
					_data_->result = FALSE;
					_g_object_unref0 (_data_->message);
					_g_free0 (_data_->filepath);
					_g_free0 (_data_->font_dir);
					_g_object_unref0 (_data_->font);
					block80_data_unref (_data_->_data80_);
					_data_->_data80_ = NULL;
					_g_object_unref0 (_data_->session);
					block79_data_unref (_data_->_data79_);
					_data_->_data79_ = NULL;
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
					if (_data_->_state_ != 0) {
						while (!g_task_get_completed (_data_->_async_result)) {
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
						}
					}
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
				_g_object_unref0 (_data_->message);
				_g_free0 (_data_->filepath);
				_g_free0 (_data_->font_dir);
				_g_object_unref0 (_data_->font);
				block80_data_unref (_data_->_data80_);
				_data_->_data80_ = NULL;
			}
		}
	}
	_data_->result = _data_->_data79_->retval;
	_g_object_unref0 (_data_->session);
	block79_data_unref (_data_->_data79_);
	_data_->_data79_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static inline gpointer
font_manager_google_fonts_family_get_instance_private (FontManagerGoogleFontsFamily* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsFamily_private_offset);
}

static Block82Data*
block82_data_ref (Block82Data* _data82_)
{
	g_atomic_int_inc (&_data82_->_ref_count_);
	return _data82_;
}

static void
block82_data_unref (void * _userdata_)
{
	Block82Data* _data82_;
	_data82_ = (Block82Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data82_->_ref_count_)) {
		FontManagerGoogleFontsFamily* self;
		self = _data82_->self;
		_json_object_unref0 (_data82_->filelist);
		_g_object_unref0 (self);
		g_slice_free (Block82Data, _data82_);
	}
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static void
__lambda192_ (Block82Data* _data82_,
              JsonArray* array,
              guint index,
              JsonNode* node)
{
	FontManagerGoogleFontsFamily* self;
	gchar* entry = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	FontManagerGoogleFontsFont* variant = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	FontManagerStringSet* _tmp4_;
	FontManagerGoogleFontsFont* _tmp5_;
	GPtrArray* _tmp6_;
	FontManagerGoogleFontsFont* _tmp7_;
	gint _tmp8_;
	self = _data82_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = json_node_get_string (node);
	_tmp1_ = g_strdup (_tmp0_);
	entry = _tmp1_;
	_tmp2_ = self->priv->_family;
	_tmp3_ = json_object_get_string_member (_data82_->filelist, entry);
	_tmp4_ = self->priv->_subsets;
	_tmp5_ = font_manager_google_fonts_font_new (_tmp2_, entry, _tmp3_, _tmp4_);
	variant = _tmp5_;
	_tmp6_ = self->priv->_variants;
	_tmp7_ = _g_object_ref0 (variant);
	g_ptr_array_insert (_tmp6_, (gint) index, _tmp7_);
	_tmp8_ = self->priv->_count;
	font_manager_google_fonts_family_set_count (self, _tmp8_ + 1);
	_g_object_unref0 (variant);
	_g_free0 (entry);
}

static void
___lambda192__json_array_foreach (JsonArray* array,
                                  guint index_,
                                  JsonNode* element_node,
                                  gpointer self)
{
	__lambda192_ (self, array, index_, element_node);
}

static void
__lambda193_ (FontManagerGoogleFontsFamily* self,
              JsonArray* array,
              guint index,
              JsonNode* node)
{
	FontManagerStringSet* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (array != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = self->priv->_subsets;
	_tmp1_ = json_node_get_string (node);
	font_manager_string_set_add (_tmp0_, _tmp1_);
}

static void
___lambda193__json_array_foreach (JsonArray* array,
                                  guint index_,
                                  JsonNode* element_node,
                                  gpointer self)
{
	__lambda193_ ((FontManagerGoogleFontsFamily*) self, array, index_, element_node);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

FontManagerGoogleFontsFamily*
font_manager_google_fonts_family_construct (GType object_type,
                                            JsonObject* source)
{
	FontManagerGoogleFontsFamily * self = NULL;
	Block82Data* _data82_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GPtrArray* _tmp2_;
	GPtrArray* _tmp3_;
	FontManagerStringSet* _tmp4_;
	FontManagerStringSet* _tmp5_;
	JsonObject* _tmp6_;
	JsonObject* _tmp7_;
	JsonArray* _tmp8_;
	JsonArray* _tmp9_;
	gchar** _version = NULL;
	GPtrArray* _tmp10_;
	gconstpointer _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _version_length1;
	gint __version_size_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	g_return_val_if_fail (source != NULL, NULL);
	_data82_ = g_slice_new0 (Block82Data);
	_data82_->_ref_count_ = 1;
	self = (FontManagerGoogleFontsFamily*) g_object_new (object_type, NULL);
	_data82_->self = g_object_ref (self);
	_tmp0_ = json_object_get_string_member (source, "family");
	font_manager_google_fonts_family_set_family (self, _tmp0_);
	_tmp1_ = json_object_get_string_member (source, "category");
	font_manager_google_fonts_family_set_category (self, _tmp1_);
	_tmp2_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
	_tmp3_ = _tmp2_;
	font_manager_google_fonts_family_set_variants (self, _tmp3_);
	_g_ptr_array_unref0 (_tmp3_);
	_tmp4_ = font_manager_string_set_new ();
	_tmp5_ = _tmp4_;
	font_manager_google_fonts_family_set_subsets (self, _tmp5_);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = json_object_get_object_member (source, "files");
	_tmp7_ = _json_object_ref0 (_tmp6_);
	_data82_->filelist = _tmp7_;
	_tmp8_ = json_object_get_array_member (source, "variants");
	json_array_foreach_element (_tmp8_, ___lambda192__json_array_foreach, _data82_);
	_tmp9_ = json_object_get_array_member (source, "subsets");
	json_array_foreach_element (_tmp9_, ___lambda193__json_array_foreach, self);
	_tmp10_ = self->priv->_variants;
	_tmp11_ = g_ptr_array_index (_tmp10_, (guint) 0);
	_tmp12_ = font_manager_google_fonts_font_get_url ((FontManagerGoogleFontsFont*) _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "/", 0);
	_version = _tmp15_;
	_version_length1 = _vala_array_length (_tmp14_);
	__version_size_ = _version_length1;
	_tmp16_ = _version[_version_length1 - 2];
	_tmp17_ = string_replace (_tmp16_, "v", "");
	_tmp18_ = _tmp17_;
	font_manager_google_fonts_family_set_version (self, atoi (_tmp18_));
	_g_free0 (_tmp18_);
	_version = (_vala_array_free (_version, _version_length1, (GDestroyNotify) g_free), NULL);
	block82_data_unref (_data82_);
	_data82_ = NULL;
	return self;
}

FontManagerGoogleFontsFamily*
font_manager_google_fonts_family_new (JsonObject* source)
{
	return font_manager_google_fonts_family_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, source);
}

static Block83Data*
block83_data_ref (Block83Data* _data83_)
{
	g_atomic_int_inc (&_data83_->_ref_count_);
	return _data83_;
}

static void
block83_data_unref (void * _userdata_)
{
	Block83Data* _data83_;
	_data83_ = (Block83Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data83_->_ref_count_)) {
		FontManagerGoogleFontsFamily* self;
		self = _data83_->self;
		_g_object_unref0 (_data83_->_result_);
		_g_object_unref0 (self);
		g_slice_free (Block83Data, _data83_);
	}
}

static void
__lambda194_ (Block83Data* _data83_,
              FontManagerGoogleFontsFont* variant)
{
	FontManagerGoogleFontsFamily* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	self = _data83_->self;
	g_return_if_fail (variant != NULL);
	_tmp0_ = font_manager_google_fonts_font_get_italic (variant);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		return;
	}
	_tmp2_ = font_manager_google_fonts_font_get_weight (variant);
	_tmp3_ = _tmp2_;
	if (((FontManagerGoogleFontsWeight) _tmp3_) == FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR) {
		FontManagerGoogleFontsFont* _tmp4_;
		_tmp4_ = _g_object_ref0 (variant);
		_g_object_unref0 (_data83_->_result_);
		_data83_->_result_ = _tmp4_;
	}
}

static void
___lambda194__gfunc (gconstpointer data,
                     gpointer self)
{
	__lambda194_ (self, (FontManagerGoogleFontsFont*) data);
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_family_get_default_variant (FontManagerGoogleFontsFamily* self)
{
	Block83Data* _data83_;
	GPtrArray* _tmp0_;
	gconstpointer _tmp1_;
	FontManagerGoogleFontsFont* _tmp2_;
	GPtrArray* _tmp3_;
	FontManagerGoogleFontsFont* _tmp4_;
	FontManagerGoogleFontsFont* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data83_ = g_slice_new0 (Block83Data);
	_data83_->_ref_count_ = 1;
	_data83_->self = g_object_ref (self);
	_tmp0_ = self->priv->_variants;
	_tmp1_ = g_ptr_array_index (_tmp0_, (guint) 0);
	_tmp2_ = _g_object_ref0 ((FontManagerGoogleFontsFont*) _tmp1_);
	_data83_->_result_ = _tmp2_;
	_tmp3_ = self->priv->_variants;
	g_ptr_array_foreach (_tmp3_, ___lambda194__gfunc, _data83_);
	_tmp4_ = _g_object_ref0 (_data83_->_result_);
	result = _tmp4_;
	block83_data_unref (_data83_);
	_data83_ = NULL;
	return result;
}

static Block84Data*
block84_data_ref (Block84Data* _data84_)
{
	g_atomic_int_inc (&_data84_->_ref_count_);
	return _data84_;
}

static void
block84_data_unref (void * _userdata_)
{
	Block84Data* _data84_;
	_data84_ = (Block84Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data84_->_ref_count_)) {
		FontManagerGoogleFontsFamily* self;
		self = _data84_->self;
		_g_string_free0 (_data84_->builder);
		_g_object_unref0 (self);
		g_slice_free (Block84Data, _data84_);
	}
}

static void
__lambda195_ (Block84Data* _data84_,
              FontManagerGoogleFontsFont* variant)
{
	FontManagerGoogleFontsFamily* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	self = _data84_->self;
	g_return_if_fail (variant != NULL);
	_tmp0_ = font_manager_google_fonts_font_to_font_face_rule (variant);
	_tmp1_ = _tmp0_;
	g_string_append (_data84_->builder, _tmp1_);
	_g_free0 (_tmp1_);
}

static void
___lambda195__gfunc (gconstpointer data,
                     gpointer self)
{
	__lambda195_ (self, (FontManagerGoogleFontsFont*) data);
}

gchar*
font_manager_google_fonts_family_to_stylesheet (FontManagerGoogleFontsFamily* self)
{
	Block84Data* _data84_;
	GString* _tmp0_;
	GPtrArray* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_data84_ = g_slice_new0 (Block84Data);
	_data84_->_ref_count_ = 1;
	_data84_->self = g_object_ref (self);
	_tmp0_ = g_string_new ("");
	_data84_->builder = _tmp0_;
	_tmp1_ = self->priv->_variants;
	g_ptr_array_foreach (_tmp1_, ___lambda195__gfunc, _data84_);
	_tmp2_ = _data84_->builder->str;
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	block84_data_unref (_data84_);
	_data84_ = NULL;
	return result;
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

FontManagerGoogleFontsFileStatus
font_manager_google_fonts_family_get_installation_status (FontManagerGoogleFontsFamily* self)
{
	FontManagerGoogleFontsFileStatus result;
	g_return_val_if_fail (self != NULL, 0);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				FontManagerGoogleFontsFileStatus status = 0;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = self->priv->_variants;
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				_tmp5_ = self->priv->_variants;
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
				status = font_manager_google_fonts_font_get_installation_status ((FontManagerGoogleFontsFont*) _tmp6_);
				if (status != FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED) {
					result = status;
					return result;
				}
			}
		}
	}
	result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
	return result;
}

const gchar*
font_manager_google_fonts_family_get_family (FontManagerGoogleFontsFamily* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_family;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_family_set_family (FontManagerGoogleFontsFamily* self,
                                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_family_get_family (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_family);
		self->priv->_family = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY]);
	}
}

const gchar*
font_manager_google_fonts_family_get_category (FontManagerGoogleFontsFamily* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_category;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_family_set_category (FontManagerGoogleFontsFamily* self,
                                               const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_family_get_category (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_category);
		self->priv->_category = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY]);
	}
}

GPtrArray*
font_manager_google_fonts_family_get_variants (FontManagerGoogleFontsFamily* self)
{
	GPtrArray* result;
	GPtrArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_variants;
	result = _tmp0_;
	return result;
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
	return self ? g_ptr_array_ref (self) : NULL;
}

void
font_manager_google_fonts_family_set_variants (FontManagerGoogleFontsFamily* self,
                                               GPtrArray* value)
{
	GPtrArray* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_family_get_variants (self);
	if (old_value != value) {
		GPtrArray* _tmp0_;
		_tmp0_ = _g_ptr_array_ref0 (value);
		_g_ptr_array_unref0 (self->priv->_variants);
		self->priv->_variants = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY]);
	}
}

FontManagerStringSet*
font_manager_google_fonts_family_get_subsets (FontManagerGoogleFontsFamily* self)
{
	FontManagerStringSet* result;
	FontManagerStringSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_subsets;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_family_set_subsets (FontManagerGoogleFontsFamily* self,
                                              FontManagerStringSet* value)
{
	FontManagerStringSet* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_family_get_subsets (self);
	if (old_value != value) {
		FontManagerStringSet* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_subsets);
		self->priv->_subsets = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY]);
	}
}

gint
font_manager_google_fonts_family_get_count (FontManagerGoogleFontsFamily* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_count;
	return result;
}

static void
font_manager_google_fonts_family_set_count (FontManagerGoogleFontsFamily* self,
                                            gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_family_get_count (self);
	if (old_value != value) {
		self->priv->_count = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY]);
	}
}

gint
font_manager_google_fonts_family_get_version (FontManagerGoogleFontsFamily* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_version;
	return result;
}

static void
font_manager_google_fonts_family_set_version (FontManagerGoogleFontsFamily* self,
                                              gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_family_get_version (self);
	if (old_value != value) {
		self->priv->_version = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY]);
	}
}

static void
font_manager_google_fonts_family_class_init (FontManagerGoogleFontsFamilyClass * klass,
                                             gpointer klass_data)
{
	font_manager_google_fonts_family_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsFamily_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_family_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_family_set_property;
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_family_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY] = g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY] = g_param_spec_string ("category", "category", "category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY] = g_param_spec_boxed ("variants", "variants", "variants", G_TYPE_PTR_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY] = g_param_spec_object ("subsets", "subsets", "subsets", font_manager_string_set_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY] = g_param_spec_int ("count", "count", "count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY, font_manager_google_fonts_family_properties[FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY] = g_param_spec_int ("version", "version", "version", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
font_manager_google_fonts_family_instance_init (FontManagerGoogleFontsFamily * self,
                                                gpointer klass)
{
	self->priv = font_manager_google_fonts_family_get_instance_private (self);
	self->priv->_count = 0;
	self->priv->_version = 1;
}

static void
font_manager_google_fonts_family_finalize (GObject * obj)
{
	FontManagerGoogleFontsFamily * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
	_g_free0 (self->priv->_family);
	_g_free0 (self->priv->_category);
	_g_ptr_array_unref0 (self->priv->_variants);
	_g_object_unref0 (self->priv->_subsets);
	G_OBJECT_CLASS (font_manager_google_fonts_family_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_family_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsFamilyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_family_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsFamily), 0, (GInstanceInitFunc) font_manager_google_fonts_family_instance_init, NULL };
	GType font_manager_google_fonts_family_type_id;
	font_manager_google_fonts_family_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerGoogleFontsFamily", &g_define_type_info, 0);
	FontManagerGoogleFontsFamily_private_offset = g_type_add_instance_private (font_manager_google_fonts_family_type_id, sizeof (FontManagerGoogleFontsFamilyPrivate));
	return font_manager_google_fonts_family_type_id;
}

GType
font_manager_google_fonts_family_get_type (void)
{
	static volatile gsize font_manager_google_fonts_family_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_family_type_id__once)) {
		GType font_manager_google_fonts_family_type_id;
		font_manager_google_fonts_family_type_id = font_manager_google_fonts_family_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_family_type_id__once, font_manager_google_fonts_family_type_id);
	}
	return font_manager_google_fonts_family_type_id__once;
}

static void
_vala_font_manager_google_fonts_family_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	FontManagerGoogleFontsFamily * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
	switch (property_id) {
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY:
		g_value_set_string (value, font_manager_google_fonts_family_get_family (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY:
		g_value_set_string (value, font_manager_google_fonts_family_get_category (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY:
		g_value_set_boxed (value, font_manager_google_fonts_family_get_variants (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY:
		g_value_set_object (value, font_manager_google_fonts_family_get_subsets (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY:
		g_value_set_int (value, font_manager_google_fonts_family_get_count (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY:
		g_value_set_int (value, font_manager_google_fonts_family_get_version (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_google_fonts_family_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	FontManagerGoogleFontsFamily * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FAMILY, FontManagerGoogleFontsFamily);
	switch (property_id) {
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_FAMILY_PROPERTY:
		font_manager_google_fonts_family_set_family (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_CATEGORY_PROPERTY:
		font_manager_google_fonts_family_set_category (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VARIANTS_PROPERTY:
		font_manager_google_fonts_family_set_variants (self, g_value_get_boxed (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_SUBSETS_PROPERTY:
		font_manager_google_fonts_family_set_subsets (self, g_value_get_object (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_COUNT_PROPERTY:
		font_manager_google_fonts_family_set_count (self, g_value_get_int (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FAMILY_VERSION_PROPERTY:
		font_manager_google_fonts_family_set_version (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
font_manager_google_fonts_font_get_instance_private (FontManagerGoogleFontsFont* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerGoogleFontsFont_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_font_construct (GType object_type,
                                          const gchar* family,
                                          const gchar* variant,
                                          const gchar* url,
                                          FontManagerStringSet* subsets)
{
	FontManagerGoogleFontsFont * self = NULL;
	gboolean _tmp0_ = FALSE;
	gchar** _version = NULL;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _version_length1;
	gint __version_size_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	g_return_val_if_fail (family != NULL, NULL);
	g_return_val_if_fail (variant != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	g_return_val_if_fail (subsets != NULL, NULL);
	self = (FontManagerGoogleFontsFont*) g_object_new (object_type, "family", family, "url", url, "subsets", subsets, NULL);
	font_manager_google_fonts_font_set_italic (self, string_contains (variant, "italic"));
	if (g_strcmp0 (variant, "regular") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (variant, "italic") == 0;
	}
	if (_tmp0_) {
		font_manager_google_fonts_font_set_weight (self, (gint) FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR);
	} else {
		gchar* _tmp1_ = NULL;
		gboolean _tmp2_;
		_tmp2_ = self->priv->_italic;
		if (_tmp2_) {
			gchar* _tmp3_;
			_tmp3_ = string_replace (variant, "italic", "");
			_g_free0 (_tmp1_);
			_tmp1_ = _tmp3_;
		} else {
			gchar* _tmp4_;
			_tmp4_ = g_strdup (variant);
			_g_free0 (_tmp1_);
			_tmp1_ = _tmp4_;
		}
		font_manager_google_fonts_font_set_weight (self, atoi (_tmp1_));
		_g_free0 (_tmp1_);
	}
	_tmp6_ = _tmp5_ = g_strsplit (url, "/", 0);
	_version = _tmp6_;
	_version_length1 = _vala_array_length (_tmp5_);
	__version_size_ = _version_length1;
	_tmp7_ = _version[_version_length1 - 2];
	_tmp8_ = string_replace (_tmp7_, "v", "");
	_tmp9_ = _tmp8_;
	font_manager_google_fonts_font_set_version (self, atoi (_tmp9_));
	_g_free0 (_tmp9_);
	_version = (_vala_array_free (_version, _version_length1, (GDestroyNotify) g_free), NULL);
	return self;
}

FontManagerGoogleFontsFont*
font_manager_google_fonts_font_new (const gchar* family,
                                    const gchar* variant,
                                    const gchar* url,
                                    FontManagerStringSet* subsets)
{
	return font_manager_google_fonts_font_construct (FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, family, variant, url, subsets);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

gchar*
font_manager_google_fonts_font_to_display_name (FontManagerGoogleFontsFont* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* ital = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_italic;
	if (_tmp1_) {
		_tmp0_ = _ ("Italic");
	} else {
		_tmp0_ = "";
	}
	_tmp2_ = g_strdup (_tmp0_);
	ital = _tmp2_;
	_tmp4_ = self->priv->_italic;
	if (_tmp4_) {
		gint _tmp5_;
		_tmp5_ = self->priv->_weight;
		_tmp3_ = _tmp5_ == ((gint) FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = ital;
		return result;
	}
	_tmp6_ = self->priv->_weight;
	_tmp7_ = font_manager_google_fonts_weight_to_translatable_string ((FontManagerGoogleFontsWeight) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = ital;
	_tmp10_ = g_strdup_printf ("%s %s", _tmp8_, _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = string_strip (_tmp11_);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	result = _tmp13_;
	_g_free0 (ital);
	return result;
}

gchar*
font_manager_google_fonts_font_to_description (FontManagerGoogleFontsFont* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* ital = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_italic;
	if (_tmp1_) {
		_tmp0_ = "Italic";
	} else {
		_tmp0_ = "";
	}
	_tmp2_ = g_strdup (_tmp0_);
	ital = _tmp2_;
	_tmp4_ = self->priv->_italic;
	if (_tmp4_) {
		gint _tmp5_;
		_tmp5_ = self->priv->_weight;
		_tmp3_ = ((FontManagerGoogleFontsWeight) _tmp5_) == FONT_MANAGER_GOOGLE_FONTS_WEIGHT_REGULAR;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = ital;
		return result;
	}
	_tmp6_ = self->priv->_weight;
	_tmp7_ = font_manager_google_fonts_weight_to_string ((FontManagerGoogleFontsWeight) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = ital;
	_tmp10_ = g_strdup_printf ("%s %s", _tmp8_, _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = string_strip (_tmp11_);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp11_);
	_g_free0 (_tmp8_);
	result = _tmp13_;
	_g_free0 (ital);
	return result;
}

gchar*
font_manager_google_fonts_font_to_font_face_rule (FontManagerGoogleFontsFont* self)
{
	gchar* description = NULL;
	gchar* _tmp0_;
	gchar* local = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _local = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_ = NULL;
	gboolean _tmp13_;
	gchar* style = NULL;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = font_manager_google_fonts_font_to_description (self);
	description = _tmp0_;
	_tmp1_ = self->priv->_family;
	_tmp2_ = description;
	_tmp3_ = g_strdup_printf ("%s %s", _tmp1_, _tmp2_);
	local = _tmp3_;
	_tmp4_ = self->priv->_family;
	_tmp5_ = string_replace (_tmp4_, " ", "");
	_tmp6_ = _tmp5_;
	_tmp7_ = description;
	_tmp8_ = string_replace (_tmp7_, " ", "");
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strdup_printf ("%s-%s", _tmp6_, _tmp9_);
	_tmp11_ = _tmp10_;
	_g_free0 (_tmp9_);
	_g_free0 (_tmp6_);
	_local = _tmp11_;
	_tmp13_ = self->priv->_italic;
	if (_tmp13_) {
		_tmp12_ = "italic";
	} else {
		_tmp12_ = "normal";
	}
	_tmp14_ = g_strdup (_tmp12_);
	style = _tmp14_;
	_tmp15_ = self->priv->_family;
	_tmp16_ = self->priv->_weight;
	_tmp17_ = local;
	_tmp18_ = _local;
	_tmp19_ = self->priv->_url;
	_tmp20_ = g_strdup_printf (FONT_MANAGER_GOOGLE_FONTS_FONT_FACE, _tmp15_, style, _tmp16_, _tmp17_, _tmp18_, _tmp19_);
	result = _tmp20_;
	_g_free0 (style);
	_g_free0 (_local);
	_g_free0 (local);
	_g_free0 (description);
	return result;
}

gchar*
font_manager_google_fonts_font_get_filename (FontManagerGoogleFontsFont* self)
{
	gchar* ext = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* style = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* family = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_url;
	_tmp1_ = font_manager_get_file_extension (_tmp0_);
	ext = _tmp1_;
	_tmp2_ = font_manager_google_fonts_font_to_description (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = string_replace (_tmp3_, " ", "_");
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	style = _tmp5_;
	_tmp6_ = self->priv->_family;
	_tmp7_ = string_replace (_tmp6_, " ", "_");
	family = _tmp7_;
	_tmp8_ = self->priv->_version;
	_tmp9_ = g_strdup_printf ("%s_%s.%i.%s", family, style, _tmp8_, ext);
	result = _tmp9_;
	_g_free0 (family);
	_g_free0 (style);
	_g_free0 (ext);
	return result;
}

FontManagerGoogleFontsFileStatus
font_manager_google_fonts_font_get_installation_status (FontManagerGoogleFontsFont* self)
{
	gchar* dir = NULL;
	gchar* _tmp0_;
	gchar* filepath = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* font = NULL;
	const gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* font_dir = NULL;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	FontManagerGoogleFontsFileStatus result;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = font_manager_google_fonts_get_font_directory ();
	dir = _tmp0_;
	_tmp1_ = dir;
	_tmp2_ = self->priv->_family;
	_tmp3_ = font_manager_google_fonts_font_get_filename (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_build_filename (_tmp1_, _tmp2_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	filepath = _tmp6_;
	_tmp7_ = filepath;
	_tmp8_ = g_file_new_for_path (_tmp7_);
	font = _tmp8_;
	_tmp9_ = font;
	if (g_file_query_exists (_tmp9_, NULL)) {
		result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_INSTALLED;
		_g_object_unref0 (font);
		_g_free0 (filepath);
		_g_free0 (dir);
		return result;
	}
	_tmp10_ = dir;
	_tmp11_ = self->priv->_family;
	_tmp12_ = g_build_filename (_tmp10_, _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_file_new_for_path (_tmp13_);
	_tmp15_ = _tmp14_;
	_g_free0 (_tmp13_);
	font_dir = _tmp15_;
	_tmp16_ = font_dir;
	if (g_file_query_exists (_tmp16_, NULL)) {
		gchar* ext = NULL;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* style = NULL;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* family = NULL;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* filename = NULL;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gint _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		GFile* outdated = NULL;
		GFile* _tmp30_;
		const gchar* _tmp31_;
		GFile* _tmp32_;
		GFile* _tmp33_;
		_tmp17_ = self->priv->_url;
		_tmp18_ = font_manager_get_file_extension (_tmp17_);
		ext = _tmp18_;
		_tmp19_ = font_manager_google_fonts_font_to_description (self);
		_tmp20_ = _tmp19_;
		_tmp21_ = string_replace (_tmp20_, " ", "_");
		_tmp22_ = _tmp21_;
		_g_free0 (_tmp20_);
		style = _tmp22_;
		_tmp23_ = self->priv->_family;
		_tmp24_ = string_replace (_tmp23_, " ", "_");
		family = _tmp24_;
		_tmp25_ = family;
		_tmp26_ = style;
		_tmp27_ = self->priv->_version;
		_tmp28_ = ext;
		_tmp29_ = g_strdup_printf ("%s_%s.%i.%s", _tmp25_, _tmp26_, _tmp27_ - 1, _tmp28_);
		filename = _tmp29_;
		_tmp30_ = font_dir;
		_tmp31_ = filename;
		_tmp32_ = g_file_get_child (_tmp30_, _tmp31_);
		outdated = _tmp32_;
		_tmp33_ = outdated;
		if (g_file_query_exists (_tmp33_, NULL)) {
			result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_REQUIRES_UPDATE;
			_g_object_unref0 (outdated);
			_g_free0 (filename);
			_g_free0 (family);
			_g_free0 (style);
			_g_free0 (ext);
			_g_object_unref0 (font_dir);
			_g_object_unref0 (font);
			_g_free0 (filepath);
			_g_free0 (dir);
			return result;
		}
		_g_object_unref0 (outdated);
		_g_free0 (filename);
		_g_free0 (family);
		_g_free0 (style);
		_g_free0 (ext);
	}
	result = FONT_MANAGER_GOOGLE_FONTS_FILE_STATUS_NOT_INSTALLED;
	_g_object_unref0 (font_dir);
	_g_object_unref0 (font);
	_g_free0 (filepath);
	_g_free0 (dir);
	return result;
}

const gchar*
font_manager_google_fonts_font_get_family (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_family;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_font_set_family (FontManagerGoogleFontsFont* self,
                                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_font_get_family (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_family);
		self->priv->_family = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY]);
	}
}

const gchar*
font_manager_google_fonts_font_get_url (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_url;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_font_set_url (FontManagerGoogleFontsFont* self,
                                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_font_get_url (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_url);
		self->priv->_url = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY]);
	}
}

gint
font_manager_google_fonts_font_get_weight (FontManagerGoogleFontsFont* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_weight;
	return result;
}

void
font_manager_google_fonts_font_set_weight (FontManagerGoogleFontsFont* self,
                                           gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_font_get_weight (self);
	if (old_value != value) {
		self->priv->_weight = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY]);
	}
}

gboolean
font_manager_google_fonts_font_get_italic (FontManagerGoogleFontsFont* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_italic;
	return result;
}

void
font_manager_google_fonts_font_set_italic (FontManagerGoogleFontsFont* self,
                                           gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_font_get_italic (self);
	if (old_value != value) {
		self->priv->_italic = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY]);
	}
}

const gchar*
font_manager_google_fonts_font_get_style (FontManagerGoogleFontsFont* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_italic;
	if (_tmp1_) {
		_tmp0_ = "italic";
	} else {
		_tmp0_ = "normal";
	}
	result = _tmp0_;
	return result;
}

gint
font_manager_google_fonts_font_get_version (FontManagerGoogleFontsFont* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_version;
	return result;
}

static void
font_manager_google_fonts_font_set_version (FontManagerGoogleFontsFont* self,
                                            gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_font_get_version (self);
	if (old_value != value) {
		self->priv->_version = value;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY]);
	}
}

FontManagerStringSet*
font_manager_google_fonts_font_get_subsets (FontManagerGoogleFontsFont* self)
{
	FontManagerStringSet* result;
	FontManagerStringSet* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_subsets;
	result = _tmp0_;
	return result;
}

void
font_manager_google_fonts_font_set_subsets (FontManagerGoogleFontsFont* self,
                                            FontManagerStringSet* value)
{
	FontManagerStringSet* old_value;
	g_return_if_fail (self != NULL);
	old_value = font_manager_google_fonts_font_get_subsets (self);
	if (old_value != value) {
		FontManagerStringSet* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_subsets);
		self->priv->_subsets = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY]);
	}
}

static void
font_manager_google_fonts_font_class_init (FontManagerGoogleFontsFontClass * klass,
                                           gpointer klass_data)
{
	font_manager_google_fonts_font_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerGoogleFontsFont_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_google_fonts_font_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_google_fonts_font_set_property;
	G_OBJECT_CLASS (klass)->finalize = font_manager_google_fonts_font_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY] = g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY] = g_param_spec_int ("weight", "weight", "weight", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY] = g_param_spec_boolean ("italic", "italic", "italic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY] = g_param_spec_string ("style", "style", "style", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY] = g_param_spec_int ("version", "version", "version", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY, font_manager_google_fonts_font_properties[FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY] = g_param_spec_object ("subsets", "subsets", "subsets", font_manager_string_set_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
font_manager_google_fonts_font_instance_init (FontManagerGoogleFontsFont * self,
                                              gpointer klass)
{
	self->priv = font_manager_google_fonts_font_get_instance_private (self);
	self->priv->_version = 1;
}

static void
font_manager_google_fonts_font_finalize (GObject * obj)
{
	FontManagerGoogleFontsFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
	_g_free0 (self->priv->_family);
	_g_free0 (self->priv->_url);
	_g_object_unref0 (self->priv->_subsets);
	G_OBJECT_CLASS (font_manager_google_fonts_font_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_google_fonts_font_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerGoogleFontsFontClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_google_fonts_font_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerGoogleFontsFont), 0, (GInstanceInitFunc) font_manager_google_fonts_font_instance_init, NULL };
	GType font_manager_google_fonts_font_type_id;
	font_manager_google_fonts_font_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerGoogleFontsFont", &g_define_type_info, 0);
	FontManagerGoogleFontsFont_private_offset = g_type_add_instance_private (font_manager_google_fonts_font_type_id, sizeof (FontManagerGoogleFontsFontPrivate));
	return font_manager_google_fonts_font_type_id;
}

GType
font_manager_google_fonts_font_get_type (void)
{
	static volatile gsize font_manager_google_fonts_font_type_id__once = 0;
	if (g_once_init_enter (&font_manager_google_fonts_font_type_id__once)) {
		GType font_manager_google_fonts_font_type_id;
		font_manager_google_fonts_font_type_id = font_manager_google_fonts_font_get_type_once ();
		g_once_init_leave (&font_manager_google_fonts_font_type_id__once, font_manager_google_fonts_font_type_id);
	}
	return font_manager_google_fonts_font_type_id__once;
}

static void
_vala_font_manager_google_fonts_font_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	FontManagerGoogleFontsFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
	switch (property_id) {
		case FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY:
		g_value_set_string (value, font_manager_google_fonts_font_get_family (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY:
		g_value_set_string (value, font_manager_google_fonts_font_get_url (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY:
		g_value_set_int (value, font_manager_google_fonts_font_get_weight (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY:
		g_value_set_boolean (value, font_manager_google_fonts_font_get_italic (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_STYLE_PROPERTY:
		g_value_set_string (value, font_manager_google_fonts_font_get_style (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY:
		g_value_set_int (value, font_manager_google_fonts_font_get_version (self));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY:
		g_value_set_object (value, font_manager_google_fonts_font_get_subsets (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_google_fonts_font_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	FontManagerGoogleFontsFont * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_GOOGLE_FONTS_TYPE_FONT, FontManagerGoogleFontsFont);
	switch (property_id) {
		case FONT_MANAGER_GOOGLE_FONTS_FONT_FAMILY_PROPERTY:
		font_manager_google_fonts_font_set_family (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_URL_PROPERTY:
		font_manager_google_fonts_font_set_url (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_WEIGHT_PROPERTY:
		font_manager_google_fonts_font_set_weight (self, g_value_get_int (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_ITALIC_PROPERTY:
		font_manager_google_fonts_font_set_italic (self, g_value_get_boolean (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_VERSION_PROPERTY:
		font_manager_google_fonts_font_set_version (self, g_value_get_int (value));
		break;
		case FONT_MANAGER_GOOGLE_FONTS_FONT_SUBSETS_PROPERTY:
		font_manager_google_fonts_font_set_subsets (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

