/* MainWindow.c generated by valac 0.56.14, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/* MainWindow.vala
 *
 * Copyright (C) 2009-2022 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include "font-manager.h"
#include <glib-object.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <sqlite3.h>

#define FONT_MANAGER_FONT_VIEWER_w1 _ ("Font Viewer")
#define FONT_MANAGER_FONT_VIEWER_w2 _ ("Preview font files before installing them.")
#define FONT_MANAGER_FONT_VIEWER_w3 _ ("To preview a font simply drag it onto this area.")
#define FONT_MANAGER_FONT_VIEWER_DEFAULT_WIDTH 600
#define FONT_MANAGER_FONT_VIEWER_DEFAULT_HEIGHT 400
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW (font_manager_font_viewer_main_window_get_type ())
#define FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, FontManagerFontViewerMainWindow))
#define FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, FontManagerFontViewerMainWindowClass))
#define FONT_MANAGER_FONT_VIEWER_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_FONT_VIEWER_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW))
#define FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, FontManagerFontViewerMainWindowClass))

typedef struct _FontManagerFontViewerMainWindow FontManagerFontViewerMainWindow;
typedef struct _FontManagerFontViewerMainWindowClass FontManagerFontViewerMainWindowClass;
typedef struct _FontManagerFontViewerMainWindowPrivate FontManagerFontViewerMainWindowPrivate;
enum  {
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_0_PROPERTY,
	FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* font_manager_font_viewer_main_window_properties[FONT_MANAGER_FONT_VIEWER_MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION (font_manager_font_viewer_application_get_type ())
#define FONT_MANAGER_FONT_VIEWER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION, FontManagerFontViewerApplication))
#define FONT_MANAGER_FONT_VIEWER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION, FontManagerFontViewerApplicationClass))
#define FONT_MANAGER_FONT_VIEWER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION))
#define FONT_MANAGER_FONT_VIEWER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION))
#define FONT_MANAGER_FONT_VIEWER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION, FontManagerFontViewerApplicationClass))

typedef struct _FontManagerFontViewerApplication FontManagerFontViewerApplication;
typedef struct _FontManagerFontViewerApplicationClass FontManagerFontViewerApplicationClass;

struct _FontManagerFontViewerMainWindow {
	GtkApplicationWindow parent_instance;
	FontManagerFontViewerMainWindowPrivate * priv;
};

struct _FontManagerFontViewerMainWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _FontManagerFontViewerMainWindowPrivate {
	GtkStack* stack;
	GtkHeaderBar* titlebar;
	GtkButton* install;
	FontManagerPreviewPane* preview_pane;
	gint w;
	gint h;
	gint x;
	gint y;
	gboolean is_tiled;
	FontManagerPlaceHolder* welcome;
	FontManagerStringSet* installed;
};

static gint FontManagerFontViewerMainWindow_private_offset;
static gpointer font_manager_font_viewer_main_window_parent_class = NULL;

VALA_EXTERN GType font_manager_font_viewer_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFontViewerMainWindow, g_object_unref)
static void font_manager_font_viewer_main_window_real_constructed (GObject* base);
VALA_EXTERN void font_manager_font_viewer_main_window_update (FontManagerFontViewerMainWindow* self);
static void _font_manager_font_viewer_main_window_update_font_manager_preview_pane_changed (FontManagerPreviewPane* _sender,
                                                                                     gpointer self);
static void font_manager_font_viewer_main_window_add_actions (FontManagerFontViewerMainWindow* self);
static void font_manager_font_viewer_main_window_update_install_state (FontManagerFontViewerMainWindow* self);
static void font_manager_font_viewer_main_window_zoom (FontManagerFontViewerMainWindow* self,
                                                gboolean zoom_in,
                                                gboolean zoom_out);
static void __lambda4_ (FontManagerFontViewerMainWindow* self,
                 GSimpleAction* a,
                 GVariant* v);
static void ___lambda4__g_simple_action_activate (GSimpleAction* _sender,
                                           GVariant* parameter,
                                           gpointer self);
static void __lambda5_ (FontManagerFontViewerMainWindow* self,
                 GSimpleAction* a,
                 GVariant* v);
static void ___lambda5__g_simple_action_activate (GSimpleAction* _sender,
                                           GVariant* parameter,
                                           gpointer self);
static void __lambda6_ (FontManagerFontViewerMainWindow* self,
                 GSimpleAction* a,
                 GVariant* v);
static void ___lambda6__g_simple_action_activate (GSimpleAction* _sender,
                                           GVariant* parameter,
                                           gpointer self);
VALA_EXTERN void font_manager_font_viewer_main_window_open (FontManagerFontViewerMainWindow* self,
                                                const gchar* arg,
                                                gint index);
static void font_manager_font_viewer_main_window_update_titlebar (FontManagerFontViewerMainWindow* self,
                                                           const gchar* family,
                                                           const gchar* style);
static gchar* font_manager_font_viewer_main_window_conflicts (FontManagerFontViewerMainWindow* self,
                                                       FontManagerFont* font);
static gboolean font_manager_font_viewer_main_window_is_installed (FontManagerFontViewerMainWindow* self,
                                                            FontManagerFontInfo* info);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static gboolean font_manager_font_viewer_main_window_on_window_state_event (FontManagerFontViewerMainWindow* self,
                                                                     GtkWidget* widget,
                                                                     GdkEventWindowState* event);
static gboolean _font_manager_font_viewer_main_window_on_window_state_event_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                                                    GdkEventWindowState* event,
                                                                                                    gpointer self);
static void font_manager_font_viewer_main_window_on_size_allocate (FontManagerFontViewerMainWindow* self,
                                                            GtkWidget* widget,
                                                            GtkAllocation* allocation);
static void _font_manager_font_viewer_main_window_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                                      GtkAllocation* allocation,
                                                                                      gpointer self);
VALA_EXTERN void font_manager_font_viewer_main_window_on_install_clicked (FontManagerFontViewerMainWindow* self);
static void _font_manager_font_viewer_main_window_on_install_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self);
VALA_EXTERN gboolean font_manager_font_viewer_main_window_on_delete_event (FontManagerFontViewerMainWindow* self,
                                                               GtkWidget* widget,
                                                               GdkEventAny* event);
VALA_EXTERN GType font_manager_font_viewer_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FontManagerFontViewerApplication, g_object_unref)
VALA_EXTERN guint font_manager_font_viewer_application_register_object (void* object,
                                                            GDBusConnection* connection,
                                                            const gchar* path,
                                                            GError** error);
VALA_EXTERN GSettings* font_manager_font_viewer_application_get_settings (FontManagerFontViewerApplication* self);
static gboolean _font_manager_font_viewer_main_window_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                                        GdkEventAny* event,
                                                                                        gpointer self);
VALA_EXTERN void font_manager_font_viewer_main_window_on_realize (FontManagerFontViewerMainWindow* self,
                                                      GtkWidget* widget);
static void _font_manager_font_viewer_main_window_on_realize_gtk_widget_realize (GtkWidget* _sender,
                                                                          gpointer self);
VALA_EXTERN void font_manager_font_viewer_main_window_on_drag_data_received (FontManagerFontViewerMainWindow* self,
                                                                 GdkDragContext* context,
                                                                 gint x,
                                                                 gint y,
                                                                 GtkSelectionData* selection_data,
                                                                 guint info,
                                                                 guint time);
static void _font_manager_font_viewer_main_window_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                                                GdkDragContext* context,
                                                                                                gint x,
                                                                                                gint y,
                                                                                                GtkSelectionData* selection_data,
                                                                                                guint info,
                                                                                                guint time_,
                                                                                                gpointer self);
VALA_EXTERN FontManagerFontViewerMainWindow* font_manager_font_viewer_main_window_new (void);
VALA_EXTERN FontManagerFontViewerMainWindow* font_manager_font_viewer_main_window_construct (GType object_type);
static void font_manager_font_viewer_main_window_finalize (GObject * obj);
static GType font_manager_font_viewer_main_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

const GtkTargetEntry FONT_MANAGER_FONT_VIEWER_DragTargets[1] = {{"text/uri-list", (guint) GTK_TARGET_OTHER_APP, (guint) FONT_MANAGER_DRAG_TARGET_TYPE_EXTERNAL}};

static inline gpointer
font_manager_font_viewer_main_window_get_instance_private (FontManagerFontViewerMainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerFontViewerMainWindow_private_offset);
}

static void
_font_manager_font_viewer_main_window_update_font_manager_preview_pane_changed (FontManagerPreviewPane* _sender,
                                                                                gpointer self)
{
	font_manager_font_viewer_main_window_update ((FontManagerFontViewerMainWindow*) self);
}

static void
font_manager_font_viewer_main_window_real_constructed (GObject* base)
{
	FontManagerFontViewerMainWindow * self;
	FontManagerStringSet* _tmp0_;
	FontManagerPlaceHolder* _tmp1_;
	FontManagerPlaceHolder* _tmp2_;
	GtkStack* _tmp3_;
	FontManagerPlaceHolder* _tmp4_;
	GtkStack* _tmp5_;
	FontManagerPreviewPane* _tmp6_;
	GtkButton* _tmp7_;
	FontManagerPreviewPane* _tmp8_;
	self = (FontManagerFontViewerMainWindow*) base;
	_tmp0_ = font_manager_string_set_new ();
	_g_object_unref0 (self->priv->installed);
	self->priv->installed = _tmp0_;
	_tmp1_ = (FontManagerPlaceHolder*) font_manager_place_holder_new (FONT_MANAGER_FONT_VIEWER_w1, FONT_MANAGER_FONT_VIEWER_w2, FONT_MANAGER_FONT_VIEWER_w3, "font-x-generic-symbolic");
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->welcome);
	self->priv->welcome = _tmp1_;
	_tmp2_ = self->priv->welcome;
	gtk_widget_show ((GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->stack;
	_tmp4_ = self->priv->welcome;
	gtk_stack_add_named (_tmp3_, (GtkWidget*) _tmp4_, "Welcome");
	_tmp5_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp5_, "Welcome");
	_tmp6_ = self->priv->preview_pane;
	_tmp7_ = self->priv->install;
	gtk_notebook_set_action_widget ((GtkNotebook*) _tmp6_, (GtkWidget*) _tmp7_, GTK_PACK_END);
	_tmp8_ = self->priv->preview_pane;
	g_signal_connect_object (_tmp8_, "changed", (GCallback) _font_manager_font_viewer_main_window_update_font_manager_preview_pane_changed, self, 0);
	font_manager_font_viewer_main_window_add_actions (self);
	font_manager_font_viewer_main_window_update_install_state (self);
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, FONT_MANAGER_FONT_VIEWER_DragTargets, (gint) G_N_ELEMENTS (FONT_MANAGER_FONT_VIEWER_DragTargets), GDK_ACTION_COPY);
	G_OBJECT_CLASS (font_manager_font_viewer_main_window_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow));
	return;
}

static void
font_manager_font_viewer_main_window_zoom (FontManagerFontViewerMainWindow* self,
                                           gboolean zoom_in,
                                           gboolean zoom_out)
{
	FontManagerPreviewPanePage page = 0;
	FontManagerPreviewPane* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->preview_pane;
	page = (FontManagerPreviewPanePage) gtk_notebook_get_current_page ((GtkNotebook*) _tmp0_);
	if (zoom_in) {
		if (page == FONT_MANAGER_PREVIEW_PANE_PAGE_CHARACTER_MAP) {
			FontManagerPreviewPane* _tmp1_;
			FontManagerPreviewPane* _tmp2_;
			gdouble _tmp3_;
			gdouble _tmp4_;
			_tmp1_ = self->priv->preview_pane;
			_tmp2_ = self->priv->preview_pane;
			g_object_get (_tmp2_, "character-map-preview-size", &_tmp3_, NULL);
			_tmp4_ = _tmp3_;
			g_object_set (_tmp2_, "character-map-preview-size", _tmp4_ + 0.5, NULL);
		} else {
			FontManagerPreviewPane* _tmp5_;
			FontManagerPreviewPane* _tmp6_;
			gdouble _tmp7_;
			gdouble _tmp8_;
			_tmp5_ = self->priv->preview_pane;
			_tmp6_ = self->priv->preview_pane;
			g_object_get (_tmp6_, "preview-size", &_tmp7_, NULL);
			_tmp8_ = _tmp7_;
			g_object_set (_tmp6_, "preview-size", _tmp8_ + 0.5, NULL);
		}
	} else {
		if (zoom_out) {
			if (page == FONT_MANAGER_PREVIEW_PANE_PAGE_CHARACTER_MAP) {
				FontManagerPreviewPane* _tmp9_;
				FontManagerPreviewPane* _tmp10_;
				gdouble _tmp11_;
				gdouble _tmp12_;
				_tmp9_ = self->priv->preview_pane;
				_tmp10_ = self->priv->preview_pane;
				g_object_get (_tmp10_, "character-map-preview-size", &_tmp11_, NULL);
				_tmp12_ = _tmp11_;
				g_object_set (_tmp10_, "character-map-preview-size", _tmp12_ - 0.5, NULL);
			} else {
				FontManagerPreviewPane* _tmp13_;
				FontManagerPreviewPane* _tmp14_;
				gdouble _tmp15_;
				gdouble _tmp16_;
				_tmp13_ = self->priv->preview_pane;
				_tmp14_ = self->priv->preview_pane;
				g_object_get (_tmp14_, "preview-size", &_tmp15_, NULL);
				_tmp16_ = _tmp15_;
				g_object_set (_tmp14_, "preview-size", _tmp16_ - 0.5, NULL);
			}
		} else {
			if (page == FONT_MANAGER_PREVIEW_PANE_PAGE_CHARACTER_MAP) {
				FontManagerPreviewPane* _tmp17_;
				_tmp17_ = self->priv->preview_pane;
				g_object_set (_tmp17_, "character-map-preview-size", (gdouble) FONT_MANAGER_CHARACTER_MAP_PREVIEW_SIZE, NULL);
			} else {
				FontManagerPreviewPane* _tmp18_;
				_tmp18_ = self->priv->preview_pane;
				g_object_set (_tmp18_, "preview-size", FONT_MANAGER_DEFAULT_PREVIEW_SIZE, NULL);
			}
		}
	}
	return;
}

static void
__lambda4_ (FontManagerFontViewerMainWindow* self,
            GSimpleAction* a,
            GVariant* v)
{
	g_return_if_fail (a != NULL);
	font_manager_font_viewer_main_window_zoom (self, TRUE, FALSE);
}

static void
___lambda4__g_simple_action_activate (GSimpleAction* _sender,
                                      GVariant* parameter,
                                      gpointer self)
{
	__lambda4_ ((FontManagerFontViewerMainWindow*) self, _sender, parameter);
}

static void
__lambda5_ (FontManagerFontViewerMainWindow* self,
            GSimpleAction* a,
            GVariant* v)
{
	g_return_if_fail (a != NULL);
	font_manager_font_viewer_main_window_zoom (self, FALSE, TRUE);
}

static void
___lambda5__g_simple_action_activate (GSimpleAction* _sender,
                                      GVariant* parameter,
                                      gpointer self)
{
	__lambda5_ ((FontManagerFontViewerMainWindow*) self, _sender, parameter);
}

static void
__lambda6_ (FontManagerFontViewerMainWindow* self,
            GSimpleAction* a,
            GVariant* v)
{
	g_return_if_fail (a != NULL);
	font_manager_font_viewer_main_window_zoom (self, FALSE, FALSE);
}

static void
___lambda6__g_simple_action_activate (GSimpleAction* _sender,
                                      GVariant* parameter,
                                      gpointer self)
{
	__lambda6_ ((FontManagerFontViewerMainWindow*) self, _sender, parameter);
}

static void
font_manager_font_viewer_main_window_add_actions (FontManagerFontViewerMainWindow* self)
{
	GSimpleAction* action = NULL;
	GSimpleAction* _tmp0_;
	GSimpleAction* _tmp1_;
	gchar** accels = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gint accels_length1;
	gint _accels_size_;
	GSimpleAction* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GSimpleAction* _tmp7_;
	GSimpleAction* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	GSimpleAction* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	GSimpleAction* _tmp13_;
	GSimpleAction* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	GSimpleAction* _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_simple_action_new ("zoom_in", NULL);
	action = _tmp0_;
	_tmp1_ = action;
	g_signal_connect_object (_tmp1_, "activate", (GCallback) ___lambda4__g_simple_action_activate, self, 0);
	_tmp2_ = g_strdup ("<Ctrl>plus");
	_tmp3_ = g_strdup ("<Ctrl>equal");
	_tmp4_ = g_new0 (gchar*, 3 + 1);
	_tmp4_[0] = _tmp2_;
	_tmp4_[1] = _tmp3_;
	_tmp4_[2] = NULL;
	accels = _tmp4_;
	accels_length1 = 3;
	_accels_size_ = accels_length1;
	_tmp5_ = action;
	_tmp6_ = accels;
	_tmp6__length1 = accels_length1;
	font_manager_add_keyboard_shortcut (_tmp5_, "zoom_in", _tmp6_);
	_tmp7_ = g_simple_action_new ("zoom_out", NULL);
	_g_object_unref0 (action);
	action = _tmp7_;
	_tmp8_ = action;
	g_signal_connect_object (_tmp8_, "activate", (GCallback) ___lambda5__g_simple_action_activate, self, 0);
	_tmp9_ = g_strdup ("<Ctrl>minus");
	_tmp10_ = g_new0 (gchar*, 2 + 1);
	_tmp10_[0] = _tmp9_;
	_tmp10_[1] = NULL;
	accels = (_vala_array_free (accels, accels_length1, (GDestroyNotify) g_free), NULL);
	accels = _tmp10_;
	accels_length1 = 2;
	_accels_size_ = accels_length1;
	_tmp11_ = action;
	_tmp12_ = accels;
	_tmp12__length1 = accels_length1;
	font_manager_add_keyboard_shortcut (_tmp11_, "zoom_out", _tmp12_);
	_tmp13_ = g_simple_action_new ("zoom_default", NULL);
	_g_object_unref0 (action);
	action = _tmp13_;
	_tmp14_ = action;
	g_signal_connect_object (_tmp14_, "activate", (GCallback) ___lambda6__g_simple_action_activate, self, 0);
	_tmp15_ = g_strdup ("<Ctrl>0");
	_tmp16_ = g_new0 (gchar*, 2 + 1);
	_tmp16_[0] = _tmp15_;
	_tmp16_[1] = NULL;
	accels = (_vala_array_free (accels, accels_length1, (GDestroyNotify) g_free), NULL);
	accels = _tmp16_;
	accels_length1 = 2;
	_accels_size_ = accels_length1;
	_tmp17_ = action;
	_tmp18_ = accels;
	_tmp18__length1 = accels_length1;
	font_manager_add_keyboard_shortcut (_tmp17_, "zoom_default", _tmp18_);
	accels = (_vala_array_free (accels, accels_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (action);
	return;
}

void
font_manager_font_viewer_main_window_open (FontManagerFontViewerMainWindow* self,
                                           const gchar* arg,
                                           gint index)
{
	FontManagerPreviewPane* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (arg != NULL);
	_tmp0_ = self->priv->preview_pane;
	font_manager_preview_pane_show_uri (_tmp0_, arg, index);
	font_manager_font_viewer_main_window_update (self);
	return;
}

void
font_manager_font_viewer_main_window_update (FontManagerFontViewerMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	FontManagerPreviewPane* _tmp1_;
	FontManagerFont* _tmp2_;
	FontManagerFont* _tmp3_;
	FontManagerFont* _tmp4_;
	gboolean _tmp5_;
	gboolean have_valid_source = FALSE;
	const gchar* _tmp24_ = NULL;
	GtkStack* _tmp25_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->preview_pane;
	g_object_get (_tmp1_, "font", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_ != NULL;
	_g_object_unref0 (_tmp4_);
	if (_tmp5_) {
		FontManagerPreviewPane* _tmp6_;
		FontManagerFont* _tmp7_;
		FontManagerFont* _tmp8_;
		FontManagerFont* _tmp9_;
		_tmp6_ = self->priv->preview_pane;
		g_object_get (_tmp6_, "font", &_tmp7_, NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_;
		_tmp0_ = font_manager_json_proxy_is_valid ((FontManagerJsonProxy*) _tmp9_);
		_g_object_unref0 (_tmp9_);
	} else {
		_tmp0_ = FALSE;
	}
	have_valid_source = _tmp0_;
	if (have_valid_source) {
		FontManagerPreviewPane* _tmp10_;
		FontManagerFont* _tmp11_;
		FontManagerFont* _tmp12_;
		FontManagerFont* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		FontManagerPreviewPane* _tmp17_;
		FontManagerFont* _tmp18_;
		FontManagerFont* _tmp19_;
		FontManagerFont* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		_tmp10_ = self->priv->preview_pane;
		g_object_get (_tmp10_, "font", &_tmp11_, NULL);
		_tmp12_ = _tmp11_;
		_tmp13_ = _tmp12_;
		g_object_get (_tmp13_, "family", &_tmp14_, NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = _tmp15_;
		_tmp17_ = self->priv->preview_pane;
		g_object_get (_tmp17_, "font", &_tmp18_, NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = _tmp19_;
		g_object_get (_tmp20_, "style", &_tmp21_, NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = _tmp22_;
		font_manager_font_viewer_main_window_update_titlebar (self, _tmp16_, _tmp23_);
		_g_free0 (_tmp23_);
		_g_object_unref0 (_tmp20_);
		_g_free0 (_tmp16_);
		_g_object_unref0 (_tmp13_);
	} else {
		font_manager_font_viewer_main_window_update_titlebar (self, NULL, NULL);
	}
	if (have_valid_source) {
		_tmp24_ = "Preview";
	} else {
		_tmp24_ = "Welcome";
	}
	_tmp25_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp25_, _tmp24_);
	font_manager_font_viewer_main_window_update_install_state (self);
	gtk_widget_queue_draw ((GtkWidget*) self);
	return;
}

static void
font_manager_font_viewer_main_window_update_titlebar (FontManagerFontViewerMainWindow* self,
                                                      const gchar* family,
                                                      const gchar* style)
{
	gboolean _tmp0_ = FALSE;
	GtkHeaderBar* _tmp3_;
	GtkHeaderBar* _tmp4_;
	static const char tt_tmpl[] = "<big><b>%s</b> </big><b>%s</b>";
	GtkHeaderBar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	g_return_if_fail (self != NULL);
	if (family == NULL) {
		_tmp0_ = style == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkHeaderBar* _tmp1_;
		GtkHeaderBar* _tmp2_;
		_tmp1_ = self->priv->titlebar;
		gtk_header_bar_set_title (_tmp1_, _ ("No file selected"));
		_tmp2_ = self->priv->titlebar;
		gtk_header_bar_set_subtitle (_tmp2_, _ ("Or unsupported filetype."));
		return;
	}
	_tmp3_ = self->priv->titlebar;
	gtk_header_bar_set_title (_tmp3_, family);
	_tmp4_ = self->priv->titlebar;
	gtk_header_bar_set_subtitle (_tmp4_, style);
	_tmp5_ = self->priv->titlebar;
	_tmp6_ = g_markup_escape_text (family, (gssize) -1);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup_printf (tt_tmpl, _tmp7_, style);
	_tmp9_ = _tmp8_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp5_, _tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	return;
}

static gchar*
font_manager_font_viewer_main_window_conflicts (FontManagerFontViewerMainWindow* self,
                                                FontManagerFont* font)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (font != NULL, NULL);
	{
		FontManagerDatabase* db = NULL;
		FontManagerDatabase* _tmp0_;
		FontManagerDatabase* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		FontManagerDatabase* _tmp7_;
		sqlite3_stmt* _tmp8_;
		_tmp0_ = font_manager_get_database (FONT_MANAGER_DATABASE_TYPE_FONT, &_inner_error0_);
		db = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp1_ = db;
		g_object_get (font, "description", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strdup_printf ("SELECT DISTINCT filepath FROM Fonts WHERE description = \"%s\"", _tmp4_);
		_tmp6_ = _tmp5_;
		font_manager_database_execute_query (_tmp1_, _tmp6_, &_inner_error0_);
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (db);
			goto __catch0_g_error;
		}
		_tmp7_ = db;
		_tmp8_ = _tmp7_->stmt;
		if (sqlite3_step (_tmp8_) == SQLITE_ROW) {
			FontManagerDatabase* _tmp9_;
			sqlite3_stmt* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			_tmp9_ = db;
			_tmp10_ = _tmp9_->stmt;
			_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 0);
			_tmp12_ = g_strdup (_tmp11_);
			result = _tmp12_;
			_g_object_unref0 (db);
			return result;
		}
		_g_object_unref0 (db);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = NULL;
	return result;
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
}

static gboolean
font_manager_font_viewer_main_window_is_installed (FontManagerFontViewerMainWindow* self,
                                                   FontManagerFontInfo* info)
{
	FontManagerStringSet* _tmp0_;
	FontManagerPreviewPane* _tmp1_;
	FontManagerFontInfo* _tmp2_;
	FontManagerFontInfo* _tmp3_;
	FontManagerFontInfo* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	GList* filelist = NULL;
	GList* _tmp9_;
	GList* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GCompareFunc _tmp14_;
	GList* _tmp15_;
	gboolean _tmp16_;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (info != NULL, FALSE);
	_tmp0_ = self->priv->installed;
	_tmp1_ = self->priv->preview_pane;
	g_object_get (_tmp1_, "metadata", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	g_object_get (_tmp4_, "checksum", &_tmp5_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp8_ = font_manager_string_set_contains (_tmp0_, _tmp7_);
	_g_free0 (_tmp7_);
	_g_object_unref0 (_tmp4_);
	if (_tmp8_) {
		result = TRUE;
		return result;
	}
	_tmp9_ = font_manager_list_available_font_files ();
	filelist = _tmp9_;
	_tmp10_ = filelist;
	g_object_get (info, "filepath", &_tmp11_, NULL);
	_tmp12_ = _tmp11_;
	_tmp13_ = _tmp12_;
	_tmp14_ = ((GCompareFunc) g_strcmp0);
	_tmp15_ = g_list_find_custom (_tmp10_, _tmp13_, _tmp14_);
	_tmp16_ = _tmp15_ != NULL;
	_g_free0 (_tmp13_);
	if (_tmp16_) {
		result = TRUE;
		(filelist == NULL) ? NULL : (filelist = (_g_list_free__g_free0_ (filelist), NULL));
		return result;
	}
	{
		FontManagerDatabase* db = NULL;
		FontManagerDatabase* _tmp17_;
		FontManagerDatabase* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		_tmp17_ = font_manager_get_database (FONT_MANAGER_DATABASE_TYPE_METADATA, &_inner_error0_);
		db = _tmp17_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp18_ = db;
		g_object_get (info, "checksum", &_tmp19_, NULL);
		_tmp20_ = _tmp19_;
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strdup_printf ("SELECT DISTINCT filepath FROM Metadata WHERE checksum = \"%s\"", _tmp21_);
		_tmp23_ = _tmp22_;
		font_manager_database_execute_query (_tmp18_, _tmp23_, &_inner_error0_);
		_g_free0 (_tmp23_);
		_g_free0 (_tmp21_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (db);
			goto __catch0_g_error;
		}
		{
			FontManagerDatabaseIterator* _row_it = NULL;
			FontManagerDatabase* _tmp24_;
			FontManagerDatabaseIterator* _tmp25_;
			_tmp24_ = db;
			_tmp25_ = font_manager_database_iterator (_tmp24_);
			_row_it = _tmp25_;
			while (TRUE) {
				FontManagerDatabaseIterator* _tmp26_;
				sqlite3_stmt* row = NULL;
				FontManagerDatabaseIterator* _tmp27_;
				sqlite3_stmt* _tmp28_;
				GList* _tmp29_;
				sqlite3_stmt* _tmp30_;
				const gchar* _tmp31_;
				GCompareFunc _tmp32_;
				GList* _tmp33_;
				_tmp26_ = _row_it;
				if (!font_manager_database_iterator_next (_tmp26_)) {
					break;
				}
				_tmp27_ = _row_it;
				_tmp28_ = font_manager_database_iterator_get (_tmp27_);
				row = _tmp28_;
				_tmp29_ = filelist;
				_tmp30_ = row;
				_tmp31_ = (const gchar*) sqlite3_column_text (_tmp30_, 0);
				_tmp32_ = ((GCompareFunc) g_strcmp0);
				_tmp33_ = g_list_find_custom (_tmp29_, _tmp31_, _tmp32_);
				if (_tmp33_ != NULL) {
					result = TRUE;
					_g_object_unref0 (_row_it);
					_g_object_unref0 (db);
					(filelist == NULL) ? NULL : (filelist = (_g_list_free__g_free0_ (filelist), NULL));
					return result;
				}
			}
			_g_object_unref0 (_row_it);
		}
		_g_object_unref0 (db);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp34_ = FALSE;
		(filelist == NULL) ? NULL : (filelist = (_g_list_free__g_free0_ (filelist), NULL));
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp34_;
	}
	result = FALSE;
	(filelist == NULL) ? NULL : (filelist = (_g_list_free__g_free0_ (filelist), NULL));
	return result;
}

static void
font_manager_font_viewer_main_window_update_install_state (FontManagerFontViewerMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	FontManagerPreviewPane* _tmp1_;
	FontManagerFont* _tmp2_;
	FontManagerFont* _tmp3_;
	FontManagerFont* _tmp4_;
	gboolean _tmp5_;
	gboolean have_valid_source = FALSE;
	GtkButton* _tmp10_;
	FontManagerPreviewPane* _tmp11_;
	FontManagerFontInfo* _tmp12_;
	FontManagerFontInfo* _tmp13_;
	FontManagerFontInfo* _tmp14_;
	gboolean _installed = FALSE;
	FontManagerPreviewPane* _tmp15_;
	FontManagerFontInfo* _tmp16_;
	FontManagerFontInfo* _tmp17_;
	FontManagerFontInfo* _tmp18_;
	gboolean _tmp19_;
	gchar* conflict = NULL;
	FontManagerPreviewPane* _tmp20_;
	FontManagerFont* _tmp21_;
	FontManagerFont* _tmp22_;
	FontManagerFont* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	FontManagerPreviewPane* _tmp26_;
	FontManagerFontInfo* _tmp27_;
	FontManagerFontInfo* _tmp28_;
	FontManagerFontInfo* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GtkButton* _tmp33_;
	GtkButton* _tmp34_;
	GtkStyleContext* _tmp35_;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	const gchar* _tmp38_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->preview_pane;
	g_object_get (_tmp1_, "font", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_ != NULL;
	_g_object_unref0 (_tmp4_);
	if (_tmp5_) {
		FontManagerPreviewPane* _tmp6_;
		FontManagerFont* _tmp7_;
		FontManagerFont* _tmp8_;
		FontManagerFont* _tmp9_;
		_tmp6_ = self->priv->preview_pane;
		g_object_get (_tmp6_, "font", &_tmp7_, NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_;
		_tmp0_ = font_manager_json_proxy_is_valid ((FontManagerJsonProxy*) _tmp9_);
		_g_object_unref0 (_tmp9_);
	} else {
		_tmp0_ = FALSE;
	}
	have_valid_source = _tmp0_;
	_tmp10_ = self->priv->install;
	gtk_widget_set_visible ((GtkWidget*) _tmp10_, have_valid_source);
	if (!have_valid_source) {
		return;
	}
	font_manager_clear_application_fonts ();
	_tmp11_ = self->priv->preview_pane;
	g_object_get (_tmp11_, "metadata", &_tmp12_, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = _tmp13_;
	g_return_if_fail (font_manager_json_proxy_is_valid ((FontManagerJsonProxy*) _tmp14_));
	_g_object_unref0 (_tmp14_);
	_tmp15_ = self->priv->preview_pane;
	g_object_get (_tmp15_, "metadata", &_tmp16_, NULL);
	_tmp17_ = _tmp16_;
	_tmp18_ = _tmp17_;
	_tmp19_ = font_manager_font_viewer_main_window_is_installed (self, _tmp18_);
	_g_object_unref0 (_tmp18_);
	_installed = _tmp19_;
	_tmp20_ = self->priv->preview_pane;
	g_object_get (_tmp20_, "font", &_tmp21_, NULL);
	_tmp22_ = _tmp21_;
	_tmp23_ = _tmp22_;
	_tmp24_ = font_manager_font_viewer_main_window_conflicts (self, _tmp23_);
	_tmp25_ = _tmp24_;
	_g_object_unref0 (_tmp23_);
	conflict = _tmp25_;
	_tmp26_ = self->priv->preview_pane;
	g_object_get (_tmp26_, "metadata", &_tmp27_, NULL);
	_tmp28_ = _tmp27_;
	_tmp29_ = _tmp28_;
	g_object_get (_tmp29_, "filepath", &_tmp30_, NULL);
	_tmp31_ = _tmp30_;
	_tmp32_ = _tmp31_;
	font_manager_add_application_font (_tmp32_);
	_g_free0 (_tmp32_);
	_g_object_unref0 (_tmp29_);
	_tmp33_ = self->priv->install;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp33_, FALSE);
	_tmp34_ = self->priv->install;
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
	gtk_style_context_add_class (_tmp35_, "SensitiveChildLabel");
	_tmp38_ = conflict;
	if (_tmp38_ != NULL) {
		const gchar* _tmp39_;
		_tmp39_ = conflict;
		_tmp37_ = font_manager_exists (_tmp39_);
	} else {
		_tmp37_ = FALSE;
	}
	if (_tmp37_) {
		const gchar* _tmp40_;
		FontManagerPreviewPane* _tmp41_;
		FontManagerFont* _tmp42_;
		FontManagerFont* _tmp43_;
		FontManagerFont* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		_tmp40_ = conflict;
		_tmp41_ = self->priv->preview_pane;
		g_object_get (_tmp41_, "font", &_tmp42_, NULL);
		_tmp43_ = _tmp42_;
		_tmp44_ = _tmp43_;
		g_object_get (_tmp44_, "filepath", &_tmp45_, NULL);
		_tmp46_ = _tmp45_;
		_tmp47_ = _tmp46_;
		_tmp36_ = font_manager_timecmp (_tmp40_, _tmp47_) > 0;
		_g_free0 (_tmp47_);
		_g_object_unref0 (_tmp44_);
	} else {
		_tmp36_ = FALSE;
	}
	if (_tmp36_) {
		GtkButton* _tmp48_;
		_tmp48_ = self->priv->install;
		gtk_button_set_label (_tmp48_, _ ("Newer version already installed"));
	} else {
		if (_installed) {
			GtkButton* _tmp49_;
			_tmp49_ = self->priv->install;
			gtk_button_set_label (_tmp49_, _ ("Installed"));
		} else {
			GtkButton* _tmp50_;
			GtkStyleContext* _tmp51_;
			GtkButton* _tmp52_;
			GtkButton* _tmp53_;
			_tmp50_ = self->priv->install;
			_tmp51_ = gtk_widget_get_style_context ((GtkWidget*) _tmp50_);
			gtk_style_context_remove_class (_tmp51_, "SensitiveChildLabel");
			_tmp52_ = self->priv->install;
			gtk_button_set_label (_tmp52_, _ ("Install Font"));
			_tmp53_ = self->priv->install;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp53_, TRUE);
		}
	}
	_g_free0 (conflict);
	return;
}

static gboolean
font_manager_font_viewer_main_window_on_window_state_event (FontManagerFontViewerMainWindow* self,
                                                            GtkWidget* widget,
                                                            GdkEventWindowState* event)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if ((event->changed_mask & GDK_WINDOW_STATE_TILED) != 0) {
		self->priv->is_tiled = (event->new_window_state & GDK_WINDOW_STATE_TILED) != 0;
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
_font_manager_font_viewer_main_window_on_window_state_event_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                                           GdkEventWindowState* event,
                                                                                           gpointer self)
{
	gboolean result;
	result = font_manager_font_viewer_main_window_on_window_state_event ((FontManagerFontViewerMainWindow*) self, _sender, event);
	return result;
}

static void
font_manager_font_viewer_main_window_on_size_allocate (FontManagerFontViewerMainWindow* self,
                                                       GtkWidget* widget,
                                                       GtkAllocation* allocation)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (allocation != NULL);
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->is_tiled;
	}
	if (_tmp0_) {
		return;
	}
	gtk_window_get_size ((GtkWindow*) self, &_tmp3_, &_tmp4_);
	self->priv->w = _tmp3_;
	self->priv->h = _tmp4_;
	gtk_window_get_position ((GtkWindow*) self, &_tmp5_, &_tmp6_);
	self->priv->x = _tmp5_;
	self->priv->y = _tmp6_;
	return;
}

static void
_font_manager_font_viewer_main_window_on_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                                 GtkAllocation* allocation,
                                                                                 gpointer self)
{
	font_manager_font_viewer_main_window_on_size_allocate ((FontManagerFontViewerMainWindow*) self, _sender, allocation);
}

void
font_manager_font_viewer_main_window_on_install_clicked (FontManagerFontViewerMainWindow* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GFile* file = NULL;
		FontManagerPreviewPane* _tmp0_;
		FontManagerFont* _tmp1_;
		FontManagerFont* _tmp2_;
		FontManagerFont* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* install_dir = NULL;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		FontManagerStringSet* _tmp13_;
		FontManagerPreviewPane* _tmp14_;
		FontManagerFontInfo* _tmp15_;
		FontManagerFontInfo* _tmp16_;
		FontManagerFontInfo* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp0_ = self->priv->preview_pane;
		g_object_get (_tmp0_, "font", &_tmp1_, NULL);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		g_object_get (_tmp3_, "filepath", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = g_file_new_for_path (_tmp6_);
		_tmp8_ = _tmp7_;
		_g_free0 (_tmp6_);
		_g_object_unref0 (_tmp3_);
		file = _tmp8_;
		_tmp9_ = font_manager_get_user_font_directory ();
		_tmp10_ = _tmp9_;
		_tmp11_ = g_file_new_for_path (_tmp10_);
		_tmp12_ = _tmp11_;
		_g_free0 (_tmp10_);
		install_dir = _tmp12_;
		font_manager_install_file (file, install_dir, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (install_dir);
			_g_object_unref0 (file);
			goto __catch0_g_error;
		}
		_tmp13_ = self->priv->installed;
		_tmp14_ = self->priv->preview_pane;
		g_object_get (_tmp14_, "metadata", &_tmp15_, NULL);
		_tmp16_ = _tmp15_;
		_tmp17_ = _tmp16_;
		g_object_get (_tmp17_, "checksum", &_tmp18_, NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = _tmp19_;
		font_manager_string_set_add (_tmp13_, _tmp20_);
		_g_free0 (_tmp20_);
		_g_object_unref0 (_tmp17_);
		font_manager_font_viewer_main_window_update_install_state (self);
		_g_object_unref0 (install_dir);
		_g_object_unref0 (file);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp21_ = e;
		_tmp22_ = _tmp21_->message;
		g_critical ("MainWindow.vala:208: %s", _tmp22_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	return;
}

static void
_font_manager_font_viewer_main_window_on_install_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self)
{
	font_manager_font_viewer_main_window_on_install_clicked ((FontManagerFontViewerMainWindow*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gboolean
font_manager_font_viewer_main_window_on_delete_event (FontManagerFontViewerMainWindow* self,
                                                      GtkWidget* widget,
                                                      GdkEventAny* event)
{
	GSettings* settings = NULL;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GtkApplication* _tmp10_;
	GtkApplication* _tmp11_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = font_manager_font_viewer_application_get_settings (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION, FontManagerFontViewerApplication));
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	settings = _tmp4_;
	_tmp5_ = settings;
	if (_tmp5_ != NULL) {
		GSettings* _tmp6_;
		GSettings* _tmp7_;
		GSettings* _tmp8_;
		GSettings* _tmp9_;
		_tmp6_ = settings;
		g_settings_delay (_tmp6_);
		_tmp7_ = settings;
		g_settings_set (_tmp7_, "window-size", "(ii)", self->priv->w, self->priv->h);
		_tmp8_ = settings;
		g_settings_set (_tmp8_, "window-position", "(ii)", self->priv->x, self->priv->y);
		_tmp9_ = settings;
		g_settings_apply (_tmp9_);
	}
	_tmp10_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp11_ = _tmp10_;
	g_application_quit ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION, FontManagerFontViewerApplication));
	result = TRUE;
	_g_object_unref0 (settings);
	return result;
}

static gboolean
_font_manager_font_viewer_main_window_on_delete_event_gtk_widget_delete_event (GtkWidget* _sender,
                                                                               GdkEventAny* event,
                                                                               gpointer self)
{
	gboolean result;
	result = font_manager_font_viewer_main_window_on_delete_event ((FontManagerFontViewerMainWindow*) self, _sender, event);
	return result;
}

void
font_manager_font_viewer_main_window_on_realize (FontManagerFontViewerMainWindow* self,
                                                 GtkWidget* widget)
{
	GSettings* settings = NULL;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	GSettings* _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	FontManagerPreviewPane* _tmp12_;
	GSettings* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = font_manager_font_viewer_application_get_settings (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, FONT_MANAGER_FONT_VIEWER_TYPE_APPLICATION, FontManagerFontViewerApplication));
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	settings = _tmp4_;
	_tmp5_ = settings;
	if (_tmp5_ == NULL) {
		_g_object_unref0 (settings);
		return;
	}
	_tmp6_ = settings;
	g_settings_get (_tmp6_, "window-size", "(ii)", &_tmp7_, &_tmp8_);
	self->priv->w = _tmp7_;
	self->priv->h = _tmp8_;
	_tmp9_ = settings;
	g_settings_get (_tmp9_, "window-position", "(ii)", &_tmp10_, &_tmp11_);
	self->priv->x = _tmp10_;
	self->priv->y = _tmp11_;
	gtk_window_set_default_size ((GtkWindow*) self, self->priv->w, self->priv->h);
	gtk_window_move ((GtkWindow*) self, self->priv->x, self->priv->y);
	_tmp12_ = self->priv->preview_pane;
	_tmp13_ = settings;
	font_manager_preview_pane_restore_state (_tmp12_, _tmp13_);
	_g_object_unref0 (settings);
	return;
}

static void
_font_manager_font_viewer_main_window_on_realize_gtk_widget_realize (GtkWidget* _sender,
                                                                     gpointer self)
{
	font_manager_font_viewer_main_window_on_realize ((FontManagerFontViewerMainWindow*) self, _sender);
}

void
font_manager_font_viewer_main_window_on_drag_data_received (FontManagerFontViewerMainWindow* self,
                                                            GdkDragContext* context,
                                                            gint x,
                                                            gint y,
                                                            GtkSelectionData* selection_data,
                                                            guint info,
                                                            guint time)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	if (info == ((guint) FONT_MANAGER_DRAG_TARGET_TYPE_EXTERNAL)) {
		gchar** _tmp0_;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		const gchar* _tmp3_;
		_tmp1_ = _tmp0_ = gtk_selection_data_get_uris (selection_data);
		_tmp2_ = _tmp1_;
		_tmp2__length1 = _vala_array_length (_tmp0_);
		_tmp3_ = _tmp2_[0];
		font_manager_font_viewer_main_window_open (self, _tmp3_, 0);
		_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	}
	return;
}

static void
_font_manager_font_viewer_main_window_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                                           GdkDragContext* context,
                                                                                           gint x,
                                                                                           gint y,
                                                                                           GtkSelectionData* selection_data,
                                                                                           guint info,
                                                                                           guint time_,
                                                                                           gpointer self)
{
	font_manager_font_viewer_main_window_on_drag_data_received ((FontManagerFontViewerMainWindow*) self, context, x, y, selection_data, info, time_);
}

FontManagerFontViewerMainWindow*
font_manager_font_viewer_main_window_construct (GType object_type)
{
	FontManagerFontViewerMainWindow * self = NULL;
	self = (FontManagerFontViewerMainWindow*) g_object_new (object_type, NULL);
	return self;
}

FontManagerFontViewerMainWindow*
font_manager_font_viewer_main_window_new (void)
{
	return font_manager_font_viewer_main_window_construct (FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW);
}

static void
font_manager_font_viewer_main_window_class_init (FontManagerFontViewerMainWindowClass * klass,
                                                 gpointer klass_data)
{
	font_manager_font_viewer_main_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerFontViewerMainWindow_private_offset);
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) font_manager_font_viewer_main_window_real_constructed;
	G_OBJECT_CLASS (klass)->finalize = font_manager_font_viewer_main_window_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/FontManager/ui/font-viewer-main-window.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "titlebar", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, titlebar));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "install", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, install));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "preview_pane", FALSE, FontManagerFontViewerMainWindow_private_offset + G_STRUCT_OFFSET (FontManagerFontViewerMainWindowPrivate, preview_pane));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_window_state_event", G_CALLBACK(_font_manager_font_viewer_main_window_on_window_state_event_gtk_widget_window_state_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_size_allocate", G_CALLBACK(_font_manager_font_viewer_main_window_on_size_allocate_gtk_widget_size_allocate));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_install_clicked", G_CALLBACK(_font_manager_font_viewer_main_window_on_install_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_delete_event", G_CALLBACK(_font_manager_font_viewer_main_window_on_delete_event_gtk_widget_delete_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_realize", G_CALLBACK(_font_manager_font_viewer_main_window_on_realize_gtk_widget_realize));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_drag_data_received", G_CALLBACK(_font_manager_font_viewer_main_window_on_drag_data_received_gtk_widget_drag_data_received));
}

static void
font_manager_font_viewer_main_window_instance_init (FontManagerFontViewerMainWindow * self,
                                                    gpointer klass)
{
	self->priv = font_manager_font_viewer_main_window_get_instance_private (self);
	self->priv->w = -1;
	self->priv->h = -1;
	self->priv->x = -1;
	self->priv->y = -1;
	self->priv->is_tiled = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
font_manager_font_viewer_main_window_finalize (GObject * obj)
{
	FontManagerFontViewerMainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_FONT_VIEWER_TYPE_MAIN_WINDOW, FontManagerFontViewerMainWindow);
	_g_object_unref0 (self->priv->welcome);
	_g_object_unref0 (self->priv->installed);
	G_OBJECT_CLASS (font_manager_font_viewer_main_window_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
font_manager_font_viewer_main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FontManagerFontViewerMainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_font_viewer_main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerFontViewerMainWindow), 0, (GInstanceInitFunc) font_manager_font_viewer_main_window_instance_init, NULL };
	GType font_manager_font_viewer_main_window_type_id;
	font_manager_font_viewer_main_window_type_id = g_type_register_static (gtk_application_window_get_type (), "FontManagerFontViewerMainWindow", &g_define_type_info, 0);
	FontManagerFontViewerMainWindow_private_offset = g_type_add_instance_private (font_manager_font_viewer_main_window_type_id, sizeof (FontManagerFontViewerMainWindowPrivate));
	return font_manager_font_viewer_main_window_type_id;
}

GType
font_manager_font_viewer_main_window_get_type (void)
{
	static volatile gsize font_manager_font_viewer_main_window_type_id__once = 0;
	if (g_once_init_enter (&font_manager_font_viewer_main_window_type_id__once)) {
		GType font_manager_font_viewer_main_window_type_id;
		font_manager_font_viewer_main_window_type_id = font_manager_font_viewer_main_window_get_type_once ();
		g_once_init_leave (&font_manager_font_viewer_main_window_type_id__once, font_manager_font_viewer_main_window_type_id);
	}
	return font_manager_font_viewer_main_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

